# pylint: disable=line-too-long, invalid-name, missing-function-docstring, missing-module-docstring, superfluous-parens
# pylint: disable=wrong-import-position, unused-import, unused-wildcard-import, wildcard-import, wrong-import-order, missing-class-docstring
from __future__ import annotations
from typing import List, Optional
from datetime import date
from datetime import time
from datetime import datetime
from decimal import Decimal
from pydantic import Field
from rosetta.runtime.utils import *

__all__ = ['DistributionAndInterestPayment']


class DistributionAndInterestPayment(BaseDataClass):
  """
  A class to specify the Distributions and Interest Payment provisions applicable to the collateral agreement.
  """
  interestParameters: List[CollateralInterestParameters] = Field([], description="Represents the interest parameters for the various currencies, margin types, posting parties.")
  """
  Represents the interest parameters for the various currencies, margin types, posting parties.
  """

from cdm.product.collateral.CollateralInterestParameters import CollateralInterestParameters

DistributionAndInterestPayment.update_forward_refs()
