# pylint: disable=line-too-long, invalid-name, missing-function-docstring, missing-module-docstring, superfluous-parens
# pylint: disable=wrong-import-position, unused-import, unused-wildcard-import, wildcard-import, wrong-import-order, missing-class-docstring
from __future__ import annotations
from typing import List, Optional
from datetime import date
from datetime import time
from datetime import datetime
from decimal import Decimal
from pydantic import Field
from rosetta.runtime.utils import *

__all__ = ['Asian']


class Asian(BaseDataClass):
  """
  As per ISDA 2002 Definitions.
  """
  averagingInOut: AveragingInOutEnum = Field(..., description="")
  strikeFactor: Optional[Decimal] = Field(None, description="The factor of strike.")
  """
  The factor of strike.
  """
  averagingPeriodIn: Optional[AveragingPeriod] = Field(None, description="The averaging in period.")
  """
  The averaging in period.
  """
  averagingPeriodOut: Optional[AveragingPeriod] = Field(None, description="The averaging out period.")
  """
  The averaging out period.
  """

from cdm.product.template.AveragingInOutEnum import AveragingInOutEnum
from cdm.product.common.schedule.AveragingPeriod import AveragingPeriod

Asian.update_forward_refs()
