# ISDA CDM™ License Version 2.0

Effective date of version 2.0: February 26, 2019

© 2018-2019 The International Swaps and Derivatives Association, Inc.

## 1. Definitions

- (a).  "Licensor" means International Swaps and Derivatives Association,
Inc. ("ISDA").
- (b).  "Larger Work" means a work, including but not limited to computer
software, that combines the ISDA CDM v2.0, or portions thereof with
material not governed by the terms of this License.
- (c).  "License" means this document.
- (d).  "ISDA CDM v2.0" means the methodology and documentation of any
version 2.0 or sub-version with the designation of "2._" (e.g.,
2.1, 2.2, 2.3, etc.) located at
<http://portal.cdm.rosetta-technology.io/>.
- (e).  "You" means an individual or a legal entity exercising rights under,
and complying with all of the terms of, this License or a future
version of this License issued under Paragraph 6. For legal
entities, "You" includes any entity which controls, is controlled
by, or is under common control with You. For purposes of this
definition, "control" means 
  - (a). the power, direct or indirect, to
cause the direction or management of such entity, whether by
  contract or otherwise, or 
  - (b). ownership of fifty percent (50%) or
more of the outstanding shares or beneficial ownership of such
entity.

## 2. ISDA CDM v2.0 License

Licensor hereby grants You a world-wide, royalty-free, non-exclusive
license, subject to third party intellectual property claims, to use,
reproduce, modify, display, perform, and distribute the ISDA CDM v2.0
(or portions thereof) without modifications and solely as part of a
Larger Work.

## 3. Required Notices

If You reproduce, distribute or display any of the ISDA CDM v2.0 in any
form other than as part of computer software, then You agree to include
in each such copy or display the notice in Exhibit A.

## 4. Use of ISDA CDM v2.0 in Larger Works

- (a).  You may use the ISDA CDM v2.0 in a Larger Work, including but not
limited to computer software, and distribute Your Larger Work under
a license of Your choice, which may contain terms different from
this License, provided that the license for Your Larger Work does
not attempt to limit the recipient's rights to use the ISDA CDM v2.0
apart from Your Larger Work.
- (b).  You hereby agree to indemnify Licensor for any liability incurred by
the Licensor as a result of the distribution, purchase, sale,
reproduction, display or use of Your Larger Work.

## 5. Use of Designation "ISDA CDM"

- (a). You may use the designation "ISDA CDM":

  - (i).  to identify the ISDA CDM v2.0 approved by Licensor; and
  - (ii). to make the truthful claim that computer software or any other
product or service is based on or compliant with a specified version
of ISDA CDM v2.0.

- (b). You agree not to use the designations "ISDA" or "ISDA CDM" in a
misleading or untruthful way, or in a way that falsely suggests
endorsement or sponsorship by, or affiliation with, Licensor. You
further agree that you will not:

  - (i).  identify any specifications or standards other than the ISDA CDM
v2.0 approved by Licensor, or any computer software code containing
such specifications or standards, including standards or
specifications approved by ISDA that add to the ISDA CDM v2.0,
unless those additions are clearly and conspicuously identified as
such and in that event, You shall state conspicuously that they have
neither been reviewed nor approved by ISDA;
  - (ii). advertise or promote any computer software or any other product or
service as based on or compliant with ISDA CDM v2.0, unless You
specify the version of the ISDA CDM v2.0; or
  - (iii). use the term "ISDA" or "ISDA CDM" as a trademark or part of a
trademark for any software or any other product, or as a service
mark or part of a service mark for any service.

## 6. Revisions of the License

- (a).  Licensor may publish revised and/or new versions of the ISDA CDM
v2.0 and/or the License from time to time. Each version will be
given a distinguishing version number, beginning with the
designation of "2.0" or higher. ISDA reserves the right in its sole
discretion to designate new terms and conditions governing the
licensing of such versions.
- (b).  Once You have used the ISDA CDM v2.0 under a particular version of
the License, You may always continue to use the same specifications
under the terms of that version. You may also choose to use those
specifications under the terms of any subsequent version of the
License published by Licensor. No one other than Licensor has the
right to modify the terms applicable to the ISDA CDM v2.0 under this
or any other License.

## 7. DISCLAIMER OF WARRANTY

THE ISDA CDM V2.0 IS PROVIDED UNDER THIS LICENSE ON AN "AS IS" BASIS,
WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
WITHOUT LIMITATION, WARRANTIES THAT THE ISDA CDM V2.0 IS FREE OF
DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE OR NON-INFRINGING.
THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE ISDA CDM V2.0
IS WITH YOU. SHOULD ANY OF THE ISDA CDM V2.0 PROVE DEFECTIVE IN ANY
RESPECT, YOU (NOT THE LICENSOR) ASSUME THE COST OF ANY NECESSARY
SERVICING, REPAIR OR CORRECTION. THIS DISCLAIMER OF WARRANTY CONSTITUTES
AN ESSENTIAL PART OF THIS LICENSE. NO USE OF ANY OF THE ISDA CDM V2.0 IS
AUTHORIZED HEREUNDER EXCEPT UNDER THIS DISCLAIMER.

## 8. Termination

This License and the rights granted hereunder will terminate
automatically if You fail to comply with terms herein and fail to cure
such breach within 30 days of becoming aware of the breach.

## 9. LIMITATION OF LIABILITY

UNDER NO CIRCUMSTANCES AND UNDER NO LEGAL THEORY, WHETHER TORT(INCLUDING
NEGLIGENCE), CONTRACT, OR OTHERWISE, SHALL THE LICENSOR, ANY OF ITS
MEMBERS, OR ANY DISTRIBUTOR OF DOCUMENTS OR SOFTWARE CONTAINING ANY OF
THE ISDA CDM V2.0, OR ANY SUPPLIER OF ANY OF SUCH PARTIES, BE LIABLE TO
YOU OR ANY OTHER PERSON FOR ANY INDIRECT, SPECIAL, INCIDENTAL, PUNITIVE
OR CONSEQUENTIAL DAMAGES OF ANY CHARACTER INCLUDING, WITHOUT LIMITATION,
DAMAGES FOR LOSS OF GOODWILL, WORK STOPPAGE, COMPUTER FAILURE OR
MALFUNCTION, OR ANY AND ALL OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF
SUCH PARTY SHALL HAVE BEEN INFORMED OF THE POSSIBILITY OF SUCH DAMAGES.
THIS LIMITATION OF LIABILITY SHALL NOT APPLY TO LIABILITY FOR DEATH OR
PERSONAL INJURY RESULTING FROM SUCH PARTY'S NEGLIGENCE TO THE EXTENT
APPLICABLE LAW PROHIBITS SUCH LIMITATION. SOME JURISDICTIONS DO NOT
ALLOW THE EXCLUSION OR LIMITATION OF INCIDENTAL OR CONSEQUENTIAL
DAMAGES, SO THAT EXCLUSION AND LIMITATION MAY NOT APPLY TO YOU.

## 10. Miscellaneous

This License represents the complete agreement concerning subject matter
hereof. If any provision of this License is held to be unenforceable,
such provision shall be reformed only to the extent necessary to make it
enforceable. This License shall be governed by New York law provisions
(except to the extent applicable law, if any, provides otherwise),
including its conflict-of-law provisions. With respect to disputes in
which at least one party is a citizen of, or an entity chartered or
registered to do business in, the United States of America: (a) unless
otherwise agreed in writing, all disputes arising under or relating to
this License (excepting any dispute relating to copyright, trademark,
patent or trade secret rights, which issues must be resolved through
judicial action) shall be subject to final and binding arbitration, with
the losing party paying all costs of arbitration; (b) any arbitration
relating to this Agreement shall be held in New York City, under the
auspices of JAMS/End Dispute; and (c) any judicial litigation arising
under or relating to this agreement, including the enforcement of any
arbitration award, shall be subject to the exclusive jurisdiction of the
United States District Court for the Southern District of New York, or
in the absence of that court having subject matter jurisdiction, to the
jurisdiction of courts of the State of New York, with venue lying in New
York County. The losing party shall be responsible for costs, including
without limitation, court costs and reasonable attorney's fees and
expenses. By using ISDA CDM v2.0 under this License you consent to the
personal jurisdiction of the foregoing federal and/or New York state
courts. The application of the United Nations Convention on Contracts
for the International Sale of Goods is expressly excluded. Any law or
regulation which provides that the language of a contract shall be
construed against the drafter shall not apply to this License.

## EXHIBIT A

- The ISDA CDM™ portions of this document are subject to the ISDA CDM™
    License Version 2.0 (the "License"); you may not use the ISDA CDM
    except in compliance with that License. You may obtain a copy of the
    License at . <http://www.isda.org/isda-cdm-2/>.
- The portions of the ISDA CDM™ distributed under the License are
    distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND,
    either express or implied. See the License for the specific language
    governing rights and limitations under the License. You may obtain a
    copy of the License at . <http://www.isda.org/isda-cdm-2/>.
- The Licensor of the ISDA CDM is the International Swaps and
    Derivatives Association, Inc., 10 East 53rd Street, 9th Floor, New
    York, NY 10022, ATTN: Office of the General Counsel. All Rights
    Reserved.
    