package drr.projection.iso20022.esma.emir.refit.margin.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth108.esma.CollateralisationType3Code__1;
import iso20022.auth108.esma.MarginCollateralReport4__1;
import java.time.ZonedDateTime;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class MarginCollateralReport4__1Project_EsmaEmirMarginReportToIso20022TypeTabulator implements Tabulator<MarginCollateralReport4__1> {
	private final Field collPrtflCdField;
	private final Field collstnCtgyField;
	private final Field tmStmpField;
	
	private final CollateralPortfolioCode5Choice__1Project_EsmaEmirMarginReportToIso20022TypeTabulator collateralPortfolioCode5Choice__1Project_EsmaEmirMarginReportToIso20022TypeTabulator;
	
	@Inject
	public MarginCollateralReport4__1Project_EsmaEmirMarginReportToIso20022TypeTabulator(CollateralPortfolioCode5Choice__1Project_EsmaEmirMarginReportToIso20022TypeTabulator collateralPortfolioCode5Choice__1Project_EsmaEmirMarginReportToIso20022TypeTabulator) {
		this.collateralPortfolioCode5Choice__1Project_EsmaEmirMarginReportToIso20022TypeTabulator = collateralPortfolioCode5Choice__1Project_EsmaEmirMarginReportToIso20022TypeTabulator;
		this.collPrtflCdField = new FieldImpl(
			"collPrtflCd",
			false,
			Optional.empty(),
			Optional.empty(),
			collateralPortfolioCode5Choice__1Project_EsmaEmirMarginReportToIso20022TypeTabulator.getFields()
		);
		this.collstnCtgyField = new FieldImpl(
			"collstnCtgy",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.tmStmpField = new FieldImpl(
			"tmStmp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(collPrtflCdField, collstnCtgyField, tmStmpField);
	}
	
	@Override
	public List<FieldValue> tabulate(MarginCollateralReport4__1 input) {
		Optional<List<FieldValue>> collPrtflCd = Optional.ofNullable(input.getCollPrtflCd())
			.map(x -> collateralPortfolioCode5Choice__1Project_EsmaEmirMarginReportToIso20022TypeTabulator.tabulate(x));
		Optional<CollateralisationType3Code__1> collstnCtgy = Optional.ofNullable(input.getCollstnCtgy());
		Optional<ZonedDateTime> tmStmp = Optional.ofNullable(input.getTmStmp());
		return Arrays.asList(
			new NestedFieldValueImpl(collPrtflCdField, collPrtflCd),
			new FieldValueImpl(collstnCtgyField, collstnCtgy),
			new FieldValueImpl(tmStmpField, tmStmp)
		);
	}
}
