package drr.projection.iso20022.esma.emir.refit.margin.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth108.esma.NotApplicable1Code;
import iso20022.auth108.esma.PortfolioCode3Choice;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class PortfolioCode3ChoiceProject_EsmaEmirMarginReportToIso20022TypeTabulator implements Tabulator<PortfolioCode3Choice> {
	private final Field cdField;
	private final Field noPrtflField;
	
	public PortfolioCode3ChoiceProject_EsmaEmirMarginReportToIso20022TypeTabulator() {
		this.cdField = new FieldImpl(
			"cd",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.noPrtflField = new FieldImpl(
			"noPrtfl",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(cdField, noPrtflField);
	}
	
	@Override
	public List<FieldValue> tabulate(PortfolioCode3Choice input) {
		Optional<String> cd = Optional.ofNullable(input.getCd());
		Optional<NotApplicable1Code> noPrtfl = Optional.ofNullable(input.getNoPrtfl());
		return Arrays.asList(
			new FieldValueImpl(cdField, cd),
			new FieldValueImpl(noPrtflField, noPrtfl)
		);
	}
}
