package drr.projection.iso20022.esma.emir.refit.trade.functions;

import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.functions.ModelObjectValidator;
import com.rosetta.model.lib.functions.RosettaFunction;
import iso20022.auth030.esma.GenericIdentification175__1;
import iso20022.auth030.esma.NonFinancialInstitutionSector10__1;
import iso20022.auth030.esma.NonFinancialInstitutionSector10__1.NonFinancialInstitutionSector10__1Builder;
import java.util.Collections;
import java.util.Optional;
import javax.inject.Inject;


@ImplementedBy(Create_NonFinancialInstitutionSector10__1.Create_NonFinancialInstitutionSector10__1Default.class)
public abstract class Create_NonFinancialInstitutionSector10__1 implements RosettaFunction {
	
	@Inject protected ModelObjectValidator objectValidator;

	/**
	* @param corporateSectorOfCounterparty 
	* @param clearingThresholdOfCounterparty 
	* @param directlyLinkedToCommercialActivityOrTreasuryFinancing 
	* @return out 
	*/
	public NonFinancialInstitutionSector10__1 evaluate(String corporateSectorOfCounterparty, Boolean clearingThresholdOfCounterparty, Boolean directlyLinkedToCommercialActivityOrTreasuryFinancing) {
		NonFinancialInstitutionSector10__1.NonFinancialInstitutionSector10__1Builder outBuilder = doEvaluate(corporateSectorOfCounterparty, clearingThresholdOfCounterparty, directlyLinkedToCommercialActivityOrTreasuryFinancing);
		
		final NonFinancialInstitutionSector10__1 out;
		if (outBuilder == null) {
			out = null;
		} else {
			out = outBuilder.build();
			objectValidator.validate(NonFinancialInstitutionSector10__1.class, out);
		}
		
		return out;
	}

	protected abstract NonFinancialInstitutionSector10__1.NonFinancialInstitutionSector10__1Builder doEvaluate(String corporateSectorOfCounterparty, Boolean clearingThresholdOfCounterparty, Boolean directlyLinkedToCommercialActivityOrTreasuryFinancing);

	public static class Create_NonFinancialInstitutionSector10__1Default extends Create_NonFinancialInstitutionSector10__1 {
		@Override
		protected NonFinancialInstitutionSector10__1.NonFinancialInstitutionSector10__1Builder doEvaluate(String corporateSectorOfCounterparty, Boolean clearingThresholdOfCounterparty, Boolean directlyLinkedToCommercialActivityOrTreasuryFinancing) {
			NonFinancialInstitutionSector10__1.NonFinancialInstitutionSector10__1Builder out = NonFinancialInstitutionSector10__1.builder();
			return assignOutput(out, corporateSectorOfCounterparty, clearingThresholdOfCounterparty, directlyLinkedToCommercialActivityOrTreasuryFinancing);
		}
		
		protected NonFinancialInstitutionSector10__1.NonFinancialInstitutionSector10__1Builder assignOutput(NonFinancialInstitutionSector10__1.NonFinancialInstitutionSector10__1Builder out, String corporateSectorOfCounterparty, Boolean clearingThresholdOfCounterparty, Boolean directlyLinkedToCommercialActivityOrTreasuryFinancing) {
			final GenericIdentification175__1 genericIdentification175__1 = GenericIdentification175__1.builder()
				.setId(corporateSectorOfCounterparty)
				.build()
			;
			out = toBuilder(NonFinancialInstitutionSector10__1.builder()
				.setSctr((genericIdentification175__1 == null ? Collections.<GenericIdentification175__1>emptyList() : Collections.singletonList(genericIdentification175__1)))
				.setClrThrshld(clearingThresholdOfCounterparty)
				.setDrctlyLkdActvty(directlyLinkedToCommercialActivityOrTreasuryFinancing)
				.build()
			);
			
			return Optional.ofNullable(out)
				.map(o -> o.prune())
				.orElse(null);
		}
	}
}
