package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.AssetClassCommodityAgricultural6Choice;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class AssetClassCommodityAgricultural6ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<AssetClassCommodityAgricultural6Choice> {
	private final Field grnOilSeedField;
	private final Field softField;
	private final Field pttField;
	private final Field olvOilField;
	private final Field dairyField;
	private final Field frstryField;
	private final Field sfdField;
	private final Field liveStockField;
	private final Field grnField;
	private final Field othrField;
	
	private final AgriculturalCommodityOilSeed2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityOilSeed2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final AgriculturalCommoditySoft2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommoditySoft2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final AgriculturalCommodityPotato2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityPotato2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final AgriculturalCommodityOliveOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityOliveOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final AgriculturalCommodityDairy2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityDairy2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final AgriculturalCommodityForestry2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityForestry2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final AgriculturalCommoditySeafood2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommoditySeafood2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final AgriculturalCommodityLiveStock2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityLiveStock2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final AgriculturalCommodityGrain3Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityGrain3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final AgriculturalCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public AssetClassCommodityAgricultural6ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator(AgriculturalCommodityOilSeed2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityOilSeed2Project_EsmaEmirTradeReportToIso20022TypeTabulator, AgriculturalCommoditySoft2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommoditySoft2Project_EsmaEmirTradeReportToIso20022TypeTabulator, AgriculturalCommodityPotato2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityPotato2Project_EsmaEmirTradeReportToIso20022TypeTabulator, AgriculturalCommodityOliveOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityOliveOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator, AgriculturalCommodityDairy2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityDairy2Project_EsmaEmirTradeReportToIso20022TypeTabulator, AgriculturalCommodityForestry2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityForestry2Project_EsmaEmirTradeReportToIso20022TypeTabulator, AgriculturalCommoditySeafood2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommoditySeafood2Project_EsmaEmirTradeReportToIso20022TypeTabulator, AgriculturalCommodityLiveStock2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityLiveStock2Project_EsmaEmirTradeReportToIso20022TypeTabulator, AgriculturalCommodityGrain3Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityGrain3Project_EsmaEmirTradeReportToIso20022TypeTabulator, AgriculturalCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator agriculturalCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.agriculturalCommodityOilSeed2Project_EsmaEmirTradeReportToIso20022TypeTabulator = agriculturalCommodityOilSeed2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.agriculturalCommoditySoft2Project_EsmaEmirTradeReportToIso20022TypeTabulator = agriculturalCommoditySoft2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.agriculturalCommodityPotato2Project_EsmaEmirTradeReportToIso20022TypeTabulator = agriculturalCommodityPotato2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.agriculturalCommodityOliveOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator = agriculturalCommodityOliveOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.agriculturalCommodityDairy2Project_EsmaEmirTradeReportToIso20022TypeTabulator = agriculturalCommodityDairy2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.agriculturalCommodityForestry2Project_EsmaEmirTradeReportToIso20022TypeTabulator = agriculturalCommodityForestry2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.agriculturalCommoditySeafood2Project_EsmaEmirTradeReportToIso20022TypeTabulator = agriculturalCommoditySeafood2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.agriculturalCommodityLiveStock2Project_EsmaEmirTradeReportToIso20022TypeTabulator = agriculturalCommodityLiveStock2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.agriculturalCommodityGrain3Project_EsmaEmirTradeReportToIso20022TypeTabulator = agriculturalCommodityGrain3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.agriculturalCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator = agriculturalCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.grnOilSeedField = new FieldImpl(
			"grnOilSeed",
			false,
			Optional.empty(),
			Optional.empty(),
			agriculturalCommodityOilSeed2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.softField = new FieldImpl(
			"soft",
			false,
			Optional.empty(),
			Optional.empty(),
			agriculturalCommoditySoft2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.pttField = new FieldImpl(
			"ptt",
			false,
			Optional.empty(),
			Optional.empty(),
			agriculturalCommodityPotato2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.olvOilField = new FieldImpl(
			"olvOil",
			false,
			Optional.empty(),
			Optional.empty(),
			agriculturalCommodityOliveOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.dairyField = new FieldImpl(
			"dairy",
			false,
			Optional.empty(),
			Optional.empty(),
			agriculturalCommodityDairy2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.frstryField = new FieldImpl(
			"frstry",
			false,
			Optional.empty(),
			Optional.empty(),
			agriculturalCommodityForestry2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.sfdField = new FieldImpl(
			"sfd",
			false,
			Optional.empty(),
			Optional.empty(),
			agriculturalCommoditySeafood2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.liveStockField = new FieldImpl(
			"liveStock",
			false,
			Optional.empty(),
			Optional.empty(),
			agriculturalCommodityLiveStock2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.grnField = new FieldImpl(
			"grn",
			false,
			Optional.empty(),
			Optional.empty(),
			agriculturalCommodityGrain3Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.othrField = new FieldImpl(
			"othr",
			false,
			Optional.empty(),
			Optional.empty(),
			agriculturalCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(grnOilSeedField, softField, pttField, olvOilField, dairyField, frstryField, sfdField, liveStockField, grnField, othrField);
	}
	
	@Override
	public List<FieldValue> tabulate(AssetClassCommodityAgricultural6Choice input) {
		Optional<List<FieldValue>> grnOilSeed = Optional.ofNullable(input.getGrnOilSeed())
			.map(x -> agriculturalCommodityOilSeed2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> soft = Optional.ofNullable(input.getSoft())
			.map(x -> agriculturalCommoditySoft2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> ptt = Optional.ofNullable(input.getPtt())
			.map(x -> agriculturalCommodityPotato2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> olvOil = Optional.ofNullable(input.getOlvOil())
			.map(x -> agriculturalCommodityOliveOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> dairy = Optional.ofNullable(input.getDairy())
			.map(x -> agriculturalCommodityDairy2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> frstry = Optional.ofNullable(input.getFrstry())
			.map(x -> agriculturalCommodityForestry2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> sfd = Optional.ofNullable(input.getSfd())
			.map(x -> agriculturalCommoditySeafood2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> liveStock = Optional.ofNullable(input.getLiveStock())
			.map(x -> agriculturalCommodityLiveStock2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> grn = Optional.ofNullable(input.getGrn())
			.map(x -> agriculturalCommodityGrain3Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> othr = Optional.ofNullable(input.getOthr())
			.map(x -> agriculturalCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(grnOilSeedField, grnOilSeed),
			new NestedFieldValueImpl(softField, soft),
			new NestedFieldValueImpl(pttField, ptt),
			new NestedFieldValueImpl(olvOilField, olvOil),
			new NestedFieldValueImpl(dairyField, dairy),
			new NestedFieldValueImpl(frstryField, frstry),
			new NestedFieldValueImpl(sfdField, sfd),
			new NestedFieldValueImpl(liveStockField, liveStock),
			new NestedFieldValueImpl(grnField, grn),
			new NestedFieldValueImpl(othrField, othr)
		);
	}
}
