package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.AssetClassCommodityEnergy3Choice;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class AssetClassCommodityEnergy3ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<AssetClassCommodityEnergy3Choice> {
	private final Field elctrctyField;
	private final Field ntrlGasField;
	private final Field oilField;
	private final Field coalField;
	private final Field intrNrgyField;
	private final Field rnwblNrgyField;
	private final Field lghtEndField;
	private final Field dstlltsField;
	private final Field othrField;
	
	private final EnergyCommodityElectricity2Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityElectricity2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final EnergyCommodityNaturalGas3Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityNaturalGas3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final EnergyCommodityOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final EnergyCommodityCoal2Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityCoal2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final EnergyCommodityInterEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityInterEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final EnergyCommodityRenewableEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityRenewableEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final EnergyCommodityLightEnd2Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityLightEnd2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final EnergyCommodityDistillates2Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityDistillates2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final EnergyCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public AssetClassCommodityEnergy3ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator(EnergyCommodityElectricity2Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityElectricity2Project_EsmaEmirTradeReportToIso20022TypeTabulator, EnergyCommodityNaturalGas3Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityNaturalGas3Project_EsmaEmirTradeReportToIso20022TypeTabulator, EnergyCommodityOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator, EnergyCommodityCoal2Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityCoal2Project_EsmaEmirTradeReportToIso20022TypeTabulator, EnergyCommodityInterEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityInterEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator, EnergyCommodityRenewableEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityRenewableEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator, EnergyCommodityLightEnd2Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityLightEnd2Project_EsmaEmirTradeReportToIso20022TypeTabulator, EnergyCommodityDistillates2Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityDistillates2Project_EsmaEmirTradeReportToIso20022TypeTabulator, EnergyCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator energyCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.energyCommodityElectricity2Project_EsmaEmirTradeReportToIso20022TypeTabulator = energyCommodityElectricity2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.energyCommodityNaturalGas3Project_EsmaEmirTradeReportToIso20022TypeTabulator = energyCommodityNaturalGas3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.energyCommodityOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator = energyCommodityOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.energyCommodityCoal2Project_EsmaEmirTradeReportToIso20022TypeTabulator = energyCommodityCoal2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.energyCommodityInterEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator = energyCommodityInterEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.energyCommodityRenewableEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator = energyCommodityRenewableEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.energyCommodityLightEnd2Project_EsmaEmirTradeReportToIso20022TypeTabulator = energyCommodityLightEnd2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.energyCommodityDistillates2Project_EsmaEmirTradeReportToIso20022TypeTabulator = energyCommodityDistillates2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.energyCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator = energyCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.elctrctyField = new FieldImpl(
			"elctrcty",
			false,
			Optional.empty(),
			Optional.empty(),
			energyCommodityElectricity2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.ntrlGasField = new FieldImpl(
			"ntrlGas",
			false,
			Optional.empty(),
			Optional.empty(),
			energyCommodityNaturalGas3Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.oilField = new FieldImpl(
			"oil",
			false,
			Optional.empty(),
			Optional.empty(),
			energyCommodityOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.coalField = new FieldImpl(
			"coal",
			false,
			Optional.empty(),
			Optional.empty(),
			energyCommodityCoal2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.intrNrgyField = new FieldImpl(
			"intrNrgy",
			false,
			Optional.empty(),
			Optional.empty(),
			energyCommodityInterEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.rnwblNrgyField = new FieldImpl(
			"rnwblNrgy",
			false,
			Optional.empty(),
			Optional.empty(),
			energyCommodityRenewableEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.lghtEndField = new FieldImpl(
			"lghtEnd",
			false,
			Optional.empty(),
			Optional.empty(),
			energyCommodityLightEnd2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.dstlltsField = new FieldImpl(
			"dstllts",
			false,
			Optional.empty(),
			Optional.empty(),
			energyCommodityDistillates2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.othrField = new FieldImpl(
			"othr",
			false,
			Optional.empty(),
			Optional.empty(),
			energyCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(elctrctyField, ntrlGasField, oilField, coalField, intrNrgyField, rnwblNrgyField, lghtEndField, dstlltsField, othrField);
	}
	
	@Override
	public List<FieldValue> tabulate(AssetClassCommodityEnergy3Choice input) {
		Optional<List<FieldValue>> elctrcty = Optional.ofNullable(input.getElctrcty())
			.map(x -> energyCommodityElectricity2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> ntrlGas = Optional.ofNullable(input.getNtrlGas())
			.map(x -> energyCommodityNaturalGas3Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> oil = Optional.ofNullable(input.getOil())
			.map(x -> energyCommodityOil3Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> coal = Optional.ofNullable(input.getCoal())
			.map(x -> energyCommodityCoal2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> intrNrgy = Optional.ofNullable(input.getIntrNrgy())
			.map(x -> energyCommodityInterEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> rnwblNrgy = Optional.ofNullable(input.getRnwblNrgy())
			.map(x -> energyCommodityRenewableEnergy2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> lghtEnd = Optional.ofNullable(input.getLghtEnd())
			.map(x -> energyCommodityLightEnd2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> dstllts = Optional.ofNullable(input.getDstllts())
			.map(x -> energyCommodityDistillates2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> othr = Optional.ofNullable(input.getOthr())
			.map(x -> energyCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(elctrctyField, elctrcty),
			new NestedFieldValueImpl(ntrlGasField, ntrlGas),
			new NestedFieldValueImpl(oilField, oil),
			new NestedFieldValueImpl(coalField, coal),
			new NestedFieldValueImpl(intrNrgyField, intrNrgy),
			new NestedFieldValueImpl(rnwblNrgyField, rnwblNrgy),
			new NestedFieldValueImpl(lghtEndField, lghtEnd),
			new NestedFieldValueImpl(dstlltsField, dstllts),
			new NestedFieldValueImpl(othrField, othr)
		);
	}
}
