package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.AssetClassCommodityEnvironmental3Choice;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class AssetClassCommodityEnvironmental3ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<AssetClassCommodityEnvironmental3Choice> {
	private final Field emssnsField;
	private final Field wthrField;
	private final Field crbnRltdField;
	private final Field othrField;
	
	private final EnvironmentalCommodityEmission3Project_EsmaEmirTradeReportToIso20022TypeTabulator environmentalCommodityEmission3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final EnvironmentalCommodityWeather2Project_EsmaEmirTradeReportToIso20022TypeTabulator environmentalCommodityWeather2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final EnvironmentalCommodityCarbonRelated2Project_EsmaEmirTradeReportToIso20022TypeTabulator environmentalCommodityCarbonRelated2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final EnvironmentCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator environmentCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public AssetClassCommodityEnvironmental3ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator(EnvironmentalCommodityEmission3Project_EsmaEmirTradeReportToIso20022TypeTabulator environmentalCommodityEmission3Project_EsmaEmirTradeReportToIso20022TypeTabulator, EnvironmentalCommodityWeather2Project_EsmaEmirTradeReportToIso20022TypeTabulator environmentalCommodityWeather2Project_EsmaEmirTradeReportToIso20022TypeTabulator, EnvironmentalCommodityCarbonRelated2Project_EsmaEmirTradeReportToIso20022TypeTabulator environmentalCommodityCarbonRelated2Project_EsmaEmirTradeReportToIso20022TypeTabulator, EnvironmentCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator environmentCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.environmentalCommodityEmission3Project_EsmaEmirTradeReportToIso20022TypeTabulator = environmentalCommodityEmission3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.environmentalCommodityWeather2Project_EsmaEmirTradeReportToIso20022TypeTabulator = environmentalCommodityWeather2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.environmentalCommodityCarbonRelated2Project_EsmaEmirTradeReportToIso20022TypeTabulator = environmentalCommodityCarbonRelated2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.environmentCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator = environmentCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.emssnsField = new FieldImpl(
			"emssns",
			false,
			Optional.empty(),
			Optional.empty(),
			environmentalCommodityEmission3Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.wthrField = new FieldImpl(
			"wthr",
			false,
			Optional.empty(),
			Optional.empty(),
			environmentalCommodityWeather2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.crbnRltdField = new FieldImpl(
			"crbnRltd",
			false,
			Optional.empty(),
			Optional.empty(),
			environmentalCommodityCarbonRelated2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.othrField = new FieldImpl(
			"othr",
			false,
			Optional.empty(),
			Optional.empty(),
			environmentCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(emssnsField, wthrField, crbnRltdField, othrField);
	}
	
	@Override
	public List<FieldValue> tabulate(AssetClassCommodityEnvironmental3Choice input) {
		Optional<List<FieldValue>> emssns = Optional.ofNullable(input.getEmssns())
			.map(x -> environmentalCommodityEmission3Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> wthr = Optional.ofNullable(input.getWthr())
			.map(x -> environmentalCommodityWeather2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> crbnRltd = Optional.ofNullable(input.getCrbnRltd())
			.map(x -> environmentalCommodityCarbonRelated2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> othr = Optional.ofNullable(input.getOthr())
			.map(x -> environmentCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(emssnsField, emssns),
			new NestedFieldValueImpl(wthrField, wthr),
			new NestedFieldValueImpl(crbnRltdField, crbnRltd),
			new NestedFieldValueImpl(othrField, othr)
		);
	}
}
