package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.AssetClassCommodityFertilizer4Choice;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class AssetClassCommodityFertilizer4ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<AssetClassCommodityFertilizer4Choice> {
	private final Field ammnField;
	private final Field dmmnmPhsphtField;
	private final Field ptshField;
	private final Field slphrField;
	private final Field ureaField;
	private final Field ureaAndAmmnmNtrtField;
	private final Field othrField;
	
	private final FertilizerCommodityAmmonia2Project_EsmaEmirTradeReportToIso20022TypeTabulator fertilizerCommodityAmmonia2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final FertilizerCommodityDiammoniumPhosphate2Project_EsmaEmirTradeReportToIso20022TypeTabulator fertilizerCommodityDiammoniumPhosphate2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final FertilizerCommodityPotash2Project_EsmaEmirTradeReportToIso20022TypeTabulator fertilizerCommodityPotash2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final FertilizerCommoditySulphur2Project_EsmaEmirTradeReportToIso20022TypeTabulator fertilizerCommoditySulphur2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final FertilizerCommodityUrea2Project_EsmaEmirTradeReportToIso20022TypeTabulator fertilizerCommodityUrea2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final FertilizerCommodityUreaAndAmmoniumNitrate2Project_EsmaEmirTradeReportToIso20022TypeTabulator fertilizerCommodityUreaAndAmmoniumNitrate2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final FertilizerCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator fertilizerCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public AssetClassCommodityFertilizer4ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator(FertilizerCommodityAmmonia2Project_EsmaEmirTradeReportToIso20022TypeTabulator fertilizerCommodityAmmonia2Project_EsmaEmirTradeReportToIso20022TypeTabulator, FertilizerCommodityDiammoniumPhosphate2Project_EsmaEmirTradeReportToIso20022TypeTabulator fertilizerCommodityDiammoniumPhosphate2Project_EsmaEmirTradeReportToIso20022TypeTabulator, FertilizerCommodityPotash2Project_EsmaEmirTradeReportToIso20022TypeTabulator fertilizerCommodityPotash2Project_EsmaEmirTradeReportToIso20022TypeTabulator, FertilizerCommoditySulphur2Project_EsmaEmirTradeReportToIso20022TypeTabulator fertilizerCommoditySulphur2Project_EsmaEmirTradeReportToIso20022TypeTabulator, FertilizerCommodityUrea2Project_EsmaEmirTradeReportToIso20022TypeTabulator fertilizerCommodityUrea2Project_EsmaEmirTradeReportToIso20022TypeTabulator, FertilizerCommodityUreaAndAmmoniumNitrate2Project_EsmaEmirTradeReportToIso20022TypeTabulator fertilizerCommodityUreaAndAmmoniumNitrate2Project_EsmaEmirTradeReportToIso20022TypeTabulator, FertilizerCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator fertilizerCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.fertilizerCommodityAmmonia2Project_EsmaEmirTradeReportToIso20022TypeTabulator = fertilizerCommodityAmmonia2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.fertilizerCommodityDiammoniumPhosphate2Project_EsmaEmirTradeReportToIso20022TypeTabulator = fertilizerCommodityDiammoniumPhosphate2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.fertilizerCommodityPotash2Project_EsmaEmirTradeReportToIso20022TypeTabulator = fertilizerCommodityPotash2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.fertilizerCommoditySulphur2Project_EsmaEmirTradeReportToIso20022TypeTabulator = fertilizerCommoditySulphur2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.fertilizerCommodityUrea2Project_EsmaEmirTradeReportToIso20022TypeTabulator = fertilizerCommodityUrea2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.fertilizerCommodityUreaAndAmmoniumNitrate2Project_EsmaEmirTradeReportToIso20022TypeTabulator = fertilizerCommodityUreaAndAmmoniumNitrate2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.fertilizerCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator = fertilizerCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.ammnField = new FieldImpl(
			"ammn",
			false,
			Optional.empty(),
			Optional.empty(),
			fertilizerCommodityAmmonia2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.dmmnmPhsphtField = new FieldImpl(
			"dmmnmPhspht",
			false,
			Optional.empty(),
			Optional.empty(),
			fertilizerCommodityDiammoniumPhosphate2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.ptshField = new FieldImpl(
			"ptsh",
			false,
			Optional.empty(),
			Optional.empty(),
			fertilizerCommodityPotash2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.slphrField = new FieldImpl(
			"slphr",
			false,
			Optional.empty(),
			Optional.empty(),
			fertilizerCommoditySulphur2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.ureaField = new FieldImpl(
			"urea",
			false,
			Optional.empty(),
			Optional.empty(),
			fertilizerCommodityUrea2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.ureaAndAmmnmNtrtField = new FieldImpl(
			"ureaAndAmmnmNtrt",
			false,
			Optional.empty(),
			Optional.empty(),
			fertilizerCommodityUreaAndAmmoniumNitrate2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.othrField = new FieldImpl(
			"othr",
			false,
			Optional.empty(),
			Optional.empty(),
			fertilizerCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(ammnField, dmmnmPhsphtField, ptshField, slphrField, ureaField, ureaAndAmmnmNtrtField, othrField);
	}
	
	@Override
	public List<FieldValue> tabulate(AssetClassCommodityFertilizer4Choice input) {
		Optional<List<FieldValue>> ammn = Optional.ofNullable(input.getAmmn())
			.map(x -> fertilizerCommodityAmmonia2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> dmmnmPhspht = Optional.ofNullable(input.getDmmnmPhspht())
			.map(x -> fertilizerCommodityDiammoniumPhosphate2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> ptsh = Optional.ofNullable(input.getPtsh())
			.map(x -> fertilizerCommodityPotash2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> slphr = Optional.ofNullable(input.getSlphr())
			.map(x -> fertilizerCommoditySulphur2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> urea = Optional.ofNullable(input.getUrea())
			.map(x -> fertilizerCommodityUrea2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> ureaAndAmmnmNtrt = Optional.ofNullable(input.getUreaAndAmmnmNtrt())
			.map(x -> fertilizerCommodityUreaAndAmmoniumNitrate2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> othr = Optional.ofNullable(input.getOthr())
			.map(x -> fertilizerCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(ammnField, ammn),
			new NestedFieldValueImpl(dmmnmPhsphtField, dmmnmPhspht),
			new NestedFieldValueImpl(ptshField, ptsh),
			new NestedFieldValueImpl(slphrField, slphr),
			new NestedFieldValueImpl(ureaField, urea),
			new NestedFieldValueImpl(ureaAndAmmnmNtrtField, ureaAndAmmnmNtrt),
			new NestedFieldValueImpl(othrField, othr)
		);
	}
}
