package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.AssetClassCommodityFreight4Choice;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class AssetClassCommodityFreight4ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<AssetClassCommodityFreight4Choice> {
	private final Field dryField;
	private final Field wetField;
	private final Field cntnrShipField;
	private final Field othrField;
	
	private final FreightCommodityDry3Project_EsmaEmirTradeReportToIso20022TypeTabulator freightCommodityDry3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final FreightCommodityWet3Project_EsmaEmirTradeReportToIso20022TypeTabulator freightCommodityWet3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final FreightCommodityContainerShip2Project_EsmaEmirTradeReportToIso20022TypeTabulator freightCommodityContainerShip2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final FreightCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator freightCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public AssetClassCommodityFreight4ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator(FreightCommodityDry3Project_EsmaEmirTradeReportToIso20022TypeTabulator freightCommodityDry3Project_EsmaEmirTradeReportToIso20022TypeTabulator, FreightCommodityWet3Project_EsmaEmirTradeReportToIso20022TypeTabulator freightCommodityWet3Project_EsmaEmirTradeReportToIso20022TypeTabulator, FreightCommodityContainerShip2Project_EsmaEmirTradeReportToIso20022TypeTabulator freightCommodityContainerShip2Project_EsmaEmirTradeReportToIso20022TypeTabulator, FreightCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator freightCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.freightCommodityDry3Project_EsmaEmirTradeReportToIso20022TypeTabulator = freightCommodityDry3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.freightCommodityWet3Project_EsmaEmirTradeReportToIso20022TypeTabulator = freightCommodityWet3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.freightCommodityContainerShip2Project_EsmaEmirTradeReportToIso20022TypeTabulator = freightCommodityContainerShip2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.freightCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator = freightCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.dryField = new FieldImpl(
			"dry",
			false,
			Optional.empty(),
			Optional.empty(),
			freightCommodityDry3Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.wetField = new FieldImpl(
			"wet",
			false,
			Optional.empty(),
			Optional.empty(),
			freightCommodityWet3Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.cntnrShipField = new FieldImpl(
			"cntnrShip",
			false,
			Optional.empty(),
			Optional.empty(),
			freightCommodityContainerShip2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.othrField = new FieldImpl(
			"othr",
			false,
			Optional.empty(),
			Optional.empty(),
			freightCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(dryField, wetField, cntnrShipField, othrField);
	}
	
	@Override
	public List<FieldValue> tabulate(AssetClassCommodityFreight4Choice input) {
		Optional<List<FieldValue>> dry = Optional.ofNullable(input.getDry())
			.map(x -> freightCommodityDry3Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> wet = Optional.ofNullable(input.getWet())
			.map(x -> freightCommodityWet3Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> cntnrShip = Optional.ofNullable(input.getCntnrShip())
			.map(x -> freightCommodityContainerShip2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> othr = Optional.ofNullable(input.getOthr())
			.map(x -> freightCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(dryField, dry),
			new NestedFieldValueImpl(wetField, wet),
			new NestedFieldValueImpl(cntnrShipField, cntnrShip),
			new NestedFieldValueImpl(othrField, othr)
		);
	}
}
