package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.AssetClassCommodityIndustrialProduct2Choice;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class AssetClassCommodityIndustrialProduct2ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<AssetClassCommodityIndustrialProduct2Choice> {
	private final Field cnstrctnField;
	private final Field manfctgField;
	
	private final IndustrialProductCommodityConstruction2Project_EsmaEmirTradeReportToIso20022TypeTabulator industrialProductCommodityConstruction2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final IndustrialProductCommodityManufacturing2Project_EsmaEmirTradeReportToIso20022TypeTabulator industrialProductCommodityManufacturing2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public AssetClassCommodityIndustrialProduct2ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator(IndustrialProductCommodityConstruction2Project_EsmaEmirTradeReportToIso20022TypeTabulator industrialProductCommodityConstruction2Project_EsmaEmirTradeReportToIso20022TypeTabulator, IndustrialProductCommodityManufacturing2Project_EsmaEmirTradeReportToIso20022TypeTabulator industrialProductCommodityManufacturing2Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.industrialProductCommodityConstruction2Project_EsmaEmirTradeReportToIso20022TypeTabulator = industrialProductCommodityConstruction2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.industrialProductCommodityManufacturing2Project_EsmaEmirTradeReportToIso20022TypeTabulator = industrialProductCommodityManufacturing2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.cnstrctnField = new FieldImpl(
			"cnstrctn",
			false,
			Optional.empty(),
			Optional.empty(),
			industrialProductCommodityConstruction2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.manfctgField = new FieldImpl(
			"manfctg",
			false,
			Optional.empty(),
			Optional.empty(),
			industrialProductCommodityManufacturing2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(cnstrctnField, manfctgField);
	}
	
	@Override
	public List<FieldValue> tabulate(AssetClassCommodityIndustrialProduct2Choice input) {
		Optional<List<FieldValue>> cnstrctn = Optional.ofNullable(input.getCnstrctn())
			.map(x -> industrialProductCommodityConstruction2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> manfctg = Optional.ofNullable(input.getManfctg())
			.map(x -> industrialProductCommodityManufacturing2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(cnstrctnField, cnstrctn),
			new NestedFieldValueImpl(manfctgField, manfctg)
		);
	}
}
