package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.AssetClassCommodityMetal2Choice;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class AssetClassCommodityMetal2ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<AssetClassCommodityMetal2Choice> {
	private final Field nonPrcsField;
	private final Field prcsField;
	
	private final MetalCommodityNonPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator metalCommodityNonPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final MetalCommodityPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator metalCommodityPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public AssetClassCommodityMetal2ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator(MetalCommodityNonPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator metalCommodityNonPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator, MetalCommodityPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator metalCommodityPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.metalCommodityNonPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator = metalCommodityNonPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.metalCommodityPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator = metalCommodityPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.nonPrcsField = new FieldImpl(
			"nonPrcs",
			false,
			Optional.empty(),
			Optional.empty(),
			metalCommodityNonPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.prcsField = new FieldImpl(
			"prcs",
			false,
			Optional.empty(),
			Optional.empty(),
			metalCommodityPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(nonPrcsField, prcsField);
	}
	
	@Override
	public List<FieldValue> tabulate(AssetClassCommodityMetal2Choice input) {
		Optional<List<FieldValue>> nonPrcs = Optional.ofNullable(input.getNonPrcs())
			.map(x -> metalCommodityNonPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> prcs = Optional.ofNullable(input.getPrcs())
			.map(x -> metalCommodityPrecious2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(nonPrcsField, nonPrcs),
			new NestedFieldValueImpl(prcsField, prcs)
		);
	}
}
