package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.esma.AssetClassCommodityOther1;
import iso20022.auth030.esma.AssetClassProductType15Code;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class AssetClassCommodityOther1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<AssetClassCommodityOther1> {
	private final Field basePdctField;
	
	public AssetClassCommodityOther1Project_EsmaEmirTradeReportToIso20022TypeTabulator() {
		this.basePdctField = new FieldImpl(
			"basePdct",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(basePdctField);
	}
	
	@Override
	public List<FieldValue> tabulate(AssetClassCommodityOther1 input) {
		Optional<AssetClassProductType15Code> basePdct = Optional.ofNullable(input.getBasePdct());
		return Arrays.asList(
			new FieldValueImpl(basePdctField, basePdct)
		);
	}
}
