package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.AssetClassCommodityPaper4Choice;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class AssetClassCommodityPaper4ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<AssetClassCommodityPaper4Choice> {
	private final Field cntnrBrdField;
	private final Field nwsprntField;
	private final Field pulpField;
	private final Field rcvrdPprField;
	private final Field othrField;
	
	private final PaperCommodityContainerBoard2Project_EsmaEmirTradeReportToIso20022TypeTabulator paperCommodityContainerBoard2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final PaperCommodityNewsprint2Project_EsmaEmirTradeReportToIso20022TypeTabulator paperCommodityNewsprint2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final PaperCommodityPulp2Project_EsmaEmirTradeReportToIso20022TypeTabulator paperCommodityPulp2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final PaperCommodityOther1Project_EsmaEmirTradeReportToIso20022TypeTabulator paperCommodityOther1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public AssetClassCommodityPaper4ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator(PaperCommodityContainerBoard2Project_EsmaEmirTradeReportToIso20022TypeTabulator paperCommodityContainerBoard2Project_EsmaEmirTradeReportToIso20022TypeTabulator, PaperCommodityNewsprint2Project_EsmaEmirTradeReportToIso20022TypeTabulator paperCommodityNewsprint2Project_EsmaEmirTradeReportToIso20022TypeTabulator, PaperCommodityPulp2Project_EsmaEmirTradeReportToIso20022TypeTabulator paperCommodityPulp2Project_EsmaEmirTradeReportToIso20022TypeTabulator, PaperCommodityOther1Project_EsmaEmirTradeReportToIso20022TypeTabulator paperCommodityOther1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.paperCommodityContainerBoard2Project_EsmaEmirTradeReportToIso20022TypeTabulator = paperCommodityContainerBoard2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.paperCommodityNewsprint2Project_EsmaEmirTradeReportToIso20022TypeTabulator = paperCommodityNewsprint2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.paperCommodityPulp2Project_EsmaEmirTradeReportToIso20022TypeTabulator = paperCommodityPulp2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.paperCommodityOther1Project_EsmaEmirTradeReportToIso20022TypeTabulator = paperCommodityOther1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.cntnrBrdField = new FieldImpl(
			"cntnrBrd",
			false,
			Optional.empty(),
			Optional.empty(),
			paperCommodityContainerBoard2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.nwsprntField = new FieldImpl(
			"nwsprnt",
			false,
			Optional.empty(),
			Optional.empty(),
			paperCommodityNewsprint2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.pulpField = new FieldImpl(
			"pulp",
			false,
			Optional.empty(),
			Optional.empty(),
			paperCommodityPulp2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.rcvrdPprField = new FieldImpl(
			"rcvrdPpr",
			false,
			Optional.empty(),
			Optional.empty(),
			paperCommodityOther1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.othrField = new FieldImpl(
			"othr",
			false,
			Optional.empty(),
			Optional.empty(),
			paperCommodityOther1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(cntnrBrdField, nwsprntField, pulpField, rcvrdPprField, othrField);
	}
	
	@Override
	public List<FieldValue> tabulate(AssetClassCommodityPaper4Choice input) {
		Optional<List<FieldValue>> cntnrBrd = Optional.ofNullable(input.getCntnrBrd())
			.map(x -> paperCommodityContainerBoard2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> nwsprnt = Optional.ofNullable(input.getNwsprnt())
			.map(x -> paperCommodityNewsprint2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> pulp = Optional.ofNullable(input.getPulp())
			.map(x -> paperCommodityPulp2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> rcvrdPpr = Optional.ofNullable(input.getRcvrdPpr())
			.map(x -> paperCommodityOther1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> othr = Optional.ofNullable(input.getOthr())
			.map(x -> paperCommodityOther1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(cntnrBrdField, cntnrBrd),
			new NestedFieldValueImpl(nwsprntField, nwsprnt),
			new NestedFieldValueImpl(pulpField, pulp),
			new NestedFieldValueImpl(rcvrdPprField, rcvrdPpr),
			new NestedFieldValueImpl(othrField, othr)
		);
	}
}
