package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.AssetClassCommodityPolypropylene4Choice;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class AssetClassCommodityPolypropylene4ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<AssetClassCommodityPolypropylene4Choice> {
	private final Field plstcField;
	private final Field othrField;
	
	private final PolypropyleneCommodityPlastic2Project_EsmaEmirTradeReportToIso20022TypeTabulator polypropyleneCommodityPlastic2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final PolypropyleneCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator polypropyleneCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public AssetClassCommodityPolypropylene4ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator(PolypropyleneCommodityPlastic2Project_EsmaEmirTradeReportToIso20022TypeTabulator polypropyleneCommodityPlastic2Project_EsmaEmirTradeReportToIso20022TypeTabulator, PolypropyleneCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator polypropyleneCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.polypropyleneCommodityPlastic2Project_EsmaEmirTradeReportToIso20022TypeTabulator = polypropyleneCommodityPlastic2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.polypropyleneCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator = polypropyleneCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.plstcField = new FieldImpl(
			"plstc",
			false,
			Optional.empty(),
			Optional.empty(),
			polypropyleneCommodityPlastic2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.othrField = new FieldImpl(
			"othr",
			false,
			Optional.empty(),
			Optional.empty(),
			polypropyleneCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(plstcField, othrField);
	}
	
	@Override
	public List<FieldValue> tabulate(AssetClassCommodityPolypropylene4Choice input) {
		Optional<List<FieldValue>> plstc = Optional.ofNullable(input.getPlstc())
			.map(x -> polypropyleneCommodityPlastic2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> othr = Optional.ofNullable(input.getOthr())
			.map(x -> polypropyleneCommodityOther2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(plstcField, plstc),
			new NestedFieldValueImpl(othrField, othr)
		);
	}
}
