package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.ClearingPartyAndTime22__1;
import java.time.ZonedDateTime;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class ClearingPartyAndTime22__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<ClearingPartyAndTime22__1> {
	private final Field ccpField;
	private final Field clrDtTmField;
	
	private final OrganisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public ClearingPartyAndTime22__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(OrganisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.ccpField = new FieldImpl(
			"ccp",
			false,
			Optional.empty(),
			Optional.empty(),
			organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.clrDtTmField = new FieldImpl(
			"clrDtTm",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(ccpField, clrDtTmField);
	}
	
	@Override
	public List<FieldValue> tabulate(ClearingPartyAndTime22__1 input) {
		Optional<List<FieldValue>> ccp = Optional.ofNullable(input.getCcp())
			.map(x -> organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<ZonedDateTime> clrDtTm = Optional.ofNullable(input.getClrDtTm());
		return Arrays.asList(
			new NestedFieldValueImpl(ccpField, ccp),
			new FieldValueImpl(clrDtTmField, clrDtTm)
		);
	}
}
