package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.ContractType14__1;
import iso20022.auth030.esma.FinancialInstrumentContractType2Code;
import iso20022.auth030.esma.ProductType4Code__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class ContractType14__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<ContractType14__1> {
	private final Field ctrctTpField;
	private final Field asstClssField;
	private final Field pdctClssfctnField;
	private final Field pdctIdField;
	private final Field undrlygInstrmField;
	private final Field sttlmCcyField;
	private final Field sttlmCcyScndLegField;
	private final Field derivBasedOnCrptAsstField;
	
	private final SecurityIdentification46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator securityIdentification46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final SecurityIdentification41Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator securityIdentification41Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final CurrencyExchange23__1Project_EsmaEmirTradeReportToIso20022TypeTabulator currencyExchange23__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public ContractType14__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(SecurityIdentification46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator securityIdentification46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, SecurityIdentification41Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator securityIdentification41Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, CurrencyExchange23__1Project_EsmaEmirTradeReportToIso20022TypeTabulator currencyExchange23__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.securityIdentification46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = securityIdentification46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.securityIdentification41Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = securityIdentification41Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.currencyExchange23__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = currencyExchange23__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.ctrctTpField = new FieldImpl(
			"ctrctTp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.asstClssField = new FieldImpl(
			"asstClss",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.pdctClssfctnField = new FieldImpl(
			"pdctClssfctn",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.pdctIdField = new FieldImpl(
			"pdctId",
			false,
			Optional.empty(),
			Optional.empty(),
			securityIdentification46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.undrlygInstrmField = new FieldImpl(
			"undrlygInstrm",
			false,
			Optional.empty(),
			Optional.empty(),
			securityIdentification41Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.sttlmCcyField = new FieldImpl(
			"sttlmCcy",
			false,
			Optional.empty(),
			Optional.empty(),
			currencyExchange23__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.sttlmCcyScndLegField = new FieldImpl(
			"sttlmCcyScndLeg",
			false,
			Optional.empty(),
			Optional.empty(),
			currencyExchange23__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.derivBasedOnCrptAsstField = new FieldImpl(
			"derivBasedOnCrptAsst",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(ctrctTpField, asstClssField, pdctClssfctnField, pdctIdField, undrlygInstrmField, sttlmCcyField, sttlmCcyScndLegField, derivBasedOnCrptAsstField);
	}
	
	@Override
	public List<FieldValue> tabulate(ContractType14__1 input) {
		Optional<FinancialInstrumentContractType2Code> ctrctTp = Optional.ofNullable(input.getCtrctTp());
		Optional<ProductType4Code__1> asstClss = Optional.ofNullable(input.getAsstClss());
		Optional<String> pdctClssfctn = Optional.ofNullable(input.getPdctClssfctn());
		Optional<List<FieldValue>> pdctId = Optional.ofNullable(input.getPdctId())
			.map(x -> securityIdentification46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> undrlygInstrm = Optional.ofNullable(input.getUndrlygInstrm())
			.map(x -> securityIdentification41Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> sttlmCcy = Optional.ofNullable(input.getSttlmCcy())
			.map(x -> currencyExchange23__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> sttlmCcyScndLeg = Optional.ofNullable(input.getSttlmCcyScndLeg())
			.map(x -> currencyExchange23__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<Boolean> derivBasedOnCrptAsst = Optional.ofNullable(input.getDerivBasedOnCrptAsst());
		return Arrays.asList(
			new FieldValueImpl(ctrctTpField, ctrctTp),
			new FieldValueImpl(asstClssField, asstClss),
			new FieldValueImpl(pdctClssfctnField, pdctClssfctn),
			new NestedFieldValueImpl(pdctIdField, pdctId),
			new NestedFieldValueImpl(undrlygInstrmField, undrlygInstrm),
			new NestedFieldValueImpl(sttlmCcyField, sttlmCcy),
			new NestedFieldValueImpl(sttlmCcyScndLegField, sttlmCcyScndLeg),
			new FieldValueImpl(derivBasedOnCrptAsstField, derivBasedOnCrptAsst)
		);
	}
}
