package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.Counterparty46__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class Counterparty46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<Counterparty46__1> {
	private final Field idTpField;
	private final Field ntrField;
	private final Field rptgOblgtnField;
	
	private final PartyIdentification248Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator partyIdentification248Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final CounterpartyTradeNature15Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator counterpartyTradeNature15Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public Counterparty46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(PartyIdentification248Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator partyIdentification248Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator, CounterpartyTradeNature15Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator counterpartyTradeNature15Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.partyIdentification248Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator = partyIdentification248Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.counterpartyTradeNature15Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator = counterpartyTradeNature15Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.idTpField = new FieldImpl(
			"idTp",
			false,
			Optional.empty(),
			Optional.empty(),
			partyIdentification248Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.ntrField = new FieldImpl(
			"ntr",
			false,
			Optional.empty(),
			Optional.empty(),
			counterpartyTradeNature15Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.rptgOblgtnField = new FieldImpl(
			"rptgOblgtn",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(idTpField, ntrField, rptgOblgtnField);
	}
	
	@Override
	public List<FieldValue> tabulate(Counterparty46__1 input) {
		Optional<List<FieldValue>> idTp = Optional.ofNullable(input.getIdTp())
			.map(x -> partyIdentification248Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> ntr = Optional.ofNullable(input.getNtr())
			.map(x -> counterpartyTradeNature15Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<Boolean> rptgOblgtn = Optional.ofNullable(input.getRptgOblgtn());
		return Arrays.asList(
			new NestedFieldValueImpl(idTpField, idTp),
			new NestedFieldValueImpl(ntrField, ntr),
			new FieldValueImpl(rptgOblgtnField, rptgOblgtn)
		);
	}
}
