package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.CounterpartySpecificData36__2;
import java.time.ZonedDateTime;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class CounterpartySpecificData36__2Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<CounterpartySpecificData36__2> {
	private final Field ctrPtyField;
	private final Field rptgTmStmpField;
	
	private final TradeCounterpartyReport20__1Project_EsmaEmirTradeReportToIso20022TypeTabulator tradeCounterpartyReport20__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public CounterpartySpecificData36__2Project_EsmaEmirTradeReportToIso20022TypeTabulator(TradeCounterpartyReport20__1Project_EsmaEmirTradeReportToIso20022TypeTabulator tradeCounterpartyReport20__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.tradeCounterpartyReport20__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = tradeCounterpartyReport20__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.ctrPtyField = new FieldImpl(
			"ctrPty",
			false,
			Optional.empty(),
			Optional.empty(),
			tradeCounterpartyReport20__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.rptgTmStmpField = new FieldImpl(
			"rptgTmStmp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(ctrPtyField, rptgTmStmpField);
	}
	
	@Override
	public List<FieldValue> tabulate(CounterpartySpecificData36__2 input) {
		Optional<List<FieldValue>> ctrPty = Optional.ofNullable(input.getCtrPty())
			.map(x -> tradeCounterpartyReport20__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<ZonedDateTime> rptgTmStmp = Optional.ofNullable(input.getRptgTmStmp());
		return Arrays.asList(
			new NestedFieldValueImpl(ctrPtyField, ctrPty),
			new FieldValueImpl(rptgTmStmpField, rptgTmStmp)
		);
	}
}
