package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.CounterpartyTradeNature15Choice__2;
import iso20022.auth030.esma.NoReasonCode;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class CounterpartyTradeNature15Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<CounterpartyTradeNature15Choice__2> {
	private final Field fiField;
	private final Field nfiField;
	private final Field cntrlCntrPtyField;
	private final Field othrField;
	
	private final FinancialInstitutionSector1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator financialInstitutionSector1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final NonFinancialInstitutionSector10__2Project_EsmaEmirTradeReportToIso20022TypeTabulator nonFinancialInstitutionSector10__2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public CounterpartyTradeNature15Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator(FinancialInstitutionSector1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator financialInstitutionSector1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, NonFinancialInstitutionSector10__2Project_EsmaEmirTradeReportToIso20022TypeTabulator nonFinancialInstitutionSector10__2Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.financialInstitutionSector1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = financialInstitutionSector1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.nonFinancialInstitutionSector10__2Project_EsmaEmirTradeReportToIso20022TypeTabulator = nonFinancialInstitutionSector10__2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.fiField = new FieldImpl(
			"fi",
			false,
			Optional.empty(),
			Optional.empty(),
			financialInstitutionSector1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.nfiField = new FieldImpl(
			"nfi",
			false,
			Optional.empty(),
			Optional.empty(),
			nonFinancialInstitutionSector10__2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.cntrlCntrPtyField = new FieldImpl(
			"cntrlCntrPty",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.othrField = new FieldImpl(
			"othr",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(fiField, nfiField, cntrlCntrPtyField, othrField);
	}
	
	@Override
	public List<FieldValue> tabulate(CounterpartyTradeNature15Choice__2 input) {
		Optional<List<FieldValue>> fi = Optional.ofNullable(input.getFi())
			.map(x -> financialInstitutionSector1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> nfi = Optional.ofNullable(input.getNfi())
			.map(x -> nonFinancialInstitutionSector10__2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<NoReasonCode> cntrlCntrPty = Optional.ofNullable(input.getCntrlCntrPty());
		Optional<NoReasonCode> othr = Optional.ofNullable(input.getOthr());
		return Arrays.asList(
			new NestedFieldValueImpl(fiField, fi),
			new NestedFieldValueImpl(nfiField, nfi),
			new FieldValueImpl(cntrlCntrPtyField, cntrlCntrPty),
			new FieldValueImpl(othrField, othr)
		);
	}
}
