package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.CreditDerivative4__1;
import iso20022.auth030.esma.DebtInstrumentSeniorityType2Code;
import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class CreditDerivative4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<CreditDerivative4__1> {
	private final Field snrtyField;
	private final Field refPtyField;
	private final Field srsField;
	private final Field vrsnField;
	private final Field indxFctrField;
	private final Field trchField;
	
	private final DerivativePartyIdentification1ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator derivativePartyIdentification1ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final TrancheIndicator3ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator trancheIndicator3ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public CreditDerivative4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(DerivativePartyIdentification1ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator derivativePartyIdentification1ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator, TrancheIndicator3ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator trancheIndicator3ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.derivativePartyIdentification1ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator = derivativePartyIdentification1ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.trancheIndicator3ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator = trancheIndicator3ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.snrtyField = new FieldImpl(
			"snrty",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.refPtyField = new FieldImpl(
			"refPty",
			false,
			Optional.empty(),
			Optional.empty(),
			derivativePartyIdentification1ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.srsField = new FieldImpl(
			"srs",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.vrsnField = new FieldImpl(
			"vrsn",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.indxFctrField = new FieldImpl(
			"indxFctr",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.trchField = new FieldImpl(
			"trch",
			false,
			Optional.empty(),
			Optional.empty(),
			trancheIndicator3ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(snrtyField, refPtyField, srsField, vrsnField, indxFctrField, trchField);
	}
	
	@Override
	public List<FieldValue> tabulate(CreditDerivative4__1 input) {
		Optional<DebtInstrumentSeniorityType2Code> snrty = Optional.ofNullable(input.getSnrty());
		Optional<List<FieldValue>> refPty = Optional.ofNullable(input.getRefPty())
			.map(x -> derivativePartyIdentification1ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<Integer> srs = Optional.ofNullable(input.getSrs());
		Optional<Integer> vrsn = Optional.ofNullable(input.getVrsn());
		Optional<BigDecimal> indxFctr = Optional.ofNullable(input.getIndxFctr());
		Optional<List<FieldValue>> trch = Optional.ofNullable(input.getTrch())
			.map(x -> trancheIndicator3ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new FieldValueImpl(snrtyField, snrty),
			new NestedFieldValueImpl(refPtyField, refPty),
			new FieldValueImpl(srsField, srs),
			new FieldValueImpl(vrsnField, vrsn),
			new FieldValueImpl(indxFctrField, indxFctr),
			new NestedFieldValueImpl(trchField, trch)
		);
	}
}
