package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.esma.CurrencyExchange23__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class CurrencyExchange23__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<CurrencyExchange23__1> {
	private final Field ccyField;
	
	public CurrencyExchange23__1Project_EsmaEmirTradeReportToIso20022TypeTabulator() {
		this.ccyField = new FieldImpl(
			"ccy",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(ccyField);
	}
	
	@Override
	public List<FieldValue> tabulate(CurrencyExchange23__1 input) {
		Optional<String> ccy = Optional.ofNullable(input.getCcy());
		return Arrays.asList(
			new FieldValueImpl(ccyField, ccy)
		);
	}
}
