package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.MultiNestedFieldValueImpl;
import iso20022.auth030.esma.CustomBasket4__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;
import javax.inject.Inject;


public class CustomBasket4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<CustomBasket4__1> {
	private final Field strrField;
	private final Field idField;
	private final Field cnsttntsField;
	
	private final BasketConstituents3__1Project_EsmaEmirTradeReportToIso20022TypeTabulator basketConstituents3__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public CustomBasket4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(BasketConstituents3__1Project_EsmaEmirTradeReportToIso20022TypeTabulator basketConstituents3__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.basketConstituents3__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = basketConstituents3__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.strrField = new FieldImpl(
			"strr",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.idField = new FieldImpl(
			"id",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.cnsttntsField = new FieldImpl(
			"cnsttnts",
			true,
			Optional.empty(),
			Optional.empty(),
			basketConstituents3__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(strrField, idField, cnsttntsField);
	}
	
	@Override
	public List<FieldValue> tabulate(CustomBasket4__1 input) {
		Optional<String> strr = Optional.ofNullable(input.getStrr());
		Optional<String> id = Optional.ofNullable(input.getId());
		Optional<List<List<FieldValue>>> cnsttnts = Optional.ofNullable(input.getCnsttnts())
			.map(x -> x.stream()
				.map(_x -> basketConstituents3__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(_x))
				.collect(Collectors.toList()));
		return Arrays.asList(
			new FieldValueImpl(strrField, strr),
			new FieldValueImpl(idField, id),
			new MultiNestedFieldValueImpl(cnsttntsField, cnsttnts)
		);
	}
}
