package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.records.Date;
import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.esma.DateAndDateTime2Choice__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class DateAndDateTime2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<DateAndDateTime2Choice__1> {
	private final Field dtField;
	
	public DateAndDateTime2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator() {
		this.dtField = new FieldImpl(
			"dt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(dtField);
	}
	
	@Override
	public List<FieldValue> tabulate(DateAndDateTime2Choice__1 input) {
		Optional<Date> dt = Optional.ofNullable(input.getDt());
		return Arrays.asList(
			new FieldValueImpl(dtField, dt)
		);
	}
}
