package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.records.Date;
import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.esma.DatePeriod1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class DatePeriod1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<DatePeriod1> {
	private final Field frDtField;
	private final Field toDtField;
	
	public DatePeriod1Project_EsmaEmirTradeReportToIso20022TypeTabulator() {
		this.frDtField = new FieldImpl(
			"frDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.toDtField = new FieldImpl(
			"toDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(frDtField, toDtField);
	}
	
	@Override
	public List<FieldValue> tabulate(DatePeriod1 input) {
		Optional<Date> frDt = Optional.ofNullable(input.getFrDt());
		Optional<Date> toDt = Optional.ofNullable(input.getToDt());
		return Arrays.asList(
			new FieldValueImpl(frDtField, frDt),
			new FieldValueImpl(toDtField, toDt)
		);
	}
}
