package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.DerivativesTradeReportV03;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class DerivativesTradeReportV03Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<DerivativesTradeReportV03> {
	private final Field rptHdrField;
	private final Field tradDataField;
	
	private final TradeReportHeader4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator tradeReportHeader4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final TradeData57Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator tradeData57Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public DerivativesTradeReportV03Project_EsmaEmirTradeReportToIso20022TypeTabulator(TradeReportHeader4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator tradeReportHeader4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, TradeData57Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator tradeData57Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.tradeReportHeader4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = tradeReportHeader4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.tradeData57Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = tradeData57Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.rptHdrField = new FieldImpl(
			"rptHdr",
			false,
			Optional.empty(),
			Optional.empty(),
			tradeReportHeader4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.tradDataField = new FieldImpl(
			"tradData",
			false,
			Optional.empty(),
			Optional.empty(),
			tradeData57Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(rptHdrField, tradDataField);
	}
	
	@Override
	public List<FieldValue> tabulate(DerivativesTradeReportV03 input) {
		Optional<List<FieldValue>> rptHdr = Optional.ofNullable(input.getRptHdr())
			.map(x -> tradeReportHeader4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> tradData = Optional.ofNullable(input.getTradData())
			.map(x -> tradeData57Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(rptHdrField, rptHdr),
			new NestedFieldValueImpl(tradDataField, tradData)
		);
	}
}
