package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.Document;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class DocumentProject_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<Document> {
	private final Field derivsTradRptField;
	
	private final DerivativesTradeReportV03Project_EsmaEmirTradeReportToIso20022TypeTabulator derivativesTradeReportV03Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public DocumentProject_EsmaEmirTradeReportToIso20022TypeTabulator(DerivativesTradeReportV03Project_EsmaEmirTradeReportToIso20022TypeTabulator derivativesTradeReportV03Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.derivativesTradeReportV03Project_EsmaEmirTradeReportToIso20022TypeTabulator = derivativesTradeReportV03Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.derivsTradRptField = new FieldImpl(
			"derivsTradRpt",
			false,
			Optional.empty(),
			Optional.empty(),
			derivativesTradeReportV03Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(derivsTradRptField);
	}
	
	@Override
	public List<FieldValue> tabulate(Document input) {
		Optional<List<FieldValue>> derivsTradRpt = Optional.ofNullable(input.getDerivsTradRpt())
			.map(x -> derivativesTradeReportV03Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(derivsTradRptField, derivsTradRpt)
		);
	}
}
