package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.esma.AssetClassDetailedSubProductType31Code;
import iso20022.auth030.esma.AssetClassProductType2Code;
import iso20022.auth030.esma.AssetClassSubProductType7Code;
import iso20022.auth030.esma.EnergyCommodityNaturalGas3;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class EnergyCommodityNaturalGas3Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<EnergyCommodityNaturalGas3> {
	private final Field basePdctField;
	private final Field subPdctField;
	private final Field addtlSubPdctField;
	
	public EnergyCommodityNaturalGas3Project_EsmaEmirTradeReportToIso20022TypeTabulator() {
		this.basePdctField = new FieldImpl(
			"basePdct",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.subPdctField = new FieldImpl(
			"subPdct",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.addtlSubPdctField = new FieldImpl(
			"addtlSubPdct",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(basePdctField, subPdctField, addtlSubPdctField);
	}
	
	@Override
	public List<FieldValue> tabulate(EnergyCommodityNaturalGas3 input) {
		Optional<AssetClassProductType2Code> basePdct = Optional.ofNullable(input.getBasePdct());
		Optional<AssetClassSubProductType7Code> subPdct = Optional.ofNullable(input.getSubPdct());
		Optional<AssetClassDetailedSubProductType31Code> addtlSubPdct = Optional.ofNullable(input.getAddtlSubPdct());
		return Arrays.asList(
			new FieldValueImpl(basePdctField, basePdct),
			new FieldValueImpl(subPdctField, subPdct),
			new FieldValueImpl(addtlSubPdctField, addtlSubPdct)
		);
	}
}
