package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.MultiNestedFieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.DurationType1Code;
import iso20022.auth030.esma.EnergyDeliveryAttribute10__1;
import iso20022.auth030.esma.WeekDay3Code__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;
import javax.inject.Inject;


public class EnergyDeliveryAttribute10__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<EnergyDeliveryAttribute10__1> {
	private final Field dlvryIntrvlField;
	private final Field dlvryDtField;
	private final Field drtnField;
	private final Field wkDayField;
	private final Field dlvryCpctyField;
	private final Field qtyUnitField;
	private final Field pricTmIntrvlQtyField;
	
	private final TimePeriodDetails1Project_EsmaEmirTradeReportToIso20022TypeTabulator timePeriodDetails1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final DatePeriod1Project_EsmaEmirTradeReportToIso20022TypeTabulator datePeriod1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final Quantity47Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator quantity47Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final EnergyQuantityUnit2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator energyQuantityUnit2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final AmountAndDirection106__3Project_EsmaEmirTradeReportToIso20022TypeTabulator amountAndDirection106__3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public EnergyDeliveryAttribute10__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(TimePeriodDetails1Project_EsmaEmirTradeReportToIso20022TypeTabulator timePeriodDetails1Project_EsmaEmirTradeReportToIso20022TypeTabulator, DatePeriod1Project_EsmaEmirTradeReportToIso20022TypeTabulator datePeriod1Project_EsmaEmirTradeReportToIso20022TypeTabulator, Quantity47Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator quantity47Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, EnergyQuantityUnit2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator energyQuantityUnit2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, AmountAndDirection106__3Project_EsmaEmirTradeReportToIso20022TypeTabulator amountAndDirection106__3Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.timePeriodDetails1Project_EsmaEmirTradeReportToIso20022TypeTabulator = timePeriodDetails1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.datePeriod1Project_EsmaEmirTradeReportToIso20022TypeTabulator = datePeriod1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.quantity47Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = quantity47Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.energyQuantityUnit2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = energyQuantityUnit2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.amountAndDirection106__3Project_EsmaEmirTradeReportToIso20022TypeTabulator = amountAndDirection106__3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.dlvryIntrvlField = new FieldImpl(
			"dlvryIntrvl",
			true,
			Optional.empty(),
			Optional.empty(),
			timePeriodDetails1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.dlvryDtField = new FieldImpl(
			"dlvryDt",
			false,
			Optional.empty(),
			Optional.empty(),
			datePeriod1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.drtnField = new FieldImpl(
			"drtn",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.wkDayField = new FieldImpl(
			"wkDay",
			true,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.dlvryCpctyField = new FieldImpl(
			"dlvryCpcty",
			false,
			Optional.empty(),
			Optional.empty(),
			quantity47Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.qtyUnitField = new FieldImpl(
			"qtyUnit",
			false,
			Optional.empty(),
			Optional.empty(),
			energyQuantityUnit2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.pricTmIntrvlQtyField = new FieldImpl(
			"pricTmIntrvlQty",
			false,
			Optional.empty(),
			Optional.empty(),
			amountAndDirection106__3Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(dlvryIntrvlField, dlvryDtField, drtnField, wkDayField, dlvryCpctyField, qtyUnitField, pricTmIntrvlQtyField);
	}
	
	@Override
	public List<FieldValue> tabulate(EnergyDeliveryAttribute10__1 input) {
		Optional<List<List<FieldValue>>> dlvryIntrvl = Optional.ofNullable(input.getDlvryIntrvl())
			.map(x -> x.stream()
				.map(_x -> timePeriodDetails1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(_x))
				.collect(Collectors.toList()));
		Optional<List<FieldValue>> dlvryDt = Optional.ofNullable(input.getDlvryDt())
			.map(x -> datePeriod1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<DurationType1Code> drtn = Optional.ofNullable(input.getDrtn());
		Optional<List<? extends WeekDay3Code__1>> wkDay = Optional.ofNullable(input.getWkDay());
		Optional<List<FieldValue>> dlvryCpcty = Optional.ofNullable(input.getDlvryCpcty())
			.map(x -> quantity47Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> qtyUnit = Optional.ofNullable(input.getQtyUnit())
			.map(x -> energyQuantityUnit2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> pricTmIntrvlQty = Optional.ofNullable(input.getPricTmIntrvlQty())
			.map(x -> amountAndDirection106__3Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new MultiNestedFieldValueImpl(dlvryIntrvlField, dlvryIntrvl),
			new NestedFieldValueImpl(dlvryDtField, dlvryDt),
			new FieldValueImpl(drtnField, drtn),
			new FieldValueImpl(wkDayField, wkDay),
			new NestedFieldValueImpl(dlvryCpctyField, dlvryCpcty),
			new NestedFieldValueImpl(qtyUnitField, qtyUnit),
			new NestedFieldValueImpl(pricTmIntrvlQtyField, pricTmIntrvlQty)
		);
	}
}
