package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.MultiNestedFieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.EnergyLoadType1Code;
import iso20022.auth030.esma.EnergySpecificAttribute9__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;
import javax.inject.Inject;


public class EnergySpecificAttribute9__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<EnergySpecificAttribute9__1> {
	private final Field dlvryPtOrZoneField;
	private final Field intrCnnctnPtField;
	private final Field ldTpField;
	private final Field dlvryAttrField;
	
	private final DeliveryInterconnectionPoint1Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator deliveryInterconnectionPoint1Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final EnergyDeliveryAttribute10__1Project_EsmaEmirTradeReportToIso20022TypeTabulator energyDeliveryAttribute10__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public EnergySpecificAttribute9__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(DeliveryInterconnectionPoint1Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator deliveryInterconnectionPoint1Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, EnergyDeliveryAttribute10__1Project_EsmaEmirTradeReportToIso20022TypeTabulator energyDeliveryAttribute10__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.deliveryInterconnectionPoint1Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = deliveryInterconnectionPoint1Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.energyDeliveryAttribute10__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = energyDeliveryAttribute10__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.dlvryPtOrZoneField = new FieldImpl(
			"dlvryPtOrZone",
			true,
			Optional.empty(),
			Optional.empty(),
			deliveryInterconnectionPoint1Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.intrCnnctnPtField = new FieldImpl(
			"intrCnnctnPt",
			false,
			Optional.empty(),
			Optional.empty(),
			deliveryInterconnectionPoint1Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.ldTpField = new FieldImpl(
			"ldTp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.dlvryAttrField = new FieldImpl(
			"dlvryAttr",
			true,
			Optional.empty(),
			Optional.empty(),
			energyDeliveryAttribute10__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(dlvryPtOrZoneField, intrCnnctnPtField, ldTpField, dlvryAttrField);
	}
	
	@Override
	public List<FieldValue> tabulate(EnergySpecificAttribute9__1 input) {
		Optional<List<List<FieldValue>>> dlvryPtOrZone = Optional.ofNullable(input.getDlvryPtOrZone())
			.map(x -> x.stream()
				.map(_x -> deliveryInterconnectionPoint1Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(_x))
				.collect(Collectors.toList()));
		Optional<List<FieldValue>> intrCnnctnPt = Optional.ofNullable(input.getIntrCnnctnPt())
			.map(x -> deliveryInterconnectionPoint1Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<EnergyLoadType1Code> ldTp = Optional.ofNullable(input.getLdTp());
		Optional<List<List<FieldValue>>> dlvryAttr = Optional.ofNullable(input.getDlvryAttr())
			.map(x -> x.stream()
				.map(_x -> energyDeliveryAttribute10__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(_x))
				.collect(Collectors.toList()));
		return Arrays.asList(
			new MultiNestedFieldValueImpl(dlvryPtOrZoneField, dlvryPtOrZone),
			new NestedFieldValueImpl(intrCnnctnPtField, intrCnnctnPt),
			new FieldValueImpl(ldTpField, ldTp),
			new MultiNestedFieldValueImpl(dlvryAttrField, dlvryAttr)
		);
	}
}
