package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.esma.AssetClassProductType5Code;
import iso20022.auth030.esma.AssetClassSubProductType39Code;
import iso20022.auth030.esma.FertilizerCommodityAmmonia2;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class FertilizerCommodityAmmonia2Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<FertilizerCommodityAmmonia2> {
	private final Field basePdctField;
	private final Field subPdctField;
	
	public FertilizerCommodityAmmonia2Project_EsmaEmirTradeReportToIso20022TypeTabulator() {
		this.basePdctField = new FieldImpl(
			"basePdct",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.subPdctField = new FieldImpl(
			"subPdct",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(basePdctField, subPdctField);
	}
	
	@Override
	public List<FieldValue> tabulate(FertilizerCommodityAmmonia2 input) {
		Optional<AssetClassProductType5Code> basePdct = Optional.ofNullable(input.getBasePdct());
		Optional<AssetClassSubProductType39Code> subPdct = Optional.ofNullable(input.getSubPdct());
		return Arrays.asList(
			new FieldValueImpl(basePdctField, basePdct),
			new FieldValueImpl(subPdctField, subPdct)
		);
	}
}
