package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.MasterAgreement8__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class MasterAgreement8__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<MasterAgreement8__1> {
	private final Field tpField;
	private final Field vrsnField;
	private final Field othrMstrAgrmtDtlsField;
	
	private final AgreementType2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator agreementType2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public MasterAgreement8__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(AgreementType2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator agreementType2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.agreementType2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = agreementType2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.tpField = new FieldImpl(
			"tp",
			false,
			Optional.empty(),
			Optional.empty(),
			agreementType2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.vrsnField = new FieldImpl(
			"vrsn",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.othrMstrAgrmtDtlsField = new FieldImpl(
			"othrMstrAgrmtDtls",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(tpField, vrsnField, othrMstrAgrmtDtlsField);
	}
	
	@Override
	public List<FieldValue> tabulate(MasterAgreement8__1 input) {
		Optional<List<FieldValue>> tp = Optional.ofNullable(input.getTp())
			.map(x -> agreementType2Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<Integer> vrsn = Optional.ofNullable(input.getVrsn());
		Optional<String> othrMstrAgrmtDtls = Optional.ofNullable(input.getOthrMstrAgrmtDtls());
		return Arrays.asList(
			new NestedFieldValueImpl(tpField, tp),
			new FieldValueImpl(vrsnField, vrsn),
			new FieldValueImpl(othrMstrAgrmtDtlsField, othrMstrAgrmtDtls)
		);
	}
}
