package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.MultiNestedFieldValueImpl;
import iso20022.auth030.esma.NonFinancialInstitutionSector10__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;
import javax.inject.Inject;


public class NonFinancialInstitutionSector10__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<NonFinancialInstitutionSector10__1> {
	private final Field sctrField;
	private final Field clrThrshldField;
	private final Field drctlyLkdActvtyField;
	
	private final GenericIdentification175__1Project_EsmaEmirTradeReportToIso20022TypeTabulator genericIdentification175__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public NonFinancialInstitutionSector10__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(GenericIdentification175__1Project_EsmaEmirTradeReportToIso20022TypeTabulator genericIdentification175__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.genericIdentification175__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = genericIdentification175__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.sctrField = new FieldImpl(
			"sctr",
			true,
			Optional.empty(),
			Optional.empty(),
			genericIdentification175__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.clrThrshldField = new FieldImpl(
			"clrThrshld",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.drctlyLkdActvtyField = new FieldImpl(
			"drctlyLkdActvty",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(sctrField, clrThrshldField, drctlyLkdActvtyField);
	}
	
	@Override
	public List<FieldValue> tabulate(NonFinancialInstitutionSector10__1 input) {
		Optional<List<List<FieldValue>>> sctr = Optional.ofNullable(input.getSctr())
			.map(x -> x.stream()
				.map(_x -> genericIdentification175__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(_x))
				.collect(Collectors.toList()));
		Optional<Boolean> clrThrshld = Optional.ofNullable(input.getClrThrshld());
		Optional<Boolean> drctlyLkdActvty = Optional.ofNullable(input.getDrctlyLkdActvty());
		return Arrays.asList(
			new MultiNestedFieldValueImpl(sctrField, sctr),
			new FieldValueImpl(clrThrshldField, clrThrshld),
			new FieldValueImpl(drctlyLkdActvtyField, drctlyLkdActvty)
		);
	}
}
