package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.records.Date;
import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.MultiNestedFieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.OptionOrSwaption10__1;
import iso20022.auth030.esma.OptionStyle6Code__1;
import iso20022.auth030.esma.OptionType2Code;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;
import javax.inject.Inject;


public class OptionOrSwaption10__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<OptionOrSwaption10__1> {
	private final Field tpField;
	private final Field exrcStyleField;
	private final Field strkPricField;
	private final Field strkPricSchdlField;
	private final Field prmAmtField;
	private final Field prmPmtDtField;
	private final Field mtrtyDtOfUndrlygField;
	
	private final SecuritiesTransactionPrice17Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator securitiesTransactionPrice17Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final Schedule4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator schedule4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final ActiveOrHistoricCurrencyAnd5DecimalAmount__1Project_EsmaEmirTradeReportToIso20022TypeTabulator activeOrHistoricCurrencyAnd5DecimalAmount__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public OptionOrSwaption10__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(SecuritiesTransactionPrice17Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator securitiesTransactionPrice17Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, Schedule4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator schedule4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, ActiveOrHistoricCurrencyAnd5DecimalAmount__1Project_EsmaEmirTradeReportToIso20022TypeTabulator activeOrHistoricCurrencyAnd5DecimalAmount__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.securitiesTransactionPrice17Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = securitiesTransactionPrice17Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.schedule4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = schedule4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.activeOrHistoricCurrencyAnd5DecimalAmount__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = activeOrHistoricCurrencyAnd5DecimalAmount__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.tpField = new FieldImpl(
			"tp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.exrcStyleField = new FieldImpl(
			"exrcStyle",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.strkPricField = new FieldImpl(
			"strkPric",
			false,
			Optional.empty(),
			Optional.empty(),
			securitiesTransactionPrice17Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.strkPricSchdlField = new FieldImpl(
			"strkPricSchdl",
			true,
			Optional.empty(),
			Optional.empty(),
			schedule4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.prmAmtField = new FieldImpl(
			"prmAmt",
			false,
			Optional.empty(),
			Optional.empty(),
			activeOrHistoricCurrencyAnd5DecimalAmount__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.prmPmtDtField = new FieldImpl(
			"prmPmtDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.mtrtyDtOfUndrlygField = new FieldImpl(
			"mtrtyDtOfUndrlyg",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(tpField, exrcStyleField, strkPricField, strkPricSchdlField, prmAmtField, prmPmtDtField, mtrtyDtOfUndrlygField);
	}
	
	@Override
	public List<FieldValue> tabulate(OptionOrSwaption10__1 input) {
		Optional<OptionType2Code> tp = Optional.ofNullable(input.getTp());
		Optional<OptionStyle6Code__1> exrcStyle = Optional.ofNullable(input.getExrcStyle());
		Optional<List<FieldValue>> strkPric = Optional.ofNullable(input.getStrkPric())
			.map(x -> securitiesTransactionPrice17Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<List<FieldValue>>> strkPricSchdl = Optional.ofNullable(input.getStrkPricSchdl())
			.map(x -> x.stream()
				.map(_x -> schedule4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(_x))
				.collect(Collectors.toList()));
		Optional<List<FieldValue>> prmAmt = Optional.ofNullable(input.getPrmAmt())
			.map(x -> activeOrHistoricCurrencyAnd5DecimalAmount__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<Date> prmPmtDt = Optional.ofNullable(input.getPrmPmtDt());
		Optional<Date> mtrtyDtOfUndrlyg = Optional.ofNullable(input.getMtrtyDtOfUndrlyg());
		return Arrays.asList(
			new FieldValueImpl(tpField, tp),
			new FieldValueImpl(exrcStyleField, exrcStyle),
			new NestedFieldValueImpl(strkPricField, strkPric),
			new MultiNestedFieldValueImpl(strkPricSchdlField, strkPricSchdl),
			new NestedFieldValueImpl(prmAmtField, prmAmt),
			new FieldValueImpl(prmPmtDtField, prmPmtDt),
			new FieldValueImpl(mtrtyDtOfUndrlygField, mtrtyDtOfUndrlyg)
		);
	}
}
