package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.PTRREvent2__1;
import iso20022.auth030.esma.RiskReductionService1Code__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class PTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<PTRREvent2__1> {
	private final Field tchnqField;
	private final Field svcPrvdrField;
	
	private final OrganisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public PTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(OrganisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.tchnqField = new FieldImpl(
			"tchnq",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.svcPrvdrField = new FieldImpl(
			"svcPrvdr",
			false,
			Optional.empty(),
			Optional.empty(),
			organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(tchnqField, svcPrvdrField);
	}
	
	@Override
	public List<FieldValue> tabulate(PTRREvent2__1 input) {
		Optional<RiskReductionService1Code__1> tchnq = Optional.ofNullable(input.getTchnq());
		Optional<List<FieldValue>> svcPrvdr = Optional.ofNullable(input.getSvcPrvdr())
			.map(x -> organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new FieldValueImpl(tchnqField, tchnq),
			new NestedFieldValueImpl(svcPrvdrField, svcPrvdr)
		);
	}
}
