package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.Package4__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class Package4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<Package4__1> {
	private final Field cmplxTradIdField;
	private final Field pricField;
	private final Field sprdField;
	
	private final SecuritiesTransactionPrice17Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator securitiesTransactionPrice17Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final SecuritiesTransactionPrice20Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator securitiesTransactionPrice20Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public Package4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(SecuritiesTransactionPrice17Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator securitiesTransactionPrice17Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator, SecuritiesTransactionPrice20Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator securitiesTransactionPrice20Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.securitiesTransactionPrice17Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator = securitiesTransactionPrice17Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.securitiesTransactionPrice20Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = securitiesTransactionPrice20Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.cmplxTradIdField = new FieldImpl(
			"cmplxTradId",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.pricField = new FieldImpl(
			"pric",
			false,
			Optional.empty(),
			Optional.empty(),
			securitiesTransactionPrice17Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.sprdField = new FieldImpl(
			"sprd",
			false,
			Optional.empty(),
			Optional.empty(),
			securitiesTransactionPrice20Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(cmplxTradIdField, pricField, sprdField);
	}
	
	@Override
	public List<FieldValue> tabulate(Package4__1 input) {
		Optional<String> cmplxTradId = Optional.ofNullable(input.getCmplxTradId());
		Optional<List<FieldValue>> pric = Optional.ofNullable(input.getPric())
			.map(x -> securitiesTransactionPrice17Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> sprd = Optional.ofNullable(input.getSprd())
			.map(x -> securitiesTransactionPrice20Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new FieldValueImpl(cmplxTradIdField, cmplxTradId),
			new NestedFieldValueImpl(pricField, pric),
			new NestedFieldValueImpl(sprdField, sprd)
		);
	}
}
