package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.records.Date;
import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.Schedule11__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class Schedule11__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<Schedule11__1> {
	private final Field uadjstdFctvDtField;
	private final Field uadjstdEndDtField;
	private final Field amtField;
	
	private final AmountAndDirection106__2Project_EsmaEmirTradeReportToIso20022TypeTabulator amountAndDirection106__2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public Schedule11__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(AmountAndDirection106__2Project_EsmaEmirTradeReportToIso20022TypeTabulator amountAndDirection106__2Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.amountAndDirection106__2Project_EsmaEmirTradeReportToIso20022TypeTabulator = amountAndDirection106__2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.uadjstdFctvDtField = new FieldImpl(
			"uadjstdFctvDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.uadjstdEndDtField = new FieldImpl(
			"uadjstdEndDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.amtField = new FieldImpl(
			"amt",
			false,
			Optional.empty(),
			Optional.empty(),
			amountAndDirection106__2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(uadjstdFctvDtField, uadjstdEndDtField, amtField);
	}
	
	@Override
	public List<FieldValue> tabulate(Schedule11__1 input) {
		Optional<Date> uadjstdFctvDt = Optional.ofNullable(input.getUadjstdFctvDt());
		Optional<Date> uadjstdEndDt = Optional.ofNullable(input.getUadjstdEndDt());
		Optional<List<FieldValue>> amt = Optional.ofNullable(input.getAmt())
			.map(x -> amountAndDirection106__2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new FieldValueImpl(uadjstdFctvDtField, uadjstdFctvDt),
			new FieldValueImpl(uadjstdEndDtField, uadjstdEndDt),
			new NestedFieldValueImpl(amtField, amt)
		);
	}
}
