package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.records.Date;
import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.Schedule1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class Schedule1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<Schedule1> {
	private final Field uadjstdFctvDtField;
	private final Field uadjstdEndDtField;
	private final Field pricField;
	
	private final SecuritiesTransactionPrice17ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator securitiesTransactionPrice17ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public Schedule1Project_EsmaEmirTradeReportToIso20022TypeTabulator(SecuritiesTransactionPrice17ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator securitiesTransactionPrice17ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.securitiesTransactionPrice17ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator = securitiesTransactionPrice17ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.uadjstdFctvDtField = new FieldImpl(
			"uadjstdFctvDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.uadjstdEndDtField = new FieldImpl(
			"uadjstdEndDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.pricField = new FieldImpl(
			"pric",
			false,
			Optional.empty(),
			Optional.empty(),
			securitiesTransactionPrice17ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(uadjstdFctvDtField, uadjstdEndDtField, pricField);
	}
	
	@Override
	public List<FieldValue> tabulate(Schedule1 input) {
		Optional<Date> uadjstdFctvDt = Optional.ofNullable(input.getUadjstdFctvDt());
		Optional<Date> uadjstdEndDt = Optional.ofNullable(input.getUadjstdEndDt());
		Optional<List<FieldValue>> pric = Optional.ofNullable(input.getPric())
			.map(x -> securitiesTransactionPrice17ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new FieldValueImpl(uadjstdFctvDtField, uadjstdFctvDt),
			new FieldValueImpl(uadjstdEndDtField, uadjstdEndDt),
			new NestedFieldValueImpl(pricField, pric)
		);
	}
}
