package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.PriceStatus1Code;
import iso20022.auth030.esma.SecuritiesTransactionPrice17Choice;
import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class SecuritiesTransactionPrice17ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<SecuritiesTransactionPrice17Choice> {
	private final Field mntryValField;
	private final Field unitField;
	private final Field pctgField;
	private final Field yldField;
	private final Field dcmlField;
	private final Field pdgPricField;
	private final Field othrField;
	
	private final AmountAndDirection106Project_EsmaEmirTradeReportToIso20022TypeTabulator amountAndDirection106Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final SecuritiesTransactionPrice5Project_EsmaEmirTradeReportToIso20022TypeTabulator securitiesTransactionPrice5Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public SecuritiesTransactionPrice17ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator(AmountAndDirection106Project_EsmaEmirTradeReportToIso20022TypeTabulator amountAndDirection106Project_EsmaEmirTradeReportToIso20022TypeTabulator, SecuritiesTransactionPrice5Project_EsmaEmirTradeReportToIso20022TypeTabulator securitiesTransactionPrice5Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.amountAndDirection106Project_EsmaEmirTradeReportToIso20022TypeTabulator = amountAndDirection106Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.securitiesTransactionPrice5Project_EsmaEmirTradeReportToIso20022TypeTabulator = securitiesTransactionPrice5Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.mntryValField = new FieldImpl(
			"mntryVal",
			false,
			Optional.empty(),
			Optional.empty(),
			amountAndDirection106Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.unitField = new FieldImpl(
			"unit",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.pctgField = new FieldImpl(
			"pctg",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.yldField = new FieldImpl(
			"yld",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.dcmlField = new FieldImpl(
			"dcml",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.pdgPricField = new FieldImpl(
			"pdgPric",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.othrField = new FieldImpl(
			"othr",
			false,
			Optional.empty(),
			Optional.empty(),
			securitiesTransactionPrice5Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(mntryValField, unitField, pctgField, yldField, dcmlField, pdgPricField, othrField);
	}
	
	@Override
	public List<FieldValue> tabulate(SecuritiesTransactionPrice17Choice input) {
		Optional<List<FieldValue>> mntryVal = Optional.ofNullable(input.getMntryVal())
			.map(x -> amountAndDirection106Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<BigDecimal> unit = Optional.ofNullable(input.getUnit());
		Optional<BigDecimal> pctg = Optional.ofNullable(input.getPctg());
		Optional<BigDecimal> yld = Optional.ofNullable(input.getYld());
		Optional<BigDecimal> dcml = Optional.ofNullable(input.getDcml());
		Optional<PriceStatus1Code> pdgPric = Optional.ofNullable(input.getPdgPric());
		Optional<List<FieldValue>> othr = Optional.ofNullable(input.getOthr())
			.map(x -> securitiesTransactionPrice5Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(mntryValField, mntryVal),
			new FieldValueImpl(unitField, unit),
			new FieldValueImpl(pctgField, pctg),
			new FieldValueImpl(yldField, yld),
			new FieldValueImpl(dcmlField, dcml),
			new FieldValueImpl(pdgPricField, pdgPric),
			new NestedFieldValueImpl(othrField, othr)
		);
	}
}
