package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.esma.SecuritiesTransactionPrice5;
import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class SecuritiesTransactionPrice5Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<SecuritiesTransactionPrice5> {
	private final Field valField;
	private final Field tpField;
	
	public SecuritiesTransactionPrice5Project_EsmaEmirTradeReportToIso20022TypeTabulator() {
		this.valField = new FieldImpl(
			"val",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.tpField = new FieldImpl(
			"tp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(valField, tpField);
	}
	
	@Override
	public List<FieldValue> tabulate(SecuritiesTransactionPrice5 input) {
		Optional<BigDecimal> val = Optional.ofNullable(input.getVal());
		Optional<String> tp = Optional.ofNullable(input.getTp());
		return Arrays.asList(
			new FieldValueImpl(valField, val),
			new FieldValueImpl(tpField, tp)
		);
	}
}
