package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.SecurityIdentification41Choice__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class SecurityIdentification41Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<SecurityIdentification41Choice__1> {
	private final Field isinField;
	private final Field bsktField;
	private final Field indxField;
	
	private final CustomBasket4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator customBasket4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final IndexIdentification1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator indexIdentification1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public SecurityIdentification41Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(CustomBasket4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator customBasket4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, IndexIdentification1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator indexIdentification1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.customBasket4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = customBasket4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.indexIdentification1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = indexIdentification1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.isinField = new FieldImpl(
			"isin",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.bsktField = new FieldImpl(
			"bskt",
			false,
			Optional.empty(),
			Optional.empty(),
			customBasket4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.indxField = new FieldImpl(
			"indx",
			false,
			Optional.empty(),
			Optional.empty(),
			indexIdentification1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(isinField, bsktField, indxField);
	}
	
	@Override
	public List<FieldValue> tabulate(SecurityIdentification41Choice__1 input) {
		Optional<String> isin = Optional.ofNullable(input.getIsin());
		Optional<List<FieldValue>> bskt = Optional.ofNullable(input.getBskt())
			.map(x -> customBasket4__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> indx = Optional.ofNullable(input.getIndx())
			.map(x -> indexIdentification1__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new FieldValueImpl(isinField, isin),
			new NestedFieldValueImpl(bsktField, bskt),
			new NestedFieldValueImpl(indxField, indx)
		);
	}
}
