package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.esma.TimePeriodDetails1;
import java.time.LocalTime;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class TimePeriodDetails1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<TimePeriodDetails1> {
	private final Field frTmField;
	private final Field toTmField;
	
	public TimePeriodDetails1Project_EsmaEmirTradeReportToIso20022TypeTabulator() {
		this.frTmField = new FieldImpl(
			"frTm",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.toTmField = new FieldImpl(
			"toTm",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(frTmField, toTmField);
	}
	
	@Override
	public List<FieldValue> tabulate(TimePeriodDetails1 input) {
		Optional<LocalTime> frTm = Optional.ofNullable(input.getFrTm());
		Optional<LocalTime> toTm = Optional.ofNullable(input.getToTm());
		return Arrays.asList(
			new FieldValueImpl(frTmField, frTm),
			new FieldValueImpl(toTmField, toTm)
		);
	}
}
