package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.ClearingObligationType1Code;
import iso20022.auth030.esma.TradeClearing11__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class TradeClearing11__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<TradeClearing11__1> {
	private final Field clrOblgtnField;
	private final Field clrStsField;
	private final Field intraGrpField;
	
	private final Cleared23Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator cleared23Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public TradeClearing11__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(Cleared23Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator cleared23Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.cleared23Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = cleared23Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.clrOblgtnField = new FieldImpl(
			"clrOblgtn",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.clrStsField = new FieldImpl(
			"clrSts",
			false,
			Optional.empty(),
			Optional.empty(),
			cleared23Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.intraGrpField = new FieldImpl(
			"intraGrp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(clrOblgtnField, clrStsField, intraGrpField);
	}
	
	@Override
	public List<FieldValue> tabulate(TradeClearing11__1 input) {
		Optional<ClearingObligationType1Code> clrOblgtn = Optional.ofNullable(input.getClrOblgtn());
		Optional<List<FieldValue>> clrSts = Optional.ofNullable(input.getClrSts())
			.map(x -> cleared23Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<Boolean> intraGrp = Optional.ofNullable(input.getIntraGrp());
		return Arrays.asList(
			new FieldValueImpl(clrOblgtnField, clrOblgtn),
			new NestedFieldValueImpl(clrStsField, clrSts),
			new FieldValueImpl(intraGrpField, intraGrp)
		);
	}
}
