package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.TradeConfirmation1Choice;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class TradeConfirmation1ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<TradeConfirmation1Choice> {
	private final Field confdField;
	private final Field nonConfdField;
	
	private final TradeConfirmation2Project_EsmaEmirTradeReportToIso20022TypeTabulator tradeConfirmation2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final TradeNonConfirmation1Project_EsmaEmirTradeReportToIso20022TypeTabulator tradeNonConfirmation1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public TradeConfirmation1ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator(TradeConfirmation2Project_EsmaEmirTradeReportToIso20022TypeTabulator tradeConfirmation2Project_EsmaEmirTradeReportToIso20022TypeTabulator, TradeNonConfirmation1Project_EsmaEmirTradeReportToIso20022TypeTabulator tradeNonConfirmation1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.tradeConfirmation2Project_EsmaEmirTradeReportToIso20022TypeTabulator = tradeConfirmation2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.tradeNonConfirmation1Project_EsmaEmirTradeReportToIso20022TypeTabulator = tradeNonConfirmation1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.confdField = new FieldImpl(
			"confd",
			false,
			Optional.empty(),
			Optional.empty(),
			tradeConfirmation2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.nonConfdField = new FieldImpl(
			"nonConfd",
			false,
			Optional.empty(),
			Optional.empty(),
			tradeNonConfirmation1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(confdField, nonConfdField);
	}
	
	@Override
	public List<FieldValue> tabulate(TradeConfirmation1Choice input) {
		Optional<List<FieldValue>> confd = Optional.ofNullable(input.getConfd())
			.map(x -> tradeConfirmation2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> nonConfd = Optional.ofNullable(input.getNonConfd())
			.map(x -> tradeNonConfirmation1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(confdField, confd),
			new NestedFieldValueImpl(nonConfdField, nonConfd)
		);
	}
}
