package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.TradeCounterpartyReport20__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class TradeCounterpartyReport20__1Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<TradeCounterpartyReport20__1> {
	private final Field rptgCtrPtyField;
	private final Field othrCtrPtyField;
	private final Field brkrField;
	private final Field submitgAgtField;
	private final Field clrMmbField;
	private final Field nttyRspnsblForRptField;
	
	private final Counterparty45__1Project_EsmaEmirTradeReportToIso20022TypeTabulator counterparty45__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final Counterparty46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator counterparty46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final OrganisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final PartyIdentification248Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator partyIdentification248Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public TradeCounterpartyReport20__1Project_EsmaEmirTradeReportToIso20022TypeTabulator(Counterparty45__1Project_EsmaEmirTradeReportToIso20022TypeTabulator counterparty45__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, Counterparty46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator counterparty46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, OrganisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, PartyIdentification248Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator partyIdentification248Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.counterparty45__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = counterparty45__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.counterparty46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = counterparty46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.partyIdentification248Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = partyIdentification248Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.rptgCtrPtyField = new FieldImpl(
			"rptgCtrPty",
			false,
			Optional.empty(),
			Optional.empty(),
			counterparty45__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.othrCtrPtyField = new FieldImpl(
			"othrCtrPty",
			false,
			Optional.empty(),
			Optional.empty(),
			counterparty46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.brkrField = new FieldImpl(
			"brkr",
			false,
			Optional.empty(),
			Optional.empty(),
			organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.submitgAgtField = new FieldImpl(
			"submitgAgt",
			false,
			Optional.empty(),
			Optional.empty(),
			organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.clrMmbField = new FieldImpl(
			"clrMmb",
			false,
			Optional.empty(),
			Optional.empty(),
			partyIdentification248Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.nttyRspnsblForRptField = new FieldImpl(
			"nttyRspnsblForRpt",
			false,
			Optional.empty(),
			Optional.empty(),
			organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(rptgCtrPtyField, othrCtrPtyField, brkrField, submitgAgtField, clrMmbField, nttyRspnsblForRptField);
	}
	
	@Override
	public List<FieldValue> tabulate(TradeCounterpartyReport20__1 input) {
		Optional<List<FieldValue>> rptgCtrPty = Optional.ofNullable(input.getRptgCtrPty())
			.map(x -> counterparty45__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> othrCtrPty = Optional.ofNullable(input.getOthrCtrPty())
			.map(x -> counterparty46__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> brkr = Optional.ofNullable(input.getBrkr())
			.map(x -> organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> submitgAgt = Optional.ofNullable(input.getSubmitgAgt())
			.map(x -> organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> clrMmb = Optional.ofNullable(input.getClrMmb())
			.map(x -> partyIdentification248Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> nttyRspnsblForRpt = Optional.ofNullable(input.getNttyRspnsblForRpt())
			.map(x -> organisationIdentification15Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(rptgCtrPtyField, rptgCtrPty),
			new NestedFieldValueImpl(othrCtrPtyField, othrCtrPty),
			new NestedFieldValueImpl(brkrField, brkr),
			new NestedFieldValueImpl(submitgAgtField, submitgAgt),
			new NestedFieldValueImpl(clrMmbField, clrMmb),
			new NestedFieldValueImpl(nttyRspnsblForRptField, nttyRspnsblForRpt)
		);
	}
}
