package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.ModificationLevel1Code;
import iso20022.auth030.esma.TradeData42__4;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class TradeData42__4Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<TradeData42__4> {
	private final Field ctrPtySpcfcDataField;
	private final Field cmonTradDataField;
	private final Field lvlField;
	
	private final CounterpartySpecificData36__3Project_EsmaEmirTradeReportToIso20022TypeTabulator counterpartySpecificData36__3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final CommonTradeDataReport69__4Project_EsmaEmirTradeReportToIso20022TypeTabulator commonTradeDataReport69__4Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public TradeData42__4Project_EsmaEmirTradeReportToIso20022TypeTabulator(CounterpartySpecificData36__3Project_EsmaEmirTradeReportToIso20022TypeTabulator counterpartySpecificData36__3Project_EsmaEmirTradeReportToIso20022TypeTabulator, CommonTradeDataReport69__4Project_EsmaEmirTradeReportToIso20022TypeTabulator commonTradeDataReport69__4Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.counterpartySpecificData36__3Project_EsmaEmirTradeReportToIso20022TypeTabulator = counterpartySpecificData36__3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.commonTradeDataReport69__4Project_EsmaEmirTradeReportToIso20022TypeTabulator = commonTradeDataReport69__4Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.ctrPtySpcfcDataField = new FieldImpl(
			"ctrPtySpcfcData",
			false,
			Optional.empty(),
			Optional.empty(),
			counterpartySpecificData36__3Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.cmonTradDataField = new FieldImpl(
			"cmonTradData",
			false,
			Optional.empty(),
			Optional.empty(),
			commonTradeDataReport69__4Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.lvlField = new FieldImpl(
			"lvl",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(ctrPtySpcfcDataField, cmonTradDataField, lvlField);
	}
	
	@Override
	public List<FieldValue> tabulate(TradeData42__4 input) {
		Optional<List<FieldValue>> ctrPtySpcfcData = Optional.ofNullable(input.getCtrPtySpcfcData())
			.map(x -> counterpartySpecificData36__3Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> cmonTradData = Optional.ofNullable(input.getCmonTradData())
			.map(x -> commonTradeDataReport69__4Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<ModificationLevel1Code> lvl = Optional.ofNullable(input.getLvl());
		return Arrays.asList(
			new NestedFieldValueImpl(ctrPtySpcfcDataField, ctrPtySpcfcData),
			new NestedFieldValueImpl(cmonTradDataField, cmonTradData),
			new FieldValueImpl(lvlField, lvl)
		);
	}
}
