package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.records.Date;
import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.MultiNestedFieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.TradeTransaction49__4;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;
import javax.inject.Inject;


public class TradeTransaction49__4Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<TradeTransaction49__4> {
	private final Field txIdField;
	private final Field sbsqntTxIdField;
	private final Field collPrtflCdField;
	private final Field earlyTermntnDtField;
	private final Field pstTradRskRdctnFlgField;
	private final Field pstTradRskRdctnEvtField;
	private final Field derivEvtField;
	private final Field othrPmtField;
	
	private final UniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator uniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final UniqueTransactionIdentifier3Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator uniqueTransactionIdentifier3Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final CollateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator collateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final PTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator pTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final DerivativeEvent6__4Project_EsmaEmirTradeReportToIso20022TypeTabulator derivativeEvent6__4Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final OtherPayment5__1Project_EsmaEmirTradeReportToIso20022TypeTabulator otherPayment5__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public TradeTransaction49__4Project_EsmaEmirTradeReportToIso20022TypeTabulator(UniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator uniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator, UniqueTransactionIdentifier3Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator uniqueTransactionIdentifier3Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, CollateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator collateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, PTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator pTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, DerivativeEvent6__4Project_EsmaEmirTradeReportToIso20022TypeTabulator derivativeEvent6__4Project_EsmaEmirTradeReportToIso20022TypeTabulator, OtherPayment5__1Project_EsmaEmirTradeReportToIso20022TypeTabulator otherPayment5__1Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.uniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator = uniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.uniqueTransactionIdentifier3Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = uniqueTransactionIdentifier3Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.collateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = collateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.pTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = pTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.derivativeEvent6__4Project_EsmaEmirTradeReportToIso20022TypeTabulator = derivativeEvent6__4Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.otherPayment5__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = otherPayment5__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.txIdField = new FieldImpl(
			"txId",
			false,
			Optional.empty(),
			Optional.empty(),
			uniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.sbsqntTxIdField = new FieldImpl(
			"sbsqntTxId",
			false,
			Optional.empty(),
			Optional.empty(),
			uniqueTransactionIdentifier3Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.collPrtflCdField = new FieldImpl(
			"collPrtflCd",
			false,
			Optional.empty(),
			Optional.empty(),
			collateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.earlyTermntnDtField = new FieldImpl(
			"earlyTermntnDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.pstTradRskRdctnFlgField = new FieldImpl(
			"pstTradRskRdctnFlg",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.pstTradRskRdctnEvtField = new FieldImpl(
			"pstTradRskRdctnEvt",
			false,
			Optional.empty(),
			Optional.empty(),
			pTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.derivEvtField = new FieldImpl(
			"derivEvt",
			false,
			Optional.empty(),
			Optional.empty(),
			derivativeEvent6__4Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.othrPmtField = new FieldImpl(
			"othrPmt",
			true,
			Optional.empty(),
			Optional.empty(),
			otherPayment5__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(txIdField, sbsqntTxIdField, collPrtflCdField, earlyTermntnDtField, pstTradRskRdctnFlgField, pstTradRskRdctnEvtField, derivEvtField, othrPmtField);
	}
	
	@Override
	public List<FieldValue> tabulate(TradeTransaction49__4 input) {
		Optional<List<FieldValue>> txId = Optional.ofNullable(input.getTxId())
			.map(x -> uniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> sbsqntTxId = Optional.ofNullable(input.getSbsqntTxId())
			.map(x -> uniqueTransactionIdentifier3Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> collPrtflCd = Optional.ofNullable(input.getCollPrtflCd())
			.map(x -> collateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<Date> earlyTermntnDt = Optional.ofNullable(input.getEarlyTermntnDt());
		Optional<Boolean> pstTradRskRdctnFlg = Optional.ofNullable(input.getPstTradRskRdctnFlg());
		Optional<List<FieldValue>> pstTradRskRdctnEvt = Optional.ofNullable(input.getPstTradRskRdctnEvt())
			.map(x -> pTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> derivEvt = Optional.ofNullable(input.getDerivEvt())
			.map(x -> derivativeEvent6__4Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<List<FieldValue>>> othrPmt = Optional.ofNullable(input.getOthrPmt())
			.map(x -> x.stream()
				.map(_x -> otherPayment5__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(_x))
				.collect(Collectors.toList()));
		return Arrays.asList(
			new NestedFieldValueImpl(txIdField, txId),
			new NestedFieldValueImpl(sbsqntTxIdField, sbsqntTxId),
			new NestedFieldValueImpl(collPrtflCdField, collPrtflCd),
			new FieldValueImpl(earlyTermntnDtField, earlyTermntnDt),
			new FieldValueImpl(pstTradRskRdctnFlgField, pstTradRskRdctnFlg),
			new NestedFieldValueImpl(pstTradRskRdctnEvtField, pstTradRskRdctnEvt),
			new NestedFieldValueImpl(derivEvtField, derivEvt),
			new MultiNestedFieldValueImpl(othrPmtField, othrPmt)
		);
	}
}
