package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.TradeTransaction49__6;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class TradeTransaction49__6Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<TradeTransaction49__6> {
	private final Field txIdField;
	private final Field collPrtflCdField;
	private final Field pstTradRskRdctnFlgField;
	private final Field pstTradRskRdctnEvtField;
	private final Field derivEvtField;
	
	private final UniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator uniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final CollateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator collateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final PTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator pTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	private final DerivativeEvent6__5Project_EsmaEmirTradeReportToIso20022TypeTabulator derivativeEvent6__5Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public TradeTransaction49__6Project_EsmaEmirTradeReportToIso20022TypeTabulator(UniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator uniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator, CollateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator collateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, PTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator pTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator, DerivativeEvent6__5Project_EsmaEmirTradeReportToIso20022TypeTabulator derivativeEvent6__5Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.uniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator = uniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.collateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = collateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.pTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator = pTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.derivativeEvent6__5Project_EsmaEmirTradeReportToIso20022TypeTabulator = derivativeEvent6__5Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.txIdField = new FieldImpl(
			"txId",
			false,
			Optional.empty(),
			Optional.empty(),
			uniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.collPrtflCdField = new FieldImpl(
			"collPrtflCd",
			false,
			Optional.empty(),
			Optional.empty(),
			collateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.pstTradRskRdctnFlgField = new FieldImpl(
			"pstTradRskRdctnFlg",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.pstTradRskRdctnEvtField = new FieldImpl(
			"pstTradRskRdctnEvt",
			false,
			Optional.empty(),
			Optional.empty(),
			pTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.derivEvtField = new FieldImpl(
			"derivEvt",
			false,
			Optional.empty(),
			Optional.empty(),
			derivativeEvent6__5Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(txIdField, collPrtflCdField, pstTradRskRdctnFlgField, pstTradRskRdctnEvtField, derivEvtField);
	}
	
	@Override
	public List<FieldValue> tabulate(TradeTransaction49__6 input) {
		Optional<List<FieldValue>> txId = Optional.ofNullable(input.getTxId())
			.map(x -> uniqueTransactionIdentifier2Choice__2Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> collPrtflCd = Optional.ofNullable(input.getCollPrtflCd())
			.map(x -> collateralPortfolioCode5Choice__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<Boolean> pstTradRskRdctnFlg = Optional.ofNullable(input.getPstTradRskRdctnFlg());
		Optional<List<FieldValue>> pstTradRskRdctnEvt = Optional.ofNullable(input.getPstTradRskRdctnEvt())
			.map(x -> pTRREvent2__1Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> derivEvt = Optional.ofNullable(input.getDerivEvt())
			.map(x -> derivativeEvent6__5Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(txIdField, txId),
			new NestedFieldValueImpl(collPrtflCdField, collPrtflCd),
			new FieldValueImpl(pstTradRskRdctnFlgField, pstTradRskRdctnFlg),
			new NestedFieldValueImpl(pstTradRskRdctnEvtField, pstTradRskRdctnEvt),
			new NestedFieldValueImpl(derivEvtField, derivEvt)
		);
	}
}
