package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.esma.Tranche3;
import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class Tranche3Project_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<Tranche3> {
	private final Field attchmntPtField;
	private final Field dtchmntPtField;
	
	public Tranche3Project_EsmaEmirTradeReportToIso20022TypeTabulator() {
		this.attchmntPtField = new FieldImpl(
			"attchmntPt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.dtchmntPtField = new FieldImpl(
			"dtchmntPt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(attchmntPtField, dtchmntPtField);
	}
	
	@Override
	public List<FieldValue> tabulate(Tranche3 input) {
		Optional<BigDecimal> attchmntPt = Optional.ofNullable(input.getAttchmntPt());
		Optional<BigDecimal> dtchmntPt = Optional.ofNullable(input.getDtchmntPt());
		return Arrays.asList(
			new FieldValueImpl(attchmntPtField, attchmntPt),
			new FieldValueImpl(dtchmntPtField, dtchmntPt)
		);
	}
}
