package drr.projection.iso20022.esma.emir.refit.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.esma.NoReasonCode;
import iso20022.auth030.esma.TrancheIndicator3Choice;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class TrancheIndicator3ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator implements Tabulator<TrancheIndicator3Choice> {
	private final Field trnchdField;
	private final Field utrnchdField;
	
	private final Tranche3Project_EsmaEmirTradeReportToIso20022TypeTabulator tranche3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
	
	@Inject
	public TrancheIndicator3ChoiceProject_EsmaEmirTradeReportToIso20022TypeTabulator(Tranche3Project_EsmaEmirTradeReportToIso20022TypeTabulator tranche3Project_EsmaEmirTradeReportToIso20022TypeTabulator) {
		this.tranche3Project_EsmaEmirTradeReportToIso20022TypeTabulator = tranche3Project_EsmaEmirTradeReportToIso20022TypeTabulator;
		this.trnchdField = new FieldImpl(
			"trnchd",
			false,
			Optional.empty(),
			Optional.empty(),
			tranche3Project_EsmaEmirTradeReportToIso20022TypeTabulator.getFields()
		);
		this.utrnchdField = new FieldImpl(
			"utrnchd",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(trnchdField, utrnchdField);
	}
	
	@Override
	public List<FieldValue> tabulate(TrancheIndicator3Choice input) {
		Optional<List<FieldValue>> trnchd = Optional.ofNullable(input.getTrnchd())
			.map(x -> tranche3Project_EsmaEmirTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<NoReasonCode> utrnchd = Optional.ofNullable(input.getUtrnchd());
		return Arrays.asList(
			new NestedFieldValueImpl(trnchdField, trnchd),
			new FieldValueImpl(utrnchdField, utrnchd)
		);
	}
}
