package drr.projection.iso20022.jfsa.rewrite.margin.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth108.jfsa.ActiveOrHistoricCurrencyAnd5DecimalAmount;
import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class ActiveOrHistoricCurrencyAnd5DecimalAmountProject_JFSARewriteMarginReportToIso20022TypeTabulator implements Tabulator<ActiveOrHistoricCurrencyAnd5DecimalAmount> {
	private final Field valueField;
	private final Field ccyField;
	
	public ActiveOrHistoricCurrencyAnd5DecimalAmountProject_JFSARewriteMarginReportToIso20022TypeTabulator() {
		this.valueField = new FieldImpl(
			"value",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.ccyField = new FieldImpl(
			"ccy",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(valueField, ccyField);
	}
	
	@Override
	public List<FieldValue> tabulate(ActiveOrHistoricCurrencyAnd5DecimalAmount input) {
		Optional<BigDecimal> value = Optional.ofNullable(input.getValue());
		Optional<String> ccy = Optional.ofNullable(input.getCcy());
		return Arrays.asList(
			new FieldValueImpl(valueField, value),
			new FieldValueImpl(ccyField, ccy)
		);
	}
}
