package drr.projection.iso20022.jfsa.rewrite.margin.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth108.jfsa.Document;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class DocumentProject_JFSARewriteMarginReportToIso20022TypeTabulator implements Tabulator<Document> {
	private final Field derivsTradMrgnDataRptField;
	
	private final DerivativesTradeMarginDataReportV01Project_JFSARewriteMarginReportToIso20022TypeTabulator derivativesTradeMarginDataReportV01Project_JFSARewriteMarginReportToIso20022TypeTabulator;
	
	@Inject
	public DocumentProject_JFSARewriteMarginReportToIso20022TypeTabulator(DerivativesTradeMarginDataReportV01Project_JFSARewriteMarginReportToIso20022TypeTabulator derivativesTradeMarginDataReportV01Project_JFSARewriteMarginReportToIso20022TypeTabulator) {
		this.derivativesTradeMarginDataReportV01Project_JFSARewriteMarginReportToIso20022TypeTabulator = derivativesTradeMarginDataReportV01Project_JFSARewriteMarginReportToIso20022TypeTabulator;
		this.derivsTradMrgnDataRptField = new FieldImpl(
			"derivsTradMrgnDataRpt",
			false,
			Optional.empty(),
			Optional.empty(),
			derivativesTradeMarginDataReportV01Project_JFSARewriteMarginReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(derivsTradMrgnDataRptField);
	}
	
	@Override
	public List<FieldValue> tabulate(Document input) {
		Optional<List<FieldValue>> derivsTradMrgnDataRpt = Optional.ofNullable(input.getDerivsTradMrgnDataRpt())
			.map(x -> derivativesTradeMarginDataReportV01Project_JFSARewriteMarginReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(derivsTradMrgnDataRptField, derivsTradMrgnDataRpt)
		);
	}
}
