package drr.projection.iso20022.jfsa.rewrite.margin.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth108.jfsa.TradeReportHeader4__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class TradeReportHeader4__1Project_JFSARewriteMarginReportToIso20022TypeTabulator implements Tabulator<TradeReportHeader4__1> {
	private final Field nbRcrdsField;
	
	public TradeReportHeader4__1Project_JFSARewriteMarginReportToIso20022TypeTabulator() {
		this.nbRcrdsField = new FieldImpl(
			"nbRcrds",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(nbRcrdsField);
	}
	
	@Override
	public List<FieldValue> tabulate(TradeReportHeader4__1 input) {
		Optional<Long> nbRcrds = Optional.ofNullable(input.getNbRcrds());
		return Arrays.asList(
			new FieldValueImpl(nbRcrdsField, nbRcrds)
		);
	}
}
