package drr.projection.iso20022.jfsa.rewrite.trade.functions;

import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.functions.ModelObjectValidator;
import com.rosetta.model.lib.functions.RosettaFunction;
import drr.regulation.jfsa.rewrite.trade.JFSATransactionReport;
import iso20022.auth030.jfsa.EventIdentifier1Choice__1;
import iso20022.auth030.jfsa.EventIdentifier1Choice__1.EventIdentifier1Choice__1Builder;
import java.util.Optional;
import javax.inject.Inject;


@ImplementedBy(GetDerivEvtId.GetDerivEvtIdDefault.class)
public abstract class GetDerivEvtId implements RosettaFunction {
	
	@Inject protected ModelObjectValidator objectValidator;

	/**
	* @param drrReport 
	* @return id 
	*/
	public EventIdentifier1Choice__1 evaluate(JFSATransactionReport drrReport) {
		EventIdentifier1Choice__1.EventIdentifier1Choice__1Builder idBuilder = doEvaluate(drrReport);
		
		final EventIdentifier1Choice__1 id;
		if (idBuilder == null) {
			id = null;
		} else {
			id = idBuilder.build();
			objectValidator.validate(EventIdentifier1Choice__1.class, id);
		}
		
		return id;
	}

	protected abstract EventIdentifier1Choice__1.EventIdentifier1Choice__1Builder doEvaluate(JFSATransactionReport drrReport);

	public static class GetDerivEvtIdDefault extends GetDerivEvtId {
		@Override
		protected EventIdentifier1Choice__1.EventIdentifier1Choice__1Builder doEvaluate(JFSATransactionReport drrReport) {
			EventIdentifier1Choice__1.EventIdentifier1Choice__1Builder id = EventIdentifier1Choice__1.builder();
			return assignOutput(id, drrReport);
		}
		
		protected EventIdentifier1Choice__1.EventIdentifier1Choice__1Builder assignOutput(EventIdentifier1Choice__1.EventIdentifier1Choice__1Builder id, JFSATransactionReport drrReport) {
			id = toBuilder(EventIdentifier1Choice__1.builder()
				.setEvtIdr(null)
				.build()
			);
			
			return Optional.ofNullable(id)
				.map(o -> o.prune())
				.orElse(null);
		}
	}
}
