package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.Cleared23Choice__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class Cleared23Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<Cleared23Choice__1> {
	private final Field clrdField;
	private final Field intndToClearField;
	private final Field nonClrdField;
	
	private final ClearingPartyAndTime21Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator clearingPartyAndTime21Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final ClearingPartyAndTime22Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator clearingPartyAndTime22Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final ClearingExceptionOrExemption3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator clearingExceptionOrExemption3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public Cleared23Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator(ClearingPartyAndTime21Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator clearingPartyAndTime21Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, ClearingPartyAndTime22Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator clearingPartyAndTime22Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, ClearingExceptionOrExemption3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator clearingExceptionOrExemption3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.clearingPartyAndTime21Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = clearingPartyAndTime21Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.clearingPartyAndTime22Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = clearingPartyAndTime22Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.clearingExceptionOrExemption3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = clearingExceptionOrExemption3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.clrdField = new FieldImpl(
			"clrd",
			false,
			Optional.empty(),
			Optional.empty(),
			clearingPartyAndTime21Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.intndToClearField = new FieldImpl(
			"intndToClear",
			false,
			Optional.empty(),
			Optional.empty(),
			clearingPartyAndTime22Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.nonClrdField = new FieldImpl(
			"nonClrd",
			false,
			Optional.empty(),
			Optional.empty(),
			clearingExceptionOrExemption3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(clrdField, intndToClearField, nonClrdField);
	}
	
	@Override
	public List<FieldValue> tabulate(Cleared23Choice__1 input) {
		Optional<List<FieldValue>> clrd = Optional.ofNullable(input.getClrd())
			.map(x -> clearingPartyAndTime21Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> intndToClear = Optional.ofNullable(input.getIntndToClear())
			.map(x -> clearingPartyAndTime22Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> nonClrd = Optional.ofNullable(input.getNonClrd())
			.map(x -> clearingExceptionOrExemption3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(clrdField, clrd),
			new NestedFieldValueImpl(intndToClearField, intndToClear),
			new NestedFieldValueImpl(nonClrdField, nonClrd)
		);
	}
}
