package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.ClearingAccountType4Code;
import iso20022.auth030.jfsa.ClearingPartyAndTime22__2;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class ClearingPartyAndTime22__2Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<ClearingPartyAndTime22__2> {
	private final Field ccpField;
	private final Field orgnlIdrField;
	private final Field orgnlTradRpstryIdrField;
	private final Field clrAcctOrgnField;
	
	private final OrganisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final UniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator uniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public ClearingPartyAndTime22__2Project_JFSARewriteTradeReportToIso20022TypeTabulator(OrganisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, UniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator uniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.uniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = uniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.ccpField = new FieldImpl(
			"ccp",
			false,
			Optional.empty(),
			Optional.empty(),
			organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.orgnlIdrField = new FieldImpl(
			"orgnlIdr",
			false,
			Optional.empty(),
			Optional.empty(),
			uniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.orgnlTradRpstryIdrField = new FieldImpl(
			"orgnlTradRpstryIdr",
			false,
			Optional.empty(),
			Optional.empty(),
			organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.clrAcctOrgnField = new FieldImpl(
			"clrAcctOrgn",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(ccpField, orgnlIdrField, orgnlTradRpstryIdrField, clrAcctOrgnField);
	}
	
	@Override
	public List<FieldValue> tabulate(ClearingPartyAndTime22__2 input) {
		Optional<List<FieldValue>> ccp = Optional.ofNullable(input.getCcp())
			.map(x -> organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> orgnlIdr = Optional.ofNullable(input.getOrgnlIdr())
			.map(x -> uniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> orgnlTradRpstryIdr = Optional.ofNullable(input.getOrgnlTradRpstryIdr())
			.map(x -> organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<ClearingAccountType4Code> clrAcctOrgn = Optional.ofNullable(input.getClrAcctOrgn());
		return Arrays.asList(
			new NestedFieldValueImpl(ccpField, ccp),
			new NestedFieldValueImpl(orgnlIdrField, orgnlIdr),
			new NestedFieldValueImpl(orgnlTradRpstryIdrField, orgnlTradRpstryIdr),
			new FieldValueImpl(clrAcctOrgnField, clrAcctOrgn)
		);
	}
}
