package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.ClearingPartyAndTime23__1;
import java.time.ZonedDateTime;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class ClearingPartyAndTime23__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<ClearingPartyAndTime23__1> {
	private final Field ccpField;
	private final Field clrRctDtTmField;
	private final Field orgnlIdrField;
	private final Field orgnlTradRpstryIdrField;
	
	private final OrganisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final UniqueTransactionIdentifier1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator uniqueTransactionIdentifier1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public ClearingPartyAndTime23__1Project_JFSARewriteTradeReportToIso20022TypeTabulator(OrganisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, UniqueTransactionIdentifier1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator uniqueTransactionIdentifier1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.uniqueTransactionIdentifier1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = uniqueTransactionIdentifier1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.ccpField = new FieldImpl(
			"ccp",
			false,
			Optional.empty(),
			Optional.empty(),
			organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.clrRctDtTmField = new FieldImpl(
			"clrRctDtTm",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.orgnlIdrField = new FieldImpl(
			"orgnlIdr",
			false,
			Optional.empty(),
			Optional.empty(),
			uniqueTransactionIdentifier1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.orgnlTradRpstryIdrField = new FieldImpl(
			"orgnlTradRpstryIdr",
			false,
			Optional.empty(),
			Optional.empty(),
			organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(ccpField, clrRctDtTmField, orgnlIdrField, orgnlTradRpstryIdrField);
	}
	
	@Override
	public List<FieldValue> tabulate(ClearingPartyAndTime23__1 input) {
		Optional<List<FieldValue>> ccp = Optional.ofNullable(input.getCcp())
			.map(x -> organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<ZonedDateTime> clrRctDtTm = Optional.ofNullable(input.getClrRctDtTm());
		Optional<List<FieldValue>> orgnlIdr = Optional.ofNullable(input.getOrgnlIdr())
			.map(x -> uniqueTransactionIdentifier1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> orgnlTradRpstryIdr = Optional.ofNullable(input.getOrgnlTradRpstryIdr())
			.map(x -> organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(ccpField, ccp),
			new FieldValueImpl(clrRctDtTmField, clrRctDtTm),
			new NestedFieldValueImpl(orgnlIdrField, orgnlIdr),
			new NestedFieldValueImpl(orgnlTradRpstryIdrField, orgnlTradRpstryIdr)
		);
	}
}
