package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.ContractValuationData8__1;
import iso20022.auth030.jfsa.ValuationType1Code;
import java.math.BigDecimal;
import java.time.ZonedDateTime;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class ContractValuationData8__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<ContractValuationData8__1> {
	private final Field ctrctValField;
	private final Field tmStmpField;
	private final Field tpField;
	private final Field dltaField;
	
	private final AmountAndDirection109__1Project_JFSARewriteTradeReportToIso20022TypeTabulator amountAndDirection109__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public ContractValuationData8__1Project_JFSARewriteTradeReportToIso20022TypeTabulator(AmountAndDirection109__1Project_JFSARewriteTradeReportToIso20022TypeTabulator amountAndDirection109__1Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.amountAndDirection109__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = amountAndDirection109__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.ctrctValField = new FieldImpl(
			"ctrctVal",
			false,
			Optional.empty(),
			Optional.empty(),
			amountAndDirection109__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.tmStmpField = new FieldImpl(
			"tmStmp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.tpField = new FieldImpl(
			"tp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.dltaField = new FieldImpl(
			"dlta",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(ctrctValField, tmStmpField, tpField, dltaField);
	}
	
	@Override
	public List<FieldValue> tabulate(ContractValuationData8__1 input) {
		Optional<List<FieldValue>> ctrctVal = Optional.ofNullable(input.getCtrctVal())
			.map(x -> amountAndDirection109__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<ZonedDateTime> tmStmp = Optional.ofNullable(input.getTmStmp());
		Optional<ValuationType1Code> tp = Optional.ofNullable(input.getTp());
		Optional<BigDecimal> dlta = Optional.ofNullable(input.getDlta());
		return Arrays.asList(
			new NestedFieldValueImpl(ctrctValField, ctrctVal),
			new FieldValueImpl(tmStmpField, tmStmp),
			new FieldValueImpl(tpField, tp),
			new FieldValueImpl(dltaField, dlta)
		);
	}
}
