package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.CurrencyExchange22__1;
import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class CurrencyExchange22__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<CurrencyExchange22__1> {
	private final Field xchgRateField;
	private final Field xchgRateBsisField;
	
	private final ExchangeRateBasis1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator exchangeRateBasis1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public CurrencyExchange22__1Project_JFSARewriteTradeReportToIso20022TypeTabulator(ExchangeRateBasis1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator exchangeRateBasis1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.exchangeRateBasis1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = exchangeRateBasis1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.xchgRateField = new FieldImpl(
			"xchgRate",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.xchgRateBsisField = new FieldImpl(
			"xchgRateBsis",
			false,
			Optional.empty(),
			Optional.empty(),
			exchangeRateBasis1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(xchgRateField, xchgRateBsisField);
	}
	
	@Override
	public List<FieldValue> tabulate(CurrencyExchange22__1 input) {
		Optional<BigDecimal> xchgRate = Optional.ofNullable(input.getXchgRate());
		Optional<List<FieldValue>> xchgRateBsis = Optional.ofNullable(input.getXchgRateBsis())
			.map(x -> exchangeRateBasis1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new FieldValueImpl(xchgRateField, xchgRate),
			new NestedFieldValueImpl(xchgRateBsisField, xchgRateBsis)
		);
	}
}
