package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.jfsa.CurrencyExchange23__1;
import java.time.ZonedDateTime;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class CurrencyExchange23__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<CurrencyExchange23__1> {
	private final Field ccyField;
	private final Field fxgDtField;
	
	public CurrencyExchange23__1Project_JFSARewriteTradeReportToIso20022TypeTabulator() {
		this.ccyField = new FieldImpl(
			"ccy",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.fxgDtField = new FieldImpl(
			"fxgDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(ccyField, fxgDtField);
	}
	
	@Override
	public List<FieldValue> tabulate(CurrencyExchange23__1 input) {
		Optional<String> ccy = Optional.ofNullable(input.getCcy());
		Optional<ZonedDateTime> fxgDt = Optional.ofNullable(input.getFxgDt());
		return Arrays.asList(
			new FieldValueImpl(ccyField, ccy),
			new FieldValueImpl(fxgDtField, fxgDt)
		);
	}
}
