package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.jfsa.DateAndDateTime2Choice__1;
import java.time.ZonedDateTime;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class DateAndDateTime2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<DateAndDateTime2Choice__1> {
	private final Field dtTmField;
	
	public DateAndDateTime2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator() {
		this.dtTmField = new FieldImpl(
			"dtTm",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(dtTmField);
	}
	
	@Override
	public List<FieldValue> tabulate(DateAndDateTime2Choice__1 input) {
		Optional<ZonedDateTime> dtTm = Optional.ofNullable(input.getDtTm());
		return Arrays.asList(
			new FieldValueImpl(dtTmField, dtTm)
		);
	}
}
