package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.jfsa.DerivativePartyIdentification1Choice;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class DerivativePartyIdentification1ChoiceProject_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<DerivativePartyIdentification1Choice> {
	private final Field ctryField;
	private final Field ctrySubDvsnField;
	private final Field leiField;
	
	public DerivativePartyIdentification1ChoiceProject_JFSARewriteTradeReportToIso20022TypeTabulator() {
		this.ctryField = new FieldImpl(
			"ctry",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.ctrySubDvsnField = new FieldImpl(
			"ctrySubDvsn",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.leiField = new FieldImpl(
			"lei",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(ctryField, ctrySubDvsnField, leiField);
	}
	
	@Override
	public List<FieldValue> tabulate(DerivativePartyIdentification1Choice input) {
		Optional<String> ctry = Optional.ofNullable(input.getCtry());
		Optional<String> ctrySubDvsn = Optional.ofNullable(input.getCtrySubDvsn());
		Optional<String> lei = Optional.ofNullable(input.getLei());
		return Arrays.asList(
			new FieldValueImpl(ctryField, ctry),
			new FieldValueImpl(ctrySubDvsnField, ctrySubDvsn),
			new FieldValueImpl(leiField, lei)
		);
	}
}
