package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.jfsa.Direction2;
import iso20022.auth030.jfsa.OptionParty3Code;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class Direction2Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<Direction2> {
	private final Field drctnOfTheFrstLegField;
	private final Field drctnOfTheScndLegField;
	
	public Direction2Project_JFSARewriteTradeReportToIso20022TypeTabulator() {
		this.drctnOfTheFrstLegField = new FieldImpl(
			"drctnOfTheFrstLeg",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.drctnOfTheScndLegField = new FieldImpl(
			"drctnOfTheScndLeg",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(drctnOfTheFrstLegField, drctnOfTheScndLegField);
	}
	
	@Override
	public List<FieldValue> tabulate(Direction2 input) {
		Optional<OptionParty3Code> drctnOfTheFrstLeg = Optional.ofNullable(input.getDrctnOfTheFrstLeg());
		Optional<OptionParty3Code> drctnOfTheScndLeg = Optional.ofNullable(input.getDrctnOfTheScndLeg());
		return Arrays.asList(
			new FieldValueImpl(drctnOfTheFrstLegField, drctnOfTheFrstLeg),
			new FieldValueImpl(drctnOfTheScndLegField, drctnOfTheScndLeg)
		);
	}
}
