package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.Direction4Choice;
import iso20022.auth030.jfsa.OptionParty1Code;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class Direction4ChoiceProject_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<Direction4Choice> {
	private final Field drctnField;
	private final Field ctrPtySdField;
	
	private final Direction2Project_JFSARewriteTradeReportToIso20022TypeTabulator direction2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public Direction4ChoiceProject_JFSARewriteTradeReportToIso20022TypeTabulator(Direction2Project_JFSARewriteTradeReportToIso20022TypeTabulator direction2Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.direction2Project_JFSARewriteTradeReportToIso20022TypeTabulator = direction2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.drctnField = new FieldImpl(
			"drctn",
			false,
			Optional.empty(),
			Optional.empty(),
			direction2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.ctrPtySdField = new FieldImpl(
			"ctrPtySd",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(drctnField, ctrPtySdField);
	}
	
	@Override
	public List<FieldValue> tabulate(Direction4Choice input) {
		Optional<List<FieldValue>> drctn = Optional.ofNullable(input.getDrctn())
			.map(x -> direction2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<OptionParty1Code> ctrPtySd = Optional.ofNullable(input.getCtrPtySd());
		return Arrays.asList(
			new NestedFieldValueImpl(drctnField, drctn),
			new FieldValueImpl(ctrPtySdField, ctrPtySd)
		);
	}
}
