package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.jfsa.ExchangeRateBasis1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class ExchangeRateBasis1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<ExchangeRateBasis1> {
	private final Field baseCcyField;
	private final Field qtdCcyField;
	
	public ExchangeRateBasis1Project_JFSARewriteTradeReportToIso20022TypeTabulator() {
		this.baseCcyField = new FieldImpl(
			"baseCcy",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.qtdCcyField = new FieldImpl(
			"qtdCcy",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(baseCcyField, qtdCcyField);
	}
	
	@Override
	public List<FieldValue> tabulate(ExchangeRateBasis1 input) {
		Optional<String> baseCcy = Optional.ofNullable(input.getBaseCcy());
		Optional<String> qtdCcy = Optional.ofNullable(input.getQtdCcy());
		return Arrays.asList(
			new FieldValueImpl(baseCcyField, baseCcy),
			new FieldValueImpl(qtdCcyField, qtdCcy)
		);
	}
}
