package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.records.Date;
import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.jfsa.ExerciseDate1Choice__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class ExerciseDate1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<ExerciseDate1Choice__1> {
	private final Field frstExrcDtField;
	
	public ExerciseDate1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator() {
		this.frstExrcDtField = new FieldImpl(
			"frstExrcDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(frstExrcDtField);
	}
	
	@Override
	public List<FieldValue> tabulate(ExerciseDate1Choice__1 input) {
		Optional<Date> frstExrcDt = Optional.ofNullable(input.getFrstExrcDt());
		return Arrays.asList(
			new FieldValueImpl(frstExrcDtField, frstExrcDt)
		);
	}
}
