package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.FixedRate10__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class FixedRate10__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<FixedRate10__1> {
	private final Field rateField;
	private final Field dayCntField;
	private final Field pmtFrqcyField;
	
	private final SecuritiesTransactionPrice14Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator securitiesTransactionPrice14Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final InterestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator interestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final InterestRateFrequency3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator interestRateFrequency3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public FixedRate10__1Project_JFSARewriteTradeReportToIso20022TypeTabulator(SecuritiesTransactionPrice14Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator securitiesTransactionPrice14Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, InterestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator interestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, InterestRateFrequency3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator interestRateFrequency3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.securitiesTransactionPrice14Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = securitiesTransactionPrice14Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.interestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = interestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.interestRateFrequency3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = interestRateFrequency3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.rateField = new FieldImpl(
			"rate",
			false,
			Optional.empty(),
			Optional.empty(),
			securitiesTransactionPrice14Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.dayCntField = new FieldImpl(
			"dayCnt",
			false,
			Optional.empty(),
			Optional.empty(),
			interestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.pmtFrqcyField = new FieldImpl(
			"pmtFrqcy",
			false,
			Optional.empty(),
			Optional.empty(),
			interestRateFrequency3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(rateField, dayCntField, pmtFrqcyField);
	}
	
	@Override
	public List<FieldValue> tabulate(FixedRate10__1 input) {
		Optional<List<FieldValue>> rate = Optional.ofNullable(input.getRate())
			.map(x -> securitiesTransactionPrice14Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> dayCnt = Optional.ofNullable(input.getDayCnt())
			.map(x -> interestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> pmtFrqcy = Optional.ofNullable(input.getPmtFrqcy())
			.map(x -> interestRateFrequency3Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(rateField, rate),
			new NestedFieldValueImpl(dayCntField, dayCnt),
			new NestedFieldValueImpl(pmtFrqcyField, pmtFrqcy)
		);
	}
}
