package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.FloatingRate13__3;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class FloatingRate13__3Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<FloatingRate13__3> {
	private final Field nmField;
	private final Field rateField;
	private final Field refPrdField;
	private final Field sprdField;
	private final Field dayCntField;
	private final Field pmtFrqcyField;
	private final Field rstFrqcyField;
	
	private final FloatingRateIdentification8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator floatingRateIdentification8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final InterestRateContractTerm4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator interestRateContractTerm4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final SecuritiesTransactionPrice20Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator securitiesTransactionPrice20Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final InterestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator interestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final InterestRateFrequency3Choice__2Project_JFSARewriteTradeReportToIso20022TypeTabulator interestRateFrequency3Choice__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public FloatingRate13__3Project_JFSARewriteTradeReportToIso20022TypeTabulator(FloatingRateIdentification8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator floatingRateIdentification8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, InterestRateContractTerm4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator interestRateContractTerm4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, SecuritiesTransactionPrice20Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator securitiesTransactionPrice20Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, InterestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator interestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, InterestRateFrequency3Choice__2Project_JFSARewriteTradeReportToIso20022TypeTabulator interestRateFrequency3Choice__2Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.floatingRateIdentification8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = floatingRateIdentification8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.interestRateContractTerm4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = interestRateContractTerm4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.securitiesTransactionPrice20Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = securitiesTransactionPrice20Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.interestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = interestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.interestRateFrequency3Choice__2Project_JFSARewriteTradeReportToIso20022TypeTabulator = interestRateFrequency3Choice__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.nmField = new FieldImpl(
			"nm",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.rateField = new FieldImpl(
			"rate",
			false,
			Optional.empty(),
			Optional.empty(),
			floatingRateIdentification8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.refPrdField = new FieldImpl(
			"refPrd",
			false,
			Optional.empty(),
			Optional.empty(),
			interestRateContractTerm4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.sprdField = new FieldImpl(
			"sprd",
			false,
			Optional.empty(),
			Optional.empty(),
			securitiesTransactionPrice20Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.dayCntField = new FieldImpl(
			"dayCnt",
			false,
			Optional.empty(),
			Optional.empty(),
			interestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.pmtFrqcyField = new FieldImpl(
			"pmtFrqcy",
			false,
			Optional.empty(),
			Optional.empty(),
			interestRateFrequency3Choice__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.rstFrqcyField = new FieldImpl(
			"rstFrqcy",
			false,
			Optional.empty(),
			Optional.empty(),
			interestRateFrequency3Choice__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(nmField, rateField, refPrdField, sprdField, dayCntField, pmtFrqcyField, rstFrqcyField);
	}
	
	@Override
	public List<FieldValue> tabulate(FloatingRate13__3 input) {
		Optional<String> nm = Optional.ofNullable(input.getNm());
		Optional<List<FieldValue>> rate = Optional.ofNullable(input.getRate())
			.map(x -> floatingRateIdentification8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> refPrd = Optional.ofNullable(input.getRefPrd())
			.map(x -> interestRateContractTerm4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> sprd = Optional.ofNullable(input.getSprd())
			.map(x -> securitiesTransactionPrice20Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> dayCnt = Optional.ofNullable(input.getDayCnt())
			.map(x -> interestComputationMethodFormat7__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> pmtFrqcy = Optional.ofNullable(input.getPmtFrqcy())
			.map(x -> interestRateFrequency3Choice__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> rstFrqcy = Optional.ofNullable(input.getRstFrqcy())
			.map(x -> interestRateFrequency3Choice__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new FieldValueImpl(nmField, nm),
			new NestedFieldValueImpl(rateField, rate),
			new NestedFieldValueImpl(refPrdField, refPrd),
			new NestedFieldValueImpl(sprdField, sprd),
			new NestedFieldValueImpl(dayCntField, dayCnt),
			new NestedFieldValueImpl(pmtFrqcyField, pmtFrqcy),
			new NestedFieldValueImpl(rstFrqcyField, rstFrqcy)
		);
	}
}
