package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.jfsa.GenericIdentification184;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class GenericIdentification184Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<GenericIdentification184> {
	private final Field idField;
	private final Field srcField;
	
	public GenericIdentification184Project_JFSARewriteTradeReportToIso20022TypeTabulator() {
		this.idField = new FieldImpl(
			"id",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.srcField = new FieldImpl(
			"src",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(idField, srcField);
	}
	
	@Override
	public List<FieldValue> tabulate(GenericIdentification184 input) {
		Optional<String> id = Optional.ofNullable(input.getId());
		Optional<String> src = Optional.ofNullable(input.getSrc());
		return Arrays.asList(
			new FieldValueImpl(idField, id),
			new FieldValueImpl(srcField, src)
		);
	}
}
