package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.jfsa.IndexIdentification1__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class IndexIdentification1__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<IndexIdentification1__1> {
	private final Field isinField;
	private final Field nmField;
	private final Field indxField;
	
	public IndexIdentification1__1Project_JFSARewriteTradeReportToIso20022TypeTabulator() {
		this.isinField = new FieldImpl(
			"isin",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.nmField = new FieldImpl(
			"nm",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.indxField = new FieldImpl(
			"indx",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(isinField, nmField, indxField);
	}
	
	@Override
	public List<FieldValue> tabulate(IndexIdentification1__1 input) {
		Optional<String> isin = Optional.ofNullable(input.getIsin());
		Optional<String> nm = Optional.ofNullable(input.getNm());
		Optional<String> indx = Optional.ofNullable(input.getIndx());
		return Arrays.asList(
			new FieldValueImpl(isinField, isin),
			new FieldValueImpl(nmField, nm),
			new FieldValueImpl(indxField, indx)
		);
	}
}
