package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.jfsa.Frequency13Code;
import iso20022.auth030.jfsa.InterestRateContractTerm4;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class InterestRateContractTerm4Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<InterestRateContractTerm4> {
	private final Field unitField;
	private final Field valField;
	
	public InterestRateContractTerm4Project_JFSARewriteTradeReportToIso20022TypeTabulator() {
		this.unitField = new FieldImpl(
			"unit",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.valField = new FieldImpl(
			"val",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(unitField, valField);
	}
	
	@Override
	public List<FieldValue> tabulate(InterestRateContractTerm4 input) {
		Optional<Frequency13Code> unit = Optional.ofNullable(input.getUnit());
		Optional<Integer> val = Optional.ofNullable(input.getVal());
		return Arrays.asList(
			new FieldValueImpl(unitField, unit),
			new FieldValueImpl(valField, val)
		);
	}
}
