package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.MultiNestedFieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.NotionalAmount6__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;
import javax.inject.Inject;


public class NotionalAmount6__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<NotionalAmount6__1> {
	private final Field amtField;
	private final Field schdlPrdField;
	
	private final AmountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator amountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final Schedule11__1Project_JFSARewriteTradeReportToIso20022TypeTabulator schedule11__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public NotionalAmount6__1Project_JFSARewriteTradeReportToIso20022TypeTabulator(AmountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator amountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator, Schedule11__1Project_JFSARewriteTradeReportToIso20022TypeTabulator schedule11__1Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.amountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator = amountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.schedule11__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = schedule11__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.amtField = new FieldImpl(
			"amt",
			false,
			Optional.empty(),
			Optional.empty(),
			amountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.schdlPrdField = new FieldImpl(
			"schdlPrd",
			true,
			Optional.empty(),
			Optional.empty(),
			schedule11__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(amtField, schdlPrdField);
	}
	
	@Override
	public List<FieldValue> tabulate(NotionalAmount6__1 input) {
		Optional<List<FieldValue>> amt = Optional.ofNullable(input.getAmt())
			.map(x -> amountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<List<FieldValue>>> schdlPrd = Optional.ofNullable(input.getSchdlPrd())
			.map(x -> x.stream()
				.map(_x -> schedule11__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(_x))
				.collect(Collectors.toList()));
		return Arrays.asList(
			new NestedFieldValueImpl(amtField, amt),
			new MultiNestedFieldValueImpl(schdlPrdField, schdlPrd)
		);
	}
}
