package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.NotionalAmountLegs5__2;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class NotionalAmountLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<NotionalAmountLegs5__2> {
	private final Field frstLegField;
	private final Field scndLegField;
	
	private final NotionalAmount5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator notionalAmount5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final NotionalAmount6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator notionalAmount6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public NotionalAmountLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator(NotionalAmount5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator notionalAmount5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator, NotionalAmount6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator notionalAmount6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.notionalAmount5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator = notionalAmount5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.notionalAmount6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator = notionalAmount6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.frstLegField = new FieldImpl(
			"frstLeg",
			false,
			Optional.empty(),
			Optional.empty(),
			notionalAmount5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.scndLegField = new FieldImpl(
			"scndLeg",
			false,
			Optional.empty(),
			Optional.empty(),
			notionalAmount6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(frstLegField, scndLegField);
	}
	
	@Override
	public List<FieldValue> tabulate(NotionalAmountLegs5__2 input) {
		Optional<List<FieldValue>> frstLeg = Optional.ofNullable(input.getFrstLeg())
			.map(x -> notionalAmount5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> scndLeg = Optional.ofNullable(input.getScndLeg())
			.map(x -> notionalAmount6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(frstLegField, frstLeg),
			new NestedFieldValueImpl(scndLegField, scndLeg)
		);
	}
}
