package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.records.Date;
import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.EmbeddedType1Code;
import iso20022.auth030.jfsa.OptionOrSwaption10__2;
import iso20022.auth030.jfsa.OptionStyle6Code;
import iso20022.auth030.jfsa.OptionType2Code;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class OptionOrSwaption10__2Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<OptionOrSwaption10__2> {
	private final Field tpField;
	private final Field mbddTpField;
	private final Field exrcStyleField;
	private final Field exrcDtField;
	private final Field strkPricField;
	private final Field callAmtField;
	private final Field putAmtField;
	private final Field prmAmtField;
	private final Field prmPmtDtField;
	private final Field mtrtyDtOfUndrlygField;
	
	private final ExerciseDate1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator exerciseDate1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final SecuritiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator securitiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final ActiveOrHistoricCurrencyAnd5DecimalAmountProject_JFSARewriteTradeReportToIso20022TypeTabulator activeOrHistoricCurrencyAnd5DecimalAmountProject_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public OptionOrSwaption10__2Project_JFSARewriteTradeReportToIso20022TypeTabulator(ExerciseDate1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator exerciseDate1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, SecuritiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator securitiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, ActiveOrHistoricCurrencyAnd5DecimalAmountProject_JFSARewriteTradeReportToIso20022TypeTabulator activeOrHistoricCurrencyAnd5DecimalAmountProject_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.exerciseDate1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = exerciseDate1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.securitiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = securitiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.activeOrHistoricCurrencyAnd5DecimalAmountProject_JFSARewriteTradeReportToIso20022TypeTabulator = activeOrHistoricCurrencyAnd5DecimalAmountProject_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.tpField = new FieldImpl(
			"tp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.mbddTpField = new FieldImpl(
			"mbddTp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.exrcStyleField = new FieldImpl(
			"exrcStyle",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.exrcDtField = new FieldImpl(
			"exrcDt",
			false,
			Optional.empty(),
			Optional.empty(),
			exerciseDate1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.strkPricField = new FieldImpl(
			"strkPric",
			false,
			Optional.empty(),
			Optional.empty(),
			securitiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.callAmtField = new FieldImpl(
			"callAmt",
			false,
			Optional.empty(),
			Optional.empty(),
			activeOrHistoricCurrencyAnd5DecimalAmountProject_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.putAmtField = new FieldImpl(
			"putAmt",
			false,
			Optional.empty(),
			Optional.empty(),
			activeOrHistoricCurrencyAnd5DecimalAmountProject_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.prmAmtField = new FieldImpl(
			"prmAmt",
			false,
			Optional.empty(),
			Optional.empty(),
			activeOrHistoricCurrencyAnd5DecimalAmountProject_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.prmPmtDtField = new FieldImpl(
			"prmPmtDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.mtrtyDtOfUndrlygField = new FieldImpl(
			"mtrtyDtOfUndrlyg",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(tpField, mbddTpField, exrcStyleField, exrcDtField, strkPricField, callAmtField, putAmtField, prmAmtField, prmPmtDtField, mtrtyDtOfUndrlygField);
	}
	
	@Override
	public List<FieldValue> tabulate(OptionOrSwaption10__2 input) {
		Optional<OptionType2Code> tp = Optional.ofNullable(input.getTp());
		Optional<EmbeddedType1Code> mbddTp = Optional.ofNullable(input.getMbddTp());
		Optional<OptionStyle6Code> exrcStyle = Optional.ofNullable(input.getExrcStyle());
		Optional<List<FieldValue>> exrcDt = Optional.ofNullable(input.getExrcDt())
			.map(x -> exerciseDate1Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> strkPric = Optional.ofNullable(input.getStrkPric())
			.map(x -> securitiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> callAmt = Optional.ofNullable(input.getCallAmt())
			.map(x -> activeOrHistoricCurrencyAnd5DecimalAmountProject_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> putAmt = Optional.ofNullable(input.getPutAmt())
			.map(x -> activeOrHistoricCurrencyAnd5DecimalAmountProject_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> prmAmt = Optional.ofNullable(input.getPrmAmt())
			.map(x -> activeOrHistoricCurrencyAnd5DecimalAmountProject_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<Date> prmPmtDt = Optional.ofNullable(input.getPrmPmtDt());
		Optional<Date> mtrtyDtOfUndrlyg = Optional.ofNullable(input.getMtrtyDtOfUndrlyg());
		return Arrays.asList(
			new FieldValueImpl(tpField, tp),
			new FieldValueImpl(mbddTpField, mbddTp),
			new FieldValueImpl(exrcStyleField, exrcStyle),
			new NestedFieldValueImpl(exrcDtField, exrcDt),
			new NestedFieldValueImpl(strkPricField, strkPric),
			new NestedFieldValueImpl(callAmtField, callAmt),
			new NestedFieldValueImpl(putAmtField, putAmt),
			new NestedFieldValueImpl(prmAmtField, prmAmt),
			new FieldValueImpl(prmPmtDtField, prmPmtDt),
			new FieldValueImpl(mtrtyDtOfUndrlygField, mtrtyDtOfUndrlyg)
		);
	}
}
