package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.records.Date;
import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.OtherPayment5__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class OtherPayment5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<OtherPayment5__1> {
	private final Field pmtAmtField;
	private final Field pmtTpField;
	private final Field pmtDtField;
	private final Field pmtPyerField;
	private final Field pmtRcvrField;
	
	private final AmountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator amountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final PaymentType5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator paymentType5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final PartyIdentification236Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator partyIdentification236Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public OtherPayment5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator(AmountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator amountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator, PaymentType5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator paymentType5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, PartyIdentification236Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator partyIdentification236Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.amountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator = amountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.paymentType5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = paymentType5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.partyIdentification236Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = partyIdentification236Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.pmtAmtField = new FieldImpl(
			"pmtAmt",
			false,
			Optional.empty(),
			Optional.empty(),
			amountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.pmtTpField = new FieldImpl(
			"pmtTp",
			false,
			Optional.empty(),
			Optional.empty(),
			paymentType5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.pmtDtField = new FieldImpl(
			"pmtDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.pmtPyerField = new FieldImpl(
			"pmtPyer",
			false,
			Optional.empty(),
			Optional.empty(),
			partyIdentification236Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.pmtRcvrField = new FieldImpl(
			"pmtRcvr",
			false,
			Optional.empty(),
			Optional.empty(),
			partyIdentification236Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(pmtAmtField, pmtTpField, pmtDtField, pmtPyerField, pmtRcvrField);
	}
	
	@Override
	public List<FieldValue> tabulate(OtherPayment5__1 input) {
		Optional<List<FieldValue>> pmtAmt = Optional.ofNullable(input.getPmtAmt())
			.map(x -> amountAndDirection106__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> pmtTp = Optional.ofNullable(input.getPmtTp())
			.map(x -> paymentType5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<Date> pmtDt = Optional.ofNullable(input.getPmtDt());
		Optional<List<FieldValue>> pmtPyer = Optional.ofNullable(input.getPmtPyer())
			.map(x -> partyIdentification236Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> pmtRcvr = Optional.ofNullable(input.getPmtRcvr())
			.map(x -> partyIdentification236Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(pmtAmtField, pmtAmt),
			new NestedFieldValueImpl(pmtTpField, pmtTp),
			new FieldValueImpl(pmtDtField, pmtDt),
			new NestedFieldValueImpl(pmtPyerField, pmtPyer),
			new NestedFieldValueImpl(pmtRcvrField, pmtRcvr)
		);
	}
}
