package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.jfsa.PortfolioIdentification3__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class PortfolioIdentification3__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<PortfolioIdentification3__1> {
	private final Field cdField;
	
	public PortfolioIdentification3__1Project_JFSARewriteTradeReportToIso20022TypeTabulator() {
		this.cdField = new FieldImpl(
			"cd",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(cdField);
	}
	
	@Override
	public List<FieldValue> tabulate(PortfolioIdentification3__1 input) {
		Optional<String> cd = Optional.ofNullable(input.getCd());
		return Arrays.asList(
			new FieldValueImpl(cdField, cd)
		);
	}
}
