package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.MultiNestedFieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.PriceData2__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;
import javax.inject.Inject;


public class PriceData2__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<PriceData2__1> {
	private final Field pricField;
	private final Field schdlPrdField;
	private final Field unitOfMeasrField;
	
	private final SecuritiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator securitiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final Schedule1__1Project_JFSARewriteTradeReportToIso20022TypeTabulator schedule1__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final UnitOfMeasure8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator unitOfMeasure8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public PriceData2__1Project_JFSARewriteTradeReportToIso20022TypeTabulator(SecuritiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator securitiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, Schedule1__1Project_JFSARewriteTradeReportToIso20022TypeTabulator schedule1__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, UnitOfMeasure8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator unitOfMeasure8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.securitiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = securitiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.schedule1__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = schedule1__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.unitOfMeasure8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = unitOfMeasure8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.pricField = new FieldImpl(
			"pric",
			false,
			Optional.empty(),
			Optional.empty(),
			securitiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.schdlPrdField = new FieldImpl(
			"schdlPrd",
			true,
			Optional.empty(),
			Optional.empty(),
			schedule1__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.unitOfMeasrField = new FieldImpl(
			"unitOfMeasr",
			false,
			Optional.empty(),
			Optional.empty(),
			unitOfMeasure8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(pricField, schdlPrdField, unitOfMeasrField);
	}
	
	@Override
	public List<FieldValue> tabulate(PriceData2__1 input) {
		Optional<List<FieldValue>> pric = Optional.ofNullable(input.getPric())
			.map(x -> securitiesTransactionPrice17Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<List<FieldValue>>> schdlPrd = Optional.ofNullable(input.getSchdlPrd())
			.map(x -> x.stream()
				.map(_x -> schedule1__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(_x))
				.collect(Collectors.toList()));
		Optional<List<FieldValue>> unitOfMeasr = Optional.ofNullable(input.getUnitOfMeasr())
			.map(x -> unitOfMeasure8Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(pricField, pric),
			new MultiNestedFieldValueImpl(schdlPrdField, schdlPrd),
			new NestedFieldValueImpl(unitOfMeasrField, unitOfMeasr)
		);
	}
}
