package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.jfsa.TradeConfirmation2;
import iso20022.auth030.jfsa.TradeConfirmationType1Code;
import java.time.ZonedDateTime;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class TradeConfirmation2Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<TradeConfirmation2> {
	private final Field tpField;
	private final Field tmStmpField;
	
	public TradeConfirmation2Project_JFSARewriteTradeReportToIso20022TypeTabulator() {
		this.tpField = new FieldImpl(
			"tp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.tmStmpField = new FieldImpl(
			"tmStmp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(tpField, tmStmpField);
	}
	
	@Override
	public List<FieldValue> tabulate(TradeConfirmation2 input) {
		Optional<TradeConfirmationType1Code> tp = Optional.ofNullable(input.getTp());
		Optional<ZonedDateTime> tmStmp = Optional.ofNullable(input.getTmStmp());
		return Arrays.asList(
			new FieldValueImpl(tpField, tp),
			new FieldValueImpl(tmStmpField, tmStmp)
		);
	}
}
