package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.TradeCounterpartyReport20__2;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class TradeCounterpartyReport20__2Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<TradeCounterpartyReport20__2> {
	private final Field rptgCtrPtyField;
	private final Field othrCtrPtyField;
	private final Field submitgAgtField;
	private final Field nttyRspnsblForRptField;
	
	private final Counterparty45__2Project_JFSARewriteTradeReportToIso20022TypeTabulator counterparty45__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final Counterparty46__1Project_JFSARewriteTradeReportToIso20022TypeTabulator counterparty46__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final OrganisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public TradeCounterpartyReport20__2Project_JFSARewriteTradeReportToIso20022TypeTabulator(Counterparty45__2Project_JFSARewriteTradeReportToIso20022TypeTabulator counterparty45__2Project_JFSARewriteTradeReportToIso20022TypeTabulator, Counterparty46__1Project_JFSARewriteTradeReportToIso20022TypeTabulator counterparty46__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, OrganisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.counterparty45__2Project_JFSARewriteTradeReportToIso20022TypeTabulator = counterparty45__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.counterparty46__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = counterparty46__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.rptgCtrPtyField = new FieldImpl(
			"rptgCtrPty",
			false,
			Optional.empty(),
			Optional.empty(),
			counterparty45__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.othrCtrPtyField = new FieldImpl(
			"othrCtrPty",
			false,
			Optional.empty(),
			Optional.empty(),
			counterparty46__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.submitgAgtField = new FieldImpl(
			"submitgAgt",
			false,
			Optional.empty(),
			Optional.empty(),
			organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.nttyRspnsblForRptField = new FieldImpl(
			"nttyRspnsblForRpt",
			false,
			Optional.empty(),
			Optional.empty(),
			organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(rptgCtrPtyField, othrCtrPtyField, submitgAgtField, nttyRspnsblForRptField);
	}
	
	@Override
	public List<FieldValue> tabulate(TradeCounterpartyReport20__2 input) {
		Optional<List<FieldValue>> rptgCtrPty = Optional.ofNullable(input.getRptgCtrPty())
			.map(x -> counterparty45__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> othrCtrPty = Optional.ofNullable(input.getOthrCtrPty())
			.map(x -> counterparty46__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> submitgAgt = Optional.ofNullable(input.getSubmitgAgt())
			.map(x -> organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> nttyRspnsblForRpt = Optional.ofNullable(input.getNttyRspnsblForRpt())
			.map(x -> organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(rptgCtrPtyField, rptgCtrPty),
			new NestedFieldValueImpl(othrCtrPtyField, othrCtrPty),
			new NestedFieldValueImpl(submitgAgtField, submitgAgt),
			new NestedFieldValueImpl(nttyRspnsblForRptField, nttyRspnsblForRpt)
		);
	}
}
