package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.TradeData42__5;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class TradeData42__5Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<TradeData42__5> {
	private final Field ctrPtySpcfcDataField;
	private final Field cmonTradDataField;
	private final Field techAttrbtsField;
	
	private final CounterpartySpecificData36__2Project_JFSARewriteTradeReportToIso20022TypeTabulator counterpartySpecificData36__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final CommonTradeDataReport69__5Project_JFSARewriteTradeReportToIso20022TypeTabulator commonTradeDataReport69__5Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final TechnicalAttributes5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator technicalAttributes5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public TradeData42__5Project_JFSARewriteTradeReportToIso20022TypeTabulator(CounterpartySpecificData36__2Project_JFSARewriteTradeReportToIso20022TypeTabulator counterpartySpecificData36__2Project_JFSARewriteTradeReportToIso20022TypeTabulator, CommonTradeDataReport69__5Project_JFSARewriteTradeReportToIso20022TypeTabulator commonTradeDataReport69__5Project_JFSARewriteTradeReportToIso20022TypeTabulator, TechnicalAttributes5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator technicalAttributes5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.counterpartySpecificData36__2Project_JFSARewriteTradeReportToIso20022TypeTabulator = counterpartySpecificData36__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.commonTradeDataReport69__5Project_JFSARewriteTradeReportToIso20022TypeTabulator = commonTradeDataReport69__5Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.technicalAttributes5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = technicalAttributes5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.ctrPtySpcfcDataField = new FieldImpl(
			"ctrPtySpcfcData",
			false,
			Optional.empty(),
			Optional.empty(),
			counterpartySpecificData36__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.cmonTradDataField = new FieldImpl(
			"cmonTradData",
			false,
			Optional.empty(),
			Optional.empty(),
			commonTradeDataReport69__5Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.techAttrbtsField = new FieldImpl(
			"techAttrbts",
			false,
			Optional.empty(),
			Optional.empty(),
			technicalAttributes5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(ctrPtySpcfcDataField, cmonTradDataField, techAttrbtsField);
	}
	
	@Override
	public List<FieldValue> tabulate(TradeData42__5 input) {
		Optional<List<FieldValue>> ctrPtySpcfcData = Optional.ofNullable(input.getCtrPtySpcfcData())
			.map(x -> counterpartySpecificData36__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> cmonTradData = Optional.ofNullable(input.getCmonTradData())
			.map(x -> commonTradeDataReport69__5Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> techAttrbts = Optional.ofNullable(input.getTechAttrbts())
			.map(x -> technicalAttributes5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(ctrPtySpcfcDataField, ctrPtySpcfcData),
			new NestedFieldValueImpl(cmonTradDataField, cmonTradData),
			new NestedFieldValueImpl(techAttrbtsField, techAttrbts)
		);
	}
}
