package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.MultiNestedFieldValueImpl;
import iso20022.auth030.jfsa.ReportPeriodActivity1Code;
import iso20022.auth030.jfsa.TradeData57Choice__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;
import javax.inject.Inject;


public class TradeData57Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<TradeData57Choice__1> {
	private final Field dataSetActnField;
	private final Field rptField;
	
	private final TradeReport32Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator tradeReport32Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public TradeData57Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator(TradeReport32Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator tradeReport32Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.tradeReport32Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = tradeReport32Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.dataSetActnField = new FieldImpl(
			"dataSetActn",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.rptField = new FieldImpl(
			"rpt",
			true,
			Optional.empty(),
			Optional.empty(),
			tradeReport32Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(dataSetActnField, rptField);
	}
	
	@Override
	public List<FieldValue> tabulate(TradeData57Choice__1 input) {
		Optional<ReportPeriodActivity1Code> dataSetActn = Optional.ofNullable(input.getDataSetActn());
		Optional<List<List<FieldValue>>> rpt = Optional.ofNullable(input.getRpt())
			.map(x -> x.stream()
				.map(_x -> tradeReport32Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(_x))
				.collect(Collectors.toList()));
		return Arrays.asList(
			new FieldValueImpl(dataSetActnField, dataSetActn),
			new MultiNestedFieldValueImpl(rptField, rpt)
		);
	}
}
