package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import iso20022.auth030.jfsa.TradeConfirmationType2Code;
import iso20022.auth030.jfsa.TradeNonConfirmation1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class TradeNonConfirmation1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<TradeNonConfirmation1> {
	private final Field tpField;
	
	public TradeNonConfirmation1Project_JFSARewriteTradeReportToIso20022TypeTabulator() {
		this.tpField = new FieldImpl(
			"tp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(tpField);
	}
	
	@Override
	public List<FieldValue> tabulate(TradeNonConfirmation1 input) {
		Optional<TradeConfirmationType2Code> tp = Optional.ofNullable(input.getTp());
		return Arrays.asList(
			new FieldValueImpl(tpField, tp)
		);
	}
}
