package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.TradeReportHeader4__1;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import javax.inject.Inject;


public class TradeReportHeader4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<TradeReportHeader4__1> {
	private final Field nbRcrdsField;
	private final Field newTradRpstryIdrField;
	
	private final OrganisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public TradeReportHeader4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator(OrganisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.nbRcrdsField = new FieldImpl(
			"nbRcrds",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.newTradRpstryIdrField = new FieldImpl(
			"newTradRpstryIdr",
			false,
			Optional.empty(),
			Optional.empty(),
			organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(nbRcrdsField, newTradRpstryIdrField);
	}
	
	@Override
	public List<FieldValue> tabulate(TradeReportHeader4__1 input) {
		Optional<Long> nbRcrds = Optional.ofNullable(input.getNbRcrds());
		Optional<List<FieldValue>> newTradRpstryIdr = Optional.ofNullable(input.getNewTradRpstryIdr())
			.map(x -> organisationIdentification15Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new FieldValueImpl(nbRcrdsField, nbRcrds),
			new NestedFieldValueImpl(newTradRpstryIdrField, newTradRpstryIdr)
		);
	}
}
