package drr.projection.iso20022.jfsa.rewrite.trade.projections;

import com.rosetta.model.lib.records.Date;
import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.MultiNestedFieldValueImpl;
import com.rosetta.model.lib.reports.Tabulator.NestedFieldValueImpl;
import iso20022.auth030.jfsa.PhysicalTransferType4Code;
import iso20022.auth030.jfsa.TradeTransaction49__6;
import java.time.ZonedDateTime;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;
import javax.inject.Inject;


public class TradeTransaction49__6Project_JFSARewriteTradeReportToIso20022TypeTabulator implements Tabulator<TradeTransaction49__6> {
	private final Field txIdField;
	private final Field collPrtflCdField;
	private final Field pltfmIdrField;
	private final Field txPricField;
	private final Field ntnlAmtField;
	private final Field ntnlQtyField;
	private final Field dlvryTpField;
	private final Field exctnTmStmpField;
	private final Field fctvDtField;
	private final Field xprtnDtField;
	private final Field sttlmDtField;
	private final Field derivEvtField;
	private final Field tradConfField;
	private final Field tradClrField;
	private final Field intrstRateField;
	private final Field ccyField;
	private final Field optnField;
	private final Field cdtField;
	private final Field othrPmtField;
	private final Field packgField;
	
	private final UniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator uniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final CollateralPortfolioCode5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator collateralPortfolioCode5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final PriceData2__2Project_JFSARewriteTradeReportToIso20022TypeTabulator priceData2__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final NotionalAmountLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator notionalAmountLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final NotionalQuantityLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator notionalQuantityLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final DerivativeEvent6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator derivativeEvent6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final TradeConfirmation1ChoiceProject_JFSARewriteTradeReportToIso20022TypeTabulator tradeConfirmation1ChoiceProject_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final TradeClearing11__2Project_JFSARewriteTradeReportToIso20022TypeTabulator tradeClearing11__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final InterestRateLegs14__3Project_JFSARewriteTradeReportToIso20022TypeTabulator interestRateLegs14__3Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final CurrencyExchange22__1Project_JFSARewriteTradeReportToIso20022TypeTabulator currencyExchange22__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final OptionOrSwaption10__2Project_JFSARewriteTradeReportToIso20022TypeTabulator optionOrSwaption10__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final CreditDerivative4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator creditDerivative4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final OtherPayment5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator otherPayment5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	private final Package4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator package4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
	
	@Inject
	public TradeTransaction49__6Project_JFSARewriteTradeReportToIso20022TypeTabulator(UniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator uniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, CollateralPortfolioCode5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator collateralPortfolioCode5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, PriceData2__2Project_JFSARewriteTradeReportToIso20022TypeTabulator priceData2__2Project_JFSARewriteTradeReportToIso20022TypeTabulator, NotionalAmountLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator notionalAmountLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator, NotionalQuantityLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator notionalQuantityLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator, DerivativeEvent6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator derivativeEvent6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator, TradeConfirmation1ChoiceProject_JFSARewriteTradeReportToIso20022TypeTabulator tradeConfirmation1ChoiceProject_JFSARewriteTradeReportToIso20022TypeTabulator, TradeClearing11__2Project_JFSARewriteTradeReportToIso20022TypeTabulator tradeClearing11__2Project_JFSARewriteTradeReportToIso20022TypeTabulator, InterestRateLegs14__3Project_JFSARewriteTradeReportToIso20022TypeTabulator interestRateLegs14__3Project_JFSARewriteTradeReportToIso20022TypeTabulator, CurrencyExchange22__1Project_JFSARewriteTradeReportToIso20022TypeTabulator currencyExchange22__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, OptionOrSwaption10__2Project_JFSARewriteTradeReportToIso20022TypeTabulator optionOrSwaption10__2Project_JFSARewriteTradeReportToIso20022TypeTabulator, CreditDerivative4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator creditDerivative4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, OtherPayment5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator otherPayment5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator, Package4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator package4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator) {
		this.uniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = uniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.collateralPortfolioCode5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = collateralPortfolioCode5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.priceData2__2Project_JFSARewriteTradeReportToIso20022TypeTabulator = priceData2__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.notionalAmountLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator = notionalAmountLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.notionalQuantityLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator = notionalQuantityLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.derivativeEvent6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator = derivativeEvent6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.tradeConfirmation1ChoiceProject_JFSARewriteTradeReportToIso20022TypeTabulator = tradeConfirmation1ChoiceProject_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.tradeClearing11__2Project_JFSARewriteTradeReportToIso20022TypeTabulator = tradeClearing11__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.interestRateLegs14__3Project_JFSARewriteTradeReportToIso20022TypeTabulator = interestRateLegs14__3Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.currencyExchange22__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = currencyExchange22__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.optionOrSwaption10__2Project_JFSARewriteTradeReportToIso20022TypeTabulator = optionOrSwaption10__2Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.creditDerivative4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = creditDerivative4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.otherPayment5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = otherPayment5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.package4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator = package4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator;
		this.txIdField = new FieldImpl(
			"txId",
			false,
			Optional.empty(),
			Optional.empty(),
			uniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.collPrtflCdField = new FieldImpl(
			"collPrtflCd",
			false,
			Optional.empty(),
			Optional.empty(),
			collateralPortfolioCode5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.pltfmIdrField = new FieldImpl(
			"pltfmIdr",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.txPricField = new FieldImpl(
			"txPric",
			false,
			Optional.empty(),
			Optional.empty(),
			priceData2__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.ntnlAmtField = new FieldImpl(
			"ntnlAmt",
			false,
			Optional.empty(),
			Optional.empty(),
			notionalAmountLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.ntnlQtyField = new FieldImpl(
			"ntnlQty",
			false,
			Optional.empty(),
			Optional.empty(),
			notionalQuantityLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.dlvryTpField = new FieldImpl(
			"dlvryTp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.exctnTmStmpField = new FieldImpl(
			"exctnTmStmp",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.fctvDtField = new FieldImpl(
			"fctvDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.xprtnDtField = new FieldImpl(
			"xprtnDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.sttlmDtField = new FieldImpl(
			"sttlmDt",
			false,
			Optional.empty(),
			Optional.empty(),
			Arrays.asList()
		);
		this.derivEvtField = new FieldImpl(
			"derivEvt",
			false,
			Optional.empty(),
			Optional.empty(),
			derivativeEvent6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.tradConfField = new FieldImpl(
			"tradConf",
			false,
			Optional.empty(),
			Optional.empty(),
			tradeConfirmation1ChoiceProject_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.tradClrField = new FieldImpl(
			"tradClr",
			false,
			Optional.empty(),
			Optional.empty(),
			tradeClearing11__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.intrstRateField = new FieldImpl(
			"intrstRate",
			false,
			Optional.empty(),
			Optional.empty(),
			interestRateLegs14__3Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.ccyField = new FieldImpl(
			"ccy",
			false,
			Optional.empty(),
			Optional.empty(),
			currencyExchange22__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.optnField = new FieldImpl(
			"optn",
			false,
			Optional.empty(),
			Optional.empty(),
			optionOrSwaption10__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.cdtField = new FieldImpl(
			"cdt",
			false,
			Optional.empty(),
			Optional.empty(),
			creditDerivative4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.othrPmtField = new FieldImpl(
			"othrPmt",
			true,
			Optional.empty(),
			Optional.empty(),
			otherPayment5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
		this.packgField = new FieldImpl(
			"packg",
			false,
			Optional.empty(),
			Optional.empty(),
			package4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.getFields()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(txIdField, collPrtflCdField, pltfmIdrField, txPricField, ntnlAmtField, ntnlQtyField, dlvryTpField, exctnTmStmpField, fctvDtField, xprtnDtField, sttlmDtField, derivEvtField, tradConfField, tradClrField, intrstRateField, ccyField, optnField, cdtField, othrPmtField, packgField);
	}
	
	@Override
	public List<FieldValue> tabulate(TradeTransaction49__6 input) {
		Optional<List<FieldValue>> txId = Optional.ofNullable(input.getTxId())
			.map(x -> uniqueTransactionIdentifier2Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> collPrtflCd = Optional.ofNullable(input.getCollPrtflCd())
			.map(x -> collateralPortfolioCode5Choice__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<String> pltfmIdr = Optional.ofNullable(input.getPltfmIdr());
		Optional<List<FieldValue>> txPric = Optional.ofNullable(input.getTxPric())
			.map(x -> priceData2__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> ntnlAmt = Optional.ofNullable(input.getNtnlAmt())
			.map(x -> notionalAmountLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> ntnlQty = Optional.ofNullable(input.getNtnlQty())
			.map(x -> notionalQuantityLegs5__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<PhysicalTransferType4Code> dlvryTp = Optional.ofNullable(input.getDlvryTp());
		Optional<ZonedDateTime> exctnTmStmp = Optional.ofNullable(input.getExctnTmStmp());
		Optional<Date> fctvDt = Optional.ofNullable(input.getFctvDt());
		Optional<Date> xprtnDt = Optional.ofNullable(input.getXprtnDt());
		Optional<Date> sttlmDt = Optional.ofNullable(input.getSttlmDt());
		Optional<List<FieldValue>> derivEvt = Optional.ofNullable(input.getDerivEvt())
			.map(x -> derivativeEvent6__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> tradConf = Optional.ofNullable(input.getTradConf())
			.map(x -> tradeConfirmation1ChoiceProject_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> tradClr = Optional.ofNullable(input.getTradClr())
			.map(x -> tradeClearing11__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> intrstRate = Optional.ofNullable(input.getIntrstRate())
			.map(x -> interestRateLegs14__3Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> ccy = Optional.ofNullable(input.getCcy())
			.map(x -> currencyExchange22__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> optn = Optional.ofNullable(input.getOptn())
			.map(x -> optionOrSwaption10__2Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<FieldValue>> cdt = Optional.ofNullable(input.getCdt())
			.map(x -> creditDerivative4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		Optional<List<List<FieldValue>>> othrPmt = Optional.ofNullable(input.getOthrPmt())
			.map(x -> x.stream()
				.map(_x -> otherPayment5__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(_x))
				.collect(Collectors.toList()));
		Optional<List<FieldValue>> packg = Optional.ofNullable(input.getPackg())
			.map(x -> package4__1Project_JFSARewriteTradeReportToIso20022TypeTabulator.tabulate(x));
		return Arrays.asList(
			new NestedFieldValueImpl(txIdField, txId),
			new NestedFieldValueImpl(collPrtflCdField, collPrtflCd),
			new FieldValueImpl(pltfmIdrField, pltfmIdr),
			new NestedFieldValueImpl(txPricField, txPric),
			new NestedFieldValueImpl(ntnlAmtField, ntnlAmt),
			new NestedFieldValueImpl(ntnlQtyField, ntnlQty),
			new FieldValueImpl(dlvryTpField, dlvryTp),
			new FieldValueImpl(exctnTmStmpField, exctnTmStmp),
			new FieldValueImpl(fctvDtField, fctvDt),
			new FieldValueImpl(xprtnDtField, xprtnDt),
			new FieldValueImpl(sttlmDtField, sttlmDt),
			new NestedFieldValueImpl(derivEvtField, derivEvt),
			new NestedFieldValueImpl(tradConfField, tradConf),
			new NestedFieldValueImpl(tradClrField, tradClr),
			new NestedFieldValueImpl(intrstRateField, intrstRate),
			new NestedFieldValueImpl(ccyField, ccy),
			new NestedFieldValueImpl(optnField, optn),
			new NestedFieldValueImpl(cdtField, cdt),
			new MultiNestedFieldValueImpl(othrPmtField, othrPmt),
			new NestedFieldValueImpl(packgField, packg)
		);
	}
}
