package drr.regulation.asic.rewrite.trade.meta;

import com.rosetta.model.lib.annotations.RosettaMeta;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.qualify.QualifyFunctionFactory;
import com.rosetta.model.lib.qualify.QualifyResult;
import com.rosetta.model.lib.validation.Validator;
import com.rosetta.model.lib.validation.ValidatorFactory;
import com.rosetta.model.lib.validation.ValidatorWithArg;
import drr.regulation.asic.rewrite.trade.ASICNonReportable;
import drr.regulation.asic.rewrite.trade.validation.ASICNonReportableTypeFormatValidator;
import drr.regulation.asic.rewrite.trade.validation.ASICNonReportableValidator;
import drr.regulation.asic.rewrite.trade.validation.exists.ASICNonReportableOnlyExistsValidator;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.Function;


/**
 * @version 4.2.1
 */
@RosettaMeta(model=ASICNonReportable.class)
public class ASICNonReportableMeta implements RosettaMetaData<ASICNonReportable> {

	@Override
	public List<Validator<? super ASICNonReportable>> dataRules(ValidatorFactory factory) {
		return Arrays.asList(
		);
	}
	
	@Override
	public List<Function<? super ASICNonReportable, QualifyResult>> getQualifyFunctions(QualifyFunctionFactory factory) {
		return Collections.emptyList();
	}

	@Override
	public Validator<? super ASICNonReportable> validator() {
		return new ASICNonReportableValidator();
	}

	@Override
	public Validator<? super ASICNonReportable> typeFormatValidator() {
		return new ASICNonReportableTypeFormatValidator();
	}
	
	@Override
	public ValidatorWithArg<? super ASICNonReportable, Set<String>> onlyExistsValidator() {
		return new ASICNonReportableOnlyExistsValidator();
	}
}
