package drr.regulation.asic.rewrite.trade.meta;

import com.rosetta.model.lib.annotations.RosettaMeta;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.qualify.QualifyFunctionFactory;
import com.rosetta.model.lib.qualify.QualifyResult;
import com.rosetta.model.lib.validation.Validator;
import com.rosetta.model.lib.validation.ValidatorFactory;
import com.rosetta.model.lib.validation.ValidatorWithArg;
import drr.regulation.asic.rewrite.trade.NotionalAmountScheduleLeg2Report;
import drr.regulation.asic.rewrite.trade.validation.NotionalAmountScheduleLeg2ReportTypeFormatValidator;
import drr.regulation.asic.rewrite.trade.validation.NotionalAmountScheduleLeg2ReportValidator;
import drr.regulation.asic.rewrite.trade.validation.exists.NotionalAmountScheduleLeg2ReportOnlyExistsValidator;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.Function;


/**
 * @version 4.2.1
 */
@RosettaMeta(model=NotionalAmountScheduleLeg2Report.class)
public class NotionalAmountScheduleLeg2ReportMeta implements RosettaMetaData<NotionalAmountScheduleLeg2Report> {

	@Override
	public List<Validator<? super NotionalAmountScheduleLeg2Report>> dataRules(ValidatorFactory factory) {
		return Arrays.asList(
		);
	}
	
	@Override
	public List<Function<? super NotionalAmountScheduleLeg2Report, QualifyResult>> getQualifyFunctions(QualifyFunctionFactory factory) {
		return Collections.emptyList();
	}

	@Override
	public Validator<? super NotionalAmountScheduleLeg2Report> validator() {
		return new NotionalAmountScheduleLeg2ReportValidator();
	}

	@Override
	public Validator<? super NotionalAmountScheduleLeg2Report> typeFormatValidator() {
		return new NotionalAmountScheduleLeg2ReportTypeFormatValidator();
	}
	
	@Override
	public ValidatorWithArg<? super NotionalAmountScheduleLeg2Report, Set<String>> onlyExistsValidator() {
		return new NotionalAmountScheduleLeg2ReportOnlyExistsValidator();
	}
}
