package drr.regulation.asic.rewrite.trade.reports;

import cdm.base.math.DatedValue;
import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.records.Date;
import com.rosetta.model.lib.reports.ReportFunction;
import drr.standards.iosco.cde.reports.CDENotionalAmountScheduleEffectiveDateRule;
import javax.inject.Inject;


@ImplementedBy(NotionalAmountScheduleEffectiveDateLeg2Rule.NotionalAmountScheduleEffectiveDateLeg2RuleDefault.class)
public abstract class NotionalAmountScheduleEffectiveDateLeg2Rule implements ReportFunction<DatedValue, Date> {
	
	// RosettaFunction dependencies
	//
	@Inject protected CDENotionalAmountScheduleEffectiveDateRule cDENotionalAmountScheduleEffectiveDate;

	/**
	* @param input 
	* @return output 
	*/
	@Override
	public Date evaluate(DatedValue input) {
		Date output = doEvaluate(input);
		
		return output;
	}

	protected abstract Date doEvaluate(DatedValue input);

	public static class NotionalAmountScheduleEffectiveDateLeg2RuleDefault extends NotionalAmountScheduleEffectiveDateLeg2Rule {
		@Override
		protected Date doEvaluate(DatedValue input) {
			Date output = null;
			return assignOutput(output, input);
		}
		
		protected Date assignOutput(Date output, DatedValue input) {
			output = cDENotionalAmountScheduleEffectiveDate.evaluate(input);
			
			return output;
		}
	}
}
