package drr.regulation.cftc.rewrite.meta;

import com.rosetta.model.lib.annotations.RosettaMeta;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.qualify.QualifyFunctionFactory;
import com.rosetta.model.lib.qualify.QualifyResult;
import com.rosetta.model.lib.validation.Validator;
import com.rosetta.model.lib.validation.ValidatorFactory;
import com.rosetta.model.lib.validation.ValidatorWithArg;
import drr.regulation.cftc.rewrite.CFTCGuidebookPart45;
import drr.regulation.cftc.rewrite.validation.CFTCGuidebookPart45TypeFormatValidator;
import drr.regulation.cftc.rewrite.validation.CFTCGuidebookPart45Validator;
import drr.regulation.cftc.rewrite.validation.exists.CFTCGuidebookPart45OnlyExistsValidator;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.Function;


/**
 * @version 4.2.1
 */
@RosettaMeta(model=CFTCGuidebookPart45.class)
public class CFTCGuidebookPart45Meta implements RosettaMetaData<CFTCGuidebookPart45> {

	@Override
	public List<Validator<? super CFTCGuidebookPart45>> dataRules(ValidatorFactory factory) {
		return Arrays.asList(
			factory.create(drr.regulation.cftc.rewrite.validation.datarule.CFTCGuidebookPart45LargeNotionalOffFacilitySwapElectionIndicator.class),
			factory.create(drr.regulation.cftc.rewrite.validation.datarule.CFTCGuidebookPart45SefOrDcmAnonymousIndicator.class),
			factory.create(drr.regulation.cftc.rewrite.validation.datarule.CFTCGuidebookPart45SdMspIndicatorParty2.class),
			factory.create(drr.regulation.cftc.rewrite.validation.datarule.CFTCGuidebookPart45PhysicalCommodityIndicator.class)
		);
	}
	
	@Override
	public List<Function<? super CFTCGuidebookPart45, QualifyResult>> getQualifyFunctions(QualifyFunctionFactory factory) {
		return Collections.emptyList();
	}

	@Override
	public Validator<? super CFTCGuidebookPart45> validator() {
		return new CFTCGuidebookPart45Validator();
	}

	@Override
	public Validator<? super CFTCGuidebookPart45> typeFormatValidator() {
		return new CFTCGuidebookPart45TypeFormatValidator();
	}
	
	@Override
	public ValidatorWithArg<? super CFTCGuidebookPart45, Set<String>> onlyExistsValidator() {
		return new CFTCGuidebookPart45OnlyExistsValidator();
	}
}
