package drr.regulation.cftc.rewrite.meta;

import com.rosetta.model.lib.annotations.RosettaMeta;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.qualify.QualifyFunctionFactory;
import com.rosetta.model.lib.qualify.QualifyResult;
import com.rosetta.model.lib.validation.Validator;
import com.rosetta.model.lib.validation.ValidatorFactory;
import com.rosetta.model.lib.validation.ValidatorWithArg;
import drr.regulation.cftc.rewrite.ClearingExceptionsAndExemptionsCounterparty1Report;
import drr.regulation.cftc.rewrite.validation.ClearingExceptionsAndExemptionsCounterparty1ReportTypeFormatValidator;
import drr.regulation.cftc.rewrite.validation.ClearingExceptionsAndExemptionsCounterparty1ReportValidator;
import drr.regulation.cftc.rewrite.validation.exists.ClearingExceptionsAndExemptionsCounterparty1ReportOnlyExistsValidator;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.Function;


/**
 * @version 4.2.1
 */
@RosettaMeta(model=ClearingExceptionsAndExemptionsCounterparty1Report.class)
public class ClearingExceptionsAndExemptionsCounterparty1ReportMeta implements RosettaMetaData<ClearingExceptionsAndExemptionsCounterparty1Report> {

	@Override
	public List<Validator<? super ClearingExceptionsAndExemptionsCounterparty1Report>> dataRules(ValidatorFactory factory) {
		return Arrays.asList(
		);
	}
	
	@Override
	public List<Function<? super ClearingExceptionsAndExemptionsCounterparty1Report, QualifyResult>> getQualifyFunctions(QualifyFunctionFactory factory) {
		return Collections.emptyList();
	}

	@Override
	public Validator<? super ClearingExceptionsAndExemptionsCounterparty1Report> validator() {
		return new ClearingExceptionsAndExemptionsCounterparty1ReportValidator();
	}

	@Override
	public Validator<? super ClearingExceptionsAndExemptionsCounterparty1Report> typeFormatValidator() {
		return new ClearingExceptionsAndExemptionsCounterparty1ReportTypeFormatValidator();
	}
	
	@Override
	public ValidatorWithArg<? super ClearingExceptionsAndExemptionsCounterparty1Report, Set<String>> onlyExistsValidator() {
		return new ClearingExceptionsAndExemptionsCounterparty1ReportOnlyExistsValidator();
	}
}
