package drr.regulation.cftc.rewrite.meta;

import com.rosetta.model.lib.annotations.RosettaMeta;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.qualify.QualifyFunctionFactory;
import com.rosetta.model.lib.qualify.QualifyResult;
import com.rosetta.model.lib.validation.Validator;
import com.rosetta.model.lib.validation.ValidatorFactory;
import com.rosetta.model.lib.validation.ValidatorWithArg;
import drr.regulation.cftc.rewrite.ClearingExceptionsAndExemptionsCounterparty2Report;
import drr.regulation.cftc.rewrite.validation.ClearingExceptionsAndExemptionsCounterparty2ReportTypeFormatValidator;
import drr.regulation.cftc.rewrite.validation.ClearingExceptionsAndExemptionsCounterparty2ReportValidator;
import drr.regulation.cftc.rewrite.validation.exists.ClearingExceptionsAndExemptionsCounterparty2ReportOnlyExistsValidator;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.Function;


/**
 * @version 4.2.1
 */
@RosettaMeta(model=ClearingExceptionsAndExemptionsCounterparty2Report.class)
public class ClearingExceptionsAndExemptionsCounterparty2ReportMeta implements RosettaMetaData<ClearingExceptionsAndExemptionsCounterparty2Report> {

	@Override
	public List<Validator<? super ClearingExceptionsAndExemptionsCounterparty2Report>> dataRules(ValidatorFactory factory) {
		return Arrays.asList(
		);
	}
	
	@Override
	public List<Function<? super ClearingExceptionsAndExemptionsCounterparty2Report, QualifyResult>> getQualifyFunctions(QualifyFunctionFactory factory) {
		return Collections.emptyList();
	}

	@Override
	public Validator<? super ClearingExceptionsAndExemptionsCounterparty2Report> validator() {
		return new ClearingExceptionsAndExemptionsCounterparty2ReportValidator();
	}

	@Override
	public Validator<? super ClearingExceptionsAndExemptionsCounterparty2Report> typeFormatValidator() {
		return new ClearingExceptionsAndExemptionsCounterparty2ReportTypeFormatValidator();
	}
	
	@Override
	public ValidatorWithArg<? super ClearingExceptionsAndExemptionsCounterparty2Report, Set<String>> onlyExistsValidator() {
		return new ClearingExceptionsAndExemptionsCounterparty2ReportOnlyExistsValidator();
	}
}
