package drr.regulation.cftc.rewrite.reports;

import com.rosetta.model.lib.ModelSymbolId;
import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.util.DottedPath;
import drr.regulation.cftc.rewrite.ClearingExceptionsAndExemptionsCounterparty1Report;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class ClearingExceptionsAndExemptionsCounterparty1ReportTypeTabulator implements Tabulator<ClearingExceptionsAndExemptionsCounterparty1Report> {
	private final Field valueField;
	
	public ClearingExceptionsAndExemptionsCounterparty1ReportTypeTabulator() {
		this.valueField = new FieldImpl(
			"value",
			false,
			Optional.of(new ModelSymbolId(DottedPath.of("drr", "regulation", "cftc", "rewrite"), "ClearingExceptionsAndExemptionsCounterparty1Extraction")),
			Optional.of("11-$ Clearing exceptions and exemptions - Counterparty 1"),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(valueField);
	}
	
	@Override
	public List<FieldValue> tabulate(ClearingExceptionsAndExemptionsCounterparty1Report input) {
		Optional<String> value = Optional.ofNullable(input.getValue());
		return Arrays.asList(
			new FieldValueImpl(valueField, value)
		);
	}
}
