package drr.regulation.cftc.rewrite.reports;

import com.rosetta.model.lib.ModelSymbolId;
import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.util.DottedPath;
import drr.regulation.cftc.rewrite.ClearingSwapUTIsReport;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class ClearingSwapUTIsReportTypeTabulator implements Tabulator<ClearingSwapUTIsReport> {
	private final Field identifierField;
	
	public ClearingSwapUTIsReportTypeTabulator() {
		this.identifierField = new FieldImpl(
			"identifier",
			false,
			Optional.of(new ModelSymbolId(DottedPath.of("drr", "regulation", "cftc", "rewrite"), "ClearingSwapUTI")),
			Optional.of("06-$ Clearing swap UTIs"),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(identifierField);
	}
	
	@Override
	public List<FieldValue> tabulate(ClearingSwapUTIsReport input) {
		Optional<String> identifier = Optional.ofNullable(input.getIdentifier());
		return Arrays.asList(
			new FieldValueImpl(identifierField, identifier)
		);
	}
}
