package drr.regulation.cftc.rewrite.reports;

import cdm.base.math.DatedValue;
import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.records.Date;
import com.rosetta.model.lib.reports.ReportFunction;
import drr.standards.iosco.cde.reports.CDENotionalAmountScheduleEffectiveDateRule;
import javax.inject.Inject;


@ImplementedBy(NotionalAmountScheduleLeg2EffectiveDateRule.NotionalAmountScheduleLeg2EffectiveDateRuleDefault.class)
public abstract class NotionalAmountScheduleLeg2EffectiveDateRule implements ReportFunction<DatedValue, Date> {
	
	// RosettaFunction dependencies
	//
	@Inject protected CDENotionalAmountScheduleEffectiveDateRule cDENotionalAmountScheduleEffectiveDate;

	/**
	* @param input 
	* @return output 
	*/
	@Override
	public Date evaluate(DatedValue input) {
		Date output = doEvaluate(input);
		
		return output;
	}

	protected abstract Date doEvaluate(DatedValue input);

	public static class NotionalAmountScheduleLeg2EffectiveDateRuleDefault extends NotionalAmountScheduleLeg2EffectiveDateRule {
		@Override
		protected Date doEvaluate(DatedValue input) {
			Date output = null;
			return assignOutput(output, input);
		}
		
		protected Date assignOutput(Date output, DatedValue input) {
			output = cDENotionalAmountScheduleEffectiveDate.evaluate(input);
			
			return output;
		}
	}
}
