package drr.regulation.common.functions;

import cdm.event.common.BusinessEvent;
import cdm.event.common.CounterpartyPositionBusinessEvent;
import cdm.event.common.CounterpartyPositionState;
import cdm.event.common.Instruction;
import cdm.event.common.State;
import cdm.event.common.TradeState;
import cdm.event.common.functions.QuantityDecreasedToZero;
import cdm.event.common.metafields.ReferenceWithMetaTradeState;
import cdm.event.position.PositionStatusEnum;
import cdm.event.workflow.WorkflowStep;
import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.expression.CardinalityOperator;
import com.rosetta.model.lib.functions.RosettaFunction;
import com.rosetta.model.lib.mapper.MapperS;
import drr.regulation.common.ReportableEvent;
import javax.inject.Inject;

import static com.rosetta.model.lib.expression.ExpressionOperators.*;

@ImplementedBy(IsActionTypeTERM.IsActionTypeTERMDefault.class)
public abstract class IsActionTypeTERM implements RosettaFunction {
	
	// RosettaFunction dependencies
	//
	@Inject protected QuantityDecreasedToZero quantityDecreasedToZero;

	/**
	* @param reportableEvent 
	* @return isActionTypeTerm 
	*/
	public Boolean evaluate(ReportableEvent reportableEvent) {
		Boolean isActionTypeTerm = doEvaluate(reportableEvent);
		
		return isActionTypeTerm;
	}

	protected abstract Boolean doEvaluate(ReportableEvent reportableEvent);

	public static class IsActionTypeTERMDefault extends IsActionTypeTERM {
		@Override
		protected Boolean doEvaluate(ReportableEvent reportableEvent) {
			Boolean isActionTypeTerm = null;
			return assignOutput(isActionTypeTerm, reportableEvent);
		}
		
		protected Boolean assignOutput(Boolean isActionTypeTerm, ReportableEvent reportableEvent) {
			if (areEqual(MapperS.of(quantityDecreasedToZero.evaluate(MapperS.of(reportableEvent).<WorkflowStep>map("getOriginatingWorkflowStep", _reportableEvent -> _reportableEvent.getOriginatingWorkflowStep()).<BusinessEvent>map("getBusinessEvent", workflowStep -> workflowStep.getBusinessEvent()).<Instruction>mapC("getInstruction", eventInstruction -> eventInstruction.getInstruction()).<ReferenceWithMetaTradeState>map("getBefore", instruction -> instruction.getBefore()).<TradeState>map("getValue", _f->_f.getValue()).getMulti(), MapperS.of(reportableEvent).<WorkflowStep>map("getOriginatingWorkflowStep", _reportableEvent -> _reportableEvent.getOriginatingWorkflowStep()).<BusinessEvent>map("getBusinessEvent", workflowStep -> workflowStep.getBusinessEvent()).<TradeState>mapC("getAfter", businessEvent -> businessEvent.getAfter()).getMulti())), MapperS.of(true), CardinalityOperator.All).or(exists(MapperS.of(reportableEvent).<TradeState>map("getReportableTrade", _reportableEvent -> _reportableEvent.getReportableTrade()).<State>map("getState", tradeState -> tradeState.getState())).and(areEqual(MapperS.of(reportableEvent).<TradeState>map("getReportableTrade", _reportableEvent -> _reportableEvent.getReportableTrade()).<State>map("getState", tradeState -> tradeState.getState()).<PositionStatusEnum>map("getPositionState", state -> state.getPositionState()), MapperS.of(PositionStatusEnum.CLOSED), CardinalityOperator.All))).or(areEqual(MapperS.of(MapperS.of(reportableEvent).<WorkflowStep>map("getOriginatingWorkflowStep", _reportableEvent -> _reportableEvent.getOriginatingWorkflowStep()).<CounterpartyPositionBusinessEvent>map("getCounterpartyPositionBusinessEvent", workflowStep -> workflowStep.getCounterpartyPositionBusinessEvent()).<CounterpartyPositionState>mapC("getAfter", counterpartyPositionBusinessEvent -> counterpartyPositionBusinessEvent.getAfter()).<State>map("getState", counterpartyPositionState -> counterpartyPositionState.getState()).<PositionStatusEnum>map("getPositionState", state -> state.getPositionState()).get()), MapperS.of(PositionStatusEnum.CLOSED), CardinalityOperator.All)).getOrDefault(false)) {
				isActionTypeTerm = true;
			} else {
				isActionTypeTerm = false;
			}
			
			return isActionTypeTerm;
		}
	}
}
