package drr.regulation.common.functions;

import cdm.product.qualification.functions.Qualify_Commodity_Swap_Basis;
import cdm.product.qualification.functions.Qualify_Commodity_Swap_FixedFloat;
import cdm.product.template.Product;
import cdm.product.template.TradableProduct;
import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.expression.CardinalityOperator;
import com.rosetta.model.lib.functions.RosettaFunction;
import com.rosetta.model.lib.mapper.MapperS;
import javax.inject.Inject;

import static com.rosetta.model.lib.expression.ExpressionOperators.*;

@ImplementedBy(IsCommoditySwap.IsCommoditySwapDefault.class)
public abstract class IsCommoditySwap implements RosettaFunction {
	
	// RosettaFunction dependencies
	//
	@Inject protected EconomicTermsForProduct economicTermsForProduct;
	@Inject protected Qualify_Commodity_Swap_Basis qualify_Commodity_Swap_Basis;
	@Inject protected Qualify_Commodity_Swap_FixedFloat qualify_Commodity_Swap_FixedFloat;

	/**
	* @param tradableProduct 
	* @return result 
	*/
	public Boolean evaluate(TradableProduct tradableProduct) {
		Boolean result = doEvaluate(tradableProduct);
		
		return result;
	}

	protected abstract Boolean doEvaluate(TradableProduct tradableProduct);

	public static class IsCommoditySwapDefault extends IsCommoditySwap {
		@Override
		protected Boolean doEvaluate(TradableProduct tradableProduct) {
			Boolean result = null;
			return assignOutput(result, tradableProduct);
		}
		
		protected Boolean assignOutput(Boolean result, TradableProduct tradableProduct) {
			result = areEqual(MapperS.of(qualify_Commodity_Swap_FixedFloat.evaluate(economicTermsForProduct.evaluate(MapperS.of(tradableProduct).<Product>map("getProduct", _tradableProduct -> _tradableProduct.getProduct()).get()))), MapperS.of(true), CardinalityOperator.All).or(areEqual(MapperS.of(qualify_Commodity_Swap_Basis.evaluate(economicTermsForProduct.evaluate(MapperS.of(tradableProduct).<Product>map("getProduct", _tradableProduct -> _tradableProduct.getProduct()).get()))), MapperS.of(true), CardinalityOperator.All)).get();
			
			return result;
		}
	}
}
