package drr.regulation.common.functions;

import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.expression.CardinalityOperator;
import com.rosetta.model.lib.functions.RosettaFunction;
import com.rosetta.model.lib.mapper.MapperS;

import static com.rosetta.model.lib.expression.ExpressionOperators.*;

@ImplementedBy(IsVRAllowedForActionType.IsVRAllowedForActionTypeDefault.class)
public abstract class IsVRAllowedForActionType implements RosettaFunction {

	/**
	* @param actionTypefromTrade 
	* @return validActionType 
	*/
	public Boolean evaluate(String actionTypefromTrade) {
		Boolean validActionType = doEvaluate(actionTypefromTrade);
		
		return validActionType;
	}

	protected abstract Boolean doEvaluate(String actionTypefromTrade);

	public static class IsVRAllowedForActionTypeDefault extends IsVRAllowedForActionType {
		@Override
		protected Boolean doEvaluate(String actionTypefromTrade) {
			Boolean validActionType = null;
			return assignOutput(validActionType, actionTypefromTrade);
		}
		
		protected Boolean assignOutput(Boolean validActionType, String actionTypefromTrade) {
			validActionType = areEqual(MapperS.of(actionTypefromTrade), MapperS.of("NEWT"), CardinalityOperator.All).or(areEqual(MapperS.of(actionTypefromTrade), MapperS.of("MODI"), CardinalityOperator.All)).or(areEqual(MapperS.of(actionTypefromTrade), MapperS.of("CORR"), CardinalityOperator.All)).or(areEqual(MapperS.of(actionTypefromTrade), MapperS.of("REVI"), CardinalityOperator.All)).or(areEqual(MapperS.of(actionTypefromTrade), MapperS.of("POSC"), CardinalityOperator.All)).get();
			
			return validActionType;
		}
	}
}
