package drr.regulation.common.meta;

import com.rosetta.model.lib.annotations.RosettaMeta;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.qualify.QualifyFunctionFactory;
import com.rosetta.model.lib.qualify.QualifyResult;
import com.rosetta.model.lib.validation.Validator;
import com.rosetta.model.lib.validation.ValidatorFactory;
import com.rosetta.model.lib.validation.ValidatorWithArg;
import drr.regulation.common.PriceReportablePeriod;
import drr.regulation.common.validation.PriceReportablePeriodTypeFormatValidator;
import drr.regulation.common.validation.PriceReportablePeriodValidator;
import drr.regulation.common.validation.exists.PriceReportablePeriodOnlyExistsValidator;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.Function;


/**
 * @version 4.2.1
 */
@RosettaMeta(model=PriceReportablePeriod.class)
public class PriceReportablePeriodMeta implements RosettaMetaData<PriceReportablePeriod> {

	@Override
	public List<Validator<? super PriceReportablePeriod>> dataRules(ValidatorFactory factory) {
		return Arrays.asList(
		);
	}
	
	@Override
	public List<Function<? super PriceReportablePeriod, QualifyResult>> getQualifyFunctions(QualifyFunctionFactory factory) {
		return Collections.emptyList();
	}

	@Override
	public Validator<? super PriceReportablePeriod> validator() {
		return new PriceReportablePeriodValidator();
	}

	@Override
	public Validator<? super PriceReportablePeriod> typeFormatValidator() {
		return new PriceReportablePeriodTypeFormatValidator();
	}
	
	@Override
	public ValidatorWithArg<? super PriceReportablePeriod, Set<String>> onlyExistsValidator() {
		return new PriceReportablePeriodOnlyExistsValidator();
	}
}
