package drr.regulation.esma.emir.refit.margin.reports;

import com.rosetta.model.lib.ModelSymbolId;
import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.util.DottedPath;
import drr.regulation.esma.emir.refit.margin.ESMAEMIRNonReportableCollateralData;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class ESMAEMIRNonReportableCollateralDataTypeTabulator implements Tabulator<ESMAEMIRNonReportableCollateralData> {
	private final Field micField;
	
	public ESMAEMIRNonReportableCollateralDataTypeTabulator() {
		this.micField = new FieldImpl(
			"mic",
			false,
			Optional.of(new ModelSymbolId(DottedPath.of("drr", "regulation", "esma", "emir", "refit", "margin"), "MICCollateral")),
			Optional.empty(),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(micField);
	}
	
	@Override
	public List<FieldValue> tabulate(ESMAEMIRNonReportableCollateralData input) {
		Optional<String> mic = Optional.ofNullable(input.getMic());
		return Arrays.asList(
			new FieldValueImpl(micField, mic)
		);
	}
}
