package drr.regulation.fca.ukemir.refit.margin;

import com.rosetta.model.lib.RosettaModelObject;
import com.rosetta.model.lib.RosettaModelObjectBuilder;
import com.rosetta.model.lib.annotations.RosettaAttribute;
import com.rosetta.model.lib.annotations.RosettaDataType;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.process.BuilderMerger;
import com.rosetta.model.lib.process.BuilderProcessor;
import com.rosetta.model.lib.process.Processor;
import drr.regulation.fca.ukemir.refit.margin.PartiesToTheDerivative;
import drr.regulation.fca.ukemir.refit.margin.PartiesToTheDerivative.PartiesToTheDerivativeBuilder;
import drr.regulation.fca.ukemir.refit.margin.PartiesToTheDerivative.PartiesToTheDerivativeBuilderImpl;
import drr.regulation.fca.ukemir.refit.margin.PartiesToTheDerivative.PartiesToTheDerivativeImpl;
import drr.regulation.fca.ukemir.refit.margin.meta.PartiesToTheDerivativeMeta;
import java.util.Objects;

import static java.util.Optional.ofNullable;

/**
 * @version 4.2.1
 */
@RosettaDataType(value="PartiesToTheDerivative", builder=PartiesToTheDerivative.PartiesToTheDerivativeBuilderImpl.class, version="4.2.1")
public interface PartiesToTheDerivative extends RosettaModelObject {

	PartiesToTheDerivativeMeta metaData = new PartiesToTheDerivativeMeta();

	/*********************** Getter Methods  ***********************/
	String getReportSubmittingEntityID();
	Boolean getCounterparty2IdentifierType();
	String getCounterparty2();

	/*********************** Build Methods  ***********************/
	PartiesToTheDerivative build();
	
	PartiesToTheDerivative.PartiesToTheDerivativeBuilder toBuilder();
	
	static PartiesToTheDerivative.PartiesToTheDerivativeBuilder builder() {
		return new PartiesToTheDerivative.PartiesToTheDerivativeBuilderImpl();
	}

	/*********************** Utility Methods  ***********************/
	@Override
	default RosettaMetaData<? extends PartiesToTheDerivative> metaData() {
		return metaData;
	}
	
	@Override
	default Class<? extends PartiesToTheDerivative> getType() {
		return PartiesToTheDerivative.class;
	}
	
	
	@Override
	default void process(RosettaPath path, Processor processor) {
		processor.processBasic(path.newSubPath("reportSubmittingEntityID"), String.class, getReportSubmittingEntityID(), this);
		processor.processBasic(path.newSubPath("counterparty2IdentifierType"), Boolean.class, getCounterparty2IdentifierType(), this);
		processor.processBasic(path.newSubPath("counterparty2"), String.class, getCounterparty2(), this);
	}
	

	/*********************** Builder Interface  ***********************/
	interface PartiesToTheDerivativeBuilder extends PartiesToTheDerivative, RosettaModelObjectBuilder {
		PartiesToTheDerivative.PartiesToTheDerivativeBuilder setReportSubmittingEntityID(String reportSubmittingEntityID);
		PartiesToTheDerivative.PartiesToTheDerivativeBuilder setCounterparty2IdentifierType(Boolean counterparty2IdentifierType);
		PartiesToTheDerivative.PartiesToTheDerivativeBuilder setCounterparty2(String counterparty2);

		@Override
		default void process(RosettaPath path, BuilderProcessor processor) {
			processor.processBasic(path.newSubPath("reportSubmittingEntityID"), String.class, getReportSubmittingEntityID(), this);
			processor.processBasic(path.newSubPath("counterparty2IdentifierType"), Boolean.class, getCounterparty2IdentifierType(), this);
			processor.processBasic(path.newSubPath("counterparty2"), String.class, getCounterparty2(), this);
		}
		

		PartiesToTheDerivative.PartiesToTheDerivativeBuilder prune();
	}

	/*********************** Immutable Implementation of PartiesToTheDerivative  ***********************/
	class PartiesToTheDerivativeImpl implements PartiesToTheDerivative {
		private final String reportSubmittingEntityID;
		private final Boolean counterparty2IdentifierType;
		private final String counterparty2;
		
		protected PartiesToTheDerivativeImpl(PartiesToTheDerivative.PartiesToTheDerivativeBuilder builder) {
			this.reportSubmittingEntityID = builder.getReportSubmittingEntityID();
			this.counterparty2IdentifierType = builder.getCounterparty2IdentifierType();
			this.counterparty2 = builder.getCounterparty2();
		}
		
		@Override
		@RosettaAttribute("reportSubmittingEntityID")
		public String getReportSubmittingEntityID() {
			return reportSubmittingEntityID;
		}
		
		@Override
		@RosettaAttribute("counterparty2IdentifierType")
		public Boolean getCounterparty2IdentifierType() {
			return counterparty2IdentifierType;
		}
		
		@Override
		@RosettaAttribute("counterparty2")
		public String getCounterparty2() {
			return counterparty2;
		}
		
		@Override
		public PartiesToTheDerivative build() {
			return this;
		}
		
		@Override
		public PartiesToTheDerivative.PartiesToTheDerivativeBuilder toBuilder() {
			PartiesToTheDerivative.PartiesToTheDerivativeBuilder builder = builder();
			setBuilderFields(builder);
			return builder;
		}
		
		protected void setBuilderFields(PartiesToTheDerivative.PartiesToTheDerivativeBuilder builder) {
			ofNullable(getReportSubmittingEntityID()).ifPresent(builder::setReportSubmittingEntityID);
			ofNullable(getCounterparty2IdentifierType()).ifPresent(builder::setCounterparty2IdentifierType);
			ofNullable(getCounterparty2()).ifPresent(builder::setCounterparty2);
		}

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			PartiesToTheDerivative _that = getType().cast(o);
		
			if (!Objects.equals(reportSubmittingEntityID, _that.getReportSubmittingEntityID())) return false;
			if (!Objects.equals(counterparty2IdentifierType, _that.getCounterparty2IdentifierType())) return false;
			if (!Objects.equals(counterparty2, _that.getCounterparty2())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (reportSubmittingEntityID != null ? reportSubmittingEntityID.hashCode() : 0);
			_result = 31 * _result + (counterparty2IdentifierType != null ? counterparty2IdentifierType.hashCode() : 0);
			_result = 31 * _result + (counterparty2 != null ? counterparty2.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "PartiesToTheDerivative {" +
				"reportSubmittingEntityID=" + this.reportSubmittingEntityID + ", " +
				"counterparty2IdentifierType=" + this.counterparty2IdentifierType + ", " +
				"counterparty2=" + this.counterparty2 +
			'}';
		}
	}

	/*********************** Builder Implementation of PartiesToTheDerivative  ***********************/
	class PartiesToTheDerivativeBuilderImpl implements PartiesToTheDerivative.PartiesToTheDerivativeBuilder {
	
		protected String reportSubmittingEntityID;
		protected Boolean counterparty2IdentifierType;
		protected String counterparty2;
	
		public PartiesToTheDerivativeBuilderImpl() {
		}
	
		@Override
		@RosettaAttribute("reportSubmittingEntityID")
		public String getReportSubmittingEntityID() {
			return reportSubmittingEntityID;
		}
		
		@Override
		@RosettaAttribute("counterparty2IdentifierType")
		public Boolean getCounterparty2IdentifierType() {
			return counterparty2IdentifierType;
		}
		
		@Override
		@RosettaAttribute("counterparty2")
		public String getCounterparty2() {
			return counterparty2;
		}
		
	
		@Override
		@RosettaAttribute("reportSubmittingEntityID")
		public PartiesToTheDerivative.PartiesToTheDerivativeBuilder setReportSubmittingEntityID(String reportSubmittingEntityID) {
			this.reportSubmittingEntityID = reportSubmittingEntityID==null?null:reportSubmittingEntityID;
			return this;
		}
		@Override
		@RosettaAttribute("counterparty2IdentifierType")
		public PartiesToTheDerivative.PartiesToTheDerivativeBuilder setCounterparty2IdentifierType(Boolean counterparty2IdentifierType) {
			this.counterparty2IdentifierType = counterparty2IdentifierType==null?null:counterparty2IdentifierType;
			return this;
		}
		@Override
		@RosettaAttribute("counterparty2")
		public PartiesToTheDerivative.PartiesToTheDerivativeBuilder setCounterparty2(String counterparty2) {
			this.counterparty2 = counterparty2==null?null:counterparty2;
			return this;
		}
		
		@Override
		public PartiesToTheDerivative build() {
			return new PartiesToTheDerivative.PartiesToTheDerivativeImpl(this);
		}
		
		@Override
		public PartiesToTheDerivative.PartiesToTheDerivativeBuilder toBuilder() {
			return this;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public PartiesToTheDerivative.PartiesToTheDerivativeBuilder prune() {
			return this;
		}
		
		@Override
		public boolean hasData() {
			if (getReportSubmittingEntityID()!=null) return true;
			if (getCounterparty2IdentifierType()!=null) return true;
			if (getCounterparty2()!=null) return true;
			return false;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public PartiesToTheDerivative.PartiesToTheDerivativeBuilder merge(RosettaModelObjectBuilder other, BuilderMerger merger) {
			PartiesToTheDerivative.PartiesToTheDerivativeBuilder o = (PartiesToTheDerivative.PartiesToTheDerivativeBuilder) other;
			
			
			merger.mergeBasic(getReportSubmittingEntityID(), o.getReportSubmittingEntityID(), this::setReportSubmittingEntityID);
			merger.mergeBasic(getCounterparty2IdentifierType(), o.getCounterparty2IdentifierType(), this::setCounterparty2IdentifierType);
			merger.mergeBasic(getCounterparty2(), o.getCounterparty2(), this::setCounterparty2);
			return this;
		}
	
		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			PartiesToTheDerivative _that = getType().cast(o);
		
			if (!Objects.equals(reportSubmittingEntityID, _that.getReportSubmittingEntityID())) return false;
			if (!Objects.equals(counterparty2IdentifierType, _that.getCounterparty2IdentifierType())) return false;
			if (!Objects.equals(counterparty2, _that.getCounterparty2())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (reportSubmittingEntityID != null ? reportSubmittingEntityID.hashCode() : 0);
			_result = 31 * _result + (counterparty2IdentifierType != null ? counterparty2IdentifierType.hashCode() : 0);
			_result = 31 * _result + (counterparty2 != null ? counterparty2.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "PartiesToTheDerivativeBuilder {" +
				"reportSubmittingEntityID=" + this.reportSubmittingEntityID + ", " +
				"counterparty2IdentifierType=" + this.counterparty2IdentifierType + ", " +
				"counterparty2=" + this.counterparty2 +
			'}';
		}
	}
}
