package drr.regulation.fca.ukemir.refit.margin.meta;

import com.rosetta.model.lib.annotations.RosettaMeta;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.qualify.QualifyFunctionFactory;
import com.rosetta.model.lib.qualify.QualifyResult;
import com.rosetta.model.lib.validation.Validator;
import com.rosetta.model.lib.validation.ValidatorFactory;
import com.rosetta.model.lib.validation.ValidatorWithArg;
import drr.regulation.fca.ukemir.refit.margin.FCAUKEMIRMarginReport;
import drr.regulation.fca.ukemir.refit.margin.validation.FCAUKEMIRMarginReportTypeFormatValidator;
import drr.regulation.fca.ukemir.refit.margin.validation.FCAUKEMIRMarginReportValidator;
import drr.regulation.fca.ukemir.refit.margin.validation.exists.FCAUKEMIRMarginReportOnlyExistsValidator;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.Function;


/**
 * @version 4.2.1
 */
@RosettaMeta(model=FCAUKEMIRMarginReport.class)
public class FCAUKEMIRMarginReportMeta implements RosettaMetaData<FCAUKEMIRMarginReport> {

	@Override
	public List<Validator<? super FCAUKEMIRMarginReport>> dataRules(ValidatorFactory factory) {
		return Arrays.asList(
		);
	}
	
	@Override
	public List<Function<? super FCAUKEMIRMarginReport, QualifyResult>> getQualifyFunctions(QualifyFunctionFactory factory) {
		return Collections.emptyList();
	}

	@Override
	public Validator<? super FCAUKEMIRMarginReport> validator() {
		return new FCAUKEMIRMarginReportValidator();
	}

	@Override
	public Validator<? super FCAUKEMIRMarginReport> typeFormatValidator() {
		return new FCAUKEMIRMarginReportTypeFormatValidator();
	}
	
	@Override
	public ValidatorWithArg<? super FCAUKEMIRMarginReport, Set<String>> onlyExistsValidator() {
		return new FCAUKEMIRMarginReportOnlyExistsValidator();
	}
}
