package drr.regulation.fca.ukemir.refit.margin.reports;

import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.reports.ReportFunction;
import drr.regulation.common.CollateralReportInstruction;
import drr.standards.iosco.cde.reports.CDEExcessCollateralPostedByTheReportingCounterpartyRule;
import javax.inject.Inject;


@ImplementedBy(ExcessCollateralPostedByTheCounterparty1Rule.ExcessCollateralPostedByTheCounterparty1RuleDefault.class)
public abstract class ExcessCollateralPostedByTheCounterparty1Rule implements ReportFunction<CollateralReportInstruction, Integer> {
	
	// RosettaFunction dependencies
	//
	@Inject protected CDEExcessCollateralPostedByTheReportingCounterpartyRule cDEExcessCollateralPostedByTheReportingCounterparty;

	/**
	* @param input 
	* @return output 
	*/
	@Override
	public Integer evaluate(CollateralReportInstruction input) {
		Integer output = doEvaluate(input);
		
		return output;
	}

	protected abstract Integer doEvaluate(CollateralReportInstruction input);

	public static class ExcessCollateralPostedByTheCounterparty1RuleDefault extends ExcessCollateralPostedByTheCounterparty1Rule {
		@Override
		protected Integer doEvaluate(CollateralReportInstruction input) {
			Integer output = null;
			return assignOutput(output, input);
		}
		
		protected Integer assignOutput(Integer output, CollateralReportInstruction input) {
			output = cDEExcessCollateralPostedByTheReportingCounterparty.evaluate(input);
			
			return output;
		}
	}
}
