package drr.regulation.fca.ukemir.refit.trade.meta;

import com.rosetta.model.lib.annotations.RosettaMeta;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.qualify.QualifyFunctionFactory;
import com.rosetta.model.lib.qualify.QualifyResult;
import com.rosetta.model.lib.validation.Validator;
import com.rosetta.model.lib.validation.ValidatorFactory;
import com.rosetta.model.lib.validation.ValidatorWithArg;
import drr.regulation.fca.ukemir.refit.trade.BasketConstituentsReport;
import drr.regulation.fca.ukemir.refit.trade.validation.BasketConstituentsReportTypeFormatValidator;
import drr.regulation.fca.ukemir.refit.trade.validation.BasketConstituentsReportValidator;
import drr.regulation.fca.ukemir.refit.trade.validation.exists.BasketConstituentsReportOnlyExistsValidator;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.Function;


/**
 * @version 4.2.1
 */
@RosettaMeta(model=BasketConstituentsReport.class)
public class BasketConstituentsReportMeta implements RosettaMetaData<BasketConstituentsReport> {

	@Override
	public List<Validator<? super BasketConstituentsReport>> dataRules(ValidatorFactory factory) {
		return Arrays.asList(
		);
	}
	
	@Override
	public List<Function<? super BasketConstituentsReport, QualifyResult>> getQualifyFunctions(QualifyFunctionFactory factory) {
		return Collections.emptyList();
	}

	@Override
	public Validator<? super BasketConstituentsReport> validator() {
		return new BasketConstituentsReportValidator();
	}

	@Override
	public Validator<? super BasketConstituentsReport> typeFormatValidator() {
		return new BasketConstituentsReportTypeFormatValidator();
	}
	
	@Override
	public ValidatorWithArg<? super BasketConstituentsReport, Set<String>> onlyExistsValidator() {
		return new BasketConstituentsReportOnlyExistsValidator();
	}
}
