package drr.regulation.fca.ukemir.refit.trade.meta;

import com.rosetta.model.lib.annotations.RosettaMeta;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.qualify.QualifyFunctionFactory;
import com.rosetta.model.lib.qualify.QualifyResult;
import com.rosetta.model.lib.validation.Validator;
import com.rosetta.model.lib.validation.ValidatorFactory;
import com.rosetta.model.lib.validation.ValidatorWithArg;
import drr.regulation.fca.ukemir.refit.trade.FCAUKEMIRTransactionReport;
import drr.regulation.fca.ukemir.refit.trade.validation.FCAUKEMIRTransactionReportTypeFormatValidator;
import drr.regulation.fca.ukemir.refit.trade.validation.FCAUKEMIRTransactionReportValidator;
import drr.regulation.fca.ukemir.refit.trade.validation.exists.FCAUKEMIRTransactionReportOnlyExistsValidator;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.Function;


/**
 * @version 4.2.1
 */
@RosettaMeta(model=FCAUKEMIRTransactionReport.class)
public class FCAUKEMIRTransactionReportMeta implements RosettaMetaData<FCAUKEMIRTransactionReport> {

	@Override
	public List<Validator<? super FCAUKEMIRTransactionReport>> dataRules(ValidatorFactory factory) {
		return Arrays.asList(
		);
	}
	
	@Override
	public List<Function<? super FCAUKEMIRTransactionReport, QualifyResult>> getQualifyFunctions(QualifyFunctionFactory factory) {
		return Collections.emptyList();
	}

	@Override
	public Validator<? super FCAUKEMIRTransactionReport> validator() {
		return new FCAUKEMIRTransactionReportValidator();
	}

	@Override
	public Validator<? super FCAUKEMIRTransactionReport> typeFormatValidator() {
		return new FCAUKEMIRTransactionReportTypeFormatValidator();
	}
	
	@Override
	public ValidatorWithArg<? super FCAUKEMIRTransactionReport, Set<String>> onlyExistsValidator() {
		return new FCAUKEMIRTransactionReportOnlyExistsValidator();
	}
}
