package drr.regulation.fca.ukemir.refit.trade.reports;

import com.rosetta.model.lib.ModelSymbolId;
import com.rosetta.model.lib.reports.Tabulator;
import com.rosetta.model.lib.reports.Tabulator.Field;
import com.rosetta.model.lib.reports.Tabulator.FieldImpl;
import com.rosetta.model.lib.reports.Tabulator.FieldValue;
import com.rosetta.model.lib.reports.Tabulator.FieldValueImpl;
import com.rosetta.util.DottedPath;
import drr.regulation.fca.ukemir.refit.trade.BasketConstituentsReport;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;


public class BasketConstituentsReportTypeTabulator implements Tabulator<BasketConstituentsReport> {
	private final Field identifierField;
	
	public BasketConstituentsReportTypeTabulator() {
		this.identifierField = new FieldImpl(
			"identifier",
			false,
			Optional.of(new ModelSymbolId(DottedPath.of("drr", "regulation", "fca", "ukemir", "refit", "trade"), "IdentifierOfBasketConstituents")),
			Optional.of("2.18 Identifier of the basket's constituents"),
			Arrays.asList()
		);
	}
	
	@Override
	public List<Field> getFields() {
		return Arrays.asList(identifierField);
	}
	
	@Override
	public List<FieldValue> tabulate(BasketConstituentsReport input) {
		Optional<String> identifier = Optional.ofNullable(input.getIdentifier());
		return Arrays.asList(
			new FieldValueImpl(identifierField, identifier)
		);
	}
}
