package drr.regulation.fca.ukemir.refit.trade.reports;

import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.mapper.MapperS;
import com.rosetta.model.lib.reports.ReportFunction;
import drr.regulation.common.ReportableInformation;
import drr.regulation.common.TransactionReportInstruction;

import static com.rosetta.model.lib.expression.ExpressionOperators.*;

@ImplementedBy(DerivativeBasedOnCryptoAssetsRule.DerivativeBasedOnCryptoAssetsRuleDefault.class)
public abstract class DerivativeBasedOnCryptoAssetsRule implements ReportFunction<TransactionReportInstruction, Boolean> {

	/**
	* @param input 
	* @return output 
	*/
	@Override
	public Boolean evaluate(TransactionReportInstruction input) {
		Boolean output = doEvaluate(input);
		
		return output;
	}

	protected abstract Boolean doEvaluate(TransactionReportInstruction input);

	public static class DerivativeBasedOnCryptoAssetsRuleDefault extends DerivativeBasedOnCryptoAssetsRule {
		@Override
		protected Boolean doEvaluate(TransactionReportInstruction input) {
			Boolean output = null;
			return assignOutput(output, input);
		}
		
		protected Boolean assignOutput(Boolean output, TransactionReportInstruction input) {
			output = MapperS.of(input)
				.mapSingleToItem(item -> {
					if (exists(item.<ReportableInformation>map("getReportableInformation", reportableEvent -> reportableEvent.getReportableInformation()).<Boolean>map("getCryptoBased", reportableInformation -> reportableInformation.getCryptoBased())).getOrDefault(false)) {
						return item.<ReportableInformation>map("getReportableInformation", reportableEvent -> reportableEvent.getReportableInformation()).<Boolean>map("getCryptoBased", reportableInformation -> reportableInformation.getCryptoBased());
					}
					return MapperS.of(false);
				}).get();
			
			return output;
		}
	}
}
