package drr.regulation.fca.ukemir.refit.trade.reports;

import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.reports.ReportFunction;
import drr.regulation.common.QuantityReportablePeriod;
import drr.standards.iosco.cde.reports.CDENotionalQuantityScheduleValueRule;
import java.math.BigDecimal;
import javax.inject.Inject;


@ImplementedBy(NotionalQuantityInEffectOnAssociatedEffectiveDateOfLeg2Rule.NotionalQuantityInEffectOnAssociatedEffectiveDateOfLeg2RuleDefault.class)
public abstract class NotionalQuantityInEffectOnAssociatedEffectiveDateOfLeg2Rule implements ReportFunction<QuantityReportablePeriod, BigDecimal> {
	
	// RosettaFunction dependencies
	//
	@Inject protected CDENotionalQuantityScheduleValueRule cDENotionalQuantityScheduleValue;

	/**
	* @param input 
	* @return output 
	*/
	@Override
	public BigDecimal evaluate(QuantityReportablePeriod input) {
		BigDecimal output = doEvaluate(input);
		
		return output;
	}

	protected abstract BigDecimal doEvaluate(QuantityReportablePeriod input);

	public static class NotionalQuantityInEffectOnAssociatedEffectiveDateOfLeg2RuleDefault extends NotionalQuantityInEffectOnAssociatedEffectiveDateOfLeg2Rule {
		@Override
		protected BigDecimal doEvaluate(QuantityReportablePeriod input) {
			BigDecimal output = null;
			return assignOutput(output, input);
		}
		
		protected BigDecimal assignOutput(BigDecimal output, QuantityReportablePeriod input) {
			output = cDENotionalQuantityScheduleValue.evaluate(input);
			
			return output;
		}
	}
}
