package drr.regulation.fca.ukemir.refit.trade.reports;

import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.mapper.MapperS;
import com.rosetta.model.lib.reports.ReportFunction;
import drr.regulation.common.ReportableDelivery;
import java.math.BigDecimal;


@ImplementedBy(PriceTimeIntervalQuantityRule.PriceTimeIntervalQuantityRuleDefault.class)
public abstract class PriceTimeIntervalQuantityRule implements ReportFunction<ReportableDelivery, BigDecimal> {

	/**
	* @param input 
	* @return output 
	*/
	@Override
	public BigDecimal evaluate(ReportableDelivery input) {
		BigDecimal output = doEvaluate(input);
		
		return output;
	}

	protected abstract BigDecimal doEvaluate(ReportableDelivery input);

	public static class PriceTimeIntervalQuantityRuleDefault extends PriceTimeIntervalQuantityRule {
		@Override
		protected BigDecimal doEvaluate(ReportableDelivery input) {
			BigDecimal output = null;
			return assignOutput(output, input);
		}
		
		protected BigDecimal assignOutput(BigDecimal output, ReportableDelivery input) {
			output = MapperS.of(input)
				.mapSingleToItem(item -> item.<BigDecimal>map("getPriceTimeIntervalQuantity", reportableDelivery -> reportableDelivery.getPriceTimeIntervalQuantity())).get();
			
			return output;
		}
	}
}
