package drr.regulation.jfsa.rewrite.margin.meta;

import com.rosetta.model.lib.annotations.RosettaMeta;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.qualify.QualifyFunctionFactory;
import com.rosetta.model.lib.qualify.QualifyResult;
import com.rosetta.model.lib.validation.Validator;
import com.rosetta.model.lib.validation.ValidatorFactory;
import com.rosetta.model.lib.validation.ValidatorWithArg;
import drr.regulation.jfsa.rewrite.margin.JFSAMarginReport;
import drr.regulation.jfsa.rewrite.margin.validation.JFSAMarginReportTypeFormatValidator;
import drr.regulation.jfsa.rewrite.margin.validation.JFSAMarginReportValidator;
import drr.regulation.jfsa.rewrite.margin.validation.exists.JFSAMarginReportOnlyExistsValidator;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.Function;


/**
 * @version 4.2.1
 */
@RosettaMeta(model=JFSAMarginReport.class)
public class JFSAMarginReportMeta implements RosettaMetaData<JFSAMarginReport> {

	@Override
	public List<Validator<? super JFSAMarginReport>> dataRules(ValidatorFactory factory) {
		return Arrays.asList(
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR000403.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR000701.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR000801.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR002501.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR004501.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR004601.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR004701.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR004801.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR004901.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR005001.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR005101.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR005201.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR005301.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR005401.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR005501.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR005601.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR005801.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR006001.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR006202.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR006303.class),
			factory.create(drr.regulation.jfsa.rewrite.margin.validation.datarule.JFSAMarginReportDTCCJFSABR010404.class)
		);
	}
	
	@Override
	public List<Function<? super JFSAMarginReport, QualifyResult>> getQualifyFunctions(QualifyFunctionFactory factory) {
		return Collections.emptyList();
	}

	@Override
	public Validator<? super JFSAMarginReport> validator() {
		return new JFSAMarginReportValidator();
	}

	@Override
	public Validator<? super JFSAMarginReport> typeFormatValidator() {
		return new JFSAMarginReportTypeFormatValidator();
	}
	
	@Override
	public ValidatorWithArg<? super JFSAMarginReport, Set<String>> onlyExistsValidator() {
		return new JFSAMarginReportOnlyExistsValidator();
	}
}
