package drr.regulation.jfsa.rewrite.margin.meta;

import com.rosetta.model.lib.annotations.RosettaMeta;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.qualify.QualifyFunctionFactory;
import com.rosetta.model.lib.qualify.QualifyResult;
import com.rosetta.model.lib.validation.Validator;
import com.rosetta.model.lib.validation.ValidatorFactory;
import com.rosetta.model.lib.validation.ValidatorWithArg;
import drr.regulation.jfsa.rewrite.margin.PartiesToTheDerivative;
import drr.regulation.jfsa.rewrite.margin.validation.PartiesToTheDerivativeTypeFormatValidator;
import drr.regulation.jfsa.rewrite.margin.validation.PartiesToTheDerivativeValidator;
import drr.regulation.jfsa.rewrite.margin.validation.exists.PartiesToTheDerivativeOnlyExistsValidator;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.Function;


/**
 * @version 4.2.1
 */
@RosettaMeta(model=PartiesToTheDerivative.class)
public class PartiesToTheDerivativeMeta implements RosettaMetaData<PartiesToTheDerivative> {

	@Override
	public List<Validator<? super PartiesToTheDerivative>> dataRules(ValidatorFactory factory) {
		return Arrays.asList(
		);
	}
	
	@Override
	public List<Function<? super PartiesToTheDerivative, QualifyResult>> getQualifyFunctions(QualifyFunctionFactory factory) {
		return Collections.emptyList();
	}

	@Override
	public Validator<? super PartiesToTheDerivative> validator() {
		return new PartiesToTheDerivativeValidator();
	}

	@Override
	public Validator<? super PartiesToTheDerivative> typeFormatValidator() {
		return new PartiesToTheDerivativeTypeFormatValidator();
	}
	
	@Override
	public ValidatorWithArg<? super PartiesToTheDerivative, Set<String>> onlyExistsValidator() {
		return new PartiesToTheDerivativeOnlyExistsValidator();
	}
}
