package drr.regulation.jfsa.rewrite.margin.reports;

import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.reports.ReportFunction;
import drr.regulation.common.CollateralReportInstruction;
import drr.standards.iosco.cde.reports.CDEExcessCollateralCollectedByTheReportingCounterpartyRule;
import javax.inject.Inject;


@ImplementedBy(ExcessCollateralCollectedByTheReportingCounterpartyRule.ExcessCollateralCollectedByTheReportingCounterpartyRuleDefault.class)
public abstract class ExcessCollateralCollectedByTheReportingCounterpartyRule implements ReportFunction<CollateralReportInstruction, Integer> {
	
	// RosettaFunction dependencies
	//
	@Inject protected CDEExcessCollateralCollectedByTheReportingCounterpartyRule cDEExcessCollateralCollectedByTheReportingCounterparty;

	/**
	* @param input 
	* @return output 
	*/
	@Override
	public Integer evaluate(CollateralReportInstruction input) {
		Integer output = doEvaluate(input);
		
		return output;
	}

	protected abstract Integer doEvaluate(CollateralReportInstruction input);

	public static class ExcessCollateralCollectedByTheReportingCounterpartyRuleDefault extends ExcessCollateralCollectedByTheReportingCounterpartyRule {
		@Override
		protected Integer doEvaluate(CollateralReportInstruction input) {
			Integer output = null;
			return assignOutput(output, input);
		}
		
		protected Integer assignOutput(Integer output, CollateralReportInstruction input) {
			output = cDEExcessCollateralCollectedByTheReportingCounterparty.evaluate(input);
			
			return output;
		}
	}
}
