package drr.regulation.jfsa.rewrite.trade.meta;

import com.rosetta.model.lib.annotations.RosettaMeta;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.qualify.QualifyFunctionFactory;
import com.rosetta.model.lib.qualify.QualifyResult;
import com.rosetta.model.lib.validation.Validator;
import com.rosetta.model.lib.validation.ValidatorFactory;
import com.rosetta.model.lib.validation.ValidatorWithArg;
import drr.regulation.jfsa.rewrite.trade.PackageTransactionSpread;
import drr.regulation.jfsa.rewrite.trade.validation.PackageTransactionSpreadTypeFormatValidator;
import drr.regulation.jfsa.rewrite.trade.validation.PackageTransactionSpreadValidator;
import drr.regulation.jfsa.rewrite.trade.validation.exists.PackageTransactionSpreadOnlyExistsValidator;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.Function;


/**
 * @version 4.2.1
 */
@RosettaMeta(model=PackageTransactionSpread.class)
public class PackageTransactionSpreadMeta implements RosettaMetaData<PackageTransactionSpread> {

	@Override
	public List<Validator<? super PackageTransactionSpread>> dataRules(ValidatorFactory factory) {
		return Arrays.asList(
			factory.create(drr.regulation.jfsa.rewrite.trade.validation.datarule.PackageTransactionSpreadMonetaryOrPercentageOrBasis.class)
		);
	}
	
	@Override
	public List<Function<? super PackageTransactionSpread, QualifyResult>> getQualifyFunctions(QualifyFunctionFactory factory) {
		return Collections.emptyList();
	}

	@Override
	public Validator<? super PackageTransactionSpread> validator() {
		return new PackageTransactionSpreadValidator();
	}

	@Override
	public Validator<? super PackageTransactionSpread> typeFormatValidator() {
		return new PackageTransactionSpreadTypeFormatValidator();
	}
	
	@Override
	public ValidatorWithArg<? super PackageTransactionSpread, Set<String>> onlyExistsValidator() {
		return new PackageTransactionSpreadOnlyExistsValidator();
	}
}
