package drr.regulation.jfsa.rewrite.trade.reports;

import cdm.base.math.DatedValue;
import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.reports.ReportFunction;
import drr.standards.iosco.cde.reports.CDENotionalAmountScheduleAmountRule;
import java.math.BigDecimal;
import javax.inject.Inject;


@ImplementedBy(NotionalAmountScheduleLeg2AmountRule.NotionalAmountScheduleLeg2AmountRuleDefault.class)
public abstract class NotionalAmountScheduleLeg2AmountRule implements ReportFunction<DatedValue, BigDecimal> {
	
	// RosettaFunction dependencies
	//
	@Inject protected CDENotionalAmountScheduleAmountRule cDENotionalAmountScheduleAmount;

	/**
	* @param input 
	* @return output 
	*/
	@Override
	public BigDecimal evaluate(DatedValue input) {
		BigDecimal output = doEvaluate(input);
		
		return output;
	}

	protected abstract BigDecimal doEvaluate(DatedValue input);

	public static class NotionalAmountScheduleLeg2AmountRuleDefault extends NotionalAmountScheduleLeg2AmountRule {
		@Override
		protected BigDecimal doEvaluate(DatedValue input) {
			BigDecimal output = null;
			return assignOutput(output, input);
		}
		
		protected BigDecimal assignOutput(BigDecimal output, DatedValue input) {
			output = cDENotionalAmountScheduleAmount.evaluate(input);
			
			return output;
		}
	}
}
