package drr.regulation.jfsa.rewrite.trade.reports;

import cdm.event.workflow.MessageInformation;
import cdm.event.workflow.WorkflowStep;
import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.mapper.MapperS;
import com.rosetta.model.lib.reports.ReportFunction;
import com.rosetta.model.metafields.FieldWithMetaString;
import drr.regulation.common.TransactionReportInstruction;


@ImplementedBy(TechnicalRecordIdDTCCRule.TechnicalRecordIdDTCCRuleDefault.class)
public abstract class TechnicalRecordIdDTCCRule implements ReportFunction<TransactionReportInstruction, String> {

	/**
	* @param input 
	* @return output 
	*/
	@Override
	public String evaluate(TransactionReportInstruction input) {
		String output = doEvaluate(input);
		
		return output;
	}

	protected abstract String doEvaluate(TransactionReportInstruction input);

	public static class TechnicalRecordIdDTCCRuleDefault extends TechnicalRecordIdDTCCRule {
		@Override
		protected String doEvaluate(TransactionReportInstruction input) {
			String output = null;
			return assignOutput(output, input);
		}
		
		protected String assignOutput(String output, TransactionReportInstruction input) {
			output = MapperS.of(input)
				.mapSingleToItem(item -> item.<WorkflowStep>map("getOriginatingWorkflowStep", reportableEvent -> reportableEvent.getOriginatingWorkflowStep()).<MessageInformation>map("getMessageInformation", workflowStep -> workflowStep.getMessageInformation()).<FieldWithMetaString>map("getMessageId", messageInformation -> messageInformation.getMessageId()).<String>map("getValue", _f->_f.getValue())).get();
			
			return output;
		}
	}
}
