package drr.regulation.mas.rewrite.margin.meta;

import com.rosetta.model.lib.annotations.RosettaMeta;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.qualify.QualifyFunctionFactory;
import com.rosetta.model.lib.qualify.QualifyResult;
import com.rosetta.model.lib.validation.Validator;
import com.rosetta.model.lib.validation.ValidatorFactory;
import com.rosetta.model.lib.validation.ValidatorWithArg;
import drr.regulation.mas.rewrite.margin.MASMarginReport;
import drr.regulation.mas.rewrite.margin.validation.MASMarginReportTypeFormatValidator;
import drr.regulation.mas.rewrite.margin.validation.MASMarginReportValidator;
import drr.regulation.mas.rewrite.margin.validation.exists.MASMarginReportOnlyExistsValidator;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.Function;


/**
 * @version 4.2.1
 */
@RosettaMeta(model=MASMarginReport.class)
public class MASMarginReportMeta implements RosettaMetaData<MASMarginReport> {

	@Override
	public List<Validator<? super MASMarginReport>> dataRules(ValidatorFactory factory) {
		return Arrays.asList(
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR000101.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR000201.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR001002.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR005802.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR005804.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR005901.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR006001.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR006101.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR006102.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR006201.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR006301.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR006401.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR006402.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR006501.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR006601.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR006701.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR006702.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR006801.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR006901.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR007001.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR007002.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR007101.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR007201.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR007301.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR007401.class),
			factory.create(drr.regulation.mas.rewrite.margin.validation.datarule.MASMarginReportDTCCMASBR013201.class)
		);
	}
	
	@Override
	public List<Function<? super MASMarginReport, QualifyResult>> getQualifyFunctions(QualifyFunctionFactory factory) {
		return Collections.emptyList();
	}

	@Override
	public Validator<? super MASMarginReport> validator() {
		return new MASMarginReportValidator();
	}

	@Override
	public Validator<? super MASMarginReport> typeFormatValidator() {
		return new MASMarginReportTypeFormatValidator();
	}
	
	@Override
	public ValidatorWithArg<? super MASMarginReport, Set<String>> onlyExistsValidator() {
		return new MASMarginReportOnlyExistsValidator();
	}
}
