package drr.regulation.techsprint.g20.mas.reports;

import cdm.base.staticdata.party.Party;
import cdm.base.staticdata.party.PartyIdentifier;
import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.mapper.MapperC;
import com.rosetta.model.lib.mapper.MapperS;
import com.rosetta.model.lib.reports.ReportFunction;
import com.rosetta.model.metafields.FieldWithMetaString;
import drr.regulation.common.TransactionReportInstruction;
import javax.inject.Inject;


@ImplementedBy(InterestRatePayerLeg1Rule.InterestRatePayerLeg1RuleDefault.class)
public abstract class InterestRatePayerLeg1Rule implements ReportFunction<TransactionReportInstruction, String> {
	
	// RosettaFunction dependencies
	//
	@Inject protected InterestRatePayoutPayerRule interestRatePayoutPayer;
	@Inject protected IsInterestRatePayoutRule isInterestRatePayout;

	/**
	* @param input 
	* @return output 
	*/
	@Override
	public String evaluate(TransactionReportInstruction input) {
		String output = doEvaluate(input);
		
		return output;
	}

	protected abstract String doEvaluate(TransactionReportInstruction input);

	public static class InterestRatePayerLeg1RuleDefault extends InterestRatePayerLeg1Rule {
		@Override
		protected String doEvaluate(TransactionReportInstruction input) {
			String output = null;
			return assignOutput(output, input);
		}
		
		protected String assignOutput(String output, TransactionReportInstruction input) {
			final MapperS<TransactionReportInstruction> thenResult0 = MapperS.of(input)
				.filterSingleNullSafe(item -> isInterestRatePayout.evaluate(item.get()));
			final MapperS<Party> thenResult1 = thenResult0
				.mapSingleToItem(item -> MapperS.of(interestRatePayoutPayer.evaluate(item.get())));
			final MapperC<String> thenResult2 = thenResult1
				.mapSingleToList(item -> item.<PartyIdentifier>mapC("getPartyId", party -> party.getPartyId()).<FieldWithMetaString>map("getIdentifier", partyIdentifier -> partyIdentifier.getIdentifier()).<String>map("getValue", _f->_f.getValue()));
			output = thenResult2
				.last().get();
			
			return output;
		}
	}
}
