package drr.regulation.techsprint.g20.mas.reports;

import cdm.base.staticdata.party.Address;
import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.mapper.MapperS;
import com.rosetta.model.lib.reports.ReportFunction;
import drr.regulation.common.TransactionReportInstruction;
import javax.inject.Inject;


@ImplementedBy(ReportingPartyIsInSingaporeRule.ReportingPartyIsInSingaporeRuleDefault.class)
public abstract class ReportingPartyIsInSingaporeRule implements ReportFunction<TransactionReportInstruction, Boolean> {
	
	// RosettaFunction dependencies
	//
	@Inject protected BookingLocationAddressRule bookingLocationAddress;
	@Inject protected IsAddressInSingaporeRule isAddressInSingapore;

	/**
	* @param input 
	* @return output 
	*/
	@Override
	public Boolean evaluate(TransactionReportInstruction input) {
		Boolean output = doEvaluate(input);
		
		return output;
	}

	protected abstract Boolean doEvaluate(TransactionReportInstruction input);

	public static class ReportingPartyIsInSingaporeRuleDefault extends ReportingPartyIsInSingaporeRule {
		@Override
		protected Boolean doEvaluate(TransactionReportInstruction input) {
			Boolean output = null;
			return assignOutput(output, input);
		}
		
		protected Boolean assignOutput(Boolean output, TransactionReportInstruction input) {
			final MapperS<Address> thenResult = MapperS.of(bookingLocationAddress.evaluate(input));
			output = thenResult
				.mapSingleToItem(item -> MapperS.of(isAddressInSingapore.evaluate(item.get()))).get();
			
			return output;
		}
	}
}
