package drr.standards.iosco.cde.functions;

import cdm.base.staticdata.party.Party;
import cdm.base.staticdata.party.PartyIdentifier;
import cdm.base.staticdata.party.metafields.ReferenceWithMetaParty;
import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.functions.RosettaFunction;
import com.rosetta.model.lib.mapper.MapperS;
import drr.regulation.common.ReportingSide;
import drr.regulation.common.TransactionReportInstruction;
import drr.regulation.common.functions.PartyLei;
import javax.inject.Inject;


@ImplementedBy(CDECounterparty1.CDECounterparty1Default.class)
public abstract class CDECounterparty1 implements RosettaFunction {
	
	// RosettaFunction dependencies
	//
	@Inject protected PartyLei partyLei;

	/**
	* @param reportInstruction 
	* @return lei 
	*/
	public String evaluate(TransactionReportInstruction reportInstruction) {
		String lei = doEvaluate(reportInstruction);
		
		return lei;
	}

	protected abstract String doEvaluate(TransactionReportInstruction reportInstruction);

	public static class CDECounterparty1Default extends CDECounterparty1 {
		@Override
		protected String doEvaluate(TransactionReportInstruction reportInstruction) {
			String lei = null;
			return assignOutput(lei, reportInstruction);
		}
		
		protected String assignOutput(String lei, TransactionReportInstruction reportInstruction) {
			lei = partyLei.evaluate(MapperS.of(reportInstruction).<ReportingSide>map("getReportingSide", transactionReportInstruction -> transactionReportInstruction.getReportingSide()).<ReferenceWithMetaParty>map("getReportingParty", reportingSide -> reportingSide.getReportingParty()).<Party>map("getValue", _f->_f.getValue()).<PartyIdentifier>mapC("getPartyId", party -> party.getPartyId()).getMulti());
			
			return lei;
		}
	}
}
