package drr.standards.iosco.cde.functions;

import cdm.base.staticdata.party.Party;
import cdm.base.staticdata.party.metafields.ReferenceWithMetaParty;
import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.functions.RosettaFunction;
import com.rosetta.model.lib.mapper.MapperS;
import drr.regulation.common.PartyInformation;
import drr.regulation.common.ReportableInformation;
import drr.regulation.common.ReportingSide;
import drr.regulation.common.TransactionReportInstruction;
import drr.regulation.common.functions.PartyLeiAndPersonByRoles;
import javax.inject.Inject;


@ImplementedBy(CDECounterparty2.CDECounterparty2Default.class)
public abstract class CDECounterparty2 implements RosettaFunction {
	
	// RosettaFunction dependencies
	//
	@Inject protected PartyLeiAndPersonByRoles partyLeiAndPersonByRoles;

	/**
	* @param reportInstruction 
	* @return leiAndPerson 
	*/
	public String evaluate(TransactionReportInstruction reportInstruction) {
		String leiAndPerson = doEvaluate(reportInstruction);
		
		return leiAndPerson;
	}

	protected abstract String doEvaluate(TransactionReportInstruction reportInstruction);

	public static class CDECounterparty2Default extends CDECounterparty2 {
		@Override
		protected String doEvaluate(TransactionReportInstruction reportInstruction) {
			String leiAndPerson = null;
			return assignOutput(leiAndPerson, reportInstruction);
		}
		
		protected String assignOutput(String leiAndPerson, TransactionReportInstruction reportInstruction) {
			leiAndPerson = partyLeiAndPersonByRoles.evaluate(MapperS.of(reportInstruction).<ReportingSide>map("getReportingSide", transactionReportInstruction -> transactionReportInstruction.getReportingSide()).<ReferenceWithMetaParty>map("getReportingCounterparty", reportingSide -> reportingSide.getReportingCounterparty()).<Party>map("getValue", _f->_f.getValue()).get(), MapperS.of(reportInstruction).<ReportableInformation>map("getReportableInformation", reportableEvent -> reportableEvent.getReportableInformation()).<PartyInformation>mapC("getPartyInformation", reportableInformation -> reportableInformation.getPartyInformation()).getMulti());
			
			return leiAndPerson;
		}
	}
}
