package drr.standards.iosco.cde.reports;

import cdm.base.math.DatedValue;
import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.mapper.MapperS;
import com.rosetta.model.lib.reports.ReportFunction;
import java.math.BigDecimal;


@ImplementedBy(CDENotionalAmountScheduleAmountRule.CDENotionalAmountScheduleAmountRuleDefault.class)
public abstract class CDENotionalAmountScheduleAmountRule implements ReportFunction<DatedValue, BigDecimal> {

	/**
	* @param input 
	* @return output 
	*/
	@Override
	public BigDecimal evaluate(DatedValue input) {
		BigDecimal output = doEvaluate(input);
		
		return output;
	}

	protected abstract BigDecimal doEvaluate(DatedValue input);

	public static class CDENotionalAmountScheduleAmountRuleDefault extends CDENotionalAmountScheduleAmountRule {
		@Override
		protected BigDecimal doEvaluate(DatedValue input) {
			BigDecimal output = null;
			return assignOutput(output, input);
		}
		
		protected BigDecimal assignOutput(BigDecimal output, DatedValue input) {
			output = MapperS.of(input)
				.mapSingleToItem(item -> item.<BigDecimal>map("getValue", datedValue -> datedValue.getValue())).get();
			
			return output;
		}
	}
}
