package drr.standards.iosco.cde.reports;

import cdm.base.math.DatedValue;
import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.mapper.MapperS;
import com.rosetta.model.lib.records.Date;
import com.rosetta.model.lib.reports.ReportFunction;


@ImplementedBy(CDENotionalAmountScheduleEffectiveDateRule.CDENotionalAmountScheduleEffectiveDateRuleDefault.class)
public abstract class CDENotionalAmountScheduleEffectiveDateRule implements ReportFunction<DatedValue, Date> {

	/**
	* @param input 
	* @return output 
	*/
	@Override
	public Date evaluate(DatedValue input) {
		Date output = doEvaluate(input);
		
		return output;
	}

	protected abstract Date doEvaluate(DatedValue input);

	public static class CDENotionalAmountScheduleEffectiveDateRuleDefault extends CDENotionalAmountScheduleEffectiveDateRule {
		@Override
		protected Date doEvaluate(DatedValue input) {
			Date output = null;
			return assignOutput(output, input);
		}
		
		protected Date assignOutput(Date output, DatedValue input) {
			output = MapperS.of(input)
				.mapSingleToItem(item -> item.<Date>map("getDate", datedValue -> datedValue.getDate())).get();
			
			return output;
		}
	}
}
