package iso20022.auth030.esma;

import com.rosetta.model.lib.RosettaModelObject;
import com.rosetta.model.lib.RosettaModelObjectBuilder;
import com.rosetta.model.lib.annotations.RosettaAttribute;
import com.rosetta.model.lib.annotations.RosettaDataType;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.process.BuilderMerger;
import com.rosetta.model.lib.process.BuilderProcessor;
import com.rosetta.model.lib.process.Processor;
import iso20022.auth030.esma.ActiveOrHistoricCurrencyAnd5DecimalAmount__1;
import iso20022.auth030.esma.AmountAndDirection106__2;
import iso20022.auth030.esma.AmountAndDirection106__2.AmountAndDirection106__2Builder;
import iso20022.auth030.esma.AmountAndDirection106__2.AmountAndDirection106__2BuilderImpl;
import iso20022.auth030.esma.AmountAndDirection106__2.AmountAndDirection106__2Impl;
import iso20022.auth030.esma.meta.AmountAndDirection106__2Meta;
import java.util.Objects;

import static java.util.Optional.ofNullable;

/**
 * Posting of an item to a cash account, in the context of a cash transaction, that results in an increase or decrease to the balance of the account.
 * @version ${project.version}
 */
@RosettaDataType(value="AmountAndDirection106__2", builder=AmountAndDirection106__2.AmountAndDirection106__2BuilderImpl.class, version="${project.version}")
public interface AmountAndDirection106__2 extends RosettaModelObject {

	AmountAndDirection106__2Meta metaData = new AmountAndDirection106__2Meta();

	/*********************** Getter Methods  ***********************/
	/**
	 * Amount of money in the cash entry.
	 */
	ActiveOrHistoricCurrencyAnd5DecimalAmount__1 getAmt();

	/*********************** Build Methods  ***********************/
	AmountAndDirection106__2 build();
	
	AmountAndDirection106__2.AmountAndDirection106__2Builder toBuilder();
	
	static AmountAndDirection106__2.AmountAndDirection106__2Builder builder() {
		return new AmountAndDirection106__2.AmountAndDirection106__2BuilderImpl();
	}

	/*********************** Utility Methods  ***********************/
	@Override
	default RosettaMetaData<? extends AmountAndDirection106__2> metaData() {
		return metaData;
	}
	
	@Override
	default Class<? extends AmountAndDirection106__2> getType() {
		return AmountAndDirection106__2.class;
	}
	
	
	@Override
	default void process(RosettaPath path, Processor processor) {
		processRosetta(path.newSubPath("amt"), processor, ActiveOrHistoricCurrencyAnd5DecimalAmount__1.class, getAmt());
	}
	

	/*********************** Builder Interface  ***********************/
	interface AmountAndDirection106__2Builder extends AmountAndDirection106__2, RosettaModelObjectBuilder {
		ActiveOrHistoricCurrencyAnd5DecimalAmount__1.ActiveOrHistoricCurrencyAnd5DecimalAmount__1Builder getOrCreateAmt();
		ActiveOrHistoricCurrencyAnd5DecimalAmount__1.ActiveOrHistoricCurrencyAnd5DecimalAmount__1Builder getAmt();
		AmountAndDirection106__2.AmountAndDirection106__2Builder setAmt(ActiveOrHistoricCurrencyAnd5DecimalAmount__1 amt);

		@Override
		default void process(RosettaPath path, BuilderProcessor processor) {
			processRosetta(path.newSubPath("amt"), processor, ActiveOrHistoricCurrencyAnd5DecimalAmount__1.ActiveOrHistoricCurrencyAnd5DecimalAmount__1Builder.class, getAmt());
		}
		

		AmountAndDirection106__2.AmountAndDirection106__2Builder prune();
	}

	/*********************** Immutable Implementation of AmountAndDirection106__2  ***********************/
	class AmountAndDirection106__2Impl implements AmountAndDirection106__2 {
		private final ActiveOrHistoricCurrencyAnd5DecimalAmount__1 amt;
		
		protected AmountAndDirection106__2Impl(AmountAndDirection106__2.AmountAndDirection106__2Builder builder) {
			this.amt = ofNullable(builder.getAmt()).map(f->f.build()).orElse(null);
		}
		
		@Override
		@RosettaAttribute("amt")
		public ActiveOrHistoricCurrencyAnd5DecimalAmount__1 getAmt() {
			return amt;
		}
		
		@Override
		public AmountAndDirection106__2 build() {
			return this;
		}
		
		@Override
		public AmountAndDirection106__2.AmountAndDirection106__2Builder toBuilder() {
			AmountAndDirection106__2.AmountAndDirection106__2Builder builder = builder();
			setBuilderFields(builder);
			return builder;
		}
		
		protected void setBuilderFields(AmountAndDirection106__2.AmountAndDirection106__2Builder builder) {
			ofNullable(getAmt()).ifPresent(builder::setAmt);
		}

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			AmountAndDirection106__2 _that = getType().cast(o);
		
			if (!Objects.equals(amt, _that.getAmt())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (amt != null ? amt.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "AmountAndDirection106__2 {" +
				"amt=" + this.amt +
			'}';
		}
	}

	/*********************** Builder Implementation of AmountAndDirection106__2  ***********************/
	class AmountAndDirection106__2BuilderImpl implements AmountAndDirection106__2.AmountAndDirection106__2Builder {
	
		protected ActiveOrHistoricCurrencyAnd5DecimalAmount__1.ActiveOrHistoricCurrencyAnd5DecimalAmount__1Builder amt;
	
		public AmountAndDirection106__2BuilderImpl() {
		}
	
		@Override
		@RosettaAttribute("amt")
		public ActiveOrHistoricCurrencyAnd5DecimalAmount__1.ActiveOrHistoricCurrencyAnd5DecimalAmount__1Builder getAmt() {
			return amt;
		}
		
		@Override
		public ActiveOrHistoricCurrencyAnd5DecimalAmount__1.ActiveOrHistoricCurrencyAnd5DecimalAmount__1Builder getOrCreateAmt() {
			ActiveOrHistoricCurrencyAnd5DecimalAmount__1.ActiveOrHistoricCurrencyAnd5DecimalAmount__1Builder result;
			if (amt!=null) {
				result = amt;
			}
			else {
				result = amt = ActiveOrHistoricCurrencyAnd5DecimalAmount__1.builder();
			}
			
			return result;
		}
	
		@Override
		@RosettaAttribute("amt")
		public AmountAndDirection106__2.AmountAndDirection106__2Builder setAmt(ActiveOrHistoricCurrencyAnd5DecimalAmount__1 amt) {
			this.amt = amt==null?null:amt.toBuilder();
			return this;
		}
		
		@Override
		public AmountAndDirection106__2 build() {
			return new AmountAndDirection106__2.AmountAndDirection106__2Impl(this);
		}
		
		@Override
		public AmountAndDirection106__2.AmountAndDirection106__2Builder toBuilder() {
			return this;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public AmountAndDirection106__2.AmountAndDirection106__2Builder prune() {
			if (amt!=null && !amt.prune().hasData()) amt = null;
			return this;
		}
		
		@Override
		public boolean hasData() {
			if (getAmt()!=null && getAmt().hasData()) return true;
			return false;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public AmountAndDirection106__2.AmountAndDirection106__2Builder merge(RosettaModelObjectBuilder other, BuilderMerger merger) {
			AmountAndDirection106__2.AmountAndDirection106__2Builder o = (AmountAndDirection106__2.AmountAndDirection106__2Builder) other;
			
			merger.mergeRosetta(getAmt(), o.getAmt(), this::setAmt);
			
			return this;
		}
	
		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			AmountAndDirection106__2 _that = getType().cast(o);
		
			if (!Objects.equals(amt, _that.getAmt())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (amt != null ? amt.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "AmountAndDirection106__2Builder {" +
				"amt=" + this.amt +
			'}';
		}
	}
}
