package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.AgriculturalCommodityOliveOil3;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class AgriculturalCommodityOliveOil3TypeFormatValidator implements Validator<AgriculturalCommodityOliveOil3> {

	@Override
	public ValidationResult<AgriculturalCommodityOliveOil3> validate(RosettaPath path, AgriculturalCommodityOliveOil3 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("AgriculturalCommodityOliveOil3", ValidationType.TYPE_FORMAT, "AgriculturalCommodityOliveOil3", path, "", error);
		}
		return success("AgriculturalCommodityOliveOil3", ValidationType.TYPE_FORMAT, "AgriculturalCommodityOliveOil3", path, "");
	}

}
