package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.AmountAndDirection106__4;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class AmountAndDirection106__4TypeFormatValidator implements Validator<AmountAndDirection106__4> {

	@Override
	public ValidationResult<AmountAndDirection106__4> validate(RosettaPath path, AmountAndDirection106__4 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("AmountAndDirection106__4", ValidationType.TYPE_FORMAT, "AmountAndDirection106__4", path, "", error);
		}
		return success("AmountAndDirection106__4", ValidationType.TYPE_FORMAT, "AmountAndDirection106__4", path, "");
	}

}
