package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.AssetClassCommodityFertilizer4Choice;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class AssetClassCommodityFertilizer4ChoiceTypeFormatValidator implements Validator<AssetClassCommodityFertilizer4Choice> {

	@Override
	public ValidationResult<AssetClassCommodityFertilizer4Choice> validate(RosettaPath path, AssetClassCommodityFertilizer4Choice o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("AssetClassCommodityFertilizer4Choice", ValidationType.TYPE_FORMAT, "AssetClassCommodityFertilizer4Choice", path, "", error);
		}
		return success("AssetClassCommodityFertilizer4Choice", ValidationType.TYPE_FORMAT, "AssetClassCommodityFertilizer4Choice", path, "");
	}

}
