package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.BasketConstituents3__1;
import iso20022.auth030.esma.InstrumentIdentification6Choice__1;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkCardinality;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class BasketConstituents3__1Validator implements Validator<BasketConstituents3__1> {

	@Override
	public ValidationResult<BasketConstituents3__1> validate(RosettaPath path, BasketConstituents3__1 o) {
		/* Casting is required to ensure types are output to ensure recompilation in Rosetta */
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkCardinality("instrmId", (InstrumentIdentification6Choice__1) o.getInstrmId() != null ? 1 : 0, 1, 1)
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("BasketConstituents3__1", ValidationType.CARDINALITY, "BasketConstituents3__1", path, "", error);
		}
		return success("BasketConstituents3__1", ValidationType.CARDINALITY, "BasketConstituents3__1", path, "");
	}

}
