package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.ContractValuationData8__2;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkNumber;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.Optional.empty;
import static java.util.Optional.of;
import static java.util.stream.Collectors.joining;

public class ContractValuationData8__2TypeFormatValidator implements Validator<ContractValuationData8__2> {

	@Override
	public ValidationResult<ContractValuationData8__2> validate(RosettaPath path, ContractValuationData8__2 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkNumber("dlta", o.getDlta(), of(25), of(5), empty(), empty())
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("ContractValuationData8__2", ValidationType.TYPE_FORMAT, "ContractValuationData8__2", path, "", error);
		}
		return success("ContractValuationData8__2", ValidationType.TYPE_FORMAT, "ContractValuationData8__2", path, "");
	}

}
