package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.CounterpartySpecificData36__2;
import iso20022.auth030.esma.TradeCounterpartyReport20__1;
import java.time.ZonedDateTime;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkCardinality;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class CounterpartySpecificData36__2Validator implements Validator<CounterpartySpecificData36__2> {

	@Override
	public ValidationResult<CounterpartySpecificData36__2> validate(RosettaPath path, CounterpartySpecificData36__2 o) {
		/* Casting is required to ensure types are output to ensure recompilation in Rosetta */
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkCardinality("ctrPty", (TradeCounterpartyReport20__1) o.getCtrPty() != null ? 1 : 0, 1, 1), 
				checkCardinality("rptgTmStmp", (ZonedDateTime) o.getRptgTmStmp() != null ? 1 : 0, 0, 1)
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("CounterpartySpecificData36__2", ValidationType.CARDINALITY, "CounterpartySpecificData36__2", path, "", error);
		}
		return success("CounterpartySpecificData36__2", ValidationType.CARDINALITY, "CounterpartySpecificData36__2", path, "");
	}

}
