package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.DeliveryInterconnectionPoint1Choice__1;
import iso20022.auth030.esma.EnergyLoadType1Code;
import iso20022.auth030.esma.EnergySpecificAttribute9__1;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkCardinality;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class EnergySpecificAttribute9__1Validator implements Validator<EnergySpecificAttribute9__1> {

	@Override
	public ValidationResult<EnergySpecificAttribute9__1> validate(RosettaPath path, EnergySpecificAttribute9__1 o) {
		/* Casting is required to ensure types are output to ensure recompilation in Rosetta */
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkCardinality("intrCnnctnPt", (DeliveryInterconnectionPoint1Choice__1) o.getIntrCnnctnPt() != null ? 1 : 0, 0, 1), 
				checkCardinality("ldTp", (EnergyLoadType1Code) o.getLdTp() != null ? 1 : 0, 0, 1)
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("EnergySpecificAttribute9__1", ValidationType.CARDINALITY, "EnergySpecificAttribute9__1", path, "", error);
		}
		return success("EnergySpecificAttribute9__1", ValidationType.CARDINALITY, "EnergySpecificAttribute9__1", path, "");
	}

}
