package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.FreightCommodityDry3;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class FreightCommodityDry3TypeFormatValidator implements Validator<FreightCommodityDry3> {

	@Override
	public ValidationResult<FreightCommodityDry3> validate(RosettaPath path, FreightCommodityDry3 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("FreightCommodityDry3", ValidationType.TYPE_FORMAT, "FreightCommodityDry3", path, "", error);
		}
		return success("FreightCommodityDry3", ValidationType.TYPE_FORMAT, "FreightCommodityDry3", path, "");
	}

}
