package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.GenericIdentification175__2;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkString;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.Optional.empty;
import static java.util.Optional.of;
import static java.util.stream.Collectors.joining;

public class GenericIdentification175__2TypeFormatValidator implements Validator<GenericIdentification175__2> {

	@Override
	public ValidationResult<GenericIdentification175__2> validate(RosettaPath path, GenericIdentification175__2 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkString("id", o.getId(), 1, of(72), empty())
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("GenericIdentification175__2", ValidationType.TYPE_FORMAT, "GenericIdentification175__2", path, "", error);
		}
		return success("GenericIdentification175__2", ValidationType.TYPE_FORMAT, "GenericIdentification175__2", path, "");
	}

}
