package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.InterestComputationMethodFormat7__1;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class InterestComputationMethodFormat7__1TypeFormatValidator implements Validator<InterestComputationMethodFormat7__1> {

	@Override
	public ValidationResult<InterestComputationMethodFormat7__1> validate(RosettaPath path, InterestComputationMethodFormat7__1 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("InterestComputationMethodFormat7__1", ValidationType.TYPE_FORMAT, "InterestComputationMethodFormat7__1", path, "", error);
		}
		return success("InterestComputationMethodFormat7__1", ValidationType.TYPE_FORMAT, "InterestComputationMethodFormat7__1", path, "");
	}

}
