package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.InterestRateContractTerm4__1;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkNumber;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.Optional.empty;
import static java.util.Optional.of;
import static java.util.stream.Collectors.joining;

public class InterestRateContractTerm4__1TypeFormatValidator implements Validator<InterestRateContractTerm4__1> {

	@Override
	public ValidationResult<InterestRateContractTerm4__1> validate(RosettaPath path, InterestRateContractTerm4__1 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkNumber("val", o.getVal(), of(3), of(0), empty(), empty())
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("InterestRateContractTerm4__1", ValidationType.TYPE_FORMAT, "InterestRateContractTerm4__1", path, "", error);
		}
		return success("InterestRateContractTerm4__1", ValidationType.TYPE_FORMAT, "InterestRateContractTerm4__1", path, "");
	}

}
