package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.NotionalQuantityLegs5__2;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class NotionalQuantityLegs5__2TypeFormatValidator implements Validator<NotionalQuantityLegs5__2> {

	@Override
	public ValidationResult<NotionalQuantityLegs5__2> validate(RosettaPath path, NotionalQuantityLegs5__2 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("NotionalQuantityLegs5__2", ValidationType.TYPE_FORMAT, "NotionalQuantityLegs5__2", path, "", error);
		}
		return success("NotionalQuantityLegs5__2", ValidationType.TYPE_FORMAT, "NotionalQuantityLegs5__2", path, "");
	}

}
