package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.PaperCommodityOther1;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class PaperCommodityOther1TypeFormatValidator implements Validator<PaperCommodityOther1> {

	@Override
	public ValidationResult<PaperCommodityOther1> validate(RosettaPath path, PaperCommodityOther1 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("PaperCommodityOther1", ValidationType.TYPE_FORMAT, "PaperCommodityOther1", path, "", error);
		}
		return success("PaperCommodityOther1", ValidationType.TYPE_FORMAT, "PaperCommodityOther1", path, "");
	}

}
