package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.PartyIdentification248Choice__3;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class PartyIdentification248Choice__3TypeFormatValidator implements Validator<PartyIdentification248Choice__3> {

	@Override
	public ValidationResult<PartyIdentification248Choice__3> validate(RosettaPath path, PartyIdentification248Choice__3 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("PartyIdentification248Choice__3", ValidationType.TYPE_FORMAT, "PartyIdentification248Choice__3", path, "", error);
		}
		return success("PartyIdentification248Choice__3", ValidationType.TYPE_FORMAT, "PartyIdentification248Choice__3", path, "");
	}

}
