package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.PaymentType4Code;
import iso20022.auth030.esma.PaymentType5Choice__1;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkCardinality;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class PaymentType5Choice__1Validator implements Validator<PaymentType5Choice__1> {

	@Override
	public ValidationResult<PaymentType5Choice__1> validate(RosettaPath path, PaymentType5Choice__1 o) {
		/* Casting is required to ensure types are output to ensure recompilation in Rosetta */
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkCardinality("tp", (PaymentType4Code) o.getTp() != null ? 1 : 0, 0, 1)
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("PaymentType5Choice__1", ValidationType.CARDINALITY, "PaymentType5Choice__1", path, "", error);
		}
		return success("PaymentType5Choice__1", ValidationType.CARDINALITY, "PaymentType5Choice__1", path, "");
	}

}
