package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.AmountAndDirection106__4;
import iso20022.auth030.esma.SecuritiesTransactionPrice17Choice__2;
import java.math.BigDecimal;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkCardinality;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class SecuritiesTransactionPrice17Choice__2Validator implements Validator<SecuritiesTransactionPrice17Choice__2> {

	@Override
	public ValidationResult<SecuritiesTransactionPrice17Choice__2> validate(RosettaPath path, SecuritiesTransactionPrice17Choice__2 o) {
		/* Casting is required to ensure types are output to ensure recompilation in Rosetta */
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkCardinality("mntryVal", (AmountAndDirection106__4) o.getMntryVal() != null ? 1 : 0, 0, 1), 
				checkCardinality("pctg", (BigDecimal) o.getPctg() != null ? 1 : 0, 0, 1)
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("SecuritiesTransactionPrice17Choice__2", ValidationType.CARDINALITY, "SecuritiesTransactionPrice17Choice__2", path, "", error);
		}
		return success("SecuritiesTransactionPrice17Choice__2", ValidationType.CARDINALITY, "SecuritiesTransactionPrice17Choice__2", path, "");
	}

}
