package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.Counterparty45__1;
import iso20022.auth030.esma.Counterparty46__1;
import iso20022.auth030.esma.OrganisationIdentification15Choice__1;
import iso20022.auth030.esma.PartyIdentification248Choice__1;
import iso20022.auth030.esma.TradeCounterpartyReport20__1;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkCardinality;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class TradeCounterpartyReport20__1Validator implements Validator<TradeCounterpartyReport20__1> {

	@Override
	public ValidationResult<TradeCounterpartyReport20__1> validate(RosettaPath path, TradeCounterpartyReport20__1 o) {
		/* Casting is required to ensure types are output to ensure recompilation in Rosetta */
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkCardinality("rptgCtrPty", (Counterparty45__1) o.getRptgCtrPty() != null ? 1 : 0, 1, 1), 
				checkCardinality("othrCtrPty", (Counterparty46__1) o.getOthrCtrPty() != null ? 1 : 0, 1, 1), 
				checkCardinality("brkr", (OrganisationIdentification15Choice__1) o.getBrkr() != null ? 1 : 0, 0, 1), 
				checkCardinality("submitgAgt", (OrganisationIdentification15Choice__1) o.getSubmitgAgt() != null ? 1 : 0, 1, 1), 
				checkCardinality("clrMmb", (PartyIdentification248Choice__1) o.getClrMmb() != null ? 1 : 0, 0, 1), 
				checkCardinality("nttyRspnsblForRpt", (OrganisationIdentification15Choice__1) o.getNttyRspnsblForRpt() != null ? 1 : 0, 0, 1)
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("TradeCounterpartyReport20__1", ValidationType.CARDINALITY, "TradeCounterpartyReport20__1", path, "", error);
		}
		return success("TradeCounterpartyReport20__1", ValidationType.CARDINALITY, "TradeCounterpartyReport20__1", path, "");
	}

}
