package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.TradeCounterpartyReport20__2;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class TradeCounterpartyReport20__2TypeFormatValidator implements Validator<TradeCounterpartyReport20__2> {

	@Override
	public ValidationResult<TradeCounterpartyReport20__2> validate(RosettaPath path, TradeCounterpartyReport20__2 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("TradeCounterpartyReport20__2", ValidationType.TYPE_FORMAT, "TradeCounterpartyReport20__2", path, "", error);
		}
		return success("TradeCounterpartyReport20__2", ValidationType.TYPE_FORMAT, "TradeCounterpartyReport20__2", path, "");
	}

}
