package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.UniqueProductIdentifier2Choice__1;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkString;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.Optional.empty;
import static java.util.Optional.of;
import static java.util.stream.Collectors.joining;

public class UniqueProductIdentifier2Choice__1TypeFormatValidator implements Validator<UniqueProductIdentifier2Choice__1> {

	@Override
	public ValidationResult<UniqueProductIdentifier2Choice__1> validate(RosettaPath path, UniqueProductIdentifier2Choice__1 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkString("id", o.getId(), 1, of(12), empty())
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("UniqueProductIdentifier2Choice__1", ValidationType.TYPE_FORMAT, "UniqueProductIdentifier2Choice__1", path, "", error);
		}
		return success("UniqueProductIdentifier2Choice__1", ValidationType.TYPE_FORMAT, "UniqueProductIdentifier2Choice__1", path, "");
	}

}
