package iso20022.auth030.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.UniqueTransactionIdentifier2Choice__2;
import java.util.regex.Pattern;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkString;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.Optional.empty;
import static java.util.Optional.of;
import static java.util.stream.Collectors.joining;

public class UniqueTransactionIdentifier2Choice__2TypeFormatValidator implements Validator<UniqueTransactionIdentifier2Choice__2> {

	@Override
	public ValidationResult<UniqueTransactionIdentifier2Choice__2> validate(RosettaPath path, UniqueTransactionIdentifier2Choice__2 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkString("unqTxIdr", o.getUnqTxIdr(), 0, empty(), of(Pattern.compile("[A-Z0-9]{18}[0-9]{2}[A-Z0-9]{0,32}")))
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("UniqueTransactionIdentifier2Choice__2", ValidationType.TYPE_FORMAT, "UniqueTransactionIdentifier2Choice__2", path, "", error);
		}
		return success("UniqueTransactionIdentifier2Choice__2", ValidationType.TYPE_FORMAT, "UniqueTransactionIdentifier2Choice__2", path, "");
	}

}
