package iso20022.auth030.jfsa;

import com.rosetta.model.lib.RosettaModelObject;
import com.rosetta.model.lib.RosettaModelObjectBuilder;
import com.rosetta.model.lib.annotations.RosettaAttribute;
import com.rosetta.model.lib.annotations.RosettaDataType;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.process.BuilderMerger;
import com.rosetta.model.lib.process.BuilderProcessor;
import com.rosetta.model.lib.process.Processor;
import iso20022.auth030.jfsa.CollateralPortfolioCode5Choice__1;
import iso20022.auth030.jfsa.CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder;
import iso20022.auth030.jfsa.CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1BuilderImpl;
import iso20022.auth030.jfsa.CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Impl;
import iso20022.auth030.jfsa.MarginPortfolio3__1;
import iso20022.auth030.jfsa.meta.CollateralPortfolioCode5Choice__1Meta;
import java.util.Objects;

import static java.util.Optional.ofNullable;

/**
 * @version ${project.version}
 */
@RosettaDataType(value="CollateralPortfolioCode5Choice__1", builder=CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1BuilderImpl.class, version="${project.version}")
public interface CollateralPortfolioCode5Choice__1 extends RosettaModelObject {

	CollateralPortfolioCode5Choice__1Meta metaData = new CollateralPortfolioCode5Choice__1Meta();

	/*********************** Getter Methods  ***********************/
	MarginPortfolio3__1 getMrgnPrtflCd();

	/*********************** Build Methods  ***********************/
	CollateralPortfolioCode5Choice__1 build();
	
	CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder toBuilder();
	
	static CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder builder() {
		return new CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1BuilderImpl();
	}

	/*********************** Utility Methods  ***********************/
	@Override
	default RosettaMetaData<? extends CollateralPortfolioCode5Choice__1> metaData() {
		return metaData;
	}
	
	@Override
	default Class<? extends CollateralPortfolioCode5Choice__1> getType() {
		return CollateralPortfolioCode5Choice__1.class;
	}
	
	
	@Override
	default void process(RosettaPath path, Processor processor) {
		processRosetta(path.newSubPath("mrgnPrtflCd"), processor, MarginPortfolio3__1.class, getMrgnPrtflCd());
	}
	

	/*********************** Builder Interface  ***********************/
	interface CollateralPortfolioCode5Choice__1Builder extends CollateralPortfolioCode5Choice__1, RosettaModelObjectBuilder {
		MarginPortfolio3__1.MarginPortfolio3__1Builder getOrCreateMrgnPrtflCd();
		MarginPortfolio3__1.MarginPortfolio3__1Builder getMrgnPrtflCd();
		CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder setMrgnPrtflCd(MarginPortfolio3__1 mrgnPrtflCd);

		@Override
		default void process(RosettaPath path, BuilderProcessor processor) {
			processRosetta(path.newSubPath("mrgnPrtflCd"), processor, MarginPortfolio3__1.MarginPortfolio3__1Builder.class, getMrgnPrtflCd());
		}
		

		CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder prune();
	}

	/*********************** Immutable Implementation of CollateralPortfolioCode5Choice__1  ***********************/
	class CollateralPortfolioCode5Choice__1Impl implements CollateralPortfolioCode5Choice__1 {
		private final MarginPortfolio3__1 mrgnPrtflCd;
		
		protected CollateralPortfolioCode5Choice__1Impl(CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder builder) {
			this.mrgnPrtflCd = ofNullable(builder.getMrgnPrtflCd()).map(f->f.build()).orElse(null);
		}
		
		@Override
		@RosettaAttribute("mrgnPrtflCd")
		public MarginPortfolio3__1 getMrgnPrtflCd() {
			return mrgnPrtflCd;
		}
		
		@Override
		public CollateralPortfolioCode5Choice__1 build() {
			return this;
		}
		
		@Override
		public CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder toBuilder() {
			CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder builder = builder();
			setBuilderFields(builder);
			return builder;
		}
		
		protected void setBuilderFields(CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder builder) {
			ofNullable(getMrgnPrtflCd()).ifPresent(builder::setMrgnPrtflCd);
		}

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			CollateralPortfolioCode5Choice__1 _that = getType().cast(o);
		
			if (!Objects.equals(mrgnPrtflCd, _that.getMrgnPrtflCd())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (mrgnPrtflCd != null ? mrgnPrtflCd.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "CollateralPortfolioCode5Choice__1 {" +
				"mrgnPrtflCd=" + this.mrgnPrtflCd +
			'}';
		}
	}

	/*********************** Builder Implementation of CollateralPortfolioCode5Choice__1  ***********************/
	class CollateralPortfolioCode5Choice__1BuilderImpl implements CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder {
	
		protected MarginPortfolio3__1.MarginPortfolio3__1Builder mrgnPrtflCd;
	
		public CollateralPortfolioCode5Choice__1BuilderImpl() {
		}
	
		@Override
		@RosettaAttribute("mrgnPrtflCd")
		public MarginPortfolio3__1.MarginPortfolio3__1Builder getMrgnPrtflCd() {
			return mrgnPrtflCd;
		}
		
		@Override
		public MarginPortfolio3__1.MarginPortfolio3__1Builder getOrCreateMrgnPrtflCd() {
			MarginPortfolio3__1.MarginPortfolio3__1Builder result;
			if (mrgnPrtflCd!=null) {
				result = mrgnPrtflCd;
			}
			else {
				result = mrgnPrtflCd = MarginPortfolio3__1.builder();
			}
			
			return result;
		}
	
		@Override
		@RosettaAttribute("mrgnPrtflCd")
		public CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder setMrgnPrtflCd(MarginPortfolio3__1 mrgnPrtflCd) {
			this.mrgnPrtflCd = mrgnPrtflCd==null?null:mrgnPrtflCd.toBuilder();
			return this;
		}
		
		@Override
		public CollateralPortfolioCode5Choice__1 build() {
			return new CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Impl(this);
		}
		
		@Override
		public CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder toBuilder() {
			return this;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder prune() {
			if (mrgnPrtflCd!=null && !mrgnPrtflCd.prune().hasData()) mrgnPrtflCd = null;
			return this;
		}
		
		@Override
		public boolean hasData() {
			if (getMrgnPrtflCd()!=null && getMrgnPrtflCd().hasData()) return true;
			return false;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder merge(RosettaModelObjectBuilder other, BuilderMerger merger) {
			CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder o = (CollateralPortfolioCode5Choice__1.CollateralPortfolioCode5Choice__1Builder) other;
			
			merger.mergeRosetta(getMrgnPrtflCd(), o.getMrgnPrtflCd(), this::setMrgnPrtflCd);
			
			return this;
		}
	
		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			CollateralPortfolioCode5Choice__1 _that = getType().cast(o);
		
			if (!Objects.equals(mrgnPrtflCd, _that.getMrgnPrtflCd())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (mrgnPrtflCd != null ? mrgnPrtflCd.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "CollateralPortfolioCode5Choice__1Builder {" +
				"mrgnPrtflCd=" + this.mrgnPrtflCd +
			'}';
		}
	}
}
