package iso20022.auth030.jfsa;

import com.rosetta.model.lib.RosettaModelObject;
import com.rosetta.model.lib.RosettaModelObjectBuilder;
import com.rosetta.model.lib.annotations.RosettaAttribute;
import com.rosetta.model.lib.annotations.RosettaDataType;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.process.BuilderMerger;
import com.rosetta.model.lib.process.BuilderProcessor;
import com.rosetta.model.lib.process.Processor;
import iso20022.auth030.jfsa.CommonTradeDataReport69__5;
import iso20022.auth030.jfsa.CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder;
import iso20022.auth030.jfsa.CommonTradeDataReport69__5.CommonTradeDataReport69__5BuilderImpl;
import iso20022.auth030.jfsa.CommonTradeDataReport69__5.CommonTradeDataReport69__5Impl;
import iso20022.auth030.jfsa.TradeTransaction49__5;
import iso20022.auth030.jfsa.meta.CommonTradeDataReport69__5Meta;
import java.util.Objects;

import static java.util.Optional.ofNullable;

/**
 * @version ${project.version}
 */
@RosettaDataType(value="CommonTradeDataReport69__5", builder=CommonTradeDataReport69__5.CommonTradeDataReport69__5BuilderImpl.class, version="${project.version}")
public interface CommonTradeDataReport69__5 extends RosettaModelObject {

	CommonTradeDataReport69__5Meta metaData = new CommonTradeDataReport69__5Meta();

	/*********************** Getter Methods  ***********************/
	TradeTransaction49__5 getTxData();

	/*********************** Build Methods  ***********************/
	CommonTradeDataReport69__5 build();
	
	CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder toBuilder();
	
	static CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder builder() {
		return new CommonTradeDataReport69__5.CommonTradeDataReport69__5BuilderImpl();
	}

	/*********************** Utility Methods  ***********************/
	@Override
	default RosettaMetaData<? extends CommonTradeDataReport69__5> metaData() {
		return metaData;
	}
	
	@Override
	default Class<? extends CommonTradeDataReport69__5> getType() {
		return CommonTradeDataReport69__5.class;
	}
	
	
	@Override
	default void process(RosettaPath path, Processor processor) {
		processRosetta(path.newSubPath("txData"), processor, TradeTransaction49__5.class, getTxData());
	}
	

	/*********************** Builder Interface  ***********************/
	interface CommonTradeDataReport69__5Builder extends CommonTradeDataReport69__5, RosettaModelObjectBuilder {
		TradeTransaction49__5.TradeTransaction49__5Builder getOrCreateTxData();
		TradeTransaction49__5.TradeTransaction49__5Builder getTxData();
		CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder setTxData(TradeTransaction49__5 txData);

		@Override
		default void process(RosettaPath path, BuilderProcessor processor) {
			processRosetta(path.newSubPath("txData"), processor, TradeTransaction49__5.TradeTransaction49__5Builder.class, getTxData());
		}
		

		CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder prune();
	}

	/*********************** Immutable Implementation of CommonTradeDataReport69__5  ***********************/
	class CommonTradeDataReport69__5Impl implements CommonTradeDataReport69__5 {
		private final TradeTransaction49__5 txData;
		
		protected CommonTradeDataReport69__5Impl(CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder builder) {
			this.txData = ofNullable(builder.getTxData()).map(f->f.build()).orElse(null);
		}
		
		@Override
		@RosettaAttribute("txData")
		public TradeTransaction49__5 getTxData() {
			return txData;
		}
		
		@Override
		public CommonTradeDataReport69__5 build() {
			return this;
		}
		
		@Override
		public CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder toBuilder() {
			CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder builder = builder();
			setBuilderFields(builder);
			return builder;
		}
		
		protected void setBuilderFields(CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder builder) {
			ofNullable(getTxData()).ifPresent(builder::setTxData);
		}

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			CommonTradeDataReport69__5 _that = getType().cast(o);
		
			if (!Objects.equals(txData, _that.getTxData())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (txData != null ? txData.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "CommonTradeDataReport69__5 {" +
				"txData=" + this.txData +
			'}';
		}
	}

	/*********************** Builder Implementation of CommonTradeDataReport69__5  ***********************/
	class CommonTradeDataReport69__5BuilderImpl implements CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder {
	
		protected TradeTransaction49__5.TradeTransaction49__5Builder txData;
	
		public CommonTradeDataReport69__5BuilderImpl() {
		}
	
		@Override
		@RosettaAttribute("txData")
		public TradeTransaction49__5.TradeTransaction49__5Builder getTxData() {
			return txData;
		}
		
		@Override
		public TradeTransaction49__5.TradeTransaction49__5Builder getOrCreateTxData() {
			TradeTransaction49__5.TradeTransaction49__5Builder result;
			if (txData!=null) {
				result = txData;
			}
			else {
				result = txData = TradeTransaction49__5.builder();
			}
			
			return result;
		}
	
		@Override
		@RosettaAttribute("txData")
		public CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder setTxData(TradeTransaction49__5 txData) {
			this.txData = txData==null?null:txData.toBuilder();
			return this;
		}
		
		@Override
		public CommonTradeDataReport69__5 build() {
			return new CommonTradeDataReport69__5.CommonTradeDataReport69__5Impl(this);
		}
		
		@Override
		public CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder toBuilder() {
			return this;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder prune() {
			if (txData!=null && !txData.prune().hasData()) txData = null;
			return this;
		}
		
		@Override
		public boolean hasData() {
			if (getTxData()!=null && getTxData().hasData()) return true;
			return false;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder merge(RosettaModelObjectBuilder other, BuilderMerger merger) {
			CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder o = (CommonTradeDataReport69__5.CommonTradeDataReport69__5Builder) other;
			
			merger.mergeRosetta(getTxData(), o.getTxData(), this::setTxData);
			
			return this;
		}
	
		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			CommonTradeDataReport69__5 _that = getType().cast(o);
		
			if (!Objects.equals(txData, _that.getTxData())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (txData != null ? txData.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "CommonTradeDataReport69__5Builder {" +
				"txData=" + this.txData +
			'}';
		}
	}
}
