package iso20022.auth030.jfsa;

import com.rosetta.model.lib.annotations.RosettaEnum;
import com.rosetta.model.lib.annotations.RosettaEnumValue;
import java.util.Collections;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;


/**
 * @version ${project.version}
 */
@RosettaEnum("FloatingRateIndex1Code")
public enum FloatingRateIndex1Code {

	@RosettaEnumValue(value = "BBSW") BBSW("BBSW"),
	
	@RosettaEnumValue(value = "BCOL") BCOL("BCOL"),
	
	@RosettaEnumValue(value = "BJUO") BJUO("BJUO"),
	
	@RosettaEnumValue(value = "BUBO") BUBO("BUBO"),
	
	@RosettaEnumValue(value = "CDOR") CDOR("CDOR"),
	
	@RosettaEnumValue(value = "CIBO") CIBO("CIBO"),
	
	@RosettaEnumValue(value = "CORA") CORA("CORA"),
	
	@RosettaEnumValue(value = "CZNA") CZNA("CZNA"),
	
	@RosettaEnumValue(value = "EFFR") EFFR("EFFR"),
	
	@RosettaEnumValue(value = "EONA") EONA("EONA"),
	
	@RosettaEnumValue(value = "EONS") EONS("EONS"),
	
	@RosettaEnumValue(value = "ESTR") ESTR("ESTR"),
	
	@RosettaEnumValue(value = "ETIO") ETIO("ETIO"),
	
	@RosettaEnumValue(value = "EUCH") EUCH("EUCH"),
	
	@RosettaEnumValue(value = "EURI") EURI("EURI"),
	
	@RosettaEnumValue(value = "EUUS") EUUS("EUUS"),
	
	@RosettaEnumValue(value = "FUSW") FUSW("FUSW"),
	
	@RosettaEnumValue(value = "GCFR") GCFR("GCFR"),
	
	@RosettaEnumValue(value = "HKIO") HKIO("HKIO"),
	
	@RosettaEnumValue(value = "ISDA") ISDA("ISDA"),
	
	@RosettaEnumValue(value = "JIBA") JIBA("JIBA"),
	
	@RosettaEnumValue(value = "LIBI") LIBI("LIBI"),
	
	@RosettaEnumValue(value = "LIBO") LIBO("LIBO"),
	
	@RosettaEnumValue(value = "MAAA") MAAA("MAAA"),
	
	@RosettaEnumValue(value = "MOSP") MOSP("MOSP"),
	
	@RosettaEnumValue(value = "NIBO") NIBO("NIBO"),
	
	@RosettaEnumValue(value = "OBFR") OBFR("OBFR"),
	
	@RosettaEnumValue(value = "PFAN") PFAN("PFAN"),
	
	@RosettaEnumValue(value = "PRBO") PRBO("PRBO"),
	
	@RosettaEnumValue(value = "RCTR") RCTR("RCTR"),
	
	@RosettaEnumValue(value = "SIBO") SIBO("SIBO"),
	
	@RosettaEnumValue(value = "SOFR") SOFR("SOFR"),
	
	@RosettaEnumValue(value = "SONA") SONA("SONA"),
	
	@RosettaEnumValue(value = "SORA") SORA("SORA"),
	
	@RosettaEnumValue(value = "SSOR") SSOR("SSOR"),
	
	@RosettaEnumValue(value = "STBO") STBO("STBO"),
	
	@RosettaEnumValue(value = "SWAP") SWAP("SWAP"),
	
	@RosettaEnumValue(value = "TIBO") TIBO("TIBO"),
	
	@RosettaEnumValue(value = "TLBO") TLBO("TLBO"),
	
	@RosettaEnumValue(value = "TONA") TONA("TONA"),
	
	@RosettaEnumValue(value = "TORF") TORF("TORF"),
	
	@RosettaEnumValue(value = "TREA") TREA("TREA"),
	
	@RosettaEnumValue(value = "WIBO") WIBO("WIBO")
;
	private static Map<String, FloatingRateIndex1Code> values;
	static {
        Map<String, FloatingRateIndex1Code> map = new ConcurrentHashMap<>();
		for (FloatingRateIndex1Code instance : FloatingRateIndex1Code.values()) {
			map.put(instance.toDisplayString(), instance);
		}
		values = Collections.unmodifiableMap(map);
    }

	private final String rosettaName;
	private final String displayName;

	FloatingRateIndex1Code(String rosettaName) {
		this(rosettaName, null);
	}

	FloatingRateIndex1Code(String rosettaName, String displayName) {
		this.rosettaName = rosettaName;
		this.displayName = displayName;
	}

	public static FloatingRateIndex1Code fromDisplayName(String name) {
		FloatingRateIndex1Code value = values.get(name);
		if (value == null) {
			throw new IllegalArgumentException("No enum constant with display name \"" + name + "\".");
		}
		return value;
	}

	@Override
	public String toString() {
		return toDisplayString();
	}

	public String toDisplayString() {
		return displayName != null ?  displayName : rosettaName;
	}
}
