package iso20022.auth030.jfsa;

import com.rosetta.model.lib.RosettaModelObject;
import com.rosetta.model.lib.RosettaModelObjectBuilder;
import com.rosetta.model.lib.annotations.RosettaAttribute;
import com.rosetta.model.lib.annotations.RosettaDataType;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.process.BuilderMerger;
import com.rosetta.model.lib.process.BuilderProcessor;
import com.rosetta.model.lib.process.Processor;
import iso20022.auth030.jfsa.MarginPortfolio3__1;
import iso20022.auth030.jfsa.MarginPortfolio3__1.MarginPortfolio3__1Builder;
import iso20022.auth030.jfsa.MarginPortfolio3__1.MarginPortfolio3__1BuilderImpl;
import iso20022.auth030.jfsa.MarginPortfolio3__1.MarginPortfolio3__1Impl;
import iso20022.auth030.jfsa.PortfolioCode5Choice__1;
import iso20022.auth030.jfsa.meta.MarginPortfolio3__1Meta;
import java.util.Objects;

import static java.util.Optional.ofNullable;

/**
 * @version ${project.version}
 */
@RosettaDataType(value="MarginPortfolio3__1", builder=MarginPortfolio3__1.MarginPortfolio3__1BuilderImpl.class, version="${project.version}")
public interface MarginPortfolio3__1 extends RosettaModelObject {

	MarginPortfolio3__1Meta metaData = new MarginPortfolio3__1Meta();

	/*********************** Getter Methods  ***********************/
	PortfolioCode5Choice__1 getInitlMrgnPrtflCd();
	PortfolioCode5Choice__1 getVartnMrgnPrtflCd();

	/*********************** Build Methods  ***********************/
	MarginPortfolio3__1 build();
	
	MarginPortfolio3__1.MarginPortfolio3__1Builder toBuilder();
	
	static MarginPortfolio3__1.MarginPortfolio3__1Builder builder() {
		return new MarginPortfolio3__1.MarginPortfolio3__1BuilderImpl();
	}

	/*********************** Utility Methods  ***********************/
	@Override
	default RosettaMetaData<? extends MarginPortfolio3__1> metaData() {
		return metaData;
	}
	
	@Override
	default Class<? extends MarginPortfolio3__1> getType() {
		return MarginPortfolio3__1.class;
	}
	
	
	@Override
	default void process(RosettaPath path, Processor processor) {
		processRosetta(path.newSubPath("initlMrgnPrtflCd"), processor, PortfolioCode5Choice__1.class, getInitlMrgnPrtflCd());
		processRosetta(path.newSubPath("vartnMrgnPrtflCd"), processor, PortfolioCode5Choice__1.class, getVartnMrgnPrtflCd());
	}
	

	/*********************** Builder Interface  ***********************/
	interface MarginPortfolio3__1Builder extends MarginPortfolio3__1, RosettaModelObjectBuilder {
		PortfolioCode5Choice__1.PortfolioCode5Choice__1Builder getOrCreateInitlMrgnPrtflCd();
		PortfolioCode5Choice__1.PortfolioCode5Choice__1Builder getInitlMrgnPrtflCd();
		PortfolioCode5Choice__1.PortfolioCode5Choice__1Builder getOrCreateVartnMrgnPrtflCd();
		PortfolioCode5Choice__1.PortfolioCode5Choice__1Builder getVartnMrgnPrtflCd();
		MarginPortfolio3__1.MarginPortfolio3__1Builder setInitlMrgnPrtflCd(PortfolioCode5Choice__1 initlMrgnPrtflCd);
		MarginPortfolio3__1.MarginPortfolio3__1Builder setVartnMrgnPrtflCd(PortfolioCode5Choice__1 vartnMrgnPrtflCd);

		@Override
		default void process(RosettaPath path, BuilderProcessor processor) {
			processRosetta(path.newSubPath("initlMrgnPrtflCd"), processor, PortfolioCode5Choice__1.PortfolioCode5Choice__1Builder.class, getInitlMrgnPrtflCd());
			processRosetta(path.newSubPath("vartnMrgnPrtflCd"), processor, PortfolioCode5Choice__1.PortfolioCode5Choice__1Builder.class, getVartnMrgnPrtflCd());
		}
		

		MarginPortfolio3__1.MarginPortfolio3__1Builder prune();
	}

	/*********************** Immutable Implementation of MarginPortfolio3__1  ***********************/
	class MarginPortfolio3__1Impl implements MarginPortfolio3__1 {
		private final PortfolioCode5Choice__1 initlMrgnPrtflCd;
		private final PortfolioCode5Choice__1 vartnMrgnPrtflCd;
		
		protected MarginPortfolio3__1Impl(MarginPortfolio3__1.MarginPortfolio3__1Builder builder) {
			this.initlMrgnPrtflCd = ofNullable(builder.getInitlMrgnPrtflCd()).map(f->f.build()).orElse(null);
			this.vartnMrgnPrtflCd = ofNullable(builder.getVartnMrgnPrtflCd()).map(f->f.build()).orElse(null);
		}
		
		@Override
		@RosettaAttribute("initlMrgnPrtflCd")
		public PortfolioCode5Choice__1 getInitlMrgnPrtflCd() {
			return initlMrgnPrtflCd;
		}
		
		@Override
		@RosettaAttribute("vartnMrgnPrtflCd")
		public PortfolioCode5Choice__1 getVartnMrgnPrtflCd() {
			return vartnMrgnPrtflCd;
		}
		
		@Override
		public MarginPortfolio3__1 build() {
			return this;
		}
		
		@Override
		public MarginPortfolio3__1.MarginPortfolio3__1Builder toBuilder() {
			MarginPortfolio3__1.MarginPortfolio3__1Builder builder = builder();
			setBuilderFields(builder);
			return builder;
		}
		
		protected void setBuilderFields(MarginPortfolio3__1.MarginPortfolio3__1Builder builder) {
			ofNullable(getInitlMrgnPrtflCd()).ifPresent(builder::setInitlMrgnPrtflCd);
			ofNullable(getVartnMrgnPrtflCd()).ifPresent(builder::setVartnMrgnPrtflCd);
		}

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			MarginPortfolio3__1 _that = getType().cast(o);
		
			if (!Objects.equals(initlMrgnPrtflCd, _that.getInitlMrgnPrtflCd())) return false;
			if (!Objects.equals(vartnMrgnPrtflCd, _that.getVartnMrgnPrtflCd())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (initlMrgnPrtflCd != null ? initlMrgnPrtflCd.hashCode() : 0);
			_result = 31 * _result + (vartnMrgnPrtflCd != null ? vartnMrgnPrtflCd.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "MarginPortfolio3__1 {" +
				"initlMrgnPrtflCd=" + this.initlMrgnPrtflCd + ", " +
				"vartnMrgnPrtflCd=" + this.vartnMrgnPrtflCd +
			'}';
		}
	}

	/*********************** Builder Implementation of MarginPortfolio3__1  ***********************/
	class MarginPortfolio3__1BuilderImpl implements MarginPortfolio3__1.MarginPortfolio3__1Builder {
	
		protected PortfolioCode5Choice__1.PortfolioCode5Choice__1Builder initlMrgnPrtflCd;
		protected PortfolioCode5Choice__1.PortfolioCode5Choice__1Builder vartnMrgnPrtflCd;
	
		public MarginPortfolio3__1BuilderImpl() {
		}
	
		@Override
		@RosettaAttribute("initlMrgnPrtflCd")
		public PortfolioCode5Choice__1.PortfolioCode5Choice__1Builder getInitlMrgnPrtflCd() {
			return initlMrgnPrtflCd;
		}
		
		@Override
		public PortfolioCode5Choice__1.PortfolioCode5Choice__1Builder getOrCreateInitlMrgnPrtflCd() {
			PortfolioCode5Choice__1.PortfolioCode5Choice__1Builder result;
			if (initlMrgnPrtflCd!=null) {
				result = initlMrgnPrtflCd;
			}
			else {
				result = initlMrgnPrtflCd = PortfolioCode5Choice__1.builder();
			}
			
			return result;
		}
		@Override
		@RosettaAttribute("vartnMrgnPrtflCd")
		public PortfolioCode5Choice__1.PortfolioCode5Choice__1Builder getVartnMrgnPrtflCd() {
			return vartnMrgnPrtflCd;
		}
		
		@Override
		public PortfolioCode5Choice__1.PortfolioCode5Choice__1Builder getOrCreateVartnMrgnPrtflCd() {
			PortfolioCode5Choice__1.PortfolioCode5Choice__1Builder result;
			if (vartnMrgnPrtflCd!=null) {
				result = vartnMrgnPrtflCd;
			}
			else {
				result = vartnMrgnPrtflCd = PortfolioCode5Choice__1.builder();
			}
			
			return result;
		}
	
		@Override
		@RosettaAttribute("initlMrgnPrtflCd")
		public MarginPortfolio3__1.MarginPortfolio3__1Builder setInitlMrgnPrtflCd(PortfolioCode5Choice__1 initlMrgnPrtflCd) {
			this.initlMrgnPrtflCd = initlMrgnPrtflCd==null?null:initlMrgnPrtflCd.toBuilder();
			return this;
		}
		@Override
		@RosettaAttribute("vartnMrgnPrtflCd")
		public MarginPortfolio3__1.MarginPortfolio3__1Builder setVartnMrgnPrtflCd(PortfolioCode5Choice__1 vartnMrgnPrtflCd) {
			this.vartnMrgnPrtflCd = vartnMrgnPrtflCd==null?null:vartnMrgnPrtflCd.toBuilder();
			return this;
		}
		
		@Override
		public MarginPortfolio3__1 build() {
			return new MarginPortfolio3__1.MarginPortfolio3__1Impl(this);
		}
		
		@Override
		public MarginPortfolio3__1.MarginPortfolio3__1Builder toBuilder() {
			return this;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public MarginPortfolio3__1.MarginPortfolio3__1Builder prune() {
			if (initlMrgnPrtflCd!=null && !initlMrgnPrtflCd.prune().hasData()) initlMrgnPrtflCd = null;
			if (vartnMrgnPrtflCd!=null && !vartnMrgnPrtflCd.prune().hasData()) vartnMrgnPrtflCd = null;
			return this;
		}
		
		@Override
		public boolean hasData() {
			if (getInitlMrgnPrtflCd()!=null && getInitlMrgnPrtflCd().hasData()) return true;
			if (getVartnMrgnPrtflCd()!=null && getVartnMrgnPrtflCd().hasData()) return true;
			return false;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public MarginPortfolio3__1.MarginPortfolio3__1Builder merge(RosettaModelObjectBuilder other, BuilderMerger merger) {
			MarginPortfolio3__1.MarginPortfolio3__1Builder o = (MarginPortfolio3__1.MarginPortfolio3__1Builder) other;
			
			merger.mergeRosetta(getInitlMrgnPrtflCd(), o.getInitlMrgnPrtflCd(), this::setInitlMrgnPrtflCd);
			merger.mergeRosetta(getVartnMrgnPrtflCd(), o.getVartnMrgnPrtflCd(), this::setVartnMrgnPrtflCd);
			
			return this;
		}
	
		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			MarginPortfolio3__1 _that = getType().cast(o);
		
			if (!Objects.equals(initlMrgnPrtflCd, _that.getInitlMrgnPrtflCd())) return false;
			if (!Objects.equals(vartnMrgnPrtflCd, _that.getVartnMrgnPrtflCd())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (initlMrgnPrtflCd != null ? initlMrgnPrtflCd.hashCode() : 0);
			_result = 31 * _result + (vartnMrgnPrtflCd != null ? vartnMrgnPrtflCd.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "MarginPortfolio3__1Builder {" +
				"initlMrgnPrtflCd=" + this.initlMrgnPrtflCd + ", " +
				"vartnMrgnPrtflCd=" + this.vartnMrgnPrtflCd +
			'}';
		}
	}
}
