package iso20022.auth030.jfsa;

import com.rosetta.model.lib.RosettaModelObject;
import com.rosetta.model.lib.RosettaModelObjectBuilder;
import com.rosetta.model.lib.annotations.RosettaAttribute;
import com.rosetta.model.lib.annotations.RosettaDataType;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.process.BuilderMerger;
import com.rosetta.model.lib.process.BuilderProcessor;
import com.rosetta.model.lib.process.Processor;
import iso20022.auth030.jfsa.TradeTransaction49__5;
import iso20022.auth030.jfsa.TradeTransaction49__5.TradeTransaction49__5Builder;
import iso20022.auth030.jfsa.TradeTransaction49__5.TradeTransaction49__5BuilderImpl;
import iso20022.auth030.jfsa.TradeTransaction49__5.TradeTransaction49__5Impl;
import iso20022.auth030.jfsa.UniqueTransactionIdentifier2Choice__1;
import iso20022.auth030.jfsa.meta.TradeTransaction49__5Meta;
import java.util.Objects;

import static java.util.Optional.ofNullable;

/**
 * @version ${project.version}
 */
@RosettaDataType(value="TradeTransaction49__5", builder=TradeTransaction49__5.TradeTransaction49__5BuilderImpl.class, version="${project.version}")
public interface TradeTransaction49__5 extends RosettaModelObject {

	TradeTransaction49__5Meta metaData = new TradeTransaction49__5Meta();

	/*********************** Getter Methods  ***********************/
	UniqueTransactionIdentifier2Choice__1 getTxId();

	/*********************** Build Methods  ***********************/
	TradeTransaction49__5 build();
	
	TradeTransaction49__5.TradeTransaction49__5Builder toBuilder();
	
	static TradeTransaction49__5.TradeTransaction49__5Builder builder() {
		return new TradeTransaction49__5.TradeTransaction49__5BuilderImpl();
	}

	/*********************** Utility Methods  ***********************/
	@Override
	default RosettaMetaData<? extends TradeTransaction49__5> metaData() {
		return metaData;
	}
	
	@Override
	default Class<? extends TradeTransaction49__5> getType() {
		return TradeTransaction49__5.class;
	}
	
	
	@Override
	default void process(RosettaPath path, Processor processor) {
		processRosetta(path.newSubPath("txId"), processor, UniqueTransactionIdentifier2Choice__1.class, getTxId());
	}
	

	/*********************** Builder Interface  ***********************/
	interface TradeTransaction49__5Builder extends TradeTransaction49__5, RosettaModelObjectBuilder {
		UniqueTransactionIdentifier2Choice__1.UniqueTransactionIdentifier2Choice__1Builder getOrCreateTxId();
		UniqueTransactionIdentifier2Choice__1.UniqueTransactionIdentifier2Choice__1Builder getTxId();
		TradeTransaction49__5.TradeTransaction49__5Builder setTxId(UniqueTransactionIdentifier2Choice__1 txId);

		@Override
		default void process(RosettaPath path, BuilderProcessor processor) {
			processRosetta(path.newSubPath("txId"), processor, UniqueTransactionIdentifier2Choice__1.UniqueTransactionIdentifier2Choice__1Builder.class, getTxId());
		}
		

		TradeTransaction49__5.TradeTransaction49__5Builder prune();
	}

	/*********************** Immutable Implementation of TradeTransaction49__5  ***********************/
	class TradeTransaction49__5Impl implements TradeTransaction49__5 {
		private final UniqueTransactionIdentifier2Choice__1 txId;
		
		protected TradeTransaction49__5Impl(TradeTransaction49__5.TradeTransaction49__5Builder builder) {
			this.txId = ofNullable(builder.getTxId()).map(f->f.build()).orElse(null);
		}
		
		@Override
		@RosettaAttribute("txId")
		public UniqueTransactionIdentifier2Choice__1 getTxId() {
			return txId;
		}
		
		@Override
		public TradeTransaction49__5 build() {
			return this;
		}
		
		@Override
		public TradeTransaction49__5.TradeTransaction49__5Builder toBuilder() {
			TradeTransaction49__5.TradeTransaction49__5Builder builder = builder();
			setBuilderFields(builder);
			return builder;
		}
		
		protected void setBuilderFields(TradeTransaction49__5.TradeTransaction49__5Builder builder) {
			ofNullable(getTxId()).ifPresent(builder::setTxId);
		}

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			TradeTransaction49__5 _that = getType().cast(o);
		
			if (!Objects.equals(txId, _that.getTxId())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (txId != null ? txId.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "TradeTransaction49__5 {" +
				"txId=" + this.txId +
			'}';
		}
	}

	/*********************** Builder Implementation of TradeTransaction49__5  ***********************/
	class TradeTransaction49__5BuilderImpl implements TradeTransaction49__5.TradeTransaction49__5Builder {
	
		protected UniqueTransactionIdentifier2Choice__1.UniqueTransactionIdentifier2Choice__1Builder txId;
	
		public TradeTransaction49__5BuilderImpl() {
		}
	
		@Override
		@RosettaAttribute("txId")
		public UniqueTransactionIdentifier2Choice__1.UniqueTransactionIdentifier2Choice__1Builder getTxId() {
			return txId;
		}
		
		@Override
		public UniqueTransactionIdentifier2Choice__1.UniqueTransactionIdentifier2Choice__1Builder getOrCreateTxId() {
			UniqueTransactionIdentifier2Choice__1.UniqueTransactionIdentifier2Choice__1Builder result;
			if (txId!=null) {
				result = txId;
			}
			else {
				result = txId = UniqueTransactionIdentifier2Choice__1.builder();
			}
			
			return result;
		}
	
		@Override
		@RosettaAttribute("txId")
		public TradeTransaction49__5.TradeTransaction49__5Builder setTxId(UniqueTransactionIdentifier2Choice__1 txId) {
			this.txId = txId==null?null:txId.toBuilder();
			return this;
		}
		
		@Override
		public TradeTransaction49__5 build() {
			return new TradeTransaction49__5.TradeTransaction49__5Impl(this);
		}
		
		@Override
		public TradeTransaction49__5.TradeTransaction49__5Builder toBuilder() {
			return this;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public TradeTransaction49__5.TradeTransaction49__5Builder prune() {
			if (txId!=null && !txId.prune().hasData()) txId = null;
			return this;
		}
		
		@Override
		public boolean hasData() {
			if (getTxId()!=null && getTxId().hasData()) return true;
			return false;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public TradeTransaction49__5.TradeTransaction49__5Builder merge(RosettaModelObjectBuilder other, BuilderMerger merger) {
			TradeTransaction49__5.TradeTransaction49__5Builder o = (TradeTransaction49__5.TradeTransaction49__5Builder) other;
			
			merger.mergeRosetta(getTxId(), o.getTxId(), this::setTxId);
			
			return this;
		}
	
		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			TradeTransaction49__5 _that = getType().cast(o);
		
			if (!Objects.equals(txId, _that.getTxId())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (txId != null ? txId.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "TradeTransaction49__5Builder {" +
				"txId=" + this.txId +
			'}';
		}
	}
}
