package iso20022.auth030.jfsa.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.jfsa.ClearingPartyAndTime23__1;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class ClearingPartyAndTime23__1TypeFormatValidator implements Validator<ClearingPartyAndTime23__1> {

	@Override
	public ValidationResult<ClearingPartyAndTime23__1> validate(RosettaPath path, ClearingPartyAndTime23__1 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("ClearingPartyAndTime23__1", ValidationType.TYPE_FORMAT, "ClearingPartyAndTime23__1", path, "", error);
		}
		return success("ClearingPartyAndTime23__1", ValidationType.TYPE_FORMAT, "ClearingPartyAndTime23__1", path, "");
	}

}
