package iso20022.auth030.jfsa.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.jfsa.CommonTradeDataReport69__6;
import iso20022.auth030.jfsa.ContractType14__2;
import iso20022.auth030.jfsa.TradeTransaction49__6;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkCardinality;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class CommonTradeDataReport69__6Validator implements Validator<CommonTradeDataReport69__6> {

	@Override
	public ValidationResult<CommonTradeDataReport69__6> validate(RosettaPath path, CommonTradeDataReport69__6 o) {
		/* Casting is required to ensure types are output to ensure recompilation in Rosetta */
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkCardinality("ctrctData", (ContractType14__2) o.getCtrctData() != null ? 1 : 0, 0, 1), 
				checkCardinality("txData", (TradeTransaction49__6) o.getTxData() != null ? 1 : 0, 1, 1)
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("CommonTradeDataReport69__6", ValidationType.CARDINALITY, "CommonTradeDataReport69__6", path, "", error);
		}
		return success("CommonTradeDataReport69__6", ValidationType.CARDINALITY, "CommonTradeDataReport69__6", path, "");
	}

}
