package iso20022.auth030.jfsa.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.jfsa.CommonTradeDataReport69__7;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class CommonTradeDataReport69__7TypeFormatValidator implements Validator<CommonTradeDataReport69__7> {

	@Override
	public ValidationResult<CommonTradeDataReport69__7> validate(RosettaPath path, CommonTradeDataReport69__7 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("CommonTradeDataReport69__7", ValidationType.TYPE_FORMAT, "CommonTradeDataReport69__7", path, "", error);
		}
		return success("CommonTradeDataReport69__7", ValidationType.TYPE_FORMAT, "CommonTradeDataReport69__7", path, "");
	}

}
