package iso20022.auth030.jfsa.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.jfsa.EventIdentifier1Choice__1;
import java.util.regex.Pattern;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkString;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.Optional.empty;
import static java.util.Optional.of;
import static java.util.stream.Collectors.joining;

public class EventIdentifier1Choice__1TypeFormatValidator implements Validator<EventIdentifier1Choice__1> {

	@Override
	public ValidationResult<EventIdentifier1Choice__1> validate(RosettaPath path, EventIdentifier1Choice__1 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkString("evtIdr", o.getEvtIdr(), 0, empty(), of(Pattern.compile("[A-Z0-9]{18}[0-9]{2}[A-Z0-9]{0,32}")))
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("EventIdentifier1Choice__1", ValidationType.TYPE_FORMAT, "EventIdentifier1Choice__1", path, "", error);
		}
		return success("EventIdentifier1Choice__1", ValidationType.TYPE_FORMAT, "EventIdentifier1Choice__1", path, "");
	}

}
