package iso20022.auth030.jfsa.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.jfsa.InterestRateContractTerm4;
import iso20022.auth030.jfsa.InterestRateFrequency3Choice__2;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkCardinality;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class InterestRateFrequency3Choice__2Validator implements Validator<InterestRateFrequency3Choice__2> {

	@Override
	public ValidationResult<InterestRateFrequency3Choice__2> validate(RosettaPath path, InterestRateFrequency3Choice__2 o) {
		/* Casting is required to ensure types are output to ensure recompilation in Rosetta */
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkCardinality("term", (InterestRateContractTerm4) o.getTerm() != null ? 1 : 0, 0, 1)
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("InterestRateFrequency3Choice__2", ValidationType.CARDINALITY, "InterestRateFrequency3Choice__2", path, "", error);
		}
		return success("InterestRateFrequency3Choice__2", ValidationType.CARDINALITY, "InterestRateFrequency3Choice__2", path, "");
	}

}
