package iso20022.auth030.jfsa.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.jfsa.QuantityOrTerm1Choice__1;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class QuantityOrTerm1Choice__1TypeFormatValidator implements Validator<QuantityOrTerm1Choice__1> {

	@Override
	public ValidationResult<QuantityOrTerm1Choice__1> validate(RosettaPath path, QuantityOrTerm1Choice__1 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("QuantityOrTerm1Choice__1", ValidationType.TYPE_FORMAT, "QuantityOrTerm1Choice__1", path, "", error);
		}
		return success("QuantityOrTerm1Choice__1", ValidationType.TYPE_FORMAT, "QuantityOrTerm1Choice__1", path, "");
	}

}
