package iso20022.auth030.jfsa.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.jfsa.SecuritiesTransactionPrice14Choice__1;
import java.math.BigDecimal;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkCardinality;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class SecuritiesTransactionPrice14Choice__1Validator implements Validator<SecuritiesTransactionPrice14Choice__1> {

	@Override
	public ValidationResult<SecuritiesTransactionPrice14Choice__1> validate(RosettaPath path, SecuritiesTransactionPrice14Choice__1 o) {
		/* Casting is required to ensure types are output to ensure recompilation in Rosetta */
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkCardinality("dcml", (BigDecimal) o.getDcml() != null ? 1 : 0, 0, 1)
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("SecuritiesTransactionPrice14Choice__1", ValidationType.CARDINALITY, "SecuritiesTransactionPrice14Choice__1", path, "", error);
		}
		return success("SecuritiesTransactionPrice14Choice__1", ValidationType.CARDINALITY, "SecuritiesTransactionPrice14Choice__1", path, "");
	}

}
