package iso20022.auth030.jfsa.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.jfsa.SecurityIdentification41Choice__1;
import java.util.regex.Pattern;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkString;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.Optional.empty;
import static java.util.Optional.of;
import static java.util.stream.Collectors.joining;

public class SecurityIdentification41Choice__1TypeFormatValidator implements Validator<SecurityIdentification41Choice__1> {

	@Override
	public ValidationResult<SecurityIdentification41Choice__1> validate(RosettaPath path, SecurityIdentification41Choice__1 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkString("isin", o.getIsin(), 0, empty(), of(Pattern.compile("[A-Z]{2,2}[A-Z0-9]{9,9}[0-9]{1,1}")))
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("SecurityIdentification41Choice__1", ValidationType.TYPE_FORMAT, "SecurityIdentification41Choice__1", path, "", error);
		}
		return success("SecurityIdentification41Choice__1", ValidationType.TYPE_FORMAT, "SecurityIdentification41Choice__1", path, "");
	}

}
