package iso20022.auth030.jfsa.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.jfsa.TechnicalAttributes5__1;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkCardinality;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class TechnicalAttributes5__1Validator implements Validator<TechnicalAttributes5__1> {

	@Override
	public ValidationResult<TechnicalAttributes5__1> validate(RosettaPath path, TechnicalAttributes5__1 o) {
		/* Casting is required to ensure types are output to ensure recompilation in Rosetta */
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkCardinality("techRcrdId", (String) o.getTechRcrdId() != null ? 1 : 0, 1, 1)
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("TechnicalAttributes5__1", ValidationType.CARDINALITY, "TechnicalAttributes5__1", path, "", error);
		}
		return success("TechnicalAttributes5__1", ValidationType.CARDINALITY, "TechnicalAttributes5__1", path, "");
	}

}
