package iso20022.auth030.jfsa.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.jfsa.TradeNonConfirmation1;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class TradeNonConfirmation1TypeFormatValidator implements Validator<TradeNonConfirmation1> {

	@Override
	public ValidationResult<TradeNonConfirmation1> validate(RosettaPath path, TradeNonConfirmation1 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("TradeNonConfirmation1", ValidationType.TYPE_FORMAT, "TradeNonConfirmation1", path, "", error);
		}
		return success("TradeNonConfirmation1", ValidationType.TYPE_FORMAT, "TradeNonConfirmation1", path, "");
	}

}
