package iso20022.auth030.jfsa.validation.datarule;

import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.annotations.RosettaDataRule;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.mapper.MapperS;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ChoiceRuleValidationMethod;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.jfsa.ClearingPartyAndTime21Choice__2;
import java.util.Arrays;

import static com.rosetta.model.lib.expression.ExpressionOperators.*;

/**
 * @version ${project.version}
 */
@RosettaDataRule("ClearingPartyAndTime21Choice__2Choice")
@ImplementedBy(ClearingPartyAndTime21Choice2Choice.Default.class)
public interface ClearingPartyAndTime21Choice2Choice extends Validator<ClearingPartyAndTime21Choice__2> {
	
	String NAME = "ClearingPartyAndTime21Choice__2Choice";
	String DEFINITION = "one-of";
	
	ValidationResult<ClearingPartyAndTime21Choice__2> validate(RosettaPath path, ClearingPartyAndTime21Choice__2 clearingPartyAndTime21Choice__2);
	
	class Default implements ClearingPartyAndTime21Choice2Choice {
	
		@Override
		public ValidationResult<ClearingPartyAndTime21Choice__2> validate(RosettaPath path, ClearingPartyAndTime21Choice__2 clearingPartyAndTime21Choice__2) {
			ComparisonResult result = executeDataRule(clearingPartyAndTime21Choice__2);
			if (result.get()) {
				return ValidationResult.success(NAME, ValidationResult.ValidationType.DATA_RULE, "ClearingPartyAndTime21Choice__2", path, DEFINITION);
			}
			
			String failureMessage = result.getError();
			if (failureMessage == null || failureMessage.contains("Null") || failureMessage == "") {
				failureMessage = "Condition has failed.";
			}
			return ValidationResult.failure(NAME, ValidationType.DATA_RULE, "ClearingPartyAndTime21Choice__2", path, DEFINITION, failureMessage);
		}
		
		private ComparisonResult executeDataRule(ClearingPartyAndTime21Choice__2 clearingPartyAndTime21Choice__2) {
			try {
				return choice(MapperS.of(clearingPartyAndTime21Choice__2), Arrays.asList("dtls"), ChoiceRuleValidationMethod.REQUIRED);
			}
			catch (Exception ex) {
				return ComparisonResult.failure(ex.getMessage());
			}
		}
	}
	
	@SuppressWarnings("unused")
	class NoOp implements ClearingPartyAndTime21Choice2Choice {
	
		@Override
		public ValidationResult<ClearingPartyAndTime21Choice__2> validate(RosettaPath path, ClearingPartyAndTime21Choice__2 clearingPartyAndTime21Choice__2) {
			return ValidationResult.success(NAME, ValidationResult.ValidationType.DATA_RULE, "ClearingPartyAndTime21Choice__2", path, DEFINITION);
		}
	}
}
