package iso20022.auth030.jfsa.validation.datarule;

import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.annotations.RosettaDataRule;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.mapper.MapperS;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ChoiceRuleValidationMethod;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.jfsa.UnitOfMeasure8Choice__1;
import java.util.Arrays;

import static com.rosetta.model.lib.expression.ExpressionOperators.*;

/**
 * @version ${project.version}
 */
@RosettaDataRule("UnitOfMeasure8Choice__1Choice")
@ImplementedBy(UnitOfMeasure8Choice1Choice.Default.class)
public interface UnitOfMeasure8Choice1Choice extends Validator<UnitOfMeasure8Choice__1> {
	
	String NAME = "UnitOfMeasure8Choice__1Choice";
	String DEFINITION = "one-of";
	
	ValidationResult<UnitOfMeasure8Choice__1> validate(RosettaPath path, UnitOfMeasure8Choice__1 unitOfMeasure8Choice__1);
	
	class Default implements UnitOfMeasure8Choice1Choice {
	
		@Override
		public ValidationResult<UnitOfMeasure8Choice__1> validate(RosettaPath path, UnitOfMeasure8Choice__1 unitOfMeasure8Choice__1) {
			ComparisonResult result = executeDataRule(unitOfMeasure8Choice__1);
			if (result.get()) {
				return ValidationResult.success(NAME, ValidationResult.ValidationType.DATA_RULE, "UnitOfMeasure8Choice__1", path, DEFINITION);
			}
			
			String failureMessage = result.getError();
			if (failureMessage == null || failureMessage.contains("Null") || failureMessage == "") {
				failureMessage = "Condition has failed.";
			}
			return ValidationResult.failure(NAME, ValidationType.DATA_RULE, "UnitOfMeasure8Choice__1", path, DEFINITION, failureMessage);
		}
		
		private ComparisonResult executeDataRule(UnitOfMeasure8Choice__1 unitOfMeasure8Choice__1) {
			try {
				return choice(MapperS.of(unitOfMeasure8Choice__1), Arrays.asList("cd"), ChoiceRuleValidationMethod.REQUIRED);
			}
			catch (Exception ex) {
				return ComparisonResult.failure(ex.getMessage());
			}
		}
	}
	
	@SuppressWarnings("unused")
	class NoOp implements UnitOfMeasure8Choice1Choice {
	
		@Override
		public ValidationResult<UnitOfMeasure8Choice__1> validate(RosettaPath path, UnitOfMeasure8Choice__1 unitOfMeasure8Choice__1) {
			return ValidationResult.success(NAME, ValidationResult.ValidationType.DATA_RULE, "UnitOfMeasure8Choice__1", path, DEFINITION);
		}
	}
}
