package iso20022.auth108.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth108.esma.CollateralPortfolioCode5Choice__1;
import iso20022.auth108.esma.PortfolioCode3Choice;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkCardinality;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class CollateralPortfolioCode5Choice__1Validator implements Validator<CollateralPortfolioCode5Choice__1> {

	@Override
	public ValidationResult<CollateralPortfolioCode5Choice__1> validate(RosettaPath path, CollateralPortfolioCode5Choice__1 o) {
		/* Casting is required to ensure types are output to ensure recompilation in Rosetta */
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkCardinality("prtfl", (PortfolioCode3Choice) o.getPrtfl() != null ? 1 : 0, 0, 1)
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("CollateralPortfolioCode5Choice__1", ValidationType.CARDINALITY, "CollateralPortfolioCode5Choice__1", path, "", error);
		}
		return success("CollateralPortfolioCode5Choice__1", ValidationType.CARDINALITY, "CollateralPortfolioCode5Choice__1", path, "");
	}

}
