package iso20022.auth108.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth108.esma.DerivativesTradeMarginDataReportV01;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class DerivativesTradeMarginDataReportV01TypeFormatValidator implements Validator<DerivativesTradeMarginDataReportV01> {

	@Override
	public ValidationResult<DerivativesTradeMarginDataReportV01> validate(RosettaPath path, DerivativesTradeMarginDataReportV01 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("DerivativesTradeMarginDataReportV01", ValidationType.TYPE_FORMAT, "DerivativesTradeMarginDataReportV01", path, "", error);
		}
		return success("DerivativesTradeMarginDataReportV01", ValidationType.TYPE_FORMAT, "DerivativesTradeMarginDataReportV01", path, "");
	}

}
