package iso20022.auth108.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth108.esma.TradeData55Choice__1;
import iso20022.auth108.esma.TradeReport31Choice__1;
import java.util.List;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkCardinality;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;

public class TradeData55Choice__1Validator implements Validator<TradeData55Choice__1> {

	@Override
	public ValidationResult<TradeData55Choice__1> validate(RosettaPath path, TradeData55Choice__1 o) {
		/* Casting is required to ensure types are output to ensure recompilation in Rosetta */
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkCardinality("rpt", (List<? extends TradeReport31Choice__1>) o.getRpt() == null ? 0 : ((List<? extends TradeReport31Choice__1>) o.getRpt()).size(), 0, 100000)
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("TradeData55Choice__1", ValidationType.CARDINALITY, "TradeData55Choice__1", path, "", error);
		}
		return success("TradeData55Choice__1", ValidationType.CARDINALITY, "TradeData55Choice__1", path, "");
	}

}
