package iso20022.auth108.jfsa;

import com.rosetta.model.lib.RosettaModelObject;
import com.rosetta.model.lib.RosettaModelObjectBuilder;
import com.rosetta.model.lib.annotations.RosettaAttribute;
import com.rosetta.model.lib.annotations.RosettaDataType;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.process.BuilderMerger;
import com.rosetta.model.lib.process.BuilderProcessor;
import com.rosetta.model.lib.process.Processor;
import iso20022.auth108.jfsa.MarginReportData7__1;
import iso20022.auth108.jfsa.TradeReport31Choice__1;
import iso20022.auth108.jfsa.TradeReport31Choice__1.TradeReport31Choice__1Builder;
import iso20022.auth108.jfsa.TradeReport31Choice__1.TradeReport31Choice__1BuilderImpl;
import iso20022.auth108.jfsa.TradeReport31Choice__1.TradeReport31Choice__1Impl;
import iso20022.auth108.jfsa.meta.TradeReport31Choice__1Meta;
import java.util.Objects;

import static java.util.Optional.ofNullable;

/**
 * @version ${project.version}
 */
@RosettaDataType(value="TradeReport31Choice__1", builder=TradeReport31Choice__1.TradeReport31Choice__1BuilderImpl.class, version="${project.version}")
public interface TradeReport31Choice__1 extends RosettaModelObject {

	TradeReport31Choice__1Meta metaData = new TradeReport31Choice__1Meta();

	/*********************** Getter Methods  ***********************/
	MarginReportData7__1 getMrgnUpd();

	/*********************** Build Methods  ***********************/
	TradeReport31Choice__1 build();
	
	TradeReport31Choice__1.TradeReport31Choice__1Builder toBuilder();
	
	static TradeReport31Choice__1.TradeReport31Choice__1Builder builder() {
		return new TradeReport31Choice__1.TradeReport31Choice__1BuilderImpl();
	}

	/*********************** Utility Methods  ***********************/
	@Override
	default RosettaMetaData<? extends TradeReport31Choice__1> metaData() {
		return metaData;
	}
	
	@Override
	default Class<? extends TradeReport31Choice__1> getType() {
		return TradeReport31Choice__1.class;
	}
	
	
	@Override
	default void process(RosettaPath path, Processor processor) {
		processRosetta(path.newSubPath("mrgnUpd"), processor, MarginReportData7__1.class, getMrgnUpd());
	}
	

	/*********************** Builder Interface  ***********************/
	interface TradeReport31Choice__1Builder extends TradeReport31Choice__1, RosettaModelObjectBuilder {
		MarginReportData7__1.MarginReportData7__1Builder getOrCreateMrgnUpd();
		MarginReportData7__1.MarginReportData7__1Builder getMrgnUpd();
		TradeReport31Choice__1.TradeReport31Choice__1Builder setMrgnUpd(MarginReportData7__1 mrgnUpd);

		@Override
		default void process(RosettaPath path, BuilderProcessor processor) {
			processRosetta(path.newSubPath("mrgnUpd"), processor, MarginReportData7__1.MarginReportData7__1Builder.class, getMrgnUpd());
		}
		

		TradeReport31Choice__1.TradeReport31Choice__1Builder prune();
	}

	/*********************** Immutable Implementation of TradeReport31Choice__1  ***********************/
	class TradeReport31Choice__1Impl implements TradeReport31Choice__1 {
		private final MarginReportData7__1 mrgnUpd;
		
		protected TradeReport31Choice__1Impl(TradeReport31Choice__1.TradeReport31Choice__1Builder builder) {
			this.mrgnUpd = ofNullable(builder.getMrgnUpd()).map(f->f.build()).orElse(null);
		}
		
		@Override
		@RosettaAttribute("mrgnUpd")
		public MarginReportData7__1 getMrgnUpd() {
			return mrgnUpd;
		}
		
		@Override
		public TradeReport31Choice__1 build() {
			return this;
		}
		
		@Override
		public TradeReport31Choice__1.TradeReport31Choice__1Builder toBuilder() {
			TradeReport31Choice__1.TradeReport31Choice__1Builder builder = builder();
			setBuilderFields(builder);
			return builder;
		}
		
		protected void setBuilderFields(TradeReport31Choice__1.TradeReport31Choice__1Builder builder) {
			ofNullable(getMrgnUpd()).ifPresent(builder::setMrgnUpd);
		}

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			TradeReport31Choice__1 _that = getType().cast(o);
		
			if (!Objects.equals(mrgnUpd, _that.getMrgnUpd())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (mrgnUpd != null ? mrgnUpd.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "TradeReport31Choice__1 {" +
				"mrgnUpd=" + this.mrgnUpd +
			'}';
		}
	}

	/*********************** Builder Implementation of TradeReport31Choice__1  ***********************/
	class TradeReport31Choice__1BuilderImpl implements TradeReport31Choice__1.TradeReport31Choice__1Builder {
	
		protected MarginReportData7__1.MarginReportData7__1Builder mrgnUpd;
	
		public TradeReport31Choice__1BuilderImpl() {
		}
	
		@Override
		@RosettaAttribute("mrgnUpd")
		public MarginReportData7__1.MarginReportData7__1Builder getMrgnUpd() {
			return mrgnUpd;
		}
		
		@Override
		public MarginReportData7__1.MarginReportData7__1Builder getOrCreateMrgnUpd() {
			MarginReportData7__1.MarginReportData7__1Builder result;
			if (mrgnUpd!=null) {
				result = mrgnUpd;
			}
			else {
				result = mrgnUpd = MarginReportData7__1.builder();
			}
			
			return result;
		}
	
		@Override
		@RosettaAttribute("mrgnUpd")
		public TradeReport31Choice__1.TradeReport31Choice__1Builder setMrgnUpd(MarginReportData7__1 mrgnUpd) {
			this.mrgnUpd = mrgnUpd==null?null:mrgnUpd.toBuilder();
			return this;
		}
		
		@Override
		public TradeReport31Choice__1 build() {
			return new TradeReport31Choice__1.TradeReport31Choice__1Impl(this);
		}
		
		@Override
		public TradeReport31Choice__1.TradeReport31Choice__1Builder toBuilder() {
			return this;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public TradeReport31Choice__1.TradeReport31Choice__1Builder prune() {
			if (mrgnUpd!=null && !mrgnUpd.prune().hasData()) mrgnUpd = null;
			return this;
		}
		
		@Override
		public boolean hasData() {
			if (getMrgnUpd()!=null && getMrgnUpd().hasData()) return true;
			return false;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public TradeReport31Choice__1.TradeReport31Choice__1Builder merge(RosettaModelObjectBuilder other, BuilderMerger merger) {
			TradeReport31Choice__1.TradeReport31Choice__1Builder o = (TradeReport31Choice__1.TradeReport31Choice__1Builder) other;
			
			merger.mergeRosetta(getMrgnUpd(), o.getMrgnUpd(), this::setMrgnUpd);
			
			return this;
		}
	
		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			TradeReport31Choice__1 _that = getType().cast(o);
		
			if (!Objects.equals(mrgnUpd, _that.getMrgnUpd())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (mrgnUpd != null ? mrgnUpd.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "TradeReport31Choice__1Builder {" +
				"mrgnUpd=" + this.mrgnUpd +
			'}';
		}
	}
}
