package iso20022.auth108.jfsa.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth108.jfsa.TechnicalAttributes6__1;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkString;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.Optional.empty;
import static java.util.Optional.of;
import static java.util.stream.Collectors.joining;

public class TechnicalAttributes6__1TypeFormatValidator implements Validator<TechnicalAttributes6__1> {

	@Override
	public ValidationResult<TechnicalAttributes6__1> validate(RosettaPath path, TechnicalAttributes6__1 o) {
		String error = 
			Lists.<ComparisonResult>newArrayList(
				checkString("techRcrdId", o.getTechRcrdId(), 1, of(140), empty())
			).stream().filter(res -> !res.get()).map(res -> res.getError()).collect(joining("; "));
		
		if (!isNullOrEmpty(error)) {
			return failure("TechnicalAttributes6__1", ValidationType.TYPE_FORMAT, "TechnicalAttributes6__1", path, "", error);
		}
		return success("TechnicalAttributes6__1", ValidationType.TYPE_FORMAT, "TechnicalAttributes6__1", path, "");
	}

}
