package iso20022.auth030.esma;

import com.rosetta.model.lib.annotations.RosettaEnum;
import com.rosetta.model.lib.annotations.RosettaEnumValue;
import java.util.Collections;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;


/**
 * Commodity derivative base product code list for Other.
 * @version 0.5.1
 */
@RosettaEnum("AssetClassProductType15Code")
public enum AssetClassProductType15Code {

	/**
	 * Commodity of other type.
	 */
	@RosettaEnumValue(value = "OTHR") OTHR("OTHR")
;
	private static Map<String, AssetClassProductType15Code> values;
	static {
        Map<String, AssetClassProductType15Code> map = new ConcurrentHashMap<>();
		for (AssetClassProductType15Code instance : AssetClassProductType15Code.values()) {
			map.put(instance.toDisplayString(), instance);
		}
		values = Collections.unmodifiableMap(map);
    }

	private final String rosettaName;
	private final String displayName;

	AssetClassProductType15Code(String rosettaName) {
		this(rosettaName, null);
	}

	AssetClassProductType15Code(String rosettaName, String displayName) {
		this.rosettaName = rosettaName;
		this.displayName = displayName;
	}

	public static AssetClassProductType15Code fromDisplayName(String name) {
		AssetClassProductType15Code value = values.get(name);
		if (value == null) {
			throw new IllegalArgumentException("No enum constant with display name \"" + name + "\".");
		}
		return value;
	}

	@Override
	public String toString() {
		return toDisplayString();
	}

	public String toDisplayString() {
		return displayName != null ?  displayName : rosettaName;
	}
}
