package iso20022.auth030.esma.meta;

import com.rosetta.model.lib.annotations.RosettaMeta;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.qualify.QualifyFunctionFactory;
import com.rosetta.model.lib.qualify.QualifyResult;
import com.rosetta.model.lib.validation.Validator;
import com.rosetta.model.lib.validation.ValidatorFactory;
import com.rosetta.model.lib.validation.ValidatorWithArg;
import iso20022.auth030.esma.AgriculturalCommodityOliveOil3;
import iso20022.auth030.esma.validation.AgriculturalCommodityOliveOil3TypeFormatValidator;
import iso20022.auth030.esma.validation.AgriculturalCommodityOliveOil3Validator;
import iso20022.auth030.esma.validation.exists.AgriculturalCommodityOliveOil3OnlyExistsValidator;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.function.Function;


/**
 * @version 0.5.1
 */
@RosettaMeta(model=AgriculturalCommodityOliveOil3.class)
public class AgriculturalCommodityOliveOil3Meta implements RosettaMetaData<AgriculturalCommodityOliveOil3> {

	@Override
	public List<Validator<? super AgriculturalCommodityOliveOil3>> dataRules(ValidatorFactory factory) {
		return Arrays.asList(
		);
	}
	
	@Override
	public List<Function<? super AgriculturalCommodityOliveOil3, QualifyResult>> getQualifyFunctions(QualifyFunctionFactory factory) {
		return Collections.emptyList();
	}

	@Override
	public Validator<? super AgriculturalCommodityOliveOil3> validator() {
		return new AgriculturalCommodityOliveOil3Validator();
	}

	@Override
	public Validator<? super AgriculturalCommodityOliveOil3> typeFormatValidator() {
		return new AgriculturalCommodityOliveOil3TypeFormatValidator();
	}
	
	@Override
	public ValidatorWithArg<? super AgriculturalCommodityOliveOil3, Set<String>> onlyExistsValidator() {
		return new AgriculturalCommodityOliveOil3OnlyExistsValidator();
	}
}
