package iso20022.auth030.esma.validation.datarule;

import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.annotations.RosettaDataRule;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.mapper.MapperS;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ChoiceRuleValidationMethod;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.esma.SecuritiesTransactionPrice17Choice__2;
import java.util.Arrays;

import static com.rosetta.model.lib.expression.ExpressionOperators.*;

/**
 * @version 0.5.1
 */
@RosettaDataRule("SecuritiesTransactionPrice17Choice__2Choice")
@ImplementedBy(SecuritiesTransactionPrice17Choice2Choice.Default.class)
public interface SecuritiesTransactionPrice17Choice2Choice extends Validator<SecuritiesTransactionPrice17Choice__2> {
	
	String NAME = "SecuritiesTransactionPrice17Choice__2Choice";
	String DEFINITION = "one-of";
	
	ValidationResult<SecuritiesTransactionPrice17Choice__2> validate(RosettaPath path, SecuritiesTransactionPrice17Choice__2 securitiesTransactionPrice17Choice__2);
	
	class Default implements SecuritiesTransactionPrice17Choice2Choice {
	
		@Override
		public ValidationResult<SecuritiesTransactionPrice17Choice__2> validate(RosettaPath path, SecuritiesTransactionPrice17Choice__2 securitiesTransactionPrice17Choice__2) {
			ComparisonResult result = executeDataRule(securitiesTransactionPrice17Choice__2);
			if (result.get()) {
				return ValidationResult.success(NAME, ValidationResult.ValidationType.DATA_RULE, "SecuritiesTransactionPrice17Choice__2", path, DEFINITION);
			}
			
			String failureMessage = result.getError();
			if (failureMessage == null || failureMessage.contains("Null") || failureMessage == "") {
				failureMessage = "Condition has failed.";
			}
			return ValidationResult.failure(NAME, ValidationType.DATA_RULE, "SecuritiesTransactionPrice17Choice__2", path, DEFINITION, failureMessage);
		}
		
		private ComparisonResult executeDataRule(SecuritiesTransactionPrice17Choice__2 securitiesTransactionPrice17Choice__2) {
			try {
				return choice(MapperS.of(securitiesTransactionPrice17Choice__2), Arrays.asList("mntryVal", "pctg"), ChoiceRuleValidationMethod.REQUIRED);
			}
			catch (Exception ex) {
				return ComparisonResult.failure(ex.getMessage());
			}
		}
	}
	
	@SuppressWarnings("unused")
	class NoOp implements SecuritiesTransactionPrice17Choice2Choice {
	
		@Override
		public ValidationResult<SecuritiesTransactionPrice17Choice__2> validate(RosettaPath path, SecuritiesTransactionPrice17Choice__2 securitiesTransactionPrice17Choice__2) {
			return ValidationResult.success(NAME, ValidationResult.ValidationType.DATA_RULE, "SecuritiesTransactionPrice17Choice__2", path, DEFINITION);
		}
	}
}
