package iso20022.auth030.jfsa;

import com.rosetta.model.lib.RosettaModelObject;
import com.rosetta.model.lib.RosettaModelObjectBuilder;
import com.rosetta.model.lib.annotations.RosettaAttribute;
import com.rosetta.model.lib.annotations.RosettaDataType;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.process.BuilderMerger;
import com.rosetta.model.lib.process.BuilderProcessor;
import com.rosetta.model.lib.process.Processor;
import iso20022.auth030.jfsa.CommonTradeDataReport69__4;
import iso20022.auth030.jfsa.CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder;
import iso20022.auth030.jfsa.CommonTradeDataReport69__4.CommonTradeDataReport69__4BuilderImpl;
import iso20022.auth030.jfsa.CommonTradeDataReport69__4.CommonTradeDataReport69__4Impl;
import iso20022.auth030.jfsa.ContractType14__2;
import iso20022.auth030.jfsa.TradeTransaction49__4;
import iso20022.auth030.jfsa.meta.CommonTradeDataReport69__4Meta;
import java.util.Objects;

import static java.util.Optional.ofNullable;

/**
 * @version 0.5.1
 */
@RosettaDataType(value="CommonTradeDataReport69__4", builder=CommonTradeDataReport69__4.CommonTradeDataReport69__4BuilderImpl.class, version="0.5.1")
public interface CommonTradeDataReport69__4 extends RosettaModelObject {

	CommonTradeDataReport69__4Meta metaData = new CommonTradeDataReport69__4Meta();

	/*********************** Getter Methods  ***********************/
	ContractType14__2 getCtrctData();
	TradeTransaction49__4 getTxData();

	/*********************** Build Methods  ***********************/
	CommonTradeDataReport69__4 build();
	
	CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder toBuilder();
	
	static CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder builder() {
		return new CommonTradeDataReport69__4.CommonTradeDataReport69__4BuilderImpl();
	}

	/*********************** Utility Methods  ***********************/
	@Override
	default RosettaMetaData<? extends CommonTradeDataReport69__4> metaData() {
		return metaData;
	}
	
	@Override
	default Class<? extends CommonTradeDataReport69__4> getType() {
		return CommonTradeDataReport69__4.class;
	}
	
	
	@Override
	default void process(RosettaPath path, Processor processor) {
		processRosetta(path.newSubPath("ctrctData"), processor, ContractType14__2.class, getCtrctData());
		processRosetta(path.newSubPath("txData"), processor, TradeTransaction49__4.class, getTxData());
	}
	

	/*********************** Builder Interface  ***********************/
	interface CommonTradeDataReport69__4Builder extends CommonTradeDataReport69__4, RosettaModelObjectBuilder {
		ContractType14__2.ContractType14__2Builder getOrCreateCtrctData();
		ContractType14__2.ContractType14__2Builder getCtrctData();
		TradeTransaction49__4.TradeTransaction49__4Builder getOrCreateTxData();
		TradeTransaction49__4.TradeTransaction49__4Builder getTxData();
		CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder setCtrctData(ContractType14__2 ctrctData);
		CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder setTxData(TradeTransaction49__4 txData);

		@Override
		default void process(RosettaPath path, BuilderProcessor processor) {
			processRosetta(path.newSubPath("ctrctData"), processor, ContractType14__2.ContractType14__2Builder.class, getCtrctData());
			processRosetta(path.newSubPath("txData"), processor, TradeTransaction49__4.TradeTransaction49__4Builder.class, getTxData());
		}
		

		CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder prune();
	}

	/*********************** Immutable Implementation of CommonTradeDataReport69__4  ***********************/
	class CommonTradeDataReport69__4Impl implements CommonTradeDataReport69__4 {
		private final ContractType14__2 ctrctData;
		private final TradeTransaction49__4 txData;
		
		protected CommonTradeDataReport69__4Impl(CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder builder) {
			this.ctrctData = ofNullable(builder.getCtrctData()).map(f->f.build()).orElse(null);
			this.txData = ofNullable(builder.getTxData()).map(f->f.build()).orElse(null);
		}
		
		@Override
		@RosettaAttribute("ctrctData")
		public ContractType14__2 getCtrctData() {
			return ctrctData;
		}
		
		@Override
		@RosettaAttribute("txData")
		public TradeTransaction49__4 getTxData() {
			return txData;
		}
		
		@Override
		public CommonTradeDataReport69__4 build() {
			return this;
		}
		
		@Override
		public CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder toBuilder() {
			CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder builder = builder();
			setBuilderFields(builder);
			return builder;
		}
		
		protected void setBuilderFields(CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder builder) {
			ofNullable(getCtrctData()).ifPresent(builder::setCtrctData);
			ofNullable(getTxData()).ifPresent(builder::setTxData);
		}

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			CommonTradeDataReport69__4 _that = getType().cast(o);
		
			if (!Objects.equals(ctrctData, _that.getCtrctData())) return false;
			if (!Objects.equals(txData, _that.getTxData())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (ctrctData != null ? ctrctData.hashCode() : 0);
			_result = 31 * _result + (txData != null ? txData.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "CommonTradeDataReport69__4 {" +
				"ctrctData=" + this.ctrctData + ", " +
				"txData=" + this.txData +
			'}';
		}
	}

	/*********************** Builder Implementation of CommonTradeDataReport69__4  ***********************/
	class CommonTradeDataReport69__4BuilderImpl implements CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder {
	
		protected ContractType14__2.ContractType14__2Builder ctrctData;
		protected TradeTransaction49__4.TradeTransaction49__4Builder txData;
	
		public CommonTradeDataReport69__4BuilderImpl() {
		}
	
		@Override
		@RosettaAttribute("ctrctData")
		public ContractType14__2.ContractType14__2Builder getCtrctData() {
			return ctrctData;
		}
		
		@Override
		public ContractType14__2.ContractType14__2Builder getOrCreateCtrctData() {
			ContractType14__2.ContractType14__2Builder result;
			if (ctrctData!=null) {
				result = ctrctData;
			}
			else {
				result = ctrctData = ContractType14__2.builder();
			}
			
			return result;
		}
		@Override
		@RosettaAttribute("txData")
		public TradeTransaction49__4.TradeTransaction49__4Builder getTxData() {
			return txData;
		}
		
		@Override
		public TradeTransaction49__4.TradeTransaction49__4Builder getOrCreateTxData() {
			TradeTransaction49__4.TradeTransaction49__4Builder result;
			if (txData!=null) {
				result = txData;
			}
			else {
				result = txData = TradeTransaction49__4.builder();
			}
			
			return result;
		}
	
		@Override
		@RosettaAttribute("ctrctData")
		public CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder setCtrctData(ContractType14__2 ctrctData) {
			this.ctrctData = ctrctData==null?null:ctrctData.toBuilder();
			return this;
		}
		@Override
		@RosettaAttribute("txData")
		public CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder setTxData(TradeTransaction49__4 txData) {
			this.txData = txData==null?null:txData.toBuilder();
			return this;
		}
		
		@Override
		public CommonTradeDataReport69__4 build() {
			return new CommonTradeDataReport69__4.CommonTradeDataReport69__4Impl(this);
		}
		
		@Override
		public CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder toBuilder() {
			return this;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder prune() {
			if (ctrctData!=null && !ctrctData.prune().hasData()) ctrctData = null;
			if (txData!=null && !txData.prune().hasData()) txData = null;
			return this;
		}
		
		@Override
		public boolean hasData() {
			if (getCtrctData()!=null && getCtrctData().hasData()) return true;
			if (getTxData()!=null && getTxData().hasData()) return true;
			return false;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder merge(RosettaModelObjectBuilder other, BuilderMerger merger) {
			CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder o = (CommonTradeDataReport69__4.CommonTradeDataReport69__4Builder) other;
			
			merger.mergeRosetta(getCtrctData(), o.getCtrctData(), this::setCtrctData);
			merger.mergeRosetta(getTxData(), o.getTxData(), this::setTxData);
			
			return this;
		}
	
		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			CommonTradeDataReport69__4 _that = getType().cast(o);
		
			if (!Objects.equals(ctrctData, _that.getCtrctData())) return false;
			if (!Objects.equals(txData, _that.getTxData())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (ctrctData != null ? ctrctData.hashCode() : 0);
			_result = 31 * _result + (txData != null ? txData.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "CommonTradeDataReport69__4Builder {" +
				"ctrctData=" + this.ctrctData + ", " +
				"txData=" + this.txData +
			'}';
		}
	}
}
