package iso20022.auth030.jfsa;

import com.rosetta.model.lib.RosettaModelObject;
import com.rosetta.model.lib.RosettaModelObjectBuilder;
import com.rosetta.model.lib.annotations.RosettaAttribute;
import com.rosetta.model.lib.annotations.RosettaDataType;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.process.BuilderMerger;
import com.rosetta.model.lib.process.BuilderProcessor;
import com.rosetta.model.lib.process.Processor;
import iso20022.auth030.jfsa.ContractType14__1;
import iso20022.auth030.jfsa.ContractType14__1.ContractType14__1Builder;
import iso20022.auth030.jfsa.ContractType14__1.ContractType14__1BuilderImpl;
import iso20022.auth030.jfsa.ContractType14__1.ContractType14__1Impl;
import iso20022.auth030.jfsa.CurrencyExchange23__1;
import iso20022.auth030.jfsa.FinancialInstrumentContractType2Code;
import iso20022.auth030.jfsa.ProductType4Code__1;
import iso20022.auth030.jfsa.SecurityIdentification41Choice__1;
import iso20022.auth030.jfsa.SecurityIdentification46__1;
import iso20022.auth030.jfsa.meta.ContractType14__1Meta;
import java.util.Objects;

import static java.util.Optional.ofNullable;

/**
 * @version 0.5.1
 */
@RosettaDataType(value="ContractType14__1", builder=ContractType14__1.ContractType14__1BuilderImpl.class, version="0.5.1")
public interface ContractType14__1 extends RosettaModelObject {

	ContractType14__1Meta metaData = new ContractType14__1Meta();

	/*********************** Getter Methods  ***********************/
	FinancialInstrumentContractType2Code getCtrctTp();
	ProductType4Code__1 getAsstClss();
	SecurityIdentification46__1 getPdctId();
	SecurityIdentification41Choice__1 getUndrlygInstrm();
	CurrencyExchange23__1 getSttlmCcy();
	CurrencyExchange23__1 getSttlmCcyScndLeg();
	Boolean getDerivBasedOnCrptAsst();

	/*********************** Build Methods  ***********************/
	ContractType14__1 build();
	
	ContractType14__1.ContractType14__1Builder toBuilder();
	
	static ContractType14__1.ContractType14__1Builder builder() {
		return new ContractType14__1.ContractType14__1BuilderImpl();
	}

	/*********************** Utility Methods  ***********************/
	@Override
	default RosettaMetaData<? extends ContractType14__1> metaData() {
		return metaData;
	}
	
	@Override
	default Class<? extends ContractType14__1> getType() {
		return ContractType14__1.class;
	}
	
	
	@Override
	default void process(RosettaPath path, Processor processor) {
		processor.processBasic(path.newSubPath("ctrctTp"), FinancialInstrumentContractType2Code.class, getCtrctTp(), this);
		processor.processBasic(path.newSubPath("asstClss"), ProductType4Code__1.class, getAsstClss(), this);
		processRosetta(path.newSubPath("pdctId"), processor, SecurityIdentification46__1.class, getPdctId());
		processRosetta(path.newSubPath("undrlygInstrm"), processor, SecurityIdentification41Choice__1.class, getUndrlygInstrm());
		processRosetta(path.newSubPath("sttlmCcy"), processor, CurrencyExchange23__1.class, getSttlmCcy());
		processRosetta(path.newSubPath("sttlmCcyScndLeg"), processor, CurrencyExchange23__1.class, getSttlmCcyScndLeg());
		processor.processBasic(path.newSubPath("derivBasedOnCrptAsst"), Boolean.class, getDerivBasedOnCrptAsst(), this);
	}
	

	/*********************** Builder Interface  ***********************/
	interface ContractType14__1Builder extends ContractType14__1, RosettaModelObjectBuilder {
		SecurityIdentification46__1.SecurityIdentification46__1Builder getOrCreatePdctId();
		SecurityIdentification46__1.SecurityIdentification46__1Builder getPdctId();
		SecurityIdentification41Choice__1.SecurityIdentification41Choice__1Builder getOrCreateUndrlygInstrm();
		SecurityIdentification41Choice__1.SecurityIdentification41Choice__1Builder getUndrlygInstrm();
		CurrencyExchange23__1.CurrencyExchange23__1Builder getOrCreateSttlmCcy();
		CurrencyExchange23__1.CurrencyExchange23__1Builder getSttlmCcy();
		CurrencyExchange23__1.CurrencyExchange23__1Builder getOrCreateSttlmCcyScndLeg();
		CurrencyExchange23__1.CurrencyExchange23__1Builder getSttlmCcyScndLeg();
		ContractType14__1.ContractType14__1Builder setCtrctTp(FinancialInstrumentContractType2Code ctrctTp);
		ContractType14__1.ContractType14__1Builder setAsstClss(ProductType4Code__1 asstClss);
		ContractType14__1.ContractType14__1Builder setPdctId(SecurityIdentification46__1 pdctId);
		ContractType14__1.ContractType14__1Builder setUndrlygInstrm(SecurityIdentification41Choice__1 undrlygInstrm);
		ContractType14__1.ContractType14__1Builder setSttlmCcy(CurrencyExchange23__1 sttlmCcy);
		ContractType14__1.ContractType14__1Builder setSttlmCcyScndLeg(CurrencyExchange23__1 sttlmCcyScndLeg);
		ContractType14__1.ContractType14__1Builder setDerivBasedOnCrptAsst(Boolean derivBasedOnCrptAsst);

		@Override
		default void process(RosettaPath path, BuilderProcessor processor) {
			processor.processBasic(path.newSubPath("ctrctTp"), FinancialInstrumentContractType2Code.class, getCtrctTp(), this);
			processor.processBasic(path.newSubPath("asstClss"), ProductType4Code__1.class, getAsstClss(), this);
			processRosetta(path.newSubPath("pdctId"), processor, SecurityIdentification46__1.SecurityIdentification46__1Builder.class, getPdctId());
			processRosetta(path.newSubPath("undrlygInstrm"), processor, SecurityIdentification41Choice__1.SecurityIdentification41Choice__1Builder.class, getUndrlygInstrm());
			processRosetta(path.newSubPath("sttlmCcy"), processor, CurrencyExchange23__1.CurrencyExchange23__1Builder.class, getSttlmCcy());
			processRosetta(path.newSubPath("sttlmCcyScndLeg"), processor, CurrencyExchange23__1.CurrencyExchange23__1Builder.class, getSttlmCcyScndLeg());
			processor.processBasic(path.newSubPath("derivBasedOnCrptAsst"), Boolean.class, getDerivBasedOnCrptAsst(), this);
		}
		

		ContractType14__1.ContractType14__1Builder prune();
	}

	/*********************** Immutable Implementation of ContractType14__1  ***********************/
	class ContractType14__1Impl implements ContractType14__1 {
		private final FinancialInstrumentContractType2Code ctrctTp;
		private final ProductType4Code__1 asstClss;
		private final SecurityIdentification46__1 pdctId;
		private final SecurityIdentification41Choice__1 undrlygInstrm;
		private final CurrencyExchange23__1 sttlmCcy;
		private final CurrencyExchange23__1 sttlmCcyScndLeg;
		private final Boolean derivBasedOnCrptAsst;
		
		protected ContractType14__1Impl(ContractType14__1.ContractType14__1Builder builder) {
			this.ctrctTp = builder.getCtrctTp();
			this.asstClss = builder.getAsstClss();
			this.pdctId = ofNullable(builder.getPdctId()).map(f->f.build()).orElse(null);
			this.undrlygInstrm = ofNullable(builder.getUndrlygInstrm()).map(f->f.build()).orElse(null);
			this.sttlmCcy = ofNullable(builder.getSttlmCcy()).map(f->f.build()).orElse(null);
			this.sttlmCcyScndLeg = ofNullable(builder.getSttlmCcyScndLeg()).map(f->f.build()).orElse(null);
			this.derivBasedOnCrptAsst = builder.getDerivBasedOnCrptAsst();
		}
		
		@Override
		@RosettaAttribute("ctrctTp")
		public FinancialInstrumentContractType2Code getCtrctTp() {
			return ctrctTp;
		}
		
		@Override
		@RosettaAttribute("asstClss")
		public ProductType4Code__1 getAsstClss() {
			return asstClss;
		}
		
		@Override
		@RosettaAttribute("pdctId")
		public SecurityIdentification46__1 getPdctId() {
			return pdctId;
		}
		
		@Override
		@RosettaAttribute("undrlygInstrm")
		public SecurityIdentification41Choice__1 getUndrlygInstrm() {
			return undrlygInstrm;
		}
		
		@Override
		@RosettaAttribute("sttlmCcy")
		public CurrencyExchange23__1 getSttlmCcy() {
			return sttlmCcy;
		}
		
		@Override
		@RosettaAttribute("sttlmCcyScndLeg")
		public CurrencyExchange23__1 getSttlmCcyScndLeg() {
			return sttlmCcyScndLeg;
		}
		
		@Override
		@RosettaAttribute("derivBasedOnCrptAsst")
		public Boolean getDerivBasedOnCrptAsst() {
			return derivBasedOnCrptAsst;
		}
		
		@Override
		public ContractType14__1 build() {
			return this;
		}
		
		@Override
		public ContractType14__1.ContractType14__1Builder toBuilder() {
			ContractType14__1.ContractType14__1Builder builder = builder();
			setBuilderFields(builder);
			return builder;
		}
		
		protected void setBuilderFields(ContractType14__1.ContractType14__1Builder builder) {
			ofNullable(getCtrctTp()).ifPresent(builder::setCtrctTp);
			ofNullable(getAsstClss()).ifPresent(builder::setAsstClss);
			ofNullable(getPdctId()).ifPresent(builder::setPdctId);
			ofNullable(getUndrlygInstrm()).ifPresent(builder::setUndrlygInstrm);
			ofNullable(getSttlmCcy()).ifPresent(builder::setSttlmCcy);
			ofNullable(getSttlmCcyScndLeg()).ifPresent(builder::setSttlmCcyScndLeg);
			ofNullable(getDerivBasedOnCrptAsst()).ifPresent(builder::setDerivBasedOnCrptAsst);
		}

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			ContractType14__1 _that = getType().cast(o);
		
			if (!Objects.equals(ctrctTp, _that.getCtrctTp())) return false;
			if (!Objects.equals(asstClss, _that.getAsstClss())) return false;
			if (!Objects.equals(pdctId, _that.getPdctId())) return false;
			if (!Objects.equals(undrlygInstrm, _that.getUndrlygInstrm())) return false;
			if (!Objects.equals(sttlmCcy, _that.getSttlmCcy())) return false;
			if (!Objects.equals(sttlmCcyScndLeg, _that.getSttlmCcyScndLeg())) return false;
			if (!Objects.equals(derivBasedOnCrptAsst, _that.getDerivBasedOnCrptAsst())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (ctrctTp != null ? ctrctTp.getClass().getName().hashCode() : 0);
			_result = 31 * _result + (asstClss != null ? asstClss.getClass().getName().hashCode() : 0);
			_result = 31 * _result + (pdctId != null ? pdctId.hashCode() : 0);
			_result = 31 * _result + (undrlygInstrm != null ? undrlygInstrm.hashCode() : 0);
			_result = 31 * _result + (sttlmCcy != null ? sttlmCcy.hashCode() : 0);
			_result = 31 * _result + (sttlmCcyScndLeg != null ? sttlmCcyScndLeg.hashCode() : 0);
			_result = 31 * _result + (derivBasedOnCrptAsst != null ? derivBasedOnCrptAsst.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "ContractType14__1 {" +
				"ctrctTp=" + this.ctrctTp + ", " +
				"asstClss=" + this.asstClss + ", " +
				"pdctId=" + this.pdctId + ", " +
				"undrlygInstrm=" + this.undrlygInstrm + ", " +
				"sttlmCcy=" + this.sttlmCcy + ", " +
				"sttlmCcyScndLeg=" + this.sttlmCcyScndLeg + ", " +
				"derivBasedOnCrptAsst=" + this.derivBasedOnCrptAsst +
			'}';
		}
	}

	/*********************** Builder Implementation of ContractType14__1  ***********************/
	class ContractType14__1BuilderImpl implements ContractType14__1.ContractType14__1Builder {
	
		protected FinancialInstrumentContractType2Code ctrctTp;
		protected ProductType4Code__1 asstClss;
		protected SecurityIdentification46__1.SecurityIdentification46__1Builder pdctId;
		protected SecurityIdentification41Choice__1.SecurityIdentification41Choice__1Builder undrlygInstrm;
		protected CurrencyExchange23__1.CurrencyExchange23__1Builder sttlmCcy;
		protected CurrencyExchange23__1.CurrencyExchange23__1Builder sttlmCcyScndLeg;
		protected Boolean derivBasedOnCrptAsst;
	
		public ContractType14__1BuilderImpl() {
		}
	
		@Override
		@RosettaAttribute("ctrctTp")
		public FinancialInstrumentContractType2Code getCtrctTp() {
			return ctrctTp;
		}
		
		@Override
		@RosettaAttribute("asstClss")
		public ProductType4Code__1 getAsstClss() {
			return asstClss;
		}
		
		@Override
		@RosettaAttribute("pdctId")
		public SecurityIdentification46__1.SecurityIdentification46__1Builder getPdctId() {
			return pdctId;
		}
		
		@Override
		public SecurityIdentification46__1.SecurityIdentification46__1Builder getOrCreatePdctId() {
			SecurityIdentification46__1.SecurityIdentification46__1Builder result;
			if (pdctId!=null) {
				result = pdctId;
			}
			else {
				result = pdctId = SecurityIdentification46__1.builder();
			}
			
			return result;
		}
		@Override
		@RosettaAttribute("undrlygInstrm")
		public SecurityIdentification41Choice__1.SecurityIdentification41Choice__1Builder getUndrlygInstrm() {
			return undrlygInstrm;
		}
		
		@Override
		public SecurityIdentification41Choice__1.SecurityIdentification41Choice__1Builder getOrCreateUndrlygInstrm() {
			SecurityIdentification41Choice__1.SecurityIdentification41Choice__1Builder result;
			if (undrlygInstrm!=null) {
				result = undrlygInstrm;
			}
			else {
				result = undrlygInstrm = SecurityIdentification41Choice__1.builder();
			}
			
			return result;
		}
		@Override
		@RosettaAttribute("sttlmCcy")
		public CurrencyExchange23__1.CurrencyExchange23__1Builder getSttlmCcy() {
			return sttlmCcy;
		}
		
		@Override
		public CurrencyExchange23__1.CurrencyExchange23__1Builder getOrCreateSttlmCcy() {
			CurrencyExchange23__1.CurrencyExchange23__1Builder result;
			if (sttlmCcy!=null) {
				result = sttlmCcy;
			}
			else {
				result = sttlmCcy = CurrencyExchange23__1.builder();
			}
			
			return result;
		}
		@Override
		@RosettaAttribute("sttlmCcyScndLeg")
		public CurrencyExchange23__1.CurrencyExchange23__1Builder getSttlmCcyScndLeg() {
			return sttlmCcyScndLeg;
		}
		
		@Override
		public CurrencyExchange23__1.CurrencyExchange23__1Builder getOrCreateSttlmCcyScndLeg() {
			CurrencyExchange23__1.CurrencyExchange23__1Builder result;
			if (sttlmCcyScndLeg!=null) {
				result = sttlmCcyScndLeg;
			}
			else {
				result = sttlmCcyScndLeg = CurrencyExchange23__1.builder();
			}
			
			return result;
		}
		@Override
		@RosettaAttribute("derivBasedOnCrptAsst")
		public Boolean getDerivBasedOnCrptAsst() {
			return derivBasedOnCrptAsst;
		}
		
	
		@Override
		@RosettaAttribute("ctrctTp")
		public ContractType14__1.ContractType14__1Builder setCtrctTp(FinancialInstrumentContractType2Code ctrctTp) {
			this.ctrctTp = ctrctTp==null?null:ctrctTp;
			return this;
		}
		@Override
		@RosettaAttribute("asstClss")
		public ContractType14__1.ContractType14__1Builder setAsstClss(ProductType4Code__1 asstClss) {
			this.asstClss = asstClss==null?null:asstClss;
			return this;
		}
		@Override
		@RosettaAttribute("pdctId")
		public ContractType14__1.ContractType14__1Builder setPdctId(SecurityIdentification46__1 pdctId) {
			this.pdctId = pdctId==null?null:pdctId.toBuilder();
			return this;
		}
		@Override
		@RosettaAttribute("undrlygInstrm")
		public ContractType14__1.ContractType14__1Builder setUndrlygInstrm(SecurityIdentification41Choice__1 undrlygInstrm) {
			this.undrlygInstrm = undrlygInstrm==null?null:undrlygInstrm.toBuilder();
			return this;
		}
		@Override
		@RosettaAttribute("sttlmCcy")
		public ContractType14__1.ContractType14__1Builder setSttlmCcy(CurrencyExchange23__1 sttlmCcy) {
			this.sttlmCcy = sttlmCcy==null?null:sttlmCcy.toBuilder();
			return this;
		}
		@Override
		@RosettaAttribute("sttlmCcyScndLeg")
		public ContractType14__1.ContractType14__1Builder setSttlmCcyScndLeg(CurrencyExchange23__1 sttlmCcyScndLeg) {
			this.sttlmCcyScndLeg = sttlmCcyScndLeg==null?null:sttlmCcyScndLeg.toBuilder();
			return this;
		}
		@Override
		@RosettaAttribute("derivBasedOnCrptAsst")
		public ContractType14__1.ContractType14__1Builder setDerivBasedOnCrptAsst(Boolean derivBasedOnCrptAsst) {
			this.derivBasedOnCrptAsst = derivBasedOnCrptAsst==null?null:derivBasedOnCrptAsst;
			return this;
		}
		
		@Override
		public ContractType14__1 build() {
			return new ContractType14__1.ContractType14__1Impl(this);
		}
		
		@Override
		public ContractType14__1.ContractType14__1Builder toBuilder() {
			return this;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public ContractType14__1.ContractType14__1Builder prune() {
			if (pdctId!=null && !pdctId.prune().hasData()) pdctId = null;
			if (undrlygInstrm!=null && !undrlygInstrm.prune().hasData()) undrlygInstrm = null;
			if (sttlmCcy!=null && !sttlmCcy.prune().hasData()) sttlmCcy = null;
			if (sttlmCcyScndLeg!=null && !sttlmCcyScndLeg.prune().hasData()) sttlmCcyScndLeg = null;
			return this;
		}
		
		@Override
		public boolean hasData() {
			if (getCtrctTp()!=null) return true;
			if (getAsstClss()!=null) return true;
			if (getPdctId()!=null && getPdctId().hasData()) return true;
			if (getUndrlygInstrm()!=null && getUndrlygInstrm().hasData()) return true;
			if (getSttlmCcy()!=null && getSttlmCcy().hasData()) return true;
			if (getSttlmCcyScndLeg()!=null && getSttlmCcyScndLeg().hasData()) return true;
			if (getDerivBasedOnCrptAsst()!=null) return true;
			return false;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public ContractType14__1.ContractType14__1Builder merge(RosettaModelObjectBuilder other, BuilderMerger merger) {
			ContractType14__1.ContractType14__1Builder o = (ContractType14__1.ContractType14__1Builder) other;
			
			merger.mergeRosetta(getPdctId(), o.getPdctId(), this::setPdctId);
			merger.mergeRosetta(getUndrlygInstrm(), o.getUndrlygInstrm(), this::setUndrlygInstrm);
			merger.mergeRosetta(getSttlmCcy(), o.getSttlmCcy(), this::setSttlmCcy);
			merger.mergeRosetta(getSttlmCcyScndLeg(), o.getSttlmCcyScndLeg(), this::setSttlmCcyScndLeg);
			
			merger.mergeBasic(getCtrctTp(), o.getCtrctTp(), this::setCtrctTp);
			merger.mergeBasic(getAsstClss(), o.getAsstClss(), this::setAsstClss);
			merger.mergeBasic(getDerivBasedOnCrptAsst(), o.getDerivBasedOnCrptAsst(), this::setDerivBasedOnCrptAsst);
			return this;
		}
	
		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			ContractType14__1 _that = getType().cast(o);
		
			if (!Objects.equals(ctrctTp, _that.getCtrctTp())) return false;
			if (!Objects.equals(asstClss, _that.getAsstClss())) return false;
			if (!Objects.equals(pdctId, _that.getPdctId())) return false;
			if (!Objects.equals(undrlygInstrm, _that.getUndrlygInstrm())) return false;
			if (!Objects.equals(sttlmCcy, _that.getSttlmCcy())) return false;
			if (!Objects.equals(sttlmCcyScndLeg, _that.getSttlmCcyScndLeg())) return false;
			if (!Objects.equals(derivBasedOnCrptAsst, _that.getDerivBasedOnCrptAsst())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (ctrctTp != null ? ctrctTp.getClass().getName().hashCode() : 0);
			_result = 31 * _result + (asstClss != null ? asstClss.getClass().getName().hashCode() : 0);
			_result = 31 * _result + (pdctId != null ? pdctId.hashCode() : 0);
			_result = 31 * _result + (undrlygInstrm != null ? undrlygInstrm.hashCode() : 0);
			_result = 31 * _result + (sttlmCcy != null ? sttlmCcy.hashCode() : 0);
			_result = 31 * _result + (sttlmCcyScndLeg != null ? sttlmCcyScndLeg.hashCode() : 0);
			_result = 31 * _result + (derivBasedOnCrptAsst != null ? derivBasedOnCrptAsst.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "ContractType14__1Builder {" +
				"ctrctTp=" + this.ctrctTp + ", " +
				"asstClss=" + this.asstClss + ", " +
				"pdctId=" + this.pdctId + ", " +
				"undrlygInstrm=" + this.undrlygInstrm + ", " +
				"sttlmCcy=" + this.sttlmCcy + ", " +
				"sttlmCcyScndLeg=" + this.sttlmCcyScndLeg + ", " +
				"derivBasedOnCrptAsst=" + this.derivBasedOnCrptAsst +
			'}';
		}
	}
}
