package iso20022.auth030.jfsa;

import com.rosetta.model.lib.RosettaModelObject;
import com.rosetta.model.lib.RosettaModelObjectBuilder;
import com.rosetta.model.lib.annotations.RosettaAttribute;
import com.rosetta.model.lib.annotations.RosettaDataType;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.process.BuilderMerger;
import com.rosetta.model.lib.process.BuilderProcessor;
import com.rosetta.model.lib.process.Processor;
import iso20022.auth030.jfsa.Counterparty45__2;
import iso20022.auth030.jfsa.Counterparty45__2.Counterparty45__2Builder;
import iso20022.auth030.jfsa.Counterparty45__2.Counterparty45__2BuilderImpl;
import iso20022.auth030.jfsa.Counterparty45__2.Counterparty45__2Impl;
import iso20022.auth030.jfsa.PartyIdentification248Choice__1;
import iso20022.auth030.jfsa.meta.Counterparty45__2Meta;
import java.util.Objects;

import static java.util.Optional.ofNullable;

/**
 * @version 0.5.1
 */
@RosettaDataType(value="Counterparty45__2", builder=Counterparty45__2.Counterparty45__2BuilderImpl.class, version="0.5.1")
public interface Counterparty45__2 extends RosettaModelObject {

	Counterparty45__2Meta metaData = new Counterparty45__2Meta();

	/*********************** Getter Methods  ***********************/
	PartyIdentification248Choice__1 getId();

	/*********************** Build Methods  ***********************/
	Counterparty45__2 build();
	
	Counterparty45__2.Counterparty45__2Builder toBuilder();
	
	static Counterparty45__2.Counterparty45__2Builder builder() {
		return new Counterparty45__2.Counterparty45__2BuilderImpl();
	}

	/*********************** Utility Methods  ***********************/
	@Override
	default RosettaMetaData<? extends Counterparty45__2> metaData() {
		return metaData;
	}
	
	@Override
	default Class<? extends Counterparty45__2> getType() {
		return Counterparty45__2.class;
	}
	
	
	@Override
	default void process(RosettaPath path, Processor processor) {
		processRosetta(path.newSubPath("id"), processor, PartyIdentification248Choice__1.class, getId());
	}
	

	/*********************** Builder Interface  ***********************/
	interface Counterparty45__2Builder extends Counterparty45__2, RosettaModelObjectBuilder {
		PartyIdentification248Choice__1.PartyIdentification248Choice__1Builder getOrCreateId();
		PartyIdentification248Choice__1.PartyIdentification248Choice__1Builder getId();
		Counterparty45__2.Counterparty45__2Builder setId(PartyIdentification248Choice__1 id);

		@Override
		default void process(RosettaPath path, BuilderProcessor processor) {
			processRosetta(path.newSubPath("id"), processor, PartyIdentification248Choice__1.PartyIdentification248Choice__1Builder.class, getId());
		}
		

		Counterparty45__2.Counterparty45__2Builder prune();
	}

	/*********************** Immutable Implementation of Counterparty45__2  ***********************/
	class Counterparty45__2Impl implements Counterparty45__2 {
		private final PartyIdentification248Choice__1 id;
		
		protected Counterparty45__2Impl(Counterparty45__2.Counterparty45__2Builder builder) {
			this.id = ofNullable(builder.getId()).map(f->f.build()).orElse(null);
		}
		
		@Override
		@RosettaAttribute("id")
		public PartyIdentification248Choice__1 getId() {
			return id;
		}
		
		@Override
		public Counterparty45__2 build() {
			return this;
		}
		
		@Override
		public Counterparty45__2.Counterparty45__2Builder toBuilder() {
			Counterparty45__2.Counterparty45__2Builder builder = builder();
			setBuilderFields(builder);
			return builder;
		}
		
		protected void setBuilderFields(Counterparty45__2.Counterparty45__2Builder builder) {
			ofNullable(getId()).ifPresent(builder::setId);
		}

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			Counterparty45__2 _that = getType().cast(o);
		
			if (!Objects.equals(id, _that.getId())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (id != null ? id.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "Counterparty45__2 {" +
				"id=" + this.id +
			'}';
		}
	}

	/*********************** Builder Implementation of Counterparty45__2  ***********************/
	class Counterparty45__2BuilderImpl implements Counterparty45__2.Counterparty45__2Builder {
	
		protected PartyIdentification248Choice__1.PartyIdentification248Choice__1Builder id;
	
		public Counterparty45__2BuilderImpl() {
		}
	
		@Override
		@RosettaAttribute("id")
		public PartyIdentification248Choice__1.PartyIdentification248Choice__1Builder getId() {
			return id;
		}
		
		@Override
		public PartyIdentification248Choice__1.PartyIdentification248Choice__1Builder getOrCreateId() {
			PartyIdentification248Choice__1.PartyIdentification248Choice__1Builder result;
			if (id!=null) {
				result = id;
			}
			else {
				result = id = PartyIdentification248Choice__1.builder();
			}
			
			return result;
		}
	
		@Override
		@RosettaAttribute("id")
		public Counterparty45__2.Counterparty45__2Builder setId(PartyIdentification248Choice__1 id) {
			this.id = id==null?null:id.toBuilder();
			return this;
		}
		
		@Override
		public Counterparty45__2 build() {
			return new Counterparty45__2.Counterparty45__2Impl(this);
		}
		
		@Override
		public Counterparty45__2.Counterparty45__2Builder toBuilder() {
			return this;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public Counterparty45__2.Counterparty45__2Builder prune() {
			if (id!=null && !id.prune().hasData()) id = null;
			return this;
		}
		
		@Override
		public boolean hasData() {
			if (getId()!=null && getId().hasData()) return true;
			return false;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public Counterparty45__2.Counterparty45__2Builder merge(RosettaModelObjectBuilder other, BuilderMerger merger) {
			Counterparty45__2.Counterparty45__2Builder o = (Counterparty45__2.Counterparty45__2Builder) other;
			
			merger.mergeRosetta(getId(), o.getId(), this::setId);
			
			return this;
		}
	
		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			Counterparty45__2 _that = getType().cast(o);
		
			if (!Objects.equals(id, _that.getId())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (id != null ? id.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "Counterparty45__2Builder {" +
				"id=" + this.id +
			'}';
		}
	}
}
