package iso20022.auth030.jfsa;

import com.rosetta.model.lib.annotations.RosettaEnum;
import com.rosetta.model.lib.annotations.RosettaEnumValue;
import java.util.Collections;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;


/**
 * @version 0.5.1
 */
@RosettaEnum("DerivativeEventType3Code")
public enum DerivativeEventType3Code {

	@RosettaEnumValue(value = "ALOC") ALOC("ALOC"),
	
	@RosettaEnumValue(value = "CLRG") CLRG("CLRG"),
	
	@RosettaEnumValue(value = "CLAL") CLAL("CLAL"),
	
	@RosettaEnumValue(value = "COMP") COMP("COMP"),
	
	@RosettaEnumValue(value = "CORP") CORP("CORP"),
	
	@RosettaEnumValue(value = "CREV") CREV("CREV"),
	
	@RosettaEnumValue(value = "ETRM") ETRM("ETRM"),
	
	@RosettaEnumValue(value = "EXER") EXER("EXER"),
	
	@RosettaEnumValue(value = "INCP") INCP("INCP"),
	
	@RosettaEnumValue(value = "NOVA") NOVA("NOVA"),
	
	@RosettaEnumValue(value = "PTNG") PTNG("PTNG"),
	
	@RosettaEnumValue(value = "TRAD") TRAD("TRAD"),
	
	@RosettaEnumValue(value = "UPDT") UPDT("UPDT")
;
	private static Map<String, DerivativeEventType3Code> values;
	static {
        Map<String, DerivativeEventType3Code> map = new ConcurrentHashMap<>();
		for (DerivativeEventType3Code instance : DerivativeEventType3Code.values()) {
			map.put(instance.toDisplayString(), instance);
		}
		values = Collections.unmodifiableMap(map);
    }

	private final String rosettaName;
	private final String displayName;

	DerivativeEventType3Code(String rosettaName) {
		this(rosettaName, null);
	}

	DerivativeEventType3Code(String rosettaName, String displayName) {
		this.rosettaName = rosettaName;
		this.displayName = displayName;
	}

	public static DerivativeEventType3Code fromDisplayName(String name) {
		DerivativeEventType3Code value = values.get(name);
		if (value == null) {
			throw new IllegalArgumentException("No enum constant with display name \"" + name + "\".");
		}
		return value;
	}

	@Override
	public String toString() {
		return toDisplayString();
	}

	public String toDisplayString() {
		return displayName != null ?  displayName : rosettaName;
	}
}
