package iso20022.auth030.jfsa;

import com.rosetta.model.lib.annotations.RosettaEnum;
import com.rosetta.model.lib.annotations.RosettaEnumValue;
import java.util.Collections;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;


/**
 * @version 0.5.1
 */
@RosettaEnum("EmbeddedType1Code")
public enum EmbeddedType1Code {

	@RosettaEnumValue(value = "CANC") CANC("CANC"),
	
	@RosettaEnumValue(value = "EXTD") EXTD("EXTD"),
	
	@RosettaEnumValue(value = "OPET") OPET("OPET"),
	
	@RosettaEnumValue(value = "OTHR") OTHR("OTHR"),
	
	@RosettaEnumValue(value = "MDET") MDET("MDET")
;
	private static Map<String, EmbeddedType1Code> values;
	static {
        Map<String, EmbeddedType1Code> map = new ConcurrentHashMap<>();
		for (EmbeddedType1Code instance : EmbeddedType1Code.values()) {
			map.put(instance.toDisplayString(), instance);
		}
		values = Collections.unmodifiableMap(map);
    }

	private final String rosettaName;
	private final String displayName;

	EmbeddedType1Code(String rosettaName) {
		this(rosettaName, null);
	}

	EmbeddedType1Code(String rosettaName, String displayName) {
		this.rosettaName = rosettaName;
		this.displayName = displayName;
	}

	public static EmbeddedType1Code fromDisplayName(String name) {
		EmbeddedType1Code value = values.get(name);
		if (value == null) {
			throw new IllegalArgumentException("No enum constant with display name \"" + name + "\".");
		}
		return value;
	}

	@Override
	public String toString() {
		return toDisplayString();
	}

	public String toDisplayString() {
		return displayName != null ?  displayName : rosettaName;
	}
}
