package iso20022.auth030.jfsa;

import com.rosetta.model.lib.annotations.RosettaEnum;
import com.rosetta.model.lib.annotations.RosettaEnumValue;
import java.util.Collections;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;


/**
 * @version 0.5.1
 */
@RosettaEnum("Frequency13Code")
public enum Frequency13Code {

	@RosettaEnumValue(value = "DAIL") DAIL("DAIL"),
	
	@RosettaEnumValue(value = "WEEK") WEEK("WEEK"),
	
	@RosettaEnumValue(value = "MNTH") MNTH("MNTH"),
	
	@RosettaEnumValue(value = "YEAR") YEAR("YEAR"),
	
	@RosettaEnumValue(value = "ADHO") ADHO("ADHO"),
	
	@RosettaEnumValue(value = "EXPI") EXPI("EXPI"),
	
	@RosettaEnumValue(value = "MIAN") MIAN("MIAN"),
	
	@RosettaEnumValue(value = "QURT") QURT("QURT")
;
	private static Map<String, Frequency13Code> values;
	static {
        Map<String, Frequency13Code> map = new ConcurrentHashMap<>();
		for (Frequency13Code instance : Frequency13Code.values()) {
			map.put(instance.toDisplayString(), instance);
		}
		values = Collections.unmodifiableMap(map);
    }

	private final String rosettaName;
	private final String displayName;

	Frequency13Code(String rosettaName) {
		this(rosettaName, null);
	}

	Frequency13Code(String rosettaName, String displayName) {
		this.rosettaName = rosettaName;
		this.displayName = displayName;
	}

	public static Frequency13Code fromDisplayName(String name) {
		Frequency13Code value = values.get(name);
		if (value == null) {
			throw new IllegalArgumentException("No enum constant with display name \"" + name + "\".");
		}
		return value;
	}

	@Override
	public String toString() {
		return toDisplayString();
	}

	public String toDisplayString() {
		return displayName != null ?  displayName : rosettaName;
	}
}
