package iso20022.auth030.jfsa;

import com.rosetta.model.lib.annotations.RosettaEnum;
import com.rosetta.model.lib.annotations.RosettaEnumValue;
import java.util.Collections;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;


/**
 * @version 0.5.1
 */
@RosettaEnum("InterestComputationMethod4Code")
public enum InterestComputationMethod4Code {

	@RosettaEnumValue(value = "A004") A004("A004"),
	
	@RosettaEnumValue(value = "A019") A019("A019"),
	
	@RosettaEnumValue(value = "A017") A017("A017"),
	
	@RosettaEnumValue(value = "A005") A005("A005"),
	
	@RosettaEnumValue(value = "A009") A009("A009"),
	
	@RosettaEnumValue(value = "A014") A014("A014"),
	
	@RosettaEnumValue(value = "A010") A010("A010"),
	
	@RosettaEnumValue(value = "A006") A006("A006"),
	
	@RosettaEnumValue(value = "A008") A008("A008"),
	
	@RosettaEnumValue(value = "A015") A015("A015"),
	
	@RosettaEnumValue(value = "A018") A018("A018"),
	
	@RosettaEnumValue(value = "A011") A011("A011"),
	
	@RosettaEnumValue(value = "A001") A001("A001"),
	
	@RosettaEnumValue(value = "A002") A002("A002"),
	
	@RosettaEnumValue(value = "A003") A003("A003"),
	
	@RosettaEnumValue(value = "A012") A012("A012"),
	
	@RosettaEnumValue(value = "A013") A013("A013"),
	
	@RosettaEnumValue(value = "A007") A007("A007"),
	
	@RosettaEnumValue(value = "A016") A016("A016"),
	
	@RosettaEnumValue(value = "NARR") NARR("NARR"),
	
	@RosettaEnumValue(value = "A020") A020("A020")
;
	private static Map<String, InterestComputationMethod4Code> values;
	static {
        Map<String, InterestComputationMethod4Code> map = new ConcurrentHashMap<>();
		for (InterestComputationMethod4Code instance : InterestComputationMethod4Code.values()) {
			map.put(instance.toDisplayString(), instance);
		}
		values = Collections.unmodifiableMap(map);
    }

	private final String rosettaName;
	private final String displayName;

	InterestComputationMethod4Code(String rosettaName) {
		this(rosettaName, null);
	}

	InterestComputationMethod4Code(String rosettaName, String displayName) {
		this.rosettaName = rosettaName;
		this.displayName = displayName;
	}

	public static InterestComputationMethod4Code fromDisplayName(String name) {
		InterestComputationMethod4Code value = values.get(name);
		if (value == null) {
			throw new IllegalArgumentException("No enum constant with display name \"" + name + "\".");
		}
		return value;
	}

	@Override
	public String toString() {
		return toDisplayString();
	}

	public String toDisplayString() {
		return displayName != null ?  displayName : rosettaName;
	}
}
