package iso20022.auth030.jfsa;

import com.rosetta.model.lib.RosettaModelObject;
import com.rosetta.model.lib.RosettaModelObjectBuilder;
import com.rosetta.model.lib.annotations.RosettaAttribute;
import com.rosetta.model.lib.annotations.RosettaDataType;
import com.rosetta.model.lib.meta.RosettaMetaData;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.process.BuilderMerger;
import com.rosetta.model.lib.process.BuilderProcessor;
import com.rosetta.model.lib.process.Processor;
import iso20022.auth030.jfsa.TradeData42__1;
import iso20022.auth030.jfsa.TradeData42__2;
import iso20022.auth030.jfsa.TradeData42__3;
import iso20022.auth030.jfsa.TradeData42__4;
import iso20022.auth030.jfsa.TradeData42__5;
import iso20022.auth030.jfsa.TradeData42__6;
import iso20022.auth030.jfsa.TradeData42__7;
import iso20022.auth030.jfsa.TradeReport32Choice__1;
import iso20022.auth030.jfsa.TradeReport32Choice__1.TradeReport32Choice__1Builder;
import iso20022.auth030.jfsa.TradeReport32Choice__1.TradeReport32Choice__1BuilderImpl;
import iso20022.auth030.jfsa.TradeReport32Choice__1.TradeReport32Choice__1Impl;
import iso20022.auth030.jfsa.meta.TradeReport32Choice__1Meta;
import java.util.Objects;

import static java.util.Optional.ofNullable;

/**
 * @version 0.5.1
 */
@RosettaDataType(value="TradeReport32Choice__1", builder=TradeReport32Choice__1.TradeReport32Choice__1BuilderImpl.class, version="0.5.1")
public interface TradeReport32Choice__1 extends RosettaModelObject {

	TradeReport32Choice__1Meta metaData = new TradeReport32Choice__1Meta();

	/*********************** Getter Methods  ***********************/
	TradeData42__1 getNew();
	TradeData42__2 getMod();
	TradeData42__3 getCrrctn();
	TradeData42__4 getTermntn();
	TradeData42__5 getValtnUpd();
	TradeData42__6 getErr();
	TradeData42__7 getPortOut();
	TradeData42__3 getRvv();

	/*********************** Build Methods  ***********************/
	TradeReport32Choice__1 build();
	
	TradeReport32Choice__1.TradeReport32Choice__1Builder toBuilder();
	
	static TradeReport32Choice__1.TradeReport32Choice__1Builder builder() {
		return new TradeReport32Choice__1.TradeReport32Choice__1BuilderImpl();
	}

	/*********************** Utility Methods  ***********************/
	@Override
	default RosettaMetaData<? extends TradeReport32Choice__1> metaData() {
		return metaData;
	}
	
	@Override
	default Class<? extends TradeReport32Choice__1> getType() {
		return TradeReport32Choice__1.class;
	}
	
	
	@Override
	default void process(RosettaPath path, Processor processor) {
		processRosetta(path.newSubPath("new"), processor, TradeData42__1.class, getNew());
		processRosetta(path.newSubPath("mod"), processor, TradeData42__2.class, getMod());
		processRosetta(path.newSubPath("crrctn"), processor, TradeData42__3.class, getCrrctn());
		processRosetta(path.newSubPath("termntn"), processor, TradeData42__4.class, getTermntn());
		processRosetta(path.newSubPath("valtnUpd"), processor, TradeData42__5.class, getValtnUpd());
		processRosetta(path.newSubPath("err"), processor, TradeData42__6.class, getErr());
		processRosetta(path.newSubPath("portOut"), processor, TradeData42__7.class, getPortOut());
		processRosetta(path.newSubPath("rvv"), processor, TradeData42__3.class, getRvv());
	}
	

	/*********************** Builder Interface  ***********************/
	interface TradeReport32Choice__1Builder extends TradeReport32Choice__1, RosettaModelObjectBuilder {
		TradeData42__1.TradeData42__1Builder getOrCreateNew();
		TradeData42__1.TradeData42__1Builder getNew();
		TradeData42__2.TradeData42__2Builder getOrCreateMod();
		TradeData42__2.TradeData42__2Builder getMod();
		TradeData42__3.TradeData42__3Builder getOrCreateCrrctn();
		TradeData42__3.TradeData42__3Builder getCrrctn();
		TradeData42__4.TradeData42__4Builder getOrCreateTermntn();
		TradeData42__4.TradeData42__4Builder getTermntn();
		TradeData42__5.TradeData42__5Builder getOrCreateValtnUpd();
		TradeData42__5.TradeData42__5Builder getValtnUpd();
		TradeData42__6.TradeData42__6Builder getOrCreateErr();
		TradeData42__6.TradeData42__6Builder getErr();
		TradeData42__7.TradeData42__7Builder getOrCreatePortOut();
		TradeData42__7.TradeData42__7Builder getPortOut();
		TradeData42__3.TradeData42__3Builder getOrCreateRvv();
		TradeData42__3.TradeData42__3Builder getRvv();
		TradeReport32Choice__1.TradeReport32Choice__1Builder setNew(TradeData42__1 _new);
		TradeReport32Choice__1.TradeReport32Choice__1Builder setMod(TradeData42__2 mod);
		TradeReport32Choice__1.TradeReport32Choice__1Builder setCrrctn(TradeData42__3 crrctn);
		TradeReport32Choice__1.TradeReport32Choice__1Builder setTermntn(TradeData42__4 termntn);
		TradeReport32Choice__1.TradeReport32Choice__1Builder setValtnUpd(TradeData42__5 valtnUpd);
		TradeReport32Choice__1.TradeReport32Choice__1Builder setErr(TradeData42__6 err);
		TradeReport32Choice__1.TradeReport32Choice__1Builder setPortOut(TradeData42__7 portOut);
		TradeReport32Choice__1.TradeReport32Choice__1Builder setRvv(TradeData42__3 rvv);

		@Override
		default void process(RosettaPath path, BuilderProcessor processor) {
			processRosetta(path.newSubPath("new"), processor, TradeData42__1.TradeData42__1Builder.class, getNew());
			processRosetta(path.newSubPath("mod"), processor, TradeData42__2.TradeData42__2Builder.class, getMod());
			processRosetta(path.newSubPath("crrctn"), processor, TradeData42__3.TradeData42__3Builder.class, getCrrctn());
			processRosetta(path.newSubPath("termntn"), processor, TradeData42__4.TradeData42__4Builder.class, getTermntn());
			processRosetta(path.newSubPath("valtnUpd"), processor, TradeData42__5.TradeData42__5Builder.class, getValtnUpd());
			processRosetta(path.newSubPath("err"), processor, TradeData42__6.TradeData42__6Builder.class, getErr());
			processRosetta(path.newSubPath("portOut"), processor, TradeData42__7.TradeData42__7Builder.class, getPortOut());
			processRosetta(path.newSubPath("rvv"), processor, TradeData42__3.TradeData42__3Builder.class, getRvv());
		}
		

		TradeReport32Choice__1.TradeReport32Choice__1Builder prune();
	}

	/*********************** Immutable Implementation of TradeReport32Choice__1  ***********************/
	class TradeReport32Choice__1Impl implements TradeReport32Choice__1 {
		private final TradeData42__1 _new;
		private final TradeData42__2 mod;
		private final TradeData42__3 crrctn;
		private final TradeData42__4 termntn;
		private final TradeData42__5 valtnUpd;
		private final TradeData42__6 err;
		private final TradeData42__7 portOut;
		private final TradeData42__3 rvv;
		
		protected TradeReport32Choice__1Impl(TradeReport32Choice__1.TradeReport32Choice__1Builder builder) {
			this._new = ofNullable(builder.getNew()).map(f->f.build()).orElse(null);
			this.mod = ofNullable(builder.getMod()).map(f->f.build()).orElse(null);
			this.crrctn = ofNullable(builder.getCrrctn()).map(f->f.build()).orElse(null);
			this.termntn = ofNullable(builder.getTermntn()).map(f->f.build()).orElse(null);
			this.valtnUpd = ofNullable(builder.getValtnUpd()).map(f->f.build()).orElse(null);
			this.err = ofNullable(builder.getErr()).map(f->f.build()).orElse(null);
			this.portOut = ofNullable(builder.getPortOut()).map(f->f.build()).orElse(null);
			this.rvv = ofNullable(builder.getRvv()).map(f->f.build()).orElse(null);
		}
		
		@Override
		@RosettaAttribute("new")
		public TradeData42__1 getNew() {
			return _new;
		}
		
		@Override
		@RosettaAttribute("mod")
		public TradeData42__2 getMod() {
			return mod;
		}
		
		@Override
		@RosettaAttribute("crrctn")
		public TradeData42__3 getCrrctn() {
			return crrctn;
		}
		
		@Override
		@RosettaAttribute("termntn")
		public TradeData42__4 getTermntn() {
			return termntn;
		}
		
		@Override
		@RosettaAttribute("valtnUpd")
		public TradeData42__5 getValtnUpd() {
			return valtnUpd;
		}
		
		@Override
		@RosettaAttribute("err")
		public TradeData42__6 getErr() {
			return err;
		}
		
		@Override
		@RosettaAttribute("portOut")
		public TradeData42__7 getPortOut() {
			return portOut;
		}
		
		@Override
		@RosettaAttribute("rvv")
		public TradeData42__3 getRvv() {
			return rvv;
		}
		
		@Override
		public TradeReport32Choice__1 build() {
			return this;
		}
		
		@Override
		public TradeReport32Choice__1.TradeReport32Choice__1Builder toBuilder() {
			TradeReport32Choice__1.TradeReport32Choice__1Builder builder = builder();
			setBuilderFields(builder);
			return builder;
		}
		
		protected void setBuilderFields(TradeReport32Choice__1.TradeReport32Choice__1Builder builder) {
			ofNullable(getNew()).ifPresent(builder::setNew);
			ofNullable(getMod()).ifPresent(builder::setMod);
			ofNullable(getCrrctn()).ifPresent(builder::setCrrctn);
			ofNullable(getTermntn()).ifPresent(builder::setTermntn);
			ofNullable(getValtnUpd()).ifPresent(builder::setValtnUpd);
			ofNullable(getErr()).ifPresent(builder::setErr);
			ofNullable(getPortOut()).ifPresent(builder::setPortOut);
			ofNullable(getRvv()).ifPresent(builder::setRvv);
		}

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			TradeReport32Choice__1 _that = getType().cast(o);
		
			if (!Objects.equals(_new, _that.getNew())) return false;
			if (!Objects.equals(mod, _that.getMod())) return false;
			if (!Objects.equals(crrctn, _that.getCrrctn())) return false;
			if (!Objects.equals(termntn, _that.getTermntn())) return false;
			if (!Objects.equals(valtnUpd, _that.getValtnUpd())) return false;
			if (!Objects.equals(err, _that.getErr())) return false;
			if (!Objects.equals(portOut, _that.getPortOut())) return false;
			if (!Objects.equals(rvv, _that.getRvv())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (_new != null ? _new.hashCode() : 0);
			_result = 31 * _result + (mod != null ? mod.hashCode() : 0);
			_result = 31 * _result + (crrctn != null ? crrctn.hashCode() : 0);
			_result = 31 * _result + (termntn != null ? termntn.hashCode() : 0);
			_result = 31 * _result + (valtnUpd != null ? valtnUpd.hashCode() : 0);
			_result = 31 * _result + (err != null ? err.hashCode() : 0);
			_result = 31 * _result + (portOut != null ? portOut.hashCode() : 0);
			_result = 31 * _result + (rvv != null ? rvv.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "TradeReport32Choice__1 {" +
				"new=" + this._new + ", " +
				"mod=" + this.mod + ", " +
				"crrctn=" + this.crrctn + ", " +
				"termntn=" + this.termntn + ", " +
				"valtnUpd=" + this.valtnUpd + ", " +
				"err=" + this.err + ", " +
				"portOut=" + this.portOut + ", " +
				"rvv=" + this.rvv +
			'}';
		}
	}

	/*********************** Builder Implementation of TradeReport32Choice__1  ***********************/
	class TradeReport32Choice__1BuilderImpl implements TradeReport32Choice__1.TradeReport32Choice__1Builder {
	
		protected TradeData42__1.TradeData42__1Builder _new;
		protected TradeData42__2.TradeData42__2Builder mod;
		protected TradeData42__3.TradeData42__3Builder crrctn;
		protected TradeData42__4.TradeData42__4Builder termntn;
		protected TradeData42__5.TradeData42__5Builder valtnUpd;
		protected TradeData42__6.TradeData42__6Builder err;
		protected TradeData42__7.TradeData42__7Builder portOut;
		protected TradeData42__3.TradeData42__3Builder rvv;
	
		public TradeReport32Choice__1BuilderImpl() {
		}
	
		@Override
		@RosettaAttribute("new")
		public TradeData42__1.TradeData42__1Builder getNew() {
			return _new;
		}
		
		@Override
		public TradeData42__1.TradeData42__1Builder getOrCreateNew() {
			TradeData42__1.TradeData42__1Builder result;
			if (_new!=null) {
				result = _new;
			}
			else {
				result = _new = TradeData42__1.builder();
			}
			
			return result;
		}
		@Override
		@RosettaAttribute("mod")
		public TradeData42__2.TradeData42__2Builder getMod() {
			return mod;
		}
		
		@Override
		public TradeData42__2.TradeData42__2Builder getOrCreateMod() {
			TradeData42__2.TradeData42__2Builder result;
			if (mod!=null) {
				result = mod;
			}
			else {
				result = mod = TradeData42__2.builder();
			}
			
			return result;
		}
		@Override
		@RosettaAttribute("crrctn")
		public TradeData42__3.TradeData42__3Builder getCrrctn() {
			return crrctn;
		}
		
		@Override
		public TradeData42__3.TradeData42__3Builder getOrCreateCrrctn() {
			TradeData42__3.TradeData42__3Builder result;
			if (crrctn!=null) {
				result = crrctn;
			}
			else {
				result = crrctn = TradeData42__3.builder();
			}
			
			return result;
		}
		@Override
		@RosettaAttribute("termntn")
		public TradeData42__4.TradeData42__4Builder getTermntn() {
			return termntn;
		}
		
		@Override
		public TradeData42__4.TradeData42__4Builder getOrCreateTermntn() {
			TradeData42__4.TradeData42__4Builder result;
			if (termntn!=null) {
				result = termntn;
			}
			else {
				result = termntn = TradeData42__4.builder();
			}
			
			return result;
		}
		@Override
		@RosettaAttribute("valtnUpd")
		public TradeData42__5.TradeData42__5Builder getValtnUpd() {
			return valtnUpd;
		}
		
		@Override
		public TradeData42__5.TradeData42__5Builder getOrCreateValtnUpd() {
			TradeData42__5.TradeData42__5Builder result;
			if (valtnUpd!=null) {
				result = valtnUpd;
			}
			else {
				result = valtnUpd = TradeData42__5.builder();
			}
			
			return result;
		}
		@Override
		@RosettaAttribute("err")
		public TradeData42__6.TradeData42__6Builder getErr() {
			return err;
		}
		
		@Override
		public TradeData42__6.TradeData42__6Builder getOrCreateErr() {
			TradeData42__6.TradeData42__6Builder result;
			if (err!=null) {
				result = err;
			}
			else {
				result = err = TradeData42__6.builder();
			}
			
			return result;
		}
		@Override
		@RosettaAttribute("portOut")
		public TradeData42__7.TradeData42__7Builder getPortOut() {
			return portOut;
		}
		
		@Override
		public TradeData42__7.TradeData42__7Builder getOrCreatePortOut() {
			TradeData42__7.TradeData42__7Builder result;
			if (portOut!=null) {
				result = portOut;
			}
			else {
				result = portOut = TradeData42__7.builder();
			}
			
			return result;
		}
		@Override
		@RosettaAttribute("rvv")
		public TradeData42__3.TradeData42__3Builder getRvv() {
			return rvv;
		}
		
		@Override
		public TradeData42__3.TradeData42__3Builder getOrCreateRvv() {
			TradeData42__3.TradeData42__3Builder result;
			if (rvv!=null) {
				result = rvv;
			}
			else {
				result = rvv = TradeData42__3.builder();
			}
			
			return result;
		}
	
		@Override
		@RosettaAttribute("new")
		public TradeReport32Choice__1.TradeReport32Choice__1Builder setNew(TradeData42__1 _new) {
			this._new = _new==null?null:_new.toBuilder();
			return this;
		}
		@Override
		@RosettaAttribute("mod")
		public TradeReport32Choice__1.TradeReport32Choice__1Builder setMod(TradeData42__2 mod) {
			this.mod = mod==null?null:mod.toBuilder();
			return this;
		}
		@Override
		@RosettaAttribute("crrctn")
		public TradeReport32Choice__1.TradeReport32Choice__1Builder setCrrctn(TradeData42__3 crrctn) {
			this.crrctn = crrctn==null?null:crrctn.toBuilder();
			return this;
		}
		@Override
		@RosettaAttribute("termntn")
		public TradeReport32Choice__1.TradeReport32Choice__1Builder setTermntn(TradeData42__4 termntn) {
			this.termntn = termntn==null?null:termntn.toBuilder();
			return this;
		}
		@Override
		@RosettaAttribute("valtnUpd")
		public TradeReport32Choice__1.TradeReport32Choice__1Builder setValtnUpd(TradeData42__5 valtnUpd) {
			this.valtnUpd = valtnUpd==null?null:valtnUpd.toBuilder();
			return this;
		}
		@Override
		@RosettaAttribute("err")
		public TradeReport32Choice__1.TradeReport32Choice__1Builder setErr(TradeData42__6 err) {
			this.err = err==null?null:err.toBuilder();
			return this;
		}
		@Override
		@RosettaAttribute("portOut")
		public TradeReport32Choice__1.TradeReport32Choice__1Builder setPortOut(TradeData42__7 portOut) {
			this.portOut = portOut==null?null:portOut.toBuilder();
			return this;
		}
		@Override
		@RosettaAttribute("rvv")
		public TradeReport32Choice__1.TradeReport32Choice__1Builder setRvv(TradeData42__3 rvv) {
			this.rvv = rvv==null?null:rvv.toBuilder();
			return this;
		}
		
		@Override
		public TradeReport32Choice__1 build() {
			return new TradeReport32Choice__1.TradeReport32Choice__1Impl(this);
		}
		
		@Override
		public TradeReport32Choice__1.TradeReport32Choice__1Builder toBuilder() {
			return this;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public TradeReport32Choice__1.TradeReport32Choice__1Builder prune() {
			if (_new!=null && !_new.prune().hasData()) _new = null;
			if (mod!=null && !mod.prune().hasData()) mod = null;
			if (crrctn!=null && !crrctn.prune().hasData()) crrctn = null;
			if (termntn!=null && !termntn.prune().hasData()) termntn = null;
			if (valtnUpd!=null && !valtnUpd.prune().hasData()) valtnUpd = null;
			if (err!=null && !err.prune().hasData()) err = null;
			if (portOut!=null && !portOut.prune().hasData()) portOut = null;
			if (rvv!=null && !rvv.prune().hasData()) rvv = null;
			return this;
		}
		
		@Override
		public boolean hasData() {
			if (getNew()!=null && getNew().hasData()) return true;
			if (getMod()!=null && getMod().hasData()) return true;
			if (getCrrctn()!=null && getCrrctn().hasData()) return true;
			if (getTermntn()!=null && getTermntn().hasData()) return true;
			if (getValtnUpd()!=null && getValtnUpd().hasData()) return true;
			if (getErr()!=null && getErr().hasData()) return true;
			if (getPortOut()!=null && getPortOut().hasData()) return true;
			if (getRvv()!=null && getRvv().hasData()) return true;
			return false;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		public TradeReport32Choice__1.TradeReport32Choice__1Builder merge(RosettaModelObjectBuilder other, BuilderMerger merger) {
			TradeReport32Choice__1.TradeReport32Choice__1Builder o = (TradeReport32Choice__1.TradeReport32Choice__1Builder) other;
			
			merger.mergeRosetta(getNew(), o.getNew(), this::setNew);
			merger.mergeRosetta(getMod(), o.getMod(), this::setMod);
			merger.mergeRosetta(getCrrctn(), o.getCrrctn(), this::setCrrctn);
			merger.mergeRosetta(getTermntn(), o.getTermntn(), this::setTermntn);
			merger.mergeRosetta(getValtnUpd(), o.getValtnUpd(), this::setValtnUpd);
			merger.mergeRosetta(getErr(), o.getErr(), this::setErr);
			merger.mergeRosetta(getPortOut(), o.getPortOut(), this::setPortOut);
			merger.mergeRosetta(getRvv(), o.getRvv(), this::setRvv);
			
			return this;
		}
	
		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || !(o instanceof RosettaModelObject) || !getType().equals(((RosettaModelObject)o).getType())) return false;
		
			TradeReport32Choice__1 _that = getType().cast(o);
		
			if (!Objects.equals(_new, _that.getNew())) return false;
			if (!Objects.equals(mod, _that.getMod())) return false;
			if (!Objects.equals(crrctn, _that.getCrrctn())) return false;
			if (!Objects.equals(termntn, _that.getTermntn())) return false;
			if (!Objects.equals(valtnUpd, _that.getValtnUpd())) return false;
			if (!Objects.equals(err, _that.getErr())) return false;
			if (!Objects.equals(portOut, _that.getPortOut())) return false;
			if (!Objects.equals(rvv, _that.getRvv())) return false;
			return true;
		}
		
		@Override
		public int hashCode() {
			int _result = 0;
			_result = 31 * _result + (_new != null ? _new.hashCode() : 0);
			_result = 31 * _result + (mod != null ? mod.hashCode() : 0);
			_result = 31 * _result + (crrctn != null ? crrctn.hashCode() : 0);
			_result = 31 * _result + (termntn != null ? termntn.hashCode() : 0);
			_result = 31 * _result + (valtnUpd != null ? valtnUpd.hashCode() : 0);
			_result = 31 * _result + (err != null ? err.hashCode() : 0);
			_result = 31 * _result + (portOut != null ? portOut.hashCode() : 0);
			_result = 31 * _result + (rvv != null ? rvv.hashCode() : 0);
			return _result;
		}
		
		@Override
		public String toString() {
			return "TradeReport32Choice__1Builder {" +
				"new=" + this._new + ", " +
				"mod=" + this.mod + ", " +
				"crrctn=" + this.crrctn + ", " +
				"termntn=" + this.termntn + ", " +
				"valtnUpd=" + this.valtnUpd + ", " +
				"err=" + this.err + ", " +
				"portOut=" + this.portOut + ", " +
				"rvv=" + this.rvv +
			'}';
		}
	}
}
