package iso20022.auth030.jfsa.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.jfsa.GenericIdentification179__1;
import java.util.List;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.expression.ExpressionOperators.checkString;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.Optional.empty;
import static java.util.Optional.of;
import static java.util.stream.Collectors.joining;
import static java.util.stream.Collectors.toList;

public class GenericIdentification179__1TypeFormatValidator implements Validator<GenericIdentification179__1> {

	private List<ComparisonResult> getComparisonResults(GenericIdentification179__1 o) {
		return Lists.<ComparisonResult>newArrayList(
				checkString("id", o.getId(), 1, of(52), empty())
			);
	}

	@Override
	public ValidationResult<GenericIdentification179__1> validate(RosettaPath path, GenericIdentification179__1 o) {
		String error = getComparisonResults(o)
			.stream()
			.filter(res -> !res.get())
			.map(res -> res.getError())
			.collect(joining("; "));

		if (!isNullOrEmpty(error)) {
			return failure("GenericIdentification179__1", ValidationType.TYPE_FORMAT, "GenericIdentification179__1", path, "", error);
		}
		return success("GenericIdentification179__1", ValidationType.TYPE_FORMAT, "GenericIdentification179__1", path, "");
	}

	@Override
	public List<ValidationResult<?>> getValidationResults(RosettaPath path, GenericIdentification179__1 o) {
		return getComparisonResults(o)
			.stream()
			.map(res -> {
				if (!isNullOrEmpty(res.getError())) {
					return failure("GenericIdentification179__1", ValidationType.TYPE_FORMAT, "GenericIdentification179__1", path, "", res.getError());
				}
				return success("GenericIdentification179__1", ValidationType.TYPE_FORMAT, "GenericIdentification179__1", path, "");
			})
			.collect(toList());
	}

}
