package iso20022.auth030.jfsa.validation.datarule;

import com.google.inject.ImplementedBy;
import com.rosetta.model.lib.annotations.RosettaDataRule;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.mapper.MapperS;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ChoiceRuleValidationMethod;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth030.jfsa.OrganisationIdentification15Choice__2;
import java.util.Arrays;

import static com.rosetta.model.lib.expression.ExpressionOperators.*;

/**
 * @version 0.5.1
 */
@RosettaDataRule("OrganisationIdentification15Choice__2Choice")
@ImplementedBy(OrganisationIdentification15Choice2Choice.Default.class)
public interface OrganisationIdentification15Choice2Choice extends Validator<OrganisationIdentification15Choice__2> {
	
	String NAME = "OrganisationIdentification15Choice__2Choice";
	String DEFINITION = "one-of";
	
	ValidationResult<OrganisationIdentification15Choice__2> validate(RosettaPath path, OrganisationIdentification15Choice__2 organisationIdentification15Choice__2);
	
	class Default implements OrganisationIdentification15Choice2Choice {
	
		@Override
		public ValidationResult<OrganisationIdentification15Choice__2> validate(RosettaPath path, OrganisationIdentification15Choice__2 organisationIdentification15Choice__2) {
			ComparisonResult result = executeDataRule(organisationIdentification15Choice__2);
			if (result.get()) {
				return ValidationResult.success(NAME, ValidationResult.ValidationType.DATA_RULE, "OrganisationIdentification15Choice__2", path, DEFINITION);
			}
			
			String failureMessage = result.getError();
			if (failureMessage == null || failureMessage.contains("Null") || failureMessage == "") {
				failureMessage = "Condition has failed.";
			}
			return ValidationResult.failure(NAME, ValidationType.DATA_RULE, "OrganisationIdentification15Choice__2", path, DEFINITION, failureMessage);
		}
		
		private ComparisonResult executeDataRule(OrganisationIdentification15Choice__2 organisationIdentification15Choice__2) {
			try {
				return choice(MapperS.of(organisationIdentification15Choice__2), Arrays.asList("lei", "othr"), ChoiceRuleValidationMethod.REQUIRED);
			}
			catch (Exception ex) {
				return ComparisonResult.failure(ex.getMessage());
			}
		}
	}
	
	@SuppressWarnings("unused")
	class NoOp implements OrganisationIdentification15Choice2Choice {
	
		@Override
		public ValidationResult<OrganisationIdentification15Choice__2> validate(RosettaPath path, OrganisationIdentification15Choice__2 organisationIdentification15Choice__2) {
			return ValidationResult.success(NAME, ValidationResult.ValidationType.DATA_RULE, "OrganisationIdentification15Choice__2", path, DEFINITION);
		}
	}
}
