package iso20022.auth108.esma.validation;

import com.google.common.collect.Lists;
import com.rosetta.model.lib.expression.ComparisonResult;
import com.rosetta.model.lib.path.RosettaPath;
import com.rosetta.model.lib.validation.ValidationResult;
import com.rosetta.model.lib.validation.ValidationResult.ValidationType;
import com.rosetta.model.lib.validation.Validator;
import iso20022.auth108.esma.MarginReportData7__1;
import java.util.List;

import static com.google.common.base.Strings.isNullOrEmpty;
import static com.rosetta.model.lib.validation.ValidationResult.failure;
import static com.rosetta.model.lib.validation.ValidationResult.success;
import static java.util.stream.Collectors.joining;
import static java.util.stream.Collectors.toList;

public class MarginReportData7__1TypeFormatValidator implements Validator<MarginReportData7__1> {

	private List<ComparisonResult> getComparisonResults(MarginReportData7__1 o) {
		return Lists.<ComparisonResult>newArrayList(
			);
	}

	@Override
	public ValidationResult<MarginReportData7__1> validate(RosettaPath path, MarginReportData7__1 o) {
		String error = getComparisonResults(o)
			.stream()
			.filter(res -> !res.get())
			.map(res -> res.getError())
			.collect(joining("; "));

		if (!isNullOrEmpty(error)) {
			return failure("MarginReportData7__1", ValidationType.TYPE_FORMAT, "MarginReportData7__1", path, "", error);
		}
		return success("MarginReportData7__1", ValidationType.TYPE_FORMAT, "MarginReportData7__1", path, "");
	}

	@Override
	public List<ValidationResult<?>> getValidationResults(RosettaPath path, MarginReportData7__1 o) {
		return getComparisonResults(o)
			.stream()
			.map(res -> {
				if (!isNullOrEmpty(res.getError())) {
					return failure("MarginReportData7__1", ValidationType.TYPE_FORMAT, "MarginReportData7__1", path, "", res.getError());
				}
				return success("MarginReportData7__1", ValidationType.TYPE_FORMAT, "MarginReportData7__1", path, "");
			})
			.collect(toList());
	}

}
